-- *************************************************************
--     KOHA MARC 21 STANDARD DEFAULT BIBLIOGRAPHIC FRAMEWORK
--
--
--     original default requiring greater user customisation
--                  created by a few Koha Hands
--                    guided by Paul POULAIN
--                      by thd for LibLime
--
--           Revised to Update No. 21 (September 2015)
-- *************************************************************


-- ******************************************************
-- KOHA RECORD AND HOLDINGS MANAGEMENT FIELDS/SUBFIELDS.
-- ******************************************************

-- These ought to be adjusted for different less conflicting and more
-- rationally chosen fields and subfields but I had left that for last.

-- ADJUST ME
-- Use values from your dump of marc_tag_structure and marc_subfield_structure
-- to provide support for your Koha database.


-- ******************************************************

-- Current Record ID Field/Subfields

INSERT IGNORE INTO `marc_tag_structure` (`tagfield`, `liblibrarian`, `libopac`, `repeatable`, `mandatory`, `authorised_value`, `frameworkcode`) VALUES
		('999', 'NÚMEROS DE CONTROL DE SISTEMA (KOHA)', 'NÚMEROS DE CONTROL DE SISTEMA (KOHA)', 1, 0, '', '');

INSERT IGNORE INTO `marc_subfield_structure` (`tagfield`, `tagsubfield`, `liblibrarian`, `libopac`, `repeatable`, `mandatory`, `kohafield`, `tab`, `authorised_value`, `authtypecode`, `value_builder`, `isurl`, `hidden`, `frameworkcode`, `seealso`, `link`, `defaultvalue`) VALUES
		('999', 'a', 'Tipo de ítem/unidad física [OBSOLETO]', 'Tipo de ítem/unidad física [OBSOLETO]', 0, 0, NULL, -1, NULL, NULL, '', NULL, -5, '', '', '', NULL),
		('999', 'b', 'Koha Subclase de Dewey [OBSOLETO]', 'Koha Subclase de Dewey [OBSOLETO]', 0, 0, NULL, 0, NULL, NULL, '', NULL, -5, '', '', '', NULL),
		('999', 'c', 'Koha biblionumber', 'Koha biblionumber', 0, 0, 'biblio.biblionumber', -1, NULL, NULL, '', NULL, -5, '', '', '', NULL),
		('999', 'd', 'Koha biblioitemnumber', 'Koha biblioitemnumber', 0, 0, 'biblioitems.biblioitemnumber', -1, NULL, NULL, '', NULL, -5, '', '', '', NULL);


-- ******************************************************


-- Plugins which need to be written for primary biblioitems Field/Subfields.


-- 		('942', '2', 'Source of classification or shelving scheme', 'Source of classification or shelving scheme', 0, 0, 'biblioitems.cn_source', 9, '', '', 'marc21_classcodes.pl', NULL, 0, '', '', '', NULL),
-- 		('942', 'h', 'Classification part', 'Classification part', 0, 0, 'biblioitems.cn_class', 9, '', '', 'marc21_callnumber.pl', NULL, 0, '', '', '', NULL),



-- Current primary biblioitems Field/Subfields


INSERT IGNORE INTO `marc_tag_structure` (`tagfield`, `liblibrarian`, `libopac`, `repeatable`, `mandatory`, `authorised_value`, `frameworkcode`) VALUES
		('942', 'ELEMENTOS DE PUNTO DE ACCESO ADICIONAL (KOHA)', 'ELEMENTOS DE PUNTO DE ACCESO ADICIONAL (KOHA)', 0, 0, '', '');

INSERT IGNORE INTO `marc_subfield_structure` (`tagfield`, `tagsubfield`, `liblibrarian`, `libopac`, `repeatable`, `mandatory`, `kohafield`, `tab`, `authorised_value`, `authtypecode`, `value_builder`, `isurl`, `hidden`, `frameworkcode`, `seealso`, `link`, `defaultvalue`) VALUES
		('942', '0', 'Préstamos Koha (prestado), todas las copias', 'Préstamos Koha (prestado), todas las copias', 0, 0, 'biblioitems.totalissues', 9, '', '', '', NULL, -5, '', '', '', NULL),
		('942', '2', 'Fuente del sistema de clasificación o colocación', 'Fuente del sistema de clasificación o colocación', 0, 0, 'biblioitems.cn_source', 9, 'cn_source', '', '', NULL, 0, '', '', '', NULL),
		('942', '6', 'Koha clasificación normalizada para ordenar', 'Koha clasificación normalizada para ordenar', 0, 0, 'biblioitems.cn_sort', -1, '', '', '', 0, 7, '', '', '', NULL),
		('942', 'a', 'Código de la institución [OBSOLETO]', 'Código de la institución [OBSOLETO]', 0, 0, '', 9, '', '', '', NULL, -5, '', '', '', NULL),
		('942', 'c', 'Tipo de ítem Koha', 'Tipo de ítem Koha', 0, 1, 'biblioitems.itemtype', 9, 'itemtypes', '', '', NULL, 0, '', '', '', NULL),
		('942', 'e', 'Edición', 'Edición', 0, 0, NULL, 9, '', '', '', NULL, 0, '', '', '', NULL),
		('942', 'h', 'Parte de la signatura que corresponde a la clasificación (Parte de la clasificación)', 'Parte de la signatura que corresponde a la clasificación (Parte de la clasificación)', 0, 0, 'biblioitems.cn_class', 9, '', '', '', NULL, 0, '', '', '', NULL),
		('942', 'i', 'Parte de la signatura que identifica el ejemplar (Parte del ítem)', 'Parte de la signatura que identifica el ejemplar (Parte del ítem)', 1, 0, 'biblioitems.cn_item', 9, '', '', '', NULL, 0, '', '', '', NULL),
		('942', 'k', 'Prefijo de la signatura', 'Prefijo de la signatura', 0, 0, 'biblioitems.cn_prefix', 9, '', '', '', NULL, 0, '', '', '', NULL),
		('942', 'm', 'Sufijo de la signatura', 'Sufijo de la signatura', 0, 0, 'biblioitems.cn_suffix', 9, '', '', '', 0, 0, '', '', '', NULL),
		('942', 'n', 'Suprimir en OPAC', 'Suprimir en OPAC', 0, 0, NULL, 9, '', '', '', 0, 0, '', '', '', NULL),
		('942', 's', 'Indicador de registro de publicación seriada', 'Indicador de registro de publicación seriada', 0, 0, 'biblio.serial', 9, '', '', '', NULL, -5, '', '', '', NULL);


-- ******************************************************


-- Plugins which need to be written for items Field/Subfields


-- 		('952', '2', 'Source of classification or shelving scheme', 'Source of classification or shelving scheme', 0, 0, 'items.cn_source', 10, '', '', 'marc21_classcodes.pl', NULL, 0, '', '', '', NULL),
-- 		('952', 'o', 'Koha full call number', 'Koha full call number', 0, 0, 'items.itemcallnumber', 10, '', 'marc21_itemcallnumber.pl', NULL, 0, 0, '', '', '', NULL),



-- Current Items Field/Subfields


INSERT IGNORE INTO `marc_tag_structure` (`tagfield`, `liblibrarian`, `libopac`, `repeatable`, `mandatory`, `authorised_value`, `frameworkcode`) VALUES
		('952', 'LOCALIZACIÓN E INFORMACIÓN DEL ÍTEM/UNIDAD FÍSICA (KOHA)', 'LOCALIZACIÓN E INFORMACIÓN DEL ÍTEM/UNIDAD FÍSICA (KOHA)', 1, 0, '', '');

INSERT IGNORE INTO `marc_subfield_structure` (`tagfield`, `tagsubfield`, `liblibrarian`, `libopac`, `repeatable`, `mandatory`, `kohafield`, `tab`, `authorised_value`, `authtypecode`, `value_builder`, `isurl`, `hidden`, `frameworkcode`, `seealso`, `link`, `defaultvalue`) VALUES
		('952', '0', 'Estado de retiro', 'Estado de retiro', 0, 0, 'items.withdrawn', 10, 'WITHDRAWN', '', '', 0, 0, '', '', '', NULL),
		('952', '1', 'Estado de pérdida', 'Estado de pérdida', 0, 0, 'items.itemlost', 10, 'LOST', '', '', 0, -5, '', '', '', NULL),
		('952', '2', 'Fuente del sistema de clasificación o colocación', 'Fuente del sistema de clasificación o colocación', 0, 0, 'items.cn_source', 10, 'cn_source', '', '', NULL, 0, '', '', '', NULL),
		('952', '3', 'Especificación de materiales (volumen encuadernado u otra parte)', 'Especificación de materiales (volumen encuadernado u otra parte)', 0, 0, 'items.materials', 10, '', '', '', NULL, -1, '', '', '', NULL),
		('952', '4', 'Estado dañado', 'Estado dañado', 0, 0, 'items.damaged', 10, 'DAMAGED', '', '', NULL, 0, '', '', '', NULL),
		('952', '5', 'Restricciones de uso', 'Restricciones de uso', 0, 0, 'items.restricted', 10, 'RESTRICTED', '', '', 0, 0, '', '', '', NULL),
		('952', '6', 'Koha clasificación normalizada para ordenar', 'Koha clasificación normalizada para ordenar', 0, 0, 'items.cn_sort', -1, '', '', '', 0, 7, '', '', '', NULL),
		('952', '7', 'No para préstamo', 'No para préstamo', 0, 0, 'items.notforloan', 10, 'NOT_LOAN', '', '', 0, 0, '', '', '', NULL),
		('952', '8', 'Código de colección', 'Código de colección', 0, 0, 'items.ccode', 10, 'CCODE', '', '', 0, 0, '', '', '', NULL),
		('952', '9', 'Koha itemnumber (autogenerado)', 'Koha itemnumber (autogenerado)', 0, 0, 'items.itemnumber', -1, '', '', '', 0, 7, '', '', '', NULL),
		('952', 'a', 'Localización permanente', 'Localización permanente', 0, 0, 'items.homebranch', 10, 'branches', '', '', 0, 0, '', '', '', NULL),
		('952', 'b', 'Ubicación/localización actual', 'Ubicación/localización actual', 0, 0, 'items.holdingbranch', 10, 'branches', '', '', 0, 0, '', '', '', NULL),
		('952', 'c', 'Ubicación en estantería', 'Ubicación en estantería', 0, 0, 'items.location', 10, 'LOC', '', '', 0, 0, '', '', '', NULL),
		('952', 'd', 'Fecha de adquisición', 'Fecha de adquisición', 0, 0, 'items.dateaccessioned', 10, '', '', 'dateaccessioned.pl', 0, 0, '', '', '', NULL),
		('952', 'e', 'Fuente de adquisición', 'Fuente de adquisición', 0, 0, 'items.booksellerid', 10, '', '', '', 0, 0, '', '', '', NULL),
		('952', 'f', 'Información codificada de la localización en otra ubicación', 'Información codificada de la localización en otra ubicación', 0, 0, 'items.coded_location_qualifier', 10, '', '', '', NULL, 0, '', '', '', NULL),
		('952', 'g', 'Coste, precio normal de compra', 'Coste, precio normal de compra', 0, 0, 'items.price', 10, '', '', '', 0, 0, '', '', '', NULL),
		('952', 'h', 'Enumeración/cronología de publicación seriada', 'Enumeración/cronología de publicación seriada', 0, 0, 'items.enumchron', 10, '', '', '', 0, 0, '', '', '', NULL),
		('952', 'i', 'Número de inventario', 'Número de inventario', 0, 0, 'items.stocknumber', 10, '', '', '', 0, 0, '', '', '', NULL),
		('952', 'j', 'Número de control en estantería', 'Número de control en estantería', 0, 0, 'items.stack', 10, 'STACK', '', '', NULL, -1, '', '', '', NULL),
		('952', 'l', 'Total de préstamos', 'Total de préstamos', 0, 0, 'items.issues', 10, '', '', '', NULL, -5, '', '', '', NULL),
		('952', 'm', 'Renovaciones totales', 'Renovaciones totales', 0, 0, 'items.renewals', 10, '', '', '', NULL, -5, '', '', '', NULL),
		('952', 'n', 'Fondos totales', 'Fondos totales', 0, 0, 'items.reserves', 10, '', '', '', NULL, -5, '', '', '', NULL),
		('952', 'o', 'Signatura topográfica completa', 'Signatura topográfica completa', 0, 0, 'items.itemcallnumber', 10, '', '', NULL, 0, 0, '', '', '', NULL),
		('952', 'p', 'Código de barras', 'Código de barras', 0, 0, 'items.barcode', 10, '', '', 'barcode.pl', 0, 0, '', '', '', NULL),
		('952', 'q', 'En préstamo', 'En préstamo', 0, 0, 'items.onloan', 10, '', '', '', NULL, -5, '', '', '', NULL),
		('952', 'r', 'Fecha visto por última vez', 'Fecha visto por última vez', 0, 0, 'items.datelastseen', 10, '', '', '', NULL, -5, '', '', '', NULL),
		('952', 's', 'Fecha del último préstamo', 'Fecha del último préstamo', 0, 0, 'items.datelastborrowed', 10, '', '', '', NULL, -5, '', '', '', NULL),
		('952', 't', 'Número de copia', 'Número de copia', 0, 0, 'items.copynumber', 10, '', '', '', NULL, 0, '', '', '', NULL),
		('952', 'u', 'Identificador Uniforme del Recurso', 'Identificador Uniforme del Recurso', 0, 0, 'items.uri', 10, '', '', '', 1, 0, '', '', '', NULL),
		('952', 'v', 'Coste, precio de reemplazo', 'Coste, precio de reemplazo', 0, 0, 'items.replacementprice', 10, '', '', '', 0, 0, '', '', '', NULL),
		('952', 'w', 'Precio válido a partir de', 'Precio válido a partir de', 0, 0, 'items.replacementpricedate', 10, '', '', '', 0, 0, '', '', '', NULL),
		('952', 'x', 'Nota no pública', 'Nota no pública', 0, 0, 'items.itemnotes_nonpublic', 10, '', '', '', NULL, 1, '', '', '', NULL),
		('952', 'y', 'Tipo de ítem Koha', 'Tipo de ítem Koha', 0, 0, 'items.itype', 10, 'itemtypes', '', '', NULL, 0, '', '', '', NULL),
		('952', 'z', 'Nota pública', 'Nota pública', 0, 0, 'items.itemnotes', 10, '', '', '', NULL, 0, '', '', '', NULL);




-- *******************************************************



-- *******************************************************
-- MARC 21 FIELDS/SUBFIELDS AND COMMMONLY USED EXTENSIONS
-- *******************************************************


-- A Few local use codes need specifying.  Several seealso, plugin, and
-- authority framework columns need improving.  $9 for authority record linking
-- needs to be added where not already provided by RLIN specifications.
-- Needs checking for errors but probably tolerable for use on a production.
-- A server can be upgraded easily from later versions of this file.
--
-- In the absense of more column support for qualifying the relative
-- importance of subfields to the record editor, some modest modification of
-- the default framework is needed setting the not-useful non-Koha holdings
-- subfields to not managed in Koha.

-- MARC fields including letters as part of the field identifier are from RLIN
-- and should be expected to remain along with RLIN $% subfields.  RLIN has
-- been using letters in fields because there are not enough local use number
-- fields which have not already been specified for very large union catalogue
-- networks such as RLIN itself.


-- Fields ending in c, o, or r are temporary placeholders for information from
-- a numeric value until a non-conflicting way to treat the content under the
-- proper original numeric field is adopted.
--
-- 090 for LC call numbers has been restored.  Formerly, 999, now used for the
-- Koha record ID, had been provided as a temporary place holder until all
-- Koha code for finding control fields has been changed from a numeric test
-- of < 10 to a regular expression match of m/^00/ to prevent mistaken
-- matching of fields with letters such as 09o if they were control fields.
--
-- [Fields with letters have now been moved to a development file in the misc
-- directory for lack of time to test for problems.]


INSERT IGNORE INTO `marc_tag_structure` (`tagfield`, `liblibrarian`, `libopac`, `repeatable`, `mandatory`, `authorised_value`, `frameworkcode`) VALUES
		('000', 'CABECERA', 'CABECERA', 0, 1, '', ''),
		('001', 'NÚMERO DE CONTROL', 'NÚMERO DE CONTROL', 0, 0, '', ''),
		('003', 'IDENTIFICADOR DEL NÚMERO DE CONTROL', 'IDENTIFICADOR DEL NÚMERO DE CONTROL', 0, 1, '', ''),
		('005', 'FECHA Y HORA DE LA ÚLTIMA TRANSACCIÓN', 'FECHA Y HORA DE LA ÚLTIMA TRANSACCIÓN', 0, 1, '', ''),
		('006', 'CÓDIGOS DE INFORMACIÓN DE LONGITUD FIJA--CARACTERÍSTICAS DEL MATERIAL ADICIONAL', 'CÓDIGOS DE INFORMACIÓN DE LONGITUD FIJA--CARACTERÍSTICAS DEL MATERIAL ADICIONAL', 1, 0, '', ''),
		('007', 'CAMPO FIJO DE DESCRIPCIÓN FÍSICA--INFORMACIÓN GENERAL', 'CAMPO FIJO DE DESCRIPCIÓN FÍSICA--INFORMACIÓN GENERAL', 1, 0, '', ''),
		('008', 'DATOS DE LONGITUD FIJA--INFORMACIÓN GENERAL', 'DATOS DE LONGITUD FIJA--INFORMACIÓN GENERAL', 0, 1, '', ''),
		('009', 'DESCRIPCIÓN FÍSICA CAMPO FIJO PARA COLECCIÓN DE ARCHIVOS (VM) [OBSOLETO]', 'DESCRIPCIÓN FÍSICA CAMPO FIJO PARA COLECCIÓN DE ARCHIVOS (VM) [OBSOLETO]', 1, 0, '', ''),
		('010', 'NÚMERO DE CONTROL DE LA BIBLIOTECA DEL CONGRESO', 'NÚMERO DE CONTROL DE LA BIBLIOTECA DEL CONGRESO', 0, 0, '', ''),
		('011', 'ENLACE DEL NUMERO DE CONTROL DE LA BIBLIOTECA DEL CONGRESO [OBSOLETO]', 'ENLACE DEL NUMERO DE CONTROL DE LA BIBLIOTECA DEL CONGRESO [OBSOLETO]', 0, 0, '', ''),
		('013', 'INFORMACIÓN DE CONTROL DE PATENTES', 'INFORMACIÓN DE CONTROL DE PATENTES', 1, 0, '', ''),
		('015', 'NÚMERO DE BIBLIOGRAFÍA NACIONAL', 'NÚMERO DE BIBLIOGRAFÍA NACIONAL', 1, 0, '', ''),
		('016', 'NÚMERO DE CONTROL DE UNA AGENCIA BIBLIOGRÁFICA NACIONAL', 'NÚMERO DE CONTROL DE UNA AGENCIA BIBLIOGRÁFICA NACIONAL', 1, 0, '', ''),
		('017', 'NÚMERO DE COPYRIGHT O DE DEPÓSITO LEGAL', 'NÚMERO DE COPYRIGHT O DE DEPÓSITO LEGAL', 1, 0, '', ''),
		('018', 'DERECHOS DE AUTOR DEL ARTÍCULO-CÓDIGO DE TARIFA', 'DERECHOS DE AUTOR DEL ARTÍCULO-CÓDIGO DE TARIFA', 0, 0, '', ''),
		('01e', 'CODED FIELD ERROR (RLIN)', 'ERROR DE CAMPO CODIFICADO (RLIN)', 'ERROR DE CAMPO CODIFICADO (RLIN)', 0, '', ''),
		('020', 'NÚMERO INTERNACIONAL ESTÁNDAR DEL LIBRO', 'NÚMERO INTERNACIONAL ESTÁNDAR DEL LIBRO', 1, 0, NULL, ''),
		('022', 'NÚMERO INTERNACIONAL NORMALIZADO PARA PUBLICACIONES SERIADAS', 'NÚMERO INTERNACIONAL NORMALIZADO PARA PUBLICACIONES SERIADAS', 1, 0, NULL, ''),
		('023', 'NÚMERO ESTÁNDAR DE PELÍCULAS (VM) [BORRADO]', 'NÚMERO ESTÁNDAR DE PELÍCULAS (VM) [BORRADO]', 1, 0, NULL, ''),
		('024', 'IDENTIFICADOR DE OTROS ESTÁNDARES', 'IDENTIFICADOR DE OTROS ESTÁNDARES', 1, 0, NULL, ''),
		('025', 'NÚMERO DE ADQUISICIÓN EXTRANJERO', 'NÚMERO DE ADQUISICIÓN EXTRANJERO', 1, 0, '', ''),
		('026', 'IDENTIFICADOR DE HUELLA DIGITAL', 'IDENTIFICADOR DE HUELLA DIGITAL', 1, 0, '', ''),
		('027', 'NÚMERO ESTÁNDAR DEL INFORME TÉCNICO', 'NÚMERO ESTÁNDAR DEL INFORME TÉCNICO', 1, 0, '', ''),
		('028', 'NÚMERO DE EDITOR', 'NÚMERO DE EDITOR', 1, 0, NULL, ''),
		('029', 'OTRO NÚMERO DE CONTROL DE SISTEMA (OCLC)', 'OTRO NÚMERO DE CONTROL DE SISTEMA (OCLC)', 1, 0, '', ''),
		('030', 'DESIGNACIÓN CODEN', 'DESIGNACIÓN CODEN', 1, 0, '', ''),
		('031', 'INFORMACIÓN DE LOS ÍNCIPITS MUSICALES', 'INFORMACIÓN DE LOS ÍNCIPITS MUSICALES', 1, 0, '', ''),
		('032', 'NÚMERO DE REGISTRO POSTAL', 'NÚMERO DE REGISTRO POSTAL', 1, 0, '', ''),
		('033', 'FECHA/HORA Y LUGAR DE UN ACONTECIMIENTO', 'FECHA/HORA Y LUGAR DE UN ACONTECIMIENTO', 1, 0, '', ''),
		('034', 'DATOS MATEMÁTICOS CARTOGRÁFICOS CODIFICADOS', 'DATOS MATEMÁTICOS CARTOGRÁFICOS CODIFICADOS', 1, 0, '', ''),
		('035', 'NÚMERO DE CONTROL DEL SISTEMA', 'NÚMERO DE CONTROL DEL SISTEMA', 1, 0, NULL, ''),
		('036', 'NÚMERO DE ESTUDIO ORIGINAL PARA ARCHIVOS DE ORDENADOR', 'NÚMERO DE ESTUDIO ORIGINAL PARA ARCHIVOS DE ORDENADOR', 0, 0, '', ''),
		('037', 'FUENTE DE ADQUISICIÓN', 'FUENTE DE ADQUISICIÓN', 1, 0, NULL, ''),
		('038', 'LICENCIADOR DEL CONTENIDO DEL REGISTRO', 'LICENCIADOR DEL CONTENIDO DEL REGISTRO', 0, 0, '', ''),
		('039', 'NIVEL DE CONTROL BIBLIOGRÁFICO Y DETALLES DE CODIFICACIÓN [OBSOLETO]', 'NIVEL DE CONTROL BIBLIOGRÁFICO Y DETALLES DE CODIFICACIÓN [OBSOLETO]', 0, 0, '', ''),
		('040', 'FUENTE DE LA CATALOGACIÓN', 'FUENTE DE LA CATALOGACIÓN', 0, 1, NULL, ''),
		('041', 'CÓDIGO DE LENGUA', 'CÓDIGO DE LENGUA', 1, 0, '', ''),
		('042', 'CÓDIGO DE AUTENTICACIÓN', 'CÓDIGO DE AUTENTICACIÓN', 0, 0, '', ''),
		('043', 'CÓDIGO DE ÁREA GEOGRÁFICA', 'CÓDIGO DE ÁREA GEOGRÁFICA', 0, 0, NULL, ''),
		('044', 'CÓDIGO DEL PAÍS DE LA ENTIDAD EDITORA/PRODUCTORA', 'CÓDIGO DEL PAÍS DE LA ENTIDAD EDITORA/PRODUCTORA', 0, 0, '', ''),
		('045', 'PERIODO DE TIEMPO DEL CONTENIDO', 'PERIODO DE TIEMPO DEL CONTENIDO', 0, 0, '', ''),
		('046', 'FECHAS CON CODIFICACIÓN ESPECIAL', 'FECHAS CON CODIFICACIÓN ESPECIAL', 1, 0, '', ''),
		('047', 'CÓDIGO DE FORMA DE LA COMPOSICIÓN MUSICAL', 'CÓDIGO DE FORMA DE LA COMPOSICIÓN MUSICAL', 1, 0, '', ''),
		('048', 'CÓDIGO DEL NÚMERO DE INSTRUMENTOS MUSICALES O VOCES', 'CÓDIGO DEL NÚMERO DE INSTRUMENTOS MUSICALES O VOCES', 1, 0, '', ''),
		('049', 'FONDOS LOCALES (OCLC)', 'FONDOS LOCALES (OCLC)', 0, 0, '', ''),
		('050', 'SIGNATURA TOPOGRÁFICA DE LA BIBLIOTECA DEL CONGRESO', 'SIGNATURA TOPOGRÁFICA DE LA BIBLIOTECA DEL CONGRESO', 1, 0, NULL, ''),
		('051', 'MENCIÓN DE LA BIBLIOTECA DEL CONGRESO SOBRE EJEMPLARES, EDICIÓN O SEPARATA', 'MENCIÓN DE LA BIBLIOTECA DEL CONGRESO SOBRE EJEMPLARES, EDICIÓN O SEPARATA', 1, 0, NULL, ''),
		('052', 'CLASIFICACIÓN GEOGRÁFICA', 'CLASIFICACIÓN GEOGRÁFICA', 1, 0, NULL, ''),
		('055', 'NÚMEROS DE CLASIFICACIÓN ASIGNADOS EN CANADÁ', 'NÚMEROS DE CLASIFICACIÓN ASIGNADOS EN CANADÁ', 1, 0, NULL, ''),
		('060', 'SIGNATURA TOPOGRÁFICA DE LA NATIONAL LIBRARY OF MEDICINE', 'SIGNATURA TOPOGRÁFICA DE LA NATIONAL LIBRARY OF MEDICINE', 1, 0, NULL, ''),
		('061', 'MENCIÓN DE LA NATIONAL LIBRARY OF MEDICINE SOBRE EJEMPLARES', 'MENCIÓN DE LA NATIONAL LIBRARY OF MEDICINE SOBRE EJEMPLARES', 1, 0, NULL, ''),
		('066', 'JUEGOS/CONJUNTO DE CARACTERES UTILIZADOS/PRESENTES', 'JUEGOS/CONJUNTO DE CARACTERES UTILIZADOS/PRESENTES', 0, 0, NULL, ''),
		('070', 'SIGNATURA TOPOGRÁFICA DE LA NATIONAL AGRICULTURAL LIBRARY', 'SIGNATURA TOPOGRÁFICA DE LA NATIONAL AGRICULTURAL LIBRARY', 1, 0, NULL, ''),
		('071', 'MENCIÓN DE LA NATIONAL AGRICULTURAL LIBRARY SOBRE EJEMPLARES', 'MENCIÓN DE LA NATIONAL AGRICULTURAL LIBRARY SOBRE EJEMPLARES', 1, 0, NULL, ''),
		('072', 'CÓDIGO DE CATEGORÍA DE MATERIA', 'CÓDIGO DE CATEGORÍA DE MATERIA', 1, 0, NULL, ''),
		('074', 'NÚMERO DE DOCUMENTO/ÍTEM DE LA GPO', 'NÚMERO DE DOCUMENTO/ÍTEM DE LA GPO', 1, 0, NULL, ''),
		('080', 'NÚMERO DE LA CLASIFICACIÓN DECIMAL UNIVERSAL', 'NÚMERO DE LA CLASIFICACIÓN DECIMAL UNIVERSAL', 1, 0, NULL, ''),
		('082', 'NÚMERO DE LA CLASIFICACIÓN DECIMAL DEWEY', 'NÚMERO DE LA CLASIFICACIÓN DECIMAL DEWEY', 1, 0, NULL, ''),
		('083', 'NÚMERO ADICIONAL DE LA CLASIFICACIÓN DECIMAL DEWEY', 'NÚMERO ADICIONAL DE LA CLASIFICACIÓN DECIMAL DEWEY', 1, 0, NULL, ''),
		('084', 'OTRO NÚMERO DE CLASIFICACIÓN', 'OTRO NÚMERO DE CLASIFICACIÓN', 1, 0, NULL, ''),
		('085', 'COMPONENTES DE UN NÚMERO DE CLASIFICACIÓN SINTÉTICO', 'COMPONENTES DE UN NÚMERO DE CLASIFICACIÓN SINTÉTICO', 1, 0, NULL, ''),
		('086', 'NÚMERO DE CLASIFICACIÓN PARA DOCUMENTOS GUBERNAMENTALES', 'NÚMERO DE CLASIFICACIÓN PARA DOCUMENTOS GUBERNAMENTALES', 1, 0, NULL, ''),
		('087', 'NÚMERO DE INFORME [OBSOLETO, CAN/MARC]', 'NÚMERO DE INFORME [OBSOLETO, CAN/MARC]', 1, 0, NULL, ''),
		('088', 'NÚMERO DE INFORME', 'NÚMERO DE INFORME', 1, 0, NULL, ''),
		('090', 'LOCALMENTE ASIGNADO TIPO-LC NÚMERO DE CLASIFICACIÓN (OCLC); NÚMERO DE CLASIFICACIÓN LOCAL (RLIN)', 'LOCALMENTE ASIGNADO TIPO-LC NÚMERO DE CLASIFICACIÓN (OCLC); NÚMERO DE CLASIFICACIÓN LOCAL (RLIN)', 1, 0, '', ''),
		('091', 'LOCALIZACIÓN DE MICROFILM EN ESTANTERÍA (AM) [OBSOLETO]', 'LOCALIZACIÓN DE MICROFILM EN ESTANTERÍA (AM) [OBSOLETO]', 0, 0, '', ''),
		('092', 'ASIGNACIÓN LOCAL DE SIGNATURA TOPOGRÁFICA DEWEY (OCLC)', 'ASIGNACIÓN LOCAL DE SIGNATURA TOPOGRÁFICA DEWEY (OCLC)', 1, 0, '', ''),
		('096', 'ASIGNACIÓN LOCAL TIPO-NLM SIGNATURA TOPOGRÁFICA (OCLC)', 'ASIGNACIÓN LOCAL TIPO-NLM SIGNATURA TOPOGRÁFICA (OCLC)', 1, 0, '', ''),
		('098', 'OTROS ESQUEMAS DE CLASIFICACIÓN (OCLC)', 'OTROS ESQUEMAS DE CLASIFICACIÓN (OCLC)', 1, 0, '', ''),
		('099', 'TEXTO-LIBRO SIGNATURA TOPOGRÁFICA LOCAL (OCLC)', 'TEXTO-LIBRO SIGNATURA TOPOGRÁFICA LOCAL (OCLC)', 1, 0, '', ''),
		('100', 'ENTRADA PRINCIPAL--NOMBRE DE PERSONA', 'ENTRADA PRINCIPAL--NOMBRE DE PERSONA', 0, 0, NULL, ''),
		('110', 'ENTRADA PRINCIPAL--NOMBRE DE ENTIDAD CORPORATIVA', 'ENTRADA PRINCIPAL--NOMBRE DE ENTIDAD CORPORATIVA', 0, 0, NULL, ''),
		('111', 'ENTRADA PRINCIPAL--NOMBRE DE CONGRESO/REUNIÓN', 'ENTRADA PRINCIPAL--NOMBRE DE CONGRESO/REUNIÓN', 0, 0, NULL, ''),
		('130', 'ENTRADA PRINCIPAL--TÍTULO UNIFORME', 'ENTRADA PRINCIPAL--TÍTULO UNIFORME', 0, 0, NULL, ''),
		('210', 'TÍTULO ABREVIADO', 'TÍTULO ABREVIADO', 1, 0, NULL, ''),
		('211', 'ACRÓNIMOS O TÍTULO BREVE [OBSOLETO]', 'ACRÓNIMOS O TÍTULO BREVE [OBSOLETO]', 1, 0, NULL, ''),
		('212', 'ACCESO VARIANTE DE TÍTULO [OBSOLETO]', 'ACCESO VARIANTE DE TÍTULO [OBSOLETO]', 1, 0, NULL, ''),
		('214', 'TÍTULO AUMENTADO [OBSOLETO]', 'TÍTULO AUMENTADO [OBSOLETO]', 1, 0, NULL, ''),
		('222', 'TÍTULO CLAVE', 'TÍTULO CLAVE', 1, 0, NULL, ''),
		('240', 'TÍTULO UNIFORME', 'TÍTULO UNIFORME', 0, 0, 'Unititle', ''),
		('241', 'TÍTULO LATINIZADO/ROMANIZADO (BK AM CF MP MU VM) [OBSOLETO]', 'TÍTULO LATINIZADO/ROMANIZADO (BK AM CF MP MU VM) [OBSOLETO]', 0, 0, '', ''),
		('242', 'TÍTULO TRADUCIDO POR EL CENTRO/AGENCIA CATALOGADOR', 'TÍTULO TRADUCIDO POR EL CENTRO/AGENCIA CATALOGADOR', 1, 0, NULL, ''),
		('243', 'TÍTULO UNIFORME COLECTIVO', 'TÍTULO UNIFORME COLECTIVO', 0, 0, '', ''),
		('245', 'MENCIÓN DE TÍTULO', 'MENCIÓN DE TÍTULO', 0, 1, '', ''),
		('246', 'FORMA VARIANTE DE TÍTULO', 'FORMA VARIANTE DE TÍTULO', 1, 0, NULL, ''),
		('247', 'TÍTULO ANTERIOR', 'TÍTULO ANTERIOR', 1, 0, NULL, ''),
		('250', 'MENCIÓN DE EDICIÓN', 'MENCIÓN DE EDICIÓN', 1, 0, NULL, ''),
		('254', 'MENCIÓN DE PRESENTACIÓN MUSICAL', 'MENCIÓN DE PRESENTACIÓN MUSICAL', 0, 0, NULL, ''),
		('255', 'DATOS MATEMÁTICOS CARTOGRÁFICOS', 'DATOS MATEMÁTICOS CARTOGRÁFICOS', 1, 0, NULL, ''),
		('256', 'CARACTERÍSTICAS DEL ARCHIVO DE ORDENADOR', 'CARACTERÍSTICAS DEL ARCHIVO DE ORDENADOR', 0, 0, NULL, ''),
		('257', 'PAÍS DE LA ENTIDAD PRODUCTORA', 'PAÍS DE LA ENTIDAD PRODUCTORA', 1, 0, NULL, ''),
		('258', 'DATOS DE EMISIÓN FILATÉLICA', 'DATOS DE EMISIÓN FILATÉLICA', 1, 0, NULL, ''),
		('260', 'PUBLICACIÓN, DISTRIBUCIÓN, ETC.', 'PUBLICACIÓN, DISTRIBUCIÓN, ETC.', 1, 0, NULL, ''),
		('261', 'MENCIÓN DE PIE DE IMPRENTA PARA PELÍCULAS (Pre-RCAA 1 revisado) [OBSOLETO, CAN/MARC], [LOCAL, USA]', 'MENCIÓN DE PIE DE IMPRENTA PARA PELÍCULAS (Pre-RCAA 1 revisado) [OBSOLETO, CAN/MARC], [LOCAL, USA]', 0, 0, NULL, ''),
		('262', 'MENCIÓN DE PIE DE IMPRENTA PARA GRABACIONES SONORAS (Pre-RCAA 2) [LOCAL, USA]', 'MENCIÓN DE PIE DE IMPRENTA PARA GRABACIONES SONORAS (Pre-RCAA 2) [LOCAL, USA]', 0, 0, NULL, ''),
		('263', 'FECHA PROYECTADA DE PUBLICACIÓN', 'FECHA PROYECTADA DE PUBLICACIÓN', 0, 0, NULL, ''),
		('264', 'PRODUCCIÓN, PUBLICACIÓN, DISTRIBUCIÓN, FABRICACIÓN Y COPYRIGHT', 'PRODUCCIÓN, PUBLICACIÓN, DISTRIBUCIÓN, FABRICACIÓN Y COPYRIGHT', 1, 0, NULL, ''),
		('265', 'FUENTE DE ADQUISICIÓN/DIRECCIÓN DE SUSCRIPCIÓN [OBSOLETO]', 'FUENTE DE ADQUISICIÓN/DIRECCIÓN DE SUSCRIPCIÓN [OBSOLETO]', 0, 0, NULL, ''),
		('270', 'DIRECCIÓN', 'DIRECCIÓN', 1, 0, NULL, ''),
		('300', 'DESCRIPCIÓN FÍSICA', 'DESCRIPCIÓN FÍSICA', 1, 0, NULL, ''),
		('301', 'DESCRIPCIÓN FÍSICA PARA PELÍCULAS (PRE-RCAA 2) (VM) [OBSOLETO, USMARC]', 'DESCRIPCIÓN FÍSICA PARA PELÍCULAS (PRE-RCAA 2) (VM) [OBSOLETO, USMARC]', 0, 0, NULL, ''),
		('302', 'Número de páginas o ítem (BK AM) [OBSOLETO]', 'Número de páginas o ítem (BK AM) [OBSOLETO]', 0, 0, NULL, ''),
		('303', 'Número de unidad (AM) [OBSOLETO, USMARC]', 'Número de unidad (AM) [OBSOLETO, USMARC]', 0, 0, NULL, ''),
		('304', 'PELÍCULA/SECUENCIA LINEAR (AM) [OBSOLETO, USMARC]', 'PELÍCULA/SECUENCIA LINEAR (AM) [OBSOLETO, USMARC]', 0, 0, NULL, ''),
		('305', 'DESCRIPCIÓN FÍSICA PARA GRABACIONES SONORAS (Pre-RCAA 2) (MU) [OBSOLETO]', 'DESCRIPCIÓN FÍSICA PARA GRABACIONES SONORAS (Pre-RCAA 2) (MU) [OBSOLETO]', 0, 0, NULL, ''),
		('306', 'TIEMPO DE REPRODUCCIÓN/DURACIÓN', 'TIEMPO DE REPRODUCCIÓN/DURACIÓN', 0, 0, NULL, ''),
		('307', 'HORARIO, ETC.', 'HORARIO, ETC.', 1, 0, NULL, ''),
		('308', 'DESCRIPCIÓN FÍSICA PARA PELÍCULAS (ARCHIVO) (VM) [OBSOLETO]', 'DESCRIPCIÓN FÍSICA PARA PELÍCULAS (ARCHIVO) (VM) [OBSOLETO]', 1, 0, NULL, ''),
		('310', 'PERIODICIDAD ACTUAL', 'PERIODICIDAD ACTUAL', 0, 0, NULL, ''),
		('315', 'PERIODICIDAD (CF MP) [OBSOLETO]', 'PERIODICIDAD (CF MP) [OBSOLETO]', 0, 0, NULL, ''),
		('321', 'PERIODICIDAD ANTERIOR', 'PERIODICIDAD ANTERIOR', 1, 0, NULL, ''),
		('336', 'TIPO DE CONTENIDO', 'TIPO DE CONTENIDO', 1, 0, NULL, ''),
		('337', 'TIPO DE MEDIO', 'TIPO DE MEDIO', 1, 0, NULL, ''),
		('338', 'TIPO DE SOPORTE', 'TIPO DE SOPORTE', 1, 0, NULL, ''),
		('340', 'MEDIO FÍSICO', 'MEDIO FÍSICO', 1, 0, NULL, ''),
		('342', 'INFORMACIÓN DE REFERENCIA GEOESPACIAL', 'INFORMACIÓN DE REFERENCIA GEOESPACIAL', 1, 0, NULL, ''),
		('343', 'INFORMACIÓN DE COORDENADAS PLANAS', 'INFORMACIÓN DE COORDENADAS PLANAS', 1, 0, NULL, ''),
		('344', 'CARACTERÍSTICAS DE SONIDO', 'CARACTERÍSTICAS DE SONIDO', 1, 0, NULL, ''),
		('345', 'CARACTERÍSTICAS DE LA PROYECCIÓN DE IMAGEN EN MOVIMIENTO', 'CARACTERÍSTICAS DE LA PROYECCIÓN DE IMAGEN EN MOVIMIENTO', 1, 0, NULL, ''),
		('346', 'CARACTERÍSTICAS DE VÍDEO', 'CARACTERÍSTICAS DE VÍDEO', 1, 0, NULL, ''),
		('347', 'CARACTERÍSTICAS DEL ARCHIVO DIGITAL', 'CARACTERÍSTICAS DEL ARCHIVO DIGITAL', 1, 0, NULL, ''),
		('348', 'Formato de la música notada', 'Formato de la música notada', 1, 0, NULL, ''),
		('350', 'PRECIO (NR) (BK AM CF MU VM SE) [OBSOLETO]', 'PRECIO (NR) (BK AM CF MU VM SE) [OBSOLETO]', 1, 0, NULL, ''),
		('351', 'ORGANIZACIÓN Y ORDENACIÓN DE LOS MATERIALES', 'ORGANIZACIÓN Y ORDENACIÓN DE LOS MATERIALES', 1, 0, NULL, ''),
		('352', 'REPRESENTACIÓN GRÁFICA DIGITAL', 'REPRESENTACIÓN GRÁFICA DIGITAL', 1, 0, NULL, ''),
		('355', 'CLASIFICACIÓN DE SEGURIDAD', 'CLASIFICACIÓN DE SEGURIDAD', 1, 0, NULL, ''),
		('357', 'CONTROL DE LA DIFUSIÓN', 'CONTROL DE LA DIFUSIÓN', 0, 0, NULL, ''),
		('359', 'PRECIO DE ALQUILER (VM) [OBSOLETO]', 'PRECIO DE ALQUILER (VM) [OBSOLETO]', 0, 0, NULL, ''),
		('362', 'FECHAS DE PUBLICACIÓN Y/O DESIGNACIÓN SECUENCIAL', 'FECHAS DE PUBLICACIÓN Y/O DESIGNACIÓN SECUENCIAL', 1, 0, NULL, ''),
		('363', 'FECHA NORMALIZADA Y DESIGNACIÓN SECUENCIAL', 'FECHA NORMALIZADA Y DESIGNACIÓN SECUENCIAL', 1, 0, NULL, ''),
		('365', 'PRECIO COMERCIAL', 'PRECIO COMERCIAL', 1, 0, NULL, ''),
		('366', 'INFORMACIÓN SOBRE DISPONIBILIDAD COMERCIAL', 'INFORMACIÓN SOBRE DISPONIBILIDAD COMERCIAL', 1, 0, NULL, ''),
		('370', 'LUGAR ASOCIADO', 'LUGAR ASOCIADO', 1, 0, NULL, ''),
		('377', 'LENGUA/LENGUAJE ASOCIADO', 'LENGUA/LENGUAJE ASOCIADO', 1, 0, NULL, ''),
		('380', 'FORMA DE LA OBRA', 'FORMA DE LA OBRA', 1, 0, NULL, ''),
		('381', 'OTRAS CARACTERÍSTICAS DISTINTIVAS DE OBRA O EXPRESIÓN', 'OTRAS CARACTERÍSTICAS DISTINTIVAS DE OBRA O EXPRESIÓN', 1, 0, NULL, ''),
		('382', 'MEDIO DE INTERPRETACIÓN', 'MEDIO DE INTERPRETACIÓN', 1, 0, NULL, ''),
		('383', 'DESIGNACIÓN NUMÉRICA DE OBRA MUSICAL', 'DESIGNACIÓN NUMÉRICA DE OBRA MUSICAL', 1, 0, NULL, ''),
		('384', 'TONALIDAD/CLAVE', 'TONALIDAD/CLAVE', 0, 0, NULL, ''),
		('385', 'CARACTERÍSTICAS DEL PÚBLICO', 'CARACTERÍSTICAS DEL PÚBLICO', 1, 0, NULL, ''),
		('386', 'CARACTERÍSTICAS DEL CREADOR/COLABORADOR', 'CARACTERÍSTICAS DEL CREADOR/COLABORADOR', 1, 0, NULL, ''),
		('388', 'PERIODO TEMPORAL DE CREACIÓN', 'PERIODO TEMPORAL DE CREACIÓN', 1, 0, NULL, ''),
		('400', 'MENCIÓN DE SERIE/PUNTO DE ACCESO ADICIONAL--NOMBRE DE PERSONA [OBSOLETO, CAN/MARC], [LOCAL, USA]', 'MENCIÓN DE SERIE/PUNTO DE ACCESO ADICIONAL--NOMBRE DE PERSONA [OBSOLETO, CAN/MARC], [LOCAL, USA]', 1, 0, NULL, ''),
		('410', 'MENCIÓN DE SERIE/PUNTO DE ACCESO ADICIONAL--ENTIDAD CORPORATIVA [OBSOLETO, CAN/MARC], [LOCAL, USA]', 'MENCIÓN DE SERIE/PUNTO DE ACCESO ADICIONAL--ENTIDAD CORPORATIVA [OBSOLETO, CAN/MARC], [LOCAL, USA]', 1, 0, NULL, ''),
		('411', 'MENCIÓN DE SERIE/PUNTO DE ACCESO ADICIONAL--NOMBRE DE CONGRESO/REUNIÓN [OBSOLETO, CAN/MARC], [LOCAL, USA]', 'MENCIÓN DE SERIE/PUNTO DE ACCESO ADICIONAL--NOMBRE DE CONGRESO/REUNIÓN [OBSOLETO, CAN/MARC], [LOCAL, USA]', 1, 0, NULL, ''),
		('440', 'MENCIÓN DE SERIE/PUNTO DE ACCESO ADICIONAL--TÍTULO', 'MENCIÓN DE SERIE/PUNTO DE ACCESO ADICIONAL--TÍTULO', 1, 0, NULL, ''),
		('490', 'MENCIÓN DE SERIE', 'MENCIÓN DE SERIE', 1, 0, '', ''),
		('500', 'NOTA GENERAL', 'NOTA GENERAL', 1, 0, NULL, ''),
		('501', 'NOTA DE \"CON\"', 'NOTA DE \"CON\"', 1, 0, NULL, ''),
		('502', 'NOTA DE TESIS', 'NOTA DE TESIS', 1, 0, NULL, ''),
		('503', 'NOTA DE HISTORIA BIBLIOGRÁFICA (BK CF MU) [OBSOLETO]', 'NOTA DE HISTORIA BIBLIOGRÁFICA (BK CF MU) [OBSOLETO]', 1, 0, NULL, ''),
		('504', 'NOTA DE BIBLIOGRAFÍA, ETC.', 'NOTA DE BIBLIOGRAFÍA, ETC.', 1, 0, NULL, ''),
		('505', 'NOTA DE CONTENIDO CON FORMATO', 'NOTA DE CONTENIDO CON FORMATO', 1, 0, NULL, ''),
		('506', 'NOTA DE RESTRICCIONES AL ACCESO', 'NOTA DE RESTRICCIONES AL ACCESO', 1, 0, NULL, ''),
		('507', 'NOTA DE ESCALA PARA MATERIAL GRÁFICO', 'NOTA DE ESCALA PARA MATERIAL GRÁFICO', 0, 0, NULL, ''),
		('508', 'NOTA DE CRÉDITOS DE CREACIÓN O PRODUCCIÓN', 'NOTA DE CRÉDITOS DE CREACIÓN O PRODUCCIÓN', 1, 0, NULL, ''),
		('509', 'NOTAS INFORMALES (RLIN)', 'NOTAS INFORMALES (RLIN)', 0, 0, NULL, ''),
		('510', 'NOTA DE CITAS O REFERENCIAS BIBLIOGRÁFICAS', 'NOTA DE CITAS O REFERENCIAS BIBLIOGRÁFICAS', 1, 0, NULL, ''),
		('511', 'NOTA DE PARTICIPANTES O INTÉRPRETES', 'NOTA DE PARTICIPANTES O INTÉRPRETES', 1, 0, NULL, ''),
		('512', 'NOTA DE VOLÚMENES ANTERIORES O POSTERIORES CATALOGADOS SEPARADAMENTE [OBSOLETO]', 'NOTA DE VOLÚMENES ANTERIORES O POSTERIORES CATALOGADOS SEPARADAMENTE [OBSOLETO]', 1, 0, NULL, ''),
		('513', 'NOTA DE TIPO DE INFORME Y PERÍODO CUBIERTO', 'NOTA DE TIPO DE INFORME Y PERÍODO CUBIERTO', 1, 0, NULL, ''),
		('514', 'NOTA DE CALIDAD DE LOS DATOS', 'NOTA DE CALIDAD DE LOS DATOS', 0, 0, NULL, ''),
		('515', 'NOTA DE PECULIARIDADES DE LA NUMERACIÓN', 'NOTA DE PECULIARIDADES DE LA NUMERACIÓN', 1, 0, NULL, ''),
		('516', 'NOTA DE TIPO DE ARCHIVO DE ORDENADOR O DE DATOS', 'NOTA DE TIPO DE ARCHIVO DE ORDENADOR O DE DATOS', 1, 0, NULL, ''),
		('517', 'CATEGORÍAS DE NOTA DE PELÍCULA (ARCHIVO) (VM) [OBSOLETO]', 'CATEGORÍAS DE NOTA DE PELÍCULA (ARCHIVO) (VM) [OBSOLETO]', 0, 0, NULL, ''),
		('518', 'NOTA DE FECHA/HORA Y LUGAR DE UN ACONTECIMIENTO', 'NOTA DE FECHA/HORA Y LUGAR DE UN ACONTECIMIENTO', 1, 0, NULL, ''),
		('520', 'SUMARIO, ETC.', 'SUMARIO, ETC.', 1, 0, NULL, ''),
		('521', 'NOTA DE PÚBLICO DESTINATARIO', 'NOTA DE PÚBLICO DESTINATARIO', 1, 0, NULL, ''),
		('522', 'NOTA DE ÁMBITO GEOGRÁFICO', 'NOTA DE ÁMBITO GEOGRÁFICO', 1, 0, NULL, ''),
		('523', 'PERIODO DE TIEMPO DE NOTA DE CONTENIDO (CF) [OBSOLETO]', 'PERIODO DE TIEMPO DE NOTA DE CONTENIDO (CF) [OBSOLETO]', 0, 0, NULL, ''),
		('524', 'NOTA DE FORMA USUAL DE CITA DE LOS MATERIALES DESCRITOS', 'NOTA DE FORMA USUAL DE CITA DE LOS MATERIALES DESCRITOS', 1, 0, NULL, ''),
		('525', 'NOTA DE SUPLEMENTO', 'NOTA DE SUPLEMENTO', 1, 0, NULL, ''),
		('526', 'NOTA DE INFORMACIÓN SOBRE EL PROGRAMA DE ESTUDIO', 'NOTA DE INFORMACIÓN SOBRE EL PROGRAMA DE ESTUDIO', 1, 0, NULL, ''),
		('527', 'NOTA DE CENSURA (VM) [OBSOLETO]', 'NOTA DE CENSURA (VM) [OBSOLETO]', 1, 0, NULL, ''),
		('530', 'NOTA DE FORMATO FÍSICO ADICIONAL DISPONIBLE', 'NOTA DE FORMATO FÍSICO ADICIONAL DISPONIBLE', 1, 0, NULL, ''),
		('533', 'NOTA DE REPRODUCCIÓN', 'NOTA DE REPRODUCCIÓN', 1, 0, NULL, ''),
		('534', 'NOTA SOBRE LA VERSIÓN ORIGINAL', 'NOTA SOBRE LA VERSIÓN ORIGINAL', 1, 0, NULL, ''),
		('535', 'NOTA DE LOCALIZACIÓN DE ORIGINALES/DUPLICADOS', 'NOTA DE LOCALIZACIÓN DE ORIGINALES/DUPLICADOS', 1, 0, NULL, ''),
		('536', 'NOTA DE INFORMACIÓN SOBRE LA FINANCIACIÓN', 'NOTA DE INFORMACIÓN SOBRE LA FINANCIACIÓN', 1, 0, NULL, ''),
		('537', 'FUENTE DE LA NOTA DE DATOS (CF) [OBSOLETO]', 'FUENTE DE LA NOTA DE DATOS (CF) [OBSOLETO]', 0, 0, NULL, ''),
		('538', 'NOTA DE DETALLES DEL SISTEMA', 'NOTA DE DETALLES DEL SISTEMA', 1, 0, NULL, ''),
		('540', 'NOTA DE CONDICIONES DE USO Y REPRODUCCIÓN', 'NOTA DE CONDICIONES DE USO Y REPRODUCCIÓN', 1, 0, NULL, ''),
		('541', 'NOTA DE FUENTE DE ADQUISICIÓN DIRECTA', 'NOTA DE FUENTE DE ADQUISICIÓN DIRECTA', 1, 0, NULL, ''),
		('542', 'NOTA DE INFORMACIÓN RELACIONADA CON EL ESTADO DEL COPYRIGHT', 'NOTA DE INFORMACIÓN RELACIONADA CON EL ESTADO DEL COPYRIGHT', 1, 0, NULL, ''),
		('543', 'NOTA DE SOLICITUD DE INFORMACIÓN [OBSOLETO]', 'NOTA DE SOLICITUD DE INFORMACIÓN [OBSOLETO]', 1, 0, NULL, ''),
		('544', 'NOTA DE LOCALIZACIÓN DE MATERIALES DE ARCHIVO RELACIONADOS', 'NOTA DE LOCALIZACIÓN DE MATERIALES DE ARCHIVO RELACIONADOS', 1, 0, NULL, ''),
		('545', 'DATOS BIOGRÁFICOS O HISTÓRICOS', 'DATOS BIOGRÁFICOS O HISTÓRICOS', 1, 0, NULL, ''),
		('546', 'NOTA DE LENGUA/LENGUAJE', 'NOTA DE LENGUA/LENGUAJE', 1, 0, NULL, ''),
		('547', 'NOTA DE RELACIÓN COMPLEJA CON LOS TÍTULOS ANTERIORES', 'NOTA DE RELACIÓN COMPLEJA CON LOS TÍTULOS ANTERIORES', 1, 0, NULL, ''),
		('550', 'NOTA DE ENTIDAD RESPONSABLE', 'NOTA DE ENTIDAD RESPONSABLE', 1, 0, NULL, ''),
		('552', 'NOTA DE INFORMACIÓN SOBRE EL OBJETO Y SU ATRIBUTO', 'NOTA DE INFORMACIÓN SOBRE EL OBJETO Y SU ATRIBUTO', 1, 0, NULL, ''),
		('555', 'NOTA DE ÍNDICE ACUMULATIVO U OTROS INSTRUMENTOS BIBLIOGRÁFICOS', 'NOTA DE ÍNDICE ACUMULATIVO U OTROS INSTRUMENTOS BIBLIOGRÁFICOS', 1, 0, NULL, ''),
		('556', 'NOTA DE INFORMACIÓN SOBRE LA DOCUMENTACIÓN', 'NOTA DE INFORMACIÓN SOBRE LA DOCUMENTACIÓN', 1, 0, NULL, ''),
		('561', 'PROPIEDAD E HISTORIA DE CUSTODIA/NOTA DE PROCEDENCIA', 'PROPIEDAD E HISTORIA DE CUSTODIA/NOTA DE PROCEDENCIA', 1, 0, NULL, ''),
		('562', 'NOTA DE IDENTIFICACIÓN DE LA COPIA Y VERSIÓN', 'NOTA DE IDENTIFICACIÓN DE LA COPIA Y VERSIÓN', 1, 0, NULL, ''),
		('563', 'NOTA DE ENCUADERNACIÓN', 'NOTA DE ENCUADERNACIÓN', 1, 0, NULL, ''),
		('565', 'NOTA DE CARACTERÍSTICAS DEL EXPEDIENTE', 'NOTA DE CARACTERÍSTICAS DEL EXPEDIENTE', 1, 0, NULL, ''),
		('567', 'NOTA SOBRE LA METODOLOGÍA', 'NOTA SOBRE LA METODOLOGÍA', 1, 0, NULL, ''),
		('570', 'NOTA DEL EDITOR (SE) [OBSOLETO]', 'NOTA DEL EDITOR (SE) [OBSOLETO]', 1, 0, NULL, ''),
		('580', 'NOTA DE RELACIÓN COMPLEJA', 'NOTA DE RELACIÓN COMPLEJA', 1, 0, NULL, ''),
		('581', 'NOTA DE PUBLICACIONES SOBRE LOS MATERIALES DESCRITOS', 'NOTA DE PUBLICACIONES SOBRE LOS MATERIALES DESCRITOS', 1, 0, NULL, ''),
		('582', 'NOTA DE ARCHIVOS DE COMPUTADOR RELACIONADOS (CF) [OBSOLETO]', 'NOTA DE ARCHIVOS DE COMPUTADOR RELACIONADOS (CF) [OBSOLETO]', 1, 0, NULL, ''),
		('583', 'NOTA DE ACCIÓN', 'NOTA DE ACCIÓN', 1, 0, NULL, ''),
		('584', 'NOTA DE CRECIMIENTO Y FRECUENCIA DE USO', 'NOTA DE CRECIMIENTO Y FRECUENCIA DE USO', 1, 0, NULL, ''),
		('585', 'NOTA DE EXPOSICIONES', 'NOTA DE EXPOSICIONES', 1, 0, NULL, ''),
		('586', 'NOTA DE PREMIOS', 'NOTA DE PREMIOS', 1, 0, NULL, ''),
		('588', 'NOTA DE FUENTE DE LA DESCRIPCIÓN', 'NOTA DE FUENTE DE LA DESCRIPCIÓN', 1, 0, NULL, ''),
		('590', 'NOTA LOCAL (RLIN)', 'NOTA LOCAL (RLIN)', 1, 0, NULL, ''),
		('600', 'PUNTO DE ACCESO ADICIONAL DE MATERIA--NOMBRE DE PERSONA', 'PUNTO DE ACCESO ADICIONAL DE MATERIA--NOMBRE DE PERSONA', 1, 0, NULL, ''),
		('610', 'PUNTO DE ACCESO ADICIONAL DE MATERIA--NOMBRE DE ENTIDAD CORPORATIVA', 'PUNTO DE ACCESO ADICIONAL DE MATERIA--NOMBRE DE ENTIDAD CORPORATIVA', 1, 0, NULL, ''),
		('611', 'PUNTO DE ACCESO ADICIONAL DE MATERIA--NOMBRE DE REUNIÓN/CONGRESO', 'PUNTO DE ACCESO ADICIONAL DE MATERIA--NOMBRE DE REUNIÓN/CONGRESO', 1, 0, NULL, ''),
		('630', 'PUNTO DE ACCESO ADICIONAL DE MATERIA--TÍTULO UNIFORME', 'PUNTO DE ACCESO ADICIONAL DE MATERIA--TÍTULO UNIFORME', 1, 0, NULL, ''),
		('648', 'PUNTO DE ACCESO ADICIONAL DE MATERIA--TÉRMINO CRONOLÓGICO', 'PUNTO DE ACCESO ADICIONAL DE MATERIA--TÉRMINO CRONOLÓGICO', 1, 0, NULL, ''),
		('650', 'PUNTO DE ACCESO ADICIONAL DE MATERIA--TÉRMINO DE MATERIA', 'PUNTO DE ACCESO ADICIONAL DE MATERIA--TÉRMINO DE MATERIA', 1, 0, NULL, ''),
		('651', 'PUNTO DE ACCESO ADICIONAL DE MATERIA--NOMBRE GEOGRÁFICO', 'PUNTO DE ACCESO ADICIONAL DE MATERIA--NOMBRE GEOGRÁFICO', 1, 0, NULL, ''),
		('652', 'PUNTO DE ACCESO ADICIONAL DE MATERIA--GEOGRÁFICO REVERTIDO (BK MP SE) [OBSOLETO]', 'PUNTO DE ACCESO ADICIONAL DE MATERIA--GEOGRÁFICO REVERTIDO (BK MP SE) [OBSOLETO]', 1, 0, NULL, ''),
		('653', 'TÉRMINO DE INDIZACIÓN--NO CONTROLADO', 'TÉRMINO DE INDIZACIÓN--NO CONTROLADO', 1, 0, NULL, ''),
		('654', 'PUNTO DE ACCESO ADICIONAL DE MATERIA--TÉRMINOS DE MATERIA FACETADOS', 'PUNTO DE ACCESO ADICIONAL DE MATERIA--TÉRMINOS DE MATERIA FACETADOS', 1, 0, NULL, ''),
		('655', 'TÉRMINO DE INDIZACIÓN--GÉNERO/FORMA', 'TÉRMINO DE INDIZACIÓN--GÉNERO/FORMA', 1, 0, NULL, ''),
		('656', 'TÉRMINO DE INDIZACIÓN--PROFESIÓN/OCUPACIÓN', 'TÉRMINO DE INDIZACIÓN--PROFESIÓN/OCUPACIÓN', 1, 0, NULL, ''),
		('657', 'TÉRMINO DE INDIZACIÓN--FUNCIÓN', 'TÉRMINO DE INDIZACIÓN--FUNCIÓN', 1, 0, NULL, ''),
		('658', 'TÉRMINO DE INDIZACIÓN--OBJETIVO CURRICULAR', 'TÉRMINO DE INDIZACIÓN--OBJETIVO CURRICULAR', 1, 0, NULL, ''),
		('662', 'PUNTO DE ACCESO ADICIONAL DE MATERIA--NOMBRE JERÁRQUICO DE LUGAR', 'PUNTO DE ACCESO ADICIONAL DE MATERIA--NOMBRE JERÁRQUICO DE LUGAR', 1, 0, NULL, ''),
		('690', 'PUNTO DE ACCESO ADICIONAL DE MATERIA LOCAL--TÉRMINO DE MATERIA (OCLC, RLIN)', 'PUNTO DE ACCESO ADICIONAL DE MATERIA LOCAL--TÉRMINO DE MATERIA (OCLC, RLIN)', 1, 0, '', ''),
		('691', 'PUNTO DE ACCESO ADICIONAL DE MATERIA LOCAL--NOMBRE GEOGRÁFICO (RLIN)', 'PUNTO DE ACCESO ADICIONAL DE MATERIA LOCAL--NOMBRE GEOGRÁFICO (RLIN)', 1, 0, '', ''),
		('696', 'PUNTO DE ACCESO ADICIONAL DE MATERIA LOCAL--NOMBRE DE PERSONA', 'PUNTO DE ACCESO ADICIONAL DE MATERIA LOCAL--NOMBRE DE PERSONA', 1, 0, '', ''),
		('697', 'PUNTO DE ACCESO ADICIONAL DE MATERIA LOCAL--NOMBRE DE ENTIDAD CORPORATIVA (RLIN)', 'PUNTO DE ACCESO ADICIONAL DE MATERIA LOCAL--NOMBRE DE ENTIDAD CORPORATIVA (RLIN)', 1, 0, '', ''),
		('698', 'PUNTO DE ACCESO ADICIONAL DE MATERIA LOCAL--NOMBRE DE REUNIÓN/CONGRESO (RLIN)', 'PUNTO DE ACCESO ADICIONAL DE MATERIA LOCAL--NOMBRE DE REUNIÓN/CONGRESO (RLIN)', 1, 0, '', ''),
		('699', 'PUNTO DE ACCESO ADICIONAL DE MATERIA LOCAL--TÍTULO UNIFORME (RLIN)', 'PUNTO DE ACCESO ADICIONAL DE MATERIA LOCAL--TÍTULO UNIFORME (RLIN)', 1, 0, '', ''),
		('700', 'PUNTO DE ACCESO ADICIONAL--NOMBRE DE PERSONA', 'PUNTO DE ACCESO ADICIONAL--NOMBRE DE PERSONA', 1, 0, NULL, ''),
		('705', 'PUNTO DE ACCESO ADICIONAL--NOMBRE DE PERSONA (INTÉRPRETE) (MU) [OBSOLETO]', 'PUNTO DE ACCESO ADICIONAL--NOMBRE DE PERSONA (INTÉRPRETE) (MU) [OBSOLETO]', 1, 0, NULL, ''),
		('710', 'PUNTO DE ACCESO ADICIONAL--NOMBRE DE ENTIDAD CORPORATIVA', 'PUNTO DE ACCESO ADICIONAL--NOMBRE DE ENTIDAD CORPORATIVA', 1, 0, NULL, ''),
		('711', 'PUNTO DE ACCESO ADICIONAL--NOMBRE DE REUNIÓN/CONGRESO', 'PUNTO DE ACCESO ADICIONAL--NOMBRE DE REUNIÓN/CONGRESO', 1, 0, NULL, ''),
		('715', 'PUNTO DE ACCESO ADICIONAL--NOMBRE DE ENTIDAD CORPORATIVA (INTÉRPRETE) (MU) [OBSOLETO]', 'PUNTO DE ACCESO ADICIONAL--NOMBRE DE ENTIDAD CORPORATIVA (INTÉRPRETE) (MU) [OBSOLETO]', 1, 0, NULL, ''),
		('720', 'PUNTO DE ACCESO ADICIONAL--NOMBRE NO CONTROLADO', 'PUNTO DE ACCESO ADICIONAL--NOMBRE NO CONTROLADO', 1, 0, NULL, ''),
		('730', 'PUNTO DE ACCESO ADICIONAL--TÍTULO UNIFORME', 'PUNTO DE ACCESO ADICIONAL--TÍTULO UNIFORME', 1, 0, NULL, ''),
		('740', 'PUNTO DE ACCESO ADICIONAL--TÍTULO RELACIONADO O ANALÍTICO NO CONTROLADO', 'PUNTO DE ACCESO ADICIONAL--TÍTULO RELACIONADO O ANALÍTICO NO CONTROLADO', 1, 0, NULL, ''),
		('751', 'PUNTO DE ACCESO ADICIONAL--NOMBRE GEOGRÁFICO', 'PUNTO DE ACCESO ADICIONAL--NOMBRE GEOGRÁFICO', 1, 0, NULL, ''),
		('752', 'PUNTO DE ACCESO ADICIONAL--NOMBRE JERÁRQUICO DE LUGAR', 'PUNTO DE ACCESO ADICIONAL--NOMBRE JERÁRQUICO DE LUGAR', 1, 0, NULL, ''),
		('753', 'INFORMACIÓN TÉCNICA SOBRE ACCESO A ARCHIVOS DE ORDENADOR', 'INFORMACIÓN TÉCNICA SOBRE ACCESO A ARCHIVOS DE ORDENADOR', 1, 0, NULL, ''),
		('754', 'PUNTO DE ACCESO ADICIONAL--IDENTIFICACIÓN TAXONÓMICA', 'PUNTO DE ACCESO ADICIONAL--IDENTIFICACIÓN TAXONÓMICA', 1, 0, NULL, ''),
		('755', 'PUNTO DE ACCESO ADICIONAL--CARACTERÍSTICAS FÍSICAS [OBSOLETO]', 'PUNTO DE ACCESO ADICIONAL--CARACTERÍSTICAS FÍSICAS [OBSOLETO]', 1, 0, NULL, ''),
		('760', 'ENLACE A UNA SERIE PRINCIPAL', 'ENLACE A UNA SERIE PRINCIPAL', 1, 0, NULL, ''),
		('762', 'ENLACE A UNA SUBSERIE', 'ENLACE A UNA SUBSERIE', 1, 0, NULL, ''),
		('765', 'ENLACE A LA LENGUA/LENGUAJE ORIGINAL', 'ENLACE A LA LENGUA/LENGUAJE ORIGINAL', 1, 0, NULL, ''),
		('767', 'ENLACE A UNA TRADUCCIÓN', 'ENLACE A UNA TRADUCCIÓN', 1, 0, NULL, ''),
		('770', 'ENLACE A UN SUPLEMENTO/NÚMERO ESPECIAL', 'ENLACE A UN SUPLEMENTO/NÚMERO ESPECIAL', 1, 0, NULL, ''),
		('772', 'ENLACE A LA PUBLICACIÓN PRINCIPAL', 'ENLACE A LA PUBLICACIÓN PRINCIPAL', 1, 0, NULL, ''),
		('773', 'ENLACE AL DOCUMENTO FUENTE/ENTRADA DE REGISTRO ANFITRIÓN', 'ENLACE AL DOCUMENTO FUENTE/ENTRADA DE REGISTRO ANFITRIÓN', 1, 0, NULL, ''),
		('774', 'ENLACE A UNIDAD CONSTITUYENTE', 'ENLACE A UNIDAD CONSTITUYENTE', 1, 0, NULL, ''),
		('775', 'ENTRADA/ENLACE A OTRA EDICIÓN', 'ENTRADA/ENLACE A OTRA EDICIÓN', 1, 0, NULL, ''),
		('776', 'ENTRADA/ENLACE A UN FORMATO FÍSICO ADICIONAL', 'ENTRADA/ENLACE A UN FORMATO FÍSICO ADICIONAL', 1, 0, NULL, ''),
		('777', 'ENTRADA/ENLACE A \"PUBLICADO CON\"', 'ENTRADA/ENLACE A \"PUBLICADO CON\"', 1, 0, NULL, ''),
		('780', 'ENLACE A UN TÍTULO/ENTRADA ANTERIOR', 'ENLACE A UN TÍTULO/ENTRADA ANTERIOR', 1, 0, NULL, ''),
		('785', 'ENTRADA/ENLACE A UN TÍTULO POSTERIOR', 'ENTRADA/ENLACE A UN TÍTULO POSTERIOR', 1, 0, NULL, ''),
		('786', 'ENTRADA/ENLACE A UNA FUENTE DE INFORMACIÓN', 'ENTRADA/ENLACE A UNA FUENTE DE INFORMACIÓN', 1, 0, NULL, ''),
		('787', 'ENTRA/ENLACE A OTRAS RELACIONES', 'ENTRA/ENLACE A OTRAS RELACIONES', 1, 0, NULL, ''),
		('789', 'ENTRADA DE ÍTEM COMPONENTE (RLIN)', 'ENTRADA DE ÍTEM COMPONENTE (RLIN)', 1, 0, '', ''),
		('796', 'PUNTO DE ACCESO ADICIONAL LOCAL--NOMBRE DE PERSONA (RLIN)', 'PUNTO DE ACCESO ADICIONAL LOCAL--NOMBRE DE PERSONA (RLIN)', 1, 0, '', ''),
		('797', 'PUNTO DE ACCESO ADICIONAL LOCAL--NOMBRE DE ENTIDAD CORPORATIVA (RLIN)', 'PUNTO DE ACCESO ADICIONAL LOCAL--NOMBRE DE ENTIDAD CORPORATIVA (RLIN)', 1, 0, '', ''),
		('798', 'PUNTO DE ACCESO ADICIONAL LOCAL--NOMBRE DE REUNIÓN/CONGRESO (RLIN)', 'PUNTO DE ACCESO ADICIONAL LOCAL--NOMBRE DE REUNIÓN/CONGRESO (RLIN)', 1, 0, '', ''),
		('799', 'PUNTO DE ACCESO ADICIONAL LOCAL--TÍTULO UNIFORME (RLIN)', 'PUNTO DE ACCESO ADICIONAL LOCAL--TÍTULO UNIFORME (RLIN)', 1, 0, '', ''),
		('800', 'PUNTO DE ACCESO ADICIONAL DE SERIE--NOMBRE DE PERSONA', 'PUNTO DE ACCESO ADICIONAL DE SERIE--NOMBRE DE PERSONA', 1, 0, NULL, ''),
		('810', 'PUNTO DE ACCESO ADICIONAL DE SERIE--NOMBRE DE ENTIDAD CORPORATIVA', 'PUNTO DE ACCESO ADICIONAL DE SERIE--NOMBRE DE ENTIDAD CORPORATIVA', 1, 0, NULL, ''),
		('811', 'PUNTO DE ACCESO ADICIONAL DE SERIE--NOMBRE DE REUNIÓN/CONGRESO', 'PUNTO DE ACCESO ADICIONAL DE SERIE--NOMBRE DE REUNIÓN/CONGRESO', 1, 0, NULL, ''),
		('830', 'PUNTO DE ACCESO ADICIONAL DE SERIE-TÍTULO UNIFORME', 'PUNTO DE ACCESO ADICIONAL DE SERIE-TÍTULO UNIFORME', 1, 0, NULL, ''),
		('840', 'PUNTO DE ACCESO ADICIONAL DE SERIE-TÍTULO [OBSOLETO]', 'PUNTO DE ACCESO ADICIONAL DE SERIE-TÍTULO [OBSOLETO]', 1, 0, NULL, ''),
		('841', 'VALORES CODIFICADOS DE LOS FONDOS', 'VALORES CODIFICADOS DE LOS FONDOS', 0, 0, NULL, ''),
		('842', 'DESIGNADOR TEXTUAL DE LA FORMA FÍSICA', 'DESIGNADOR TEXTUAL DE LA FORMA FÍSICA', 0, 0, NULL, ''),
		('843', 'NOTA DE REPRODUCCIÓN', 'NOTA DE REPRODUCCIÓN', 1, 0, NULL, ''),
		('844', 'NOMBRE DE UNIDAD', 'NOMBRE DE UNIDAD', 0, 0, NULL, ''),
		('845', 'NOTA DE CONDICIONES DE USO Y REPRODUCCIÓN', 'NOTA DE CONDICIONES DE USO Y REPRODUCCIÓN', 1, 0, NULL, ''),
		('850', 'INSTITUCIÓN QUE POSEE LOS FONDOS', 'INSTITUCIÓN QUE POSEE LOS FONDOS', 1, 0, NULL, ''),
		('851', 'LOCALIZACIÓN [OBSOLETO]', 'LOCALIZACIÓN [OBSOLETO]', 1, 0, NULL, ''),
		('852', 'LOCALIZACIÓN', 'LOCALIZACIÓN', 1, 0, NULL, ''),
		('853', 'LEYENDAS Y PATRONES--UNIDAD BIBLIOGRÁFICA BÁSICA', 'LEYENDAS Y PATRONES--UNIDAD BIBLIOGRÁFICA BÁSICA', 1, 0, NULL, ''),
		('854', 'LEYENDAS Y PATRONES--MATERIAL SUPLEMENTARIO', 'LEYENDAS Y PATRONES--MATERIAL SUPLEMENTARIO', 1, 0, NULL, ''),
		('855', 'LEYENDAS Y PATRONES--ÍNDICES', 'LEYENDAS Y PATRONES--ÍNDICES', 1, 0, NULL, ''),
		('856', 'LOCALIZACIÓN Y ACCESO ELECTRÓNICOS', 'LOCALIZACIÓN Y ACCESO ELECTRÓNICOS', 1, 0, NULL, ''),
		('859', 'INFORMACIÓN DE CONTROL LOCAL (RLIN)', 'INFORMACIÓN DE CONTROL LOCAL (RLIN)', 1, 0, '', ''),
		('863', 'ENUMERACIÓN Y CRONOLOGÍA--UNIDAD BIBLIOGRÁFICA BÁSICA', 'ENUMERACIÓN Y CRONOLOGÍA--UNIDAD BIBLIOGRÁFICA BÁSICA', 1, 0, NULL, ''),
		('864', 'ENUMERACIÓN Y CRONOLOGÍA--MATERIAL SUPLEMENTARIO', 'ENUMERACIÓN Y CRONOLOGÍA--MATERIAL SUPLEMENTARIO', 1, 0, NULL, ''),
		('865', 'ENUMERACIÓN Y CRONOLOGÍA--ÍNDICES', 'ENUMERACIÓN Y CRONOLOGÍA--ÍNDICES', 1, 0, NULL, ''),
		('866', 'MENCIÓN TEXTUAL DE FONDOS--UNIDAD BIBLIOGRÁFICA BÁSICA', 'MENCIÓN TEXTUAL DE FONDOS--UNIDAD BIBLIOGRÁFICA BÁSICA', 1, 0, NULL, ''),
		('867', 'MENCIÓN TEXTUAL DE FONDOS--ÍNDICES', 'MENCIÓN TEXTUAL DE FONDOS--ÍNDICES', 1, 0, NULL, ''),
		('868', 'MENCIÓN TEXTUAL DE FONDOS--ÍNDICES', 'MENCIÓN TEXTUAL DE FONDOS--ÍNDICES', 1, 0, NULL, ''),
		('870', 'NOMBRE VARIANTE DE PERSONA (SE) [OBSOLETO]', 'NOMBRE VARIANTE DE PERSONA (SE) [OBSOLETO]', 1, 0, NULL, ''),
		('871', 'NOMBRE VARIANTE DE ENTIDAD CORPORATIVA (SE) [OBSOLETO]', 'NOMBRE VARIANTE DE ENTIDAD CORPORATIVA (SE) [OBSOLETO]', 1, 0, NULL, ''),
		('872', 'NOMBRE VARIANTE DE CONFERENCIA O REUNIÓN/CONGRESO (SE) [OBSOLETO]', 'NOMBRE VARIANTE DE CONFERENCIA O REUNIÓN/CONGRESO (SE) [OBSOLETO]', 1, 0, NULL, ''),
		('873', 'ENCABEZAMIENTO VARIANTE DE TÍTULO UNIFORME (SE) [OBSOLETO]', 'ENCABEZAMIENTO VARIANTE DE TÍTULO UNIFORME (SE) [OBSOLETO]', 1, 0, NULL, ''),
		('876', 'INFORMACIÓN DEL ÍTEM/UNIDAD FÍSICA--UNIDAD BIBLIOGRÁFICA BÁSICA', 'INFORMACIÓN DEL ÍTEM/UNIDAD FÍSICA--UNIDAD BIBLIOGRÁFICA BÁSICA', 1, 0, NULL, ''),
		('877', 'INFORMACIÓN DEL ÍTEM/UNIDAD FÍSICA--MATERIAL SUPLEMENTARIO/ADICIONAL', 'INFORMACIÓN DEL ÍTEM/UNIDAD FÍSICA--MATERIAL SUPLEMENTARIO/ADICIONAL', 1, 0, NULL, ''),
		('878', 'INFORMACIÓN DE ÍTEM/UNIDAD FÍSICA--ÍNDICES', 'INFORMACIÓN DE ÍTEM/UNIDAD FÍSICA--ÍNDICES', 1, 0, NULL, ''),
		('880', 'REPRESENTACIÓN GRÁFICA ALTERNATIVA', 'REPRESENTACIÓN GRÁFICA ALTERNATIVA', 1, 0, NULL, ''),
		('882', 'INFORMACIÓN SOBRE EL REGISTRO QUE SUSTITUYE A UN REGISTRO ELIMINADO', 'INFORMACIÓN SOBRE EL REGISTRO QUE SUSTITUYE A UN REGISTRO ELIMINADO', 0, 0, NULL, ''),
		('883', 'PROCEDENCIA DE LOS METADATOS GENERADOS POR ORDENADOR', 'PROCEDENCIA DE LOS METADATOS GENERADOS POR ORDENADOR', 1, 0, NULL, ''),
		('884', 'Información sobre la conversión de la descripción', 'Información sobre la conversión de la descripción', 1, 0, NULL, ''),
		('886', 'INFORMACIÓN DE CAMPO MARC FORÁNEO', 'INFORMACIÓN DE CAMPO MARC FORÁNEO', 1, 0, NULL, ''),
		('887', 'NO-MARC CAMPO DE INFORMACIÓN', 'NO-MARC CAMPO DE INFORMACIÓN', 1, 0, NULL, ''),
		('896', 'PUNTO DE ACCESO ADICIONAL DE SERIE LOCAL--NOMBRE DE PERSONA (RLIN)', 'PUNTO DE ACCESO ADICIONAL DE SERIE LOCAL--NOMBRE DE PERSONA (RLIN)', 1, 0, '', ''),
		('897', 'PUNTO DE ACCESO ADICIONAL DE SERIE LOCAL--NOMBRE DE ENTIDAD CORPORATIVA (RLIN)', 'PUNTO DE ACCESO ADICIONAL DE SERIE LOCAL--NOMBRE DE ENTIDAD CORPORATIVA (RLIN)', 1, 0, '', ''),
		('898', 'PUNTO DE ACCESO ADICIONAL DE SERIE LOCAL--NOMBRE DE REUNIÓN/CONGRESO (RLIN)', 'PUNTO DE ACCESO ADICIONAL DE SERIE LOCAL--NOMBRE DE REUNIÓN/CONGRESO (RLIN)', 1, 0, '', ''),
		('899', 'PUNTO DE ACCESO ADICIONAL DE SERIE LOCAL--TÍTULO UNIFORME (RLIN)', 'PUNTO DE ACCESO ADICIONAL DE SERIE LOCAL--TÍTULO UNIFORME (RLIN)', 1, 0, '', ''),
		('900', 'ELEMENTOS DE DATOS A LOCAL, LDA (RLIN)', 'ELEMENTOS DE DATOS A LOCAL, LDA (RLIN)', 1, 0, '', ''),
		('901', 'ELEMENTOS DE DATOS A LOCAL LDA (RLIN)', 'ELEMENTOS DE DATOS A LOCAL LDA (RLIN)', 1, 0, '', ''),
		('902', 'ELEMENTOS DE DATOS B LOCAL, LDB (RLIN)', 'ELEMENTOS DE DATOS B LOCAL, LDB (RLIN)', 1, 0, '', ''),
		('903', 'ELEMENTOS DE DATOS C LOCAL, LDC (RLIN)', 'ELEMENTOS DE DATOS C LOCAL, LDC (RLIN)', 1, 0, '', ''),
		('904', 'ELEMENTOS DE DATOS D LOCAL, LDD (RLIN)', 'ELEMENTOS DE DATOS D LOCAL, LDD (RLIN)', 1, 0, '', ''),
		('905', 'ELEMENTOS DE DATOS E LOCAL, LDE (RLIN)', 'ELEMENTOS DE DATOS E LOCAL, LDE (RLIN)', 1, 0, '', ''),
		('906', 'ELEMENTOS DE DATOS F LOCAL, LDF (RLIN)', 'ELEMENTOS DE DATOS F LOCAL, LDF (RLIN)', 1, 0, '', ''),
		('907', 'ELEMENTOS DE DATOS G LOCAL, LDG (RLIN)', 'ELEMENTOS DE DATOS G LOCAL, LDG (RLIN)', 1, 0, '', ''),
		('908', 'COLOCAR PARÁMETRO DE COMANDO (RLIN)', 'COLOCAR PARÁMETRO DE COMANDO (RLIN)', 0, 0, '', ''),
		('910', 'DATOS DE OPCIÓN DEL USUARIO (OCLC)', 'DATOS DE OPCIÓN DEL USUARIO (OCLC)', 0, 0, '', ''),
		('911', 'EQUIVALENCIA O REFERENCIA-CRUZADA-NOMBRE DE CONFERENCIA O REUNIÓN/CONGRESO [LOCAL, CANADÁ]', 'EQUIVALENCIA O REFERENCIA-CRUZADA-NOMBRE DE CONFERENCIA O REUNIÓN/CONGRESO [LOCAL, CANADÁ]', 1, 0, '', ''),
		('930', 'EQUIVALENCIA O REFERENCIA CRUZADA-ENCABEZAMIENTO DE TÍTULO UNIFORME [LOCAL, CANADÁ]', 'EQUIVALENCIA O REFERENCIA CRUZADA-ENCABEZAMIENTO DE TÍTULO UNIFORME [LOCAL, CANADÁ]', 1, 0, '', ''),
		('936', 'OCLC/CONSER DATOS MISCELÁNEOS (OCLC); PIEZA UTILIZADA PARA CATALOGACIÓN (pre-RCAA2) (RLIN)', 'OCLC/CONSER DATOS MISCELÁNEOS (OCLC); PIEZA UTILIZADA PARA CATALOGACIÓN (pre-RCAA2) (RLIN)', 0, 0, '', ''),
		('940', 'EQUIVALENCIA O REFERENCIA-CRUZADA--TÍTULO UNIFORME [OBSOLETO] [solamente CAN/MARC]', 'EQUIVALENCIA O REFERENCIA-CRUZADA--TÍTULO UNIFORME [OBSOLETO] [solamente CAN/MARC]', 1, 0, '', ''),
		('941', 'EQUIVALENCIA O REFERENCIA-CRUZADA--TÍTULO LATINIZADO [OBSOLETO] [solamente CAN/MARC]', 'EQUIVALENCIA O REFERENCIA-CRUZADA--TÍTULO LATINIZADO [OBSOLETO] [solamente CAN/MARC]', 1, 0, '', ''),
		('943', 'EQUIVALENCIA O REFERENCIA-CRUZADA--TÍTULO COLECTIVO [OBSOLETO] [solamente CAN/MARC]', 'EQUIVALENCIA O REFERENCIA-CRUZADA--TÍTULO COLECTIVO [OBSOLETO] [solamente CAN/MARC]', 1, 0, '', ''),
		('945', 'PROCESAMIENTO DE INFORMACIÓN LOCAL (OCLC)', 'PROCESAMIENTO DE INFORMACIÓN LOCAL (OCLC)', 1, 0, '', ''),
		('946', 'PROCESAMIENTO DE INFORMACIÓN LOCAL (OCLC)', 'PROCESAMIENTO DE INFORMACIÓN LOCAL (OCLC)', 1, 0, '', ''),
		('947', 'PROCESAMIENTO DE INFORMACIÓN LOCAL (OCLC)', 'PROCESAMIENTO DE INFORMACIÓN LOCAL (OCLC)', 1, 0, '', ''),
		('948', 'PROCESAMIENTO DE INFORMACIÓN LOCAL (OCLC); DESIGNADOR DE PARTE DE LA SERIE (RLIN)', 'PROCESAMIENTO DE INFORMACIÓN LOCAL (OCLC); DESIGNADOR DE PARTE DE LA SERIE (RLIN)', 1, 0, '', ''),
		('949', 'PROCESAMIENTO DE INFORMACIÓN LOCAL (OCLC)', 'PROCESAMIENTO DE INFORMACIÓN LOCAL (OCLC)', 1, 0, '', ''),
		('950', 'FONDOS LOCALES (RLIN)', 'FONDOS LOCALES (RLIN)', 1, 0, '', ''),
		('951', 'EQUIVALENCIA O REFERENCIA-CRUZADA--NOMBRE GEOGRÁFICO/NOMBRE DE ÁREA [OBSOLETO] [solamente CAN/MARC]', 'EQUIVALENCIA O REFERENCIA-CRUZADA--NOMBRE GEOGRÁFICO/NOMBRE DE ÁREA [OBSOLETO] [solamente CAN/MARC]', 1, 0, '', ''),
		('955', 'INFORMACIÓN NIVEL-COPIA (RLIN)', 'INFORMACIÓN NIVEL-COPIA (RLIN)', 1, 0, '', ''),
		('956', 'LOCALIZACIÓN Y ACCESO ELECTRÓNICOS LOCAL (OCLC)', 'LOCALIZACIÓN Y ACCESO ELECTRÓNICOS LOCAL (OCLC)', 1, 0, '', ''),
		('960', 'LOCALIZACIÓN FÍSICA (RLIN)', 'LOCALIZACIÓN FÍSICA (RLIN)', 1, 0, '', ''),
		('967', 'CÓDIGOS ESTC ADICIONALES (RLIN)', 'CÓDIGOS ESTC ADICIONALES (RLIN)', 1, 0, '', ''),
		('980', 'EQUIVALENCIA O REFERENCIA-CRUZADA-MENCIÓN DE SERIE--NOMBRE DE PERSONA/TÍTULO [LOCAL, CANADÁ]', 'EQUIVALENCIA O REFERENCIA-CRUZADA-MENCIÓN DE SERIE--NOMBRE DE PERSONA/TÍTULO [LOCAL, CANADÁ]', 1, 0, '', ''),
		('981', 'EQUIVALENCIA O REFERENCIA-CRUZADA-MENCIÓN DE SERIE--NOMBRE DE ENTIDAD CORPORATIVA/TÍTULO [LOCAL, CANADÁ]', 'EQUIVALENCIA O REFERENCIA-CRUZADA-MENCIÓN DE SERIE--NOMBRE DE ENTIDAD CORPORATIVA/TÍTULO [LOCAL, CANADÁ]', 1, 0, '', ''),
		('982', 'EQUIVALENCIA O REFERENCIA-CRUZADA-MENCIÓN DE SERIE--NOMBRE DE CONFERENCIA O REUNIÓN/CONGRESO/TÍTULO [LOCAL, CANADÁ]', 'EQUIVALENCIA O REFERENCIA-CRUZADA-MENCIÓN DE SERIE--NOMBRE DE CONFERENCIA O REUNIÓN/CONGRESO/TÍTULO [LOCAL, CANADÁ]', 1, 0, '', ''),
		('983', 'EQUIVALENCIA O REFERENCIA-CRUZADA-MENCIÓN DE SERIE--TÍTULO/TÍTULO UNIFORME [LOCAL, CANADÁ]', 'EQUIVALENCIA O REFERENCIA-CRUZADA-MENCIÓN DE SERIE--TÍTULO/TÍTULO UNIFORME [LOCAL, CANADÁ]', 1, 0, '', ''),
		('984', 'WLN AUTOMATIC HOLDINGS STATEMENT (OCLC)', 'WLN AUTOMATIC HOLDINGS STATEMENT (OCLC)', 1, 0, '', ''),
		('987', 'HISTORIA LOCAL DE LATINIZACIÓN/CONVERSIÓN (OCLC)', 'HISTORIA LOCAL DE LATINIZACIÓN/CONVERSIÓN (OCLC)', 1, 0, '', ''),
		('990', 'EQUIVALENCIA O REFERENCIA-CRUZADA [LOCAL, CANADÁ]', 'EQUIVALENCIA O REFERENCIA-CRUZADA [LOCAL, CANADÁ]', 1, 0, '', ''),
		('995', 'RECOMENDACIÓN 995 [LOCAL, UNIMARC FRANCIA]', 'RECOMENDACIÓN 995 [LOCAL, UNIMARC FRANCIA]', 1, 0, '', ''),
		('998', 'INFORMACIÓN DE CONTROL LOCAL (RLIN)', 'INFORMACIÓN DE CONTROL LOCAL (RLIN)', 1, 0, '', '');



INSERT IGNORE INTO `marc_subfield_structure` (`tagfield`, `tagsubfield`, `liblibrarian`, `libopac`, `repeatable`, `mandatory`, `kohafield`, `tab`, `authorised_value`, `authtypecode`, `value_builder`, `isurl`, `hidden`, `frameworkcode`, `seealso`, `link`, `defaultvalue`) VALUES
		('000', '@', 'campo de control de longitud fija', 'campo de control de longitud fija', 0, 1, '', 0, '', '', 'marc21_leader.pl', 0, 0, '', '', '', NULL),
		('001', '@', 'campo de control', 'campo de control', 0, 0, '', 0, '', '', '', 0, 0, '', '', '', NULL),
		('003', '@', 'campo de control', 'campo de control', 0, 1, '', 0, '', '', 'marc21_field_003.pl', 0, 0, '', '', '', NULL),
		('005', '@', 'campo de control', 'campo de control', 0, 1, '', 0, '', '', 'marc21_field_005.pl', 0, 0, '', '', '', NULL),
		('006', '@', 'campo de control de longitud fija', 'campo de control de longitud fija', 0, 0, '', 0, '', '', 'marc21_field_006.pl', 0, -1, '', '', '', NULL),
		('007', '@', 'campo de control de longitud fija', 'campo de control de longitud fija', 0, 0, '', 0, '', '', 'marc21_field_007.pl', 0, 0, '', '', '', NULL),
		('008', '@', 'campo de control de longitud fija', 'campo de control de longitud fija', 0, 1, '', 0, '', '', 'marc21_field_008.pl', 0, 0, '', '', '', NULL),
		('009', '@', 'campo de control de longitud fija', 'campo de control de longitud fija', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('010', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 0, '', '', NULL, 0, -6, '', '', '', NULL),
		('010', 'a', 'Número de control de LC', 'Número de control de LC', 0, 0, 'biblioitems.lccn', 0, '', '', '', 0, 0, '', '', '', NULL),
		('010', 'b', 'Número de control de NUCMC', 'Número de control de NUCMC', 1, 0, '', 0, '', '', '', 0, -1, '', '', '', NULL),
		('010', 'z', 'Número de control de LC cancelado o no válido', 'Número de control de LC cancelado o no válido', 1, 0, '', 0, '', '', '', 0, -1, '', '', '', NULL),
		('011', 'a', 'Número de control de LC', 'Número de control de LC', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('013', '6', 'Enlace', 'Enlace', 0, 0, '', 0, '', '', NULL, 0, -6, '', '', '', NULL),
		('013', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('013', 'a', 'Número', 'Número', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('013', 'b', 'País', 'País', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('013', 'c', 'Tipo de número', 'Tipo de número', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('013', 'd', 'Fecha', 'Fecha', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('013', 'e', 'Estado', 'Estado', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('013', 'f', 'Parte del documento', 'Parte del documento', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('015', '2', 'Fuente', 'Fuente', 0, 0, '', 0, '', '', NULL, 0, 0, '', '', '', NULL),
		('015', '6', 'Enlace', 'Enlace', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('015', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('015', 'a', 'Número de bibliografía nacional', 'Número de bibliografía nacional', 1, 0, '', 0, '', '', '', 0, 0, '', '', '', NULL),
		('015', 'q', 'Información calificativa', 'Información calificativa', 1, 0, '', 0, '', '', '', 0, 0, '', '', '', NULL),
		('015', 'z', 'Número de bibliografía nacional cancelado o inválido', 'Número de bibliografía nacional cancelado o inválido', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('016', '2', 'Fuente', 'Fuente', 0, 0, '', 0, '', '', '', 0, 0, '', '', '', NULL),
		('016', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('016', 'a', 'Número de control del registro', 'Número de control del registro', 0, 0, '', 0, '', '', '', 0, 0, '', '', '', NULL),
		('016', 'z', 'Número de control cancelado/no válido', 'Número de control cancelado/no válido', 1, 0, '', 0, '', '', '', 0, -1, '', '', '', NULL),
		('017', '2', 'Fuente', 'Fuente', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('017', '6', 'Enlace', 'Enlace', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('017', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('017', 'a', 'Número de copyright o de depósito legal', 'Número de copyright o de depósito legal', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('017', 'b', 'Agencia que asigna', 'Agencia que asigna', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('017', 'd', 'Fecha', 'Fecha', 0, 0, '', 0, '', '', NULL, 0, -6, '', '', '', NULL),
		('017', 'i', 'Texto de visualización', 'Texto de visualización', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('017', 'z', 'Número de copyright o de depósito legal cancelado/o inválido', 'Número de copyright o de depósito legal cancelado/o inválido', 1, 0, '', 0, '', '', '', NULL, -6, '', '', '', NULL),
		('018', '6', 'Enlace', 'Enlace', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('018', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('018', 'a', 'Derechos de autor del artículo-código de tarifa', 'Derechos de autor del artículo-código de tarifa', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('01e', 'a', 'Error de campo codificado', 'Error de campo codificado', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('020', '6', 'Enlace', 'Enlace', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('020', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('020', 'a', 'Número Internacional Estándar del Libro', 'Número Internacional Estándar del Libro', 0, 0, 'biblioitems.isbn', 0, '', '', '', 0, 0, '', '', '', NULL),
		('020', 'c', 'Condiciones de disponibilidad', 'Condiciones de disponibilidad', 0, 0, '', 0, '', '', '', 0, 0, '', '', '', NULL),
		('020', 'q', 'Información calificativa', 'Información calificativa', 1, 0, '', 0, '', '', '', 0, 0, '', '', '', NULL),
		('020', 'z', 'ISBN cancelado o inválido', 'ISBN cancelado o inválido', 1, 0, '', 0, '', '', '', 0, -1, '', '', '', NULL),
		('022', '2', 'Fuente', 'Fuente', 0, 0, '', 0, '', '', '', 0, 0, '', '', '', NULL),
		('022', '6', 'Enlace', 'Enlace', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('022', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('022', 'a', 'Número Internacional Normalizado para Publicaciones Seriadas', 'Número Internacional Normalizado para Publicaciones Seriadas', 0, 0, 'biblioitems.issn', 0, '', '', '', 0, 0, '', '', '', NULL),
		('022', 'l', 'ISSN-L', 'ISSN-L', 0, 0, '', 0, '', '', '', NULL, -6, '', '', '', NULL),
		('022', 'm', 'ISSN-L Cancelado', 'ISSN-L Cancelado', 1, 0, '', 0, '', '', '', NULL, -6, '', '', '', NULL),
		('022', 'y', 'ISSN Incorrecto', 'ISSN Incorrecto', 1, 0, '', 0, '', '', '', 0, -1, '', '', '', NULL),
		('022', 'z', 'ISSN Cancelado', 'ISSN Cancelado', 1, 0, '', 0, '', '', '', 0, -1, '', '', '', NULL),
		('023', 'a', 'Número estándar de películas', 'Número estándar de películas', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('024', '2', 'Fuente del número o código', 'Fuente del número o código', 0, 0, '', 0, '', '', '', 0, 0, '', '', '', NULL),
		('024', '6', 'Enlace', 'Enlace', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('024', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('024', 'a', 'Número estándar o código', 'Número estándar o código', 0, 0, '', 0, '', '', '', 0, 0, '', '', '', NULL),
		('024', 'b', 'Códigos adicionales siguiendo el número estándar [OBSOLETO]', 'Códigos adicionales siguiendo el número estándar [OBSOLETO]', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('024', 'c', 'Condiciones de disponibilidad', 'Condiciones de disponibilidad', 0, 0, '', 0, '', '', '', 0, 0, '', '', '', NULL),
		('024', 'd', 'Códigos adicionales siguiendo el número estándar o código', 'Códigos adicionales siguiendo el número estándar o código', 0, 0, '', 0, '', '', '', 0, 0, '', '', '', NULL),
		('024', 'q', 'Información calificativa', 'Información calificativa', 1, 0, '', 0, '', '', '', 0, 0, '', '', '', NULL),
		('024', 'z', 'Número estándar o código cancelado o inválido', 'Número estándar o código cancelado o inválido', 1, 0, '', 0, '', '', '', 0, -1, '', '', '', NULL),
		('025', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('025', 'a', 'Número de adquisición extranjero', 'Número de adquisición extranjero', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('026', '2', 'Fuente', 'Fuente', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('026', '5', 'Institución que aplica el campo', 'Institución que aplica el campo', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('026', '6', 'Enlace', 'Enlace', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('026', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('026', 'a', 'Primer y segundo grupo de caracteres', 'Primer y segundo grupo de caracteres', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('026', 'b', 'Tercer y cuarto grupos de caracteres', 'Tercer y cuarto grupos de caracteres', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('026', 'c', 'Fecha', 'Fecha', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('026', 'd', 'Número de volumen o parte', 'Número de volumen o parte', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('026', 'e', 'Huella digital no analizada', 'Huella digital no analizada', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('027', '6', 'Enlace', 'Enlace', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('027', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('027', 'a', 'Número estándar del informe técnico', 'Número estándar del informe técnico', 0, 0, '', 0, '', '', '', 0, -1, '', '', '', NULL),
		('027', 'q', 'Información calificativa', 'Información calificativa', 1, 0, '', 0, '', '', '', 0, 0, '', '', '', NULL),
		('027', 'z', 'Número cancelado o inválido', 'Número cancelado o inválido', 1, 0, '', 0, '', '', '', 0, -1, '', '', '', NULL),
		('028', '6', 'Enlace', 'Enlace', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('028', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('028', 'a', 'Número de editor', 'Número de editor', 0, 0, '', 0, '', '', '', 0, 0, '', '', '', NULL),
		('028', 'b', 'Fuente', 'Fuente', 0, 0, '', 0, '', '', '', 0, 0, '', '', '', NULL),
		('028', 'q', 'Información calificativa', 'Información calificativa', 1, 0, '', 0, '', '', '', NULL, -6, '', '', '', NULL),
		('029', 'a', 'Identificador de la biblioteca OCLC', 'Identificador de la biblioteca OCLC', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('029', 'b', 'Número de control de sistema', 'Número de control de sistema', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('029', 'c', 'Nombre de conjunto OAI', 'Nombre de conjunto OAI', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('029', 't', 'Identificador del tipo de contenido', 'Identificador del tipo de contenido', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('030', '6', 'Enlace', 'Enlace', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('030', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('030', 'a', 'CODEN', 'CODEN', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('030', 'z', 'CODEN cancelado o inválido', 'CODEN cancelado o inválido', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('031', '2', 'Código de sistema', 'Código de sistema', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('031', '6', 'Enlace', 'Enlace', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('031', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('031', 'a', 'Número de obra', 'Número de obra', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('031', 'b', 'Número del movimiento', 'Número del movimiento', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('031', 'c', 'Número del pasaje', 'Número del pasaje', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('031', 'd', 'Título o cabecera', 'Título o cabecera', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('031', 'e', 'Personaje/Rol', 'Personaje/Rol', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('031', 'g', 'Clave musical', 'Clave musical', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('031', 'm', 'Voz/instrumento', 'Voz/instrumento', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('031', 'n', 'Armadura de clave', 'Armadura de clave', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('031', 'o', 'Signatura de compás/Marca de tiempo', 'Signatura de compás/Marca de tiempo', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('031', 'p', 'Notación musical', 'Notación musical', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('031', 'q', 'Nota general', 'Nota general', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('031', 'r', 'Tonalidad o modo', 'Tonalidad o modo', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('031', 's', 'Nota de validez codificada', 'Nota de validez codificada', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('031', 't', 'Texto del íncipit', 'Texto del íncipit', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('031', 'u', 'Identificador Uniforme del Recurso', 'Identificador Uniforme del Recurso', 1, 0, '', 0, '', '', '', 1, -6, '', '', '', NULL),
		('031', 'y', 'Texto de enlace', 'Texto de enlace', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('031', 'z', 'Nota pública', 'Nota pública', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('032', '6', 'Enlace', 'Enlace', 0, 0, '', 0, '', '', NULL, 0, -6, '', '', '', NULL),
		('032', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('032', 'a', 'Número de registro postal', 'Número de registro postal', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('032', 'b', 'Fuente de la agencia que asigna el número', 'Fuente de la agencia que asigna el número', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('033', '0', 'Número de control del registro', 'Número de control del registro', 1, 0, '', 0, '', '', '', NULL, -6, '', '', '', NULL),
		('033', '2', 'Fuente del término', 'Fuente del término', 1, 0, '', 0, '', '', '', NULL, -6, '', '', '', NULL),
		('033', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('033', '6', 'Enlace', 'Enlace', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('033', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('033', 'a', 'Fecha/hora formateada', 'Fecha/hora formateada', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('033', 'b', 'Código de clasificación de área geográfica', 'Código de clasificación de área geográfica', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('033', 'c', 'Código de clasificación de subárea geográfica', 'Código de clasificación de subárea geográfica', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('033', 'p', 'Lugar del acontecimiento', 'Lugar del acontecimiento', 1, 0, '', 0, '', '', '', NULL, -6, '', '', '', NULL),
		('034', '0', 'Número de control del registro de autoridad o número normalizado', 'Número de control del registro de autoridad o número normalizado', 1, 0, '', 0, '', '', '', NULL, -6, '', '', '', NULL),
		('034', '2', 'Fuente', 'Fuente', 0, 0, '', 0, '', '', '', NULL, -6, '', '', '', NULL),
		('034', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, '', 0, '', '', '', NULL, -6, '', '', '', NULL),
		('034', '6', 'Enlace', 'Enlace', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('034', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('034', 'a', 'Tipo de escala', 'Tipo de escala', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('034', 'b', 'Escala horizontal lineal razón constante', 'Escala horizontal lineal razón constante', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('034', 'c', 'Escala vertical lineal razón constante', 'Escala vertical lineal razón constante', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('034', 'd', 'Coordenadas - longitud más occidental', 'Coordenadas - longitud más occidental', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('034', 'e', 'Coordenadas--longitud más oriental', 'Coordenadas--longitud más oriental', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('034', 'f', 'Coordenadas - latitud más septentrional', 'Coordenadas - latitud más septentrional', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('034', 'g', 'Coordenadas--latitud más meridional', 'Coordenadas--latitud más meridional', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('034', 'h', 'Escala angular', 'Escala angular', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('034', 'j', 'Declinación--límite septentrional', 'Declinación--límite septentrional', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('034', 'k', 'Declinación-límite meridional', 'Declinación-límite meridional', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('034', 'm', 'Ascensión recta-límite oriental', 'Ascensión recta-límite oriental', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('034', 'n', 'Ascensión recta--límite occidental', 'Ascensión recta--límite occidental', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('034', 'p', 'Equinoccio', 'Equinoccio', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('034', 'r', 'Distancia desde la tierra', 'Distancia desde la tierra', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('034', 's', 'Latitud del anillo-G', 'Latitud del anillo-G', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('034', 't', 'Longitud del anillo-G', 'Longitud del anillo-G', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('034', 'x', 'Fecha de inicio', 'Fecha de inicio', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('034', 'y', 'Fecha de finalización', 'Fecha de finalización', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('034', 'z', 'Nombre del cuerpo extraterrestre', 'Nombre del cuerpo extraterrestre', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('035', '6', 'Enlace', 'Enlace', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('035', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('035', 'a', 'Número de control de sistema', 'Número de control de sistema', 0, 0, '', 0, '', '', '', 0, 0, '', '', '', NULL),
		('035', 'z', 'Número de control cancelado/no válido', 'Número de control cancelado/no válido', 1, 0, '', 0, '', '', '', 0, -1, '', '', '', NULL),
		('036', '6', 'Enlace', 'Enlace', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('036', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('036', 'a', 'Número de estudio original', 'Número de estudio original', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('036', 'b', 'Fuente de la agencia que asigna el número', 'Fuente de la agencia que asigna el número', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('037', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, '', 0, '', '', '', NULL, -6, '', '', '', NULL),
		('037', '5', 'Institución que aplica el campo', 'Institución que aplica el campo', 1, 0, '', 0, '', '', '', NULL, -6, '', '', '', NULL),
		('037', '6', 'Enlace', 'Enlace', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('037', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('037', 'a', 'Número de adquisición', 'Número de adquisición', 0, 0, '', 0, '', '', '', 0, -1, '', '', '', NULL),
		('037', 'b', 'Fuente del número de adquisición', 'Fuente del número de adquisición', 0, 0, '', 0, '', '', '', 0, -1, '', '', '', NULL),
		('037', 'c', 'Condiciones de disponibilidad', 'Condiciones de disponibilidad', 1, 0, '', 0, '', '', '', 0, -1, '', '', '', NULL),
		('037', 'f', 'Formato de la publicación', 'Formato de la publicación', 1, 0, '', 0, '', '', '', 0, -1, '', '', '', NULL),
		('037', 'g', 'Características adicionales del formato', 'Características adicionales del formato', 1, 0, '', 0, '', '', '', 0, -1, '', '', '', NULL),
		('037', 'n', 'Nota', 'Nota', 1, 0, '', 0, '', '', '', 0, -1, '', '', '', NULL),
		('038', '6', 'Enlace', 'Enlace', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('038', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('038', 'a', 'Licenciador del contenido del registro', 'Licenciador del contenido del registro', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('039', 'a', 'Nivel de reglas en descripción bibliográfica', 'Nivel de reglas en descripción bibliográfica', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('039', 'b', 'Nivel de esfuerzo utilizado para asignar no-encabezamientos de materia en puntos de acceso', 'Nivel de esfuerzo utilizado para asignar no-encabezamientos de materia en puntos de acceso', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('039', 'c', 'Nivel de esfuerzo utilizado en la asignación de encabezamientos de materia', 'Nivel de esfuerzo utilizado en la asignación de encabezamientos de materia', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('039', 'd', 'Nivel de esfuerzo utilizado para asignar clasificación', 'Nivel de esfuerzo utilizado para asignar clasificación', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('039', 'e', 'Número de codificación de posiciones de caracteres en campo fijo', 'Número de codificación de posiciones de caracteres en campo fijo', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('040', '6', 'Enlace', 'Enlace', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('040', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('040', 'a', 'Centro catalogador/agencia de origen', 'Centro catalogador/agencia de origen', 0, 0, '', 0, '', '', '', 0, 0, '', '', '', NULL),
		('040', 'b', 'Lengua de catalogación', 'Lengua de catalogación', 0, 0, '', 0, '', '', '', 0, 0, '', '', '', NULL),
		('040', 'c', 'Centro/agencia transcriptor', 'Centro/agencia transcriptor', 0, 1, '', 0, '', '', '', 0, 0, '', '', '', NULL),
		('040', 'd', 'Centro/agencia modificador', 'Centro/agencia modificador', 1, 0, '', 0, '', '', '', 0, 0, '', '', '', NULL),
		('040', 'e', 'Normas de descripción', 'Normas de descripción', 1, 0, '', 0, '', '', '', 0, -1, '', '', '', NULL),
		('041', '2', 'Fuente del código', 'Fuente del código', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('041', '6', 'Enlace', 'Enlace', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('041', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('041', 'a', 'Código de lengua del texto/banda sonora o título independiente', 'Código de lengua del texto/banda sonora o título independiente', 1, 0, '', 0, '', '', '', 0, -1, '', '', '', NULL),
		('041', 'b', 'Código de lengua del sumario o resumen', 'Código de lengua del sumario o resumen', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('041', 'c', 'Lenguajes de los títulos separados (VM) [OBSOLETO]; Lenguajes de las traducciones disponibles (SE) [OBSOLETO]', 'Lenguajes de los títulos separados (VM) [OBSOLETO]; Lenguajes de las traducciones disponibles (SE) [OBSOLETO]', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('041', 'd', 'Código de lengua del texto cantado o hablado', 'Código de lengua del texto cantado o hablado', 1, 0, '', 0, '', '', '', 0, -1, '', '', '', NULL),
		('041', 'e', 'Código de lengua de los libretos', 'Código de lengua de los libretos', 1, 0, '', 0, '', '', '', 0, -1, '', '', '', NULL),
		('041', 'f', 'Código de lengua de la tabla de contenido', 'Código de lengua de la tabla de contenido', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('041', 'g', 'Código de lengua del material acompañante/anejo si no son libretos', 'Código de lengua del material acompañante/anejo si no son libretos', 1, 0, '', 0, '', '', '', 0, -1, '', '', '', NULL),
		('041', 'h', 'Código de lengua original', 'Código de lengua original', 1, 0, '', 0, '', '', '', 0, -1, '', '', '', NULL),
		('041', 'j', 'Código de lengua de los subtítulos o leyendas', 'Código de lengua de los subtítulos o leyendas', 1, 0, '', 0, '', '', '', NULL, -6, '', '', '', NULL),
		('041', 'k', 'Código de lengua de las traducciones intermedias', 'Código de lengua de las traducciones intermedias', 1, 0, '', 0, '', '', '', NULL, -6, '', '', '', NULL),
		('041', 'm', 'Código de lengua del material anejo original si no son libretos', 'Código de lengua del material anejo original si no son libretos', 1, 0, '', 0, '', '', '', NULL, -6, '', '', '', NULL),
		('041', 'n', 'Código de lengua del libreto original', 'Código de lengua del libreto original', 1, 0, '', 0, '', '', '', NULL, -6, '', '', '', NULL),
		('042', 'a', 'Código de autenticación', 'Código de autenticación', 1, 0, '', 0, '', '', '', NULL, -6, '', '', '', NULL),
		('043', '0', 'Número de control del registro de autoridad o número normalizado', 'Número de control del registro de autoridad o número normalizado', 1, 0, '', 0, '', '', '', NULL, -6, '', '', '', NULL),
		('043', '2', 'Fuente del código local', 'Fuente del código local', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('043', '6', 'Enlace', 'Enlace', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('043', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('043', 'a', 'Código de área geográfica', 'Código de área geográfica', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('043', 'b', 'Código local GAC', 'Código local GAC', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('043', 'c', 'Código ISO', 'Código ISO', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('044', '2', 'Fuente del código de subentidad local', 'Fuente del código de subentidad local', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('044', '6', 'Enlace', 'Enlace', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('044', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('044', 'a', 'Código MARC del país', 'Código MARC del país', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('044', 'b', 'Código de subentidad local', 'Código de subentidad local', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('044', 'c', 'Código ISO del país', 'Código ISO del país', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('045', '6', 'Enlace', 'Enlace', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('045', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('045', 'a', 'Código de periodo de tiempo', 'Código de periodo de tiempo', 1, 0, '', 0, '', '', '', 0, -1, '', '', '', NULL),
		('045', 'b', 'Periodo de tiempo normalizado, posterior a 9999 a.C.', 'Periodo de tiempo normalizado, posterior a 9999 a.C.', 1, 0, '', 0, '', '', '', 0, -1, '', '', '', NULL),
		('045', 'c', 'Periodo de tiempo normalizado, anterior a 9999 a.C.', 'Periodo de tiempo normalizado, anterior a 9999 a.C.', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('046', '2', 'Fuente de la fecha', 'Fuente de la fecha', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('046', '6', 'Enlace', 'Enlace', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('046', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('046', 'a', 'Código de tipo de fecha', 'Código de tipo de fecha', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('046', 'b', 'Primera fecha (Fecha 1, fecha a.C.)', 'Primera fecha (Fecha 1, fecha a.C.)', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('046', 'c', 'Primera fecha (Fecha 1, fecha d.C.)', 'Primera fecha (Fecha 1, fecha d.C.)', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('046', 'd', 'Segunda fecha (fecha a.C.)', 'Segunda fecha (fecha a.C.)', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('046', 'e', 'Segunda fecha (Fecha 2, fecha d.C.)', 'Segunda fecha (Fecha 2, fecha d.C.)', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('046', 'j', 'Fecha de modificación del recurso', 'Fecha de modificación del recurso', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('046', 'k', 'Fecha única o de inicio de la creación', 'Fecha única o de inicio de la creación', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('046', 'l', 'Fecha de finalización de la creación', 'Fecha de finalización de la creación', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('046', 'm', 'Fecha de inicio de validez', 'Fecha de inicio de validez', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('046', 'n', 'Fecha de fin de validez', 'Fecha de fin de validez', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('046', 'o', 'Fecha única o fecha inicial para contenidos agregados', 'Fecha única o fecha inicial para contenidos agregados', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('046', 'p', 'Fecha final para contenidos agregados', 'Fecha final para contenidos agregados', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('047', '2', 'Fuente del código', 'Fuente del código', 0, 0, '', 0, '', '', '', 0, -1, '', '', '', NULL),
		('047', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('047', 'a', 'Código de forma de la composición musical', 'Código de forma de la composición musical', 1, 0, '', 0, '', '', '', 0, -1, '', '', '', NULL),
		('048', '2', 'Fuente del código', 'Fuente del código', 0, 0, '', 0, '', '', '', 0, -1, '', '', '', NULL),
		('048', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('048', 'a', 'Intérprete o conjunto', 'Intérprete o conjunto', 1, 0, '', 0, '', '', '', 0, -1, '', '', '', NULL),
		('048', 'b', 'Solista', 'Solista', 1, 0, '', 0, '', '', '', 0, -1, '', '', '', NULL),
		('049', 'a', 'Fondos de biblioteca', 'Fondos de biblioteca', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('049', 'c', 'Mención de copia', 'Mención de copia', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('049', 'd', 'Definición de subdivisiones bibliográficas', 'Definición de subdivisiones bibliográficas', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('049', 'l', 'Procesamiento de datos local', 'Procesamiento de datos local', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('049', 'm', 'Elementos ausentes', 'Elementos ausentes', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('049', 'n', 'Notas acerca de los fondos', 'Notas acerca de los fondos', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('049', 'o', 'Procesamiento de datos local', 'Procesamiento de datos local', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('049', 'p', 'Segunda subdivisión bibliográfica', 'Segunda subdivisión bibliográfica', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('049', 'q', 'Tercera subdivisión bibliográfica', 'Tercera subdivisión bibliográfica', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('049', 'r', 'Cuarta subdivisión bibliográfica', 'Cuarta subdivisión bibliográfica', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('049', 's', 'Quinta subdivisión bibliográfica', 'Quinta subdivisión bibliográfica', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('049', 't', 'Sexta subdivisión bibliográfica', 'Sexta subdivisión bibliográfica', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('049', 'u', 'Séptima subdivisión bibliográfica', 'Séptima subdivisión bibliográfica', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('049', 'v', 'Subdivisisión bibliográfica primaria', 'Subdivisisión bibliográfica primaria', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('049', 'y', 'Fechas inclusivas de publicación o cobertura', 'Fechas inclusivas de publicación o cobertura', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('050', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('050', '6', 'Enlace', 'Enlace', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('050', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('050', 'a', 'Número de clasificación', 'Número de clasificación', 1, 0, '', 0, '', '', '', 0, 0, '', '', '', NULL),
		('050', 'b', 'Número de documento/Ítem', 'Número de documento/Ítem', 0, 0, '', 0, '', '', '', 0, 0, '', '', '', NULL),
		('050', 'd', 'Número de clasificación suplementario (MU) [OBSOLETO]', 'Número de clasificación suplementario (MU) [OBSOLETO]', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('051', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('051', 'a', 'Número de clasificación', 'Número de clasificación', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('051', 'b', 'Número de documento/Ítem', 'Número de documento/Ítem', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('051', 'c', 'Información sobre otras copias', 'Información sobre otras copias', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('052', '2', 'Fuente del código', 'Fuente del código', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('052', '6', 'Enlace', 'Enlace', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('052', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('052', 'a', 'Código de clasificación de área geográfica', 'Código de clasificación de área geográfica', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('052', 'b', 'Código de clasificación de subárea geográfica', 'Código de clasificación de subárea geográfica', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('052', 'c', 'Materia (MP) [OBSOLETO]', 'Materia (MP) [OBSOLETO]', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('052', 'd', 'Nombre de la población', 'Nombre de la población', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('055', '2', 'Fuente del número de signatura/clasificación', 'Fuente del número de signatura/clasificación', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('055', '6', 'Enlace', 'Enlace', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('055', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('055', 'a', 'Número de clasificación', 'Número de clasificación', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('055', 'b', 'Número de documento/Ítem', 'Número de documento/Ítem', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('060', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 0, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('060', 'a', 'Número de clasificación', 'Número de clasificación', 1, 0, NULL, 0, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('060', 'b', 'Número de documento/Ítem', 'Número de documento/Ítem', 0, 0, NULL, 0, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('061', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('061', 'a', 'Número de clasificación', 'Número de clasificación', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('061', 'b', 'Número de documento/Ítem', 'Número de documento/Ítem', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('061', 'c', 'Información sobre otras copias', 'Información sobre otras copias', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('066', 'a', 'Juego/conjunto de caracteres básicos G0', 'Juego/conjunto de caracteres básicos G0', 0, 0, NULL, 0, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('066', 'b', 'Juego/conjunto de caracteres básico G1', 'Juego/conjunto de caracteres básico G1', 0, 0, NULL, 0, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('066', 'c', 'Juego/conjunto de caracteres alternativo G0 o G1', 'Juego/conjunto de caracteres alternativo G0 o G1', 1, 0, NULL, 0, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('070', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 0, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('070', 'a', 'Número de clasificación', 'Número de clasificación', 1, 0, NULL, 0, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('070', 'b', 'Número de documento/Ítem', 'Número de documento/Ítem', 0, 0, NULL, 0, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('071', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('071', 'a', 'Número de clasificación', 'Número de clasificación', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('071', 'b', 'Número de documento/Ítem', 'Número de documento/Ítem', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('071', 'c', 'Información sobre otras copias', 'Información sobre otras copias', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('072', '2', 'Fuente', 'Fuente', 0, 0, NULL, 0, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('072', '6', 'Enlace', 'Enlace', 0, 0, NULL, 0, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('072', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 0, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('072', 'a', 'Código de categoría de materia', 'Código de categoría de materia', 0, 0, NULL, 0, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('072', 'x', 'Subdivisión del código de categoría de materia', 'Subdivisión del código de categoría de materia', 1, 0, NULL, 0, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('074', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 0, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('074', 'a', 'Número de documento/ítem de la GPO', 'Número de documento/ítem de la GPO', 0, 0, NULL, 0, NULL, NULL, '', NULL, -1, '', '', '', NULL),
		('074', 'z', 'Número de documento/ítem de la GPO cancelado/no válido', 'Número de documento/ítem de la GPO cancelado/no válido', 1, 0, NULL, 0, NULL, NULL, '', NULL, -1, '', '', '', NULL),
		('080', '2', 'Identificador de la edición', 'Identificador de la edición', 0, 0, NULL, 0, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('080', '6', 'Enlace', 'Enlace', 0, 0, NULL, 0, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('080', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 0, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('080', 'a', 'Número de la Clasificación Decimal Universal', 'Número de la Clasificación Decimal Universal', 0, 0, NULL, 0, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('080', 'b', 'Número de documento/Ítem', 'Número de documento/Ítem', 0, 0, NULL, 0, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('080', 'x', 'Subdivisión auxiliar común', 'Subdivisión auxiliar común', 1, 0, NULL, 0, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('082', '2', 'Número de edición', 'Número de edición', 0, 0, '', 0, '', '', '', NULL, 0, '', '', '', NULL),
		('082', '6', 'Enlace', 'Enlace', 0, 0, '', 0, '', '', '', NULL, -6, '', '', '', NULL),
		('082', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 0, '', '', '', NULL, -6, '', '', '', NULL),
		('082', 'a', 'Número de clasificación', 'Número de clasificación', 1, 0, '', 0, '', '', '', NULL, 0, '', '', '', NULL),
		('082', 'b', 'Número de documento/Ítem', 'Número de documento/Ítem', 0, 0, '', 0, '', '', '', NULL, 0, '', '', '', NULL),
		('082', 'm', 'Designación estándar u opcional', 'Designación estándar u opcional', 0, 0, '', 0, '', '', '', NULL, -6, '', '', '', NULL),
		('082', 'q', 'Agencia que asigna', 'Agencia que asigna', 0, 0, '', 0, '', '', '', NULL, -6, '', '', '', NULL),
		('083', '2', 'Número de edición', 'Número de edición', 0, 0, '', 0, '', '', '', NULL, -6, '', '', '', NULL),
		('083', '6', 'Enlace', 'Enlace', 0, 0, '', 0, '', '', '', NULL, -6, '', '', '', NULL),
		('083', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 0, '', '', '', NULL, -6, '', '', '', NULL),
		('083', 'a', 'Número de clasificación', 'Número de clasificación', 1, 0, '', 0, '', '', '', NULL, -6, '', '', '', NULL),
		('083', 'c', 'Número de clasificación--Último número del rango', 'Número de clasificación--Último número del rango', 1, 0, '', 0, '', '', '', NULL, -6, '', '', '', NULL),
		('083', 'm', 'Designación estándar u opcional', 'Designación estándar u opcional', 0, 0, '', 0, '', '', '', NULL, -6, '', '', '', NULL),
		('083', 'q', 'Agencia que asigna', 'Agencia que asigna', 0, 0, '', 0, '', '', '', NULL, -6, '', '', '', NULL),
		('083', 'y', 'Número secuencial de tabla para subordenación interna o tabla añadida', 'Número secuencial de tabla para subordenación interna o tabla añadida', 1, 0, '', 0, '', '', '', NULL, -6, '', '', '', NULL),
		('083', 'z', 'Identificador de tabla', 'Identificador de tabla', 1, 0, '', 0, '', '', '', NULL, -6, '', '', '', NULL),
		('084', '2', 'Fuente del número', 'Fuente del número', 0, 0, NULL, 0, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('084', '6', 'Enlace', 'Enlace', 0, 0, NULL, 0, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('084', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 0, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('084', 'a', 'Número de clasificación', 'Número de clasificación', 1, 0, NULL, 0, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('084', 'b', 'Número de documento/Ítem', 'Número de documento/Ítem', 0, 0, NULL, 0, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('084', 'q', 'Agencia que asigna', 'Agencia que asigna', 0, 0, '', 0, '', '', '', NULL, -6, '', '', '', NULL),
		('085', '6', 'Enlace', 'Enlace', 0, 0, '', 0, '', '', '', NULL, -6, '', '', '', NULL),
		('085', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 0, '', '', '', NULL, -6, '', '', '', NULL),
		('085', 'a', 'Número de donde se han tomado las instrucciones-único número o número inicial del rango', 'Número de donde se han tomado las instrucciones-único número o número inicial del rango', 1, 0, '', 0, '', '', '', NULL, -6, '', '', '', NULL),
		('085', 'b', 'Número base', 'Número base', 1, 0, '', 0, '', '', '', NULL, -6, '', '', '', NULL),
		('085', 'c', 'Número de clasificación-último número del rango', 'Número de clasificación-último número del rango', 1, 0, '', 0, '', '', '', NULL, -6, '', '', '', NULL),
		('085', 'f', 'Indicador de faceta', 'Indicador de faceta', 1, 0, '', 0, '', '', '', NULL, -6, '', '', '', NULL),
		('085', 'r', 'Número raíz', 'Número raíz', 1, 0, '', 0, '', '', '', NULL, -6, '', '', '', NULL),
		('085', 's', 'Dígitos añadidos a partir de un número de clasificación de un esquema o tabla externa', 'Dígitos añadidos a partir de un número de clasificación de un esquema o tabla externa', 1, 0, '', 0, '', '', '', NULL, -6, '', '', '', NULL),
		('085', 't', 'Dígitos añadidos a partir de una subordenación interna o una tabla adicional', 'Dígitos añadidos a partir de una subordenación interna o una tabla adicional', 1, 0, '', 0, '', '', '', NULL, -6, '', '', '', NULL),
		('085', 'u', 'Número que se analiza', 'Número que se analiza', 1, 0, '', 0, '', '', '', NULL, -6, '', '', '', NULL),
		('085', 'v', 'Número de una subordenación interna o tabla adicional en el que se dan las pautas [de agregación]', 'Número de una subordenación interna o tabla adicional en el que se dan las pautas [de agregación]', 1, 0, '', 0, '', '', '', NULL, -6, '', '', '', NULL),
		('085', 'w', 'Identificador de tabla-Subordenación interna o tabla adicional', 'Identificador de tabla-Subordenación interna o tabla adicional', 1, 0, '', 0, '', '', '', NULL, -6, '', '', '', NULL),
		('085', 'y', 'Número secuencial de tabla para subordenación interna o tabla añadida', 'Número secuencial de tabla para subordenación interna o tabla añadida', 1, 0, '', 0, '', '', '', NULL, -6, '', '', '', NULL),
		('085', 'z', 'Identificador de tabla', 'Identificador de tabla', 1, 0, '', 0, '', '', '', NULL, -6, '', '', '', NULL),
		('086', '2', 'Fuente del número', 'Fuente del número', 0, 0, NULL, 0, NULL, NULL, '', NULL, -1, '', '', '', NULL),
		('086', '6', 'Enlace', 'Enlace', 0, 0, NULL, 0, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('086', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 0, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('086', 'a', 'Número de clasificación', 'Número de clasificación', 0, 0, NULL, 0, NULL, NULL, '', NULL, -1, '', '', '', NULL),
		('086', 'z', 'Número de clasificación cancelado/no válido', 'Número de clasificación cancelado/no válido', 1, 0, NULL, 0, NULL, NULL, '', NULL, -1, '', '', '', NULL),
		('087', 'a', 'Número de informe [OBSOLETO, CAN/MARC]', 'Número de informe [OBSOLETO, CAN/MARC]', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('087', 'z', 'Número de informe cancelado/no válido [OBSOLETO, CAN/MARC]', 'Número de informe cancelado/no válido [OBSOLETO, CAN/MARC]', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('088', '6', 'Enlace', 'Enlace', 0, 0, NULL, 0, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('088', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 0, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('088', 'a', 'Número de informe', 'Número de informe', 0, 0, NULL, 0, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('088', 'z', 'Número de informe cancelado/no válido', 'Número de informe cancelado/no válido', 1, 0, NULL, 0, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('090', 'a', 'Número de clasificación (OCLC) (R) ; Numero de clasificación, CALL (RLIN) (NR)', 'Número de clasificación (OCLC) (R) ; Numero de clasificación, CALL (RLIN) (NR)', 1, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('090', 'b', 'Número cutter local (OCLC) ; Número de libro/Signatura topográfica íntegra, CALL (RLIN)', 'Número cutter local (OCLC) ; Número de libro/Signatura topográfica íntegra, CALL (RLIN)', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('090', 'e', 'Característica del encabezamiento (OCLC)', 'Característica del encabezamiento (OCLC)', 0, 0, '', 0, '', '', '', 0, 5, '', '', '', NULL),
		('090', 'f', 'Sufijo de archivo (OCLC) ; Nota a pie de página, FNT (RLIN)', 'Sufijo de archivo (OCLC) ; Nota a pie de página, FNT (RLIN)', 0, 0, '', 0, '', '', '', 0, 5, '', '', '', NULL),
		('090', 'h', 'Notas adicionales locales, ANT (RLIN)', 'Notas adicionales locales, ANT (RLIN)', 0, 0, '', 0, '', '', '', 0, 5, '', '', '', NULL),
		('090', 'i', 'Instrucción de transacción de salida, INS (RLIN)', 'Instrucción de transacción de salida, INS (RLIN)', 0, 0, '', 0, '', '', '', 0, 5, '', '', '', NULL),
		('090', 'l', 'Mención de ficha de control extra, EXT (RLIN)', 'Mención de ficha de control extra, EXT (RLIN)', 0, 0, '', 0, '', '', '', 0, 5, '', '', '', NULL),
		('090', 'n', 'Notas locales adicionales, ANT (RLIN)', 'Notas locales adicionales, ANT (RLIN)', 0, 0, '', 0, '', '', '', 0, 5, '', '', '', NULL),
		('090', 'p', 'Código pathfinder, PTH (RLIN)', 'Código pathfinder, PTH (RLIN)', 0, 0, '', 0, '', '', '', 0, 5, '', '', '', NULL),
		('090', 't', 'Campo de supresión, FSP (RLIN)', 'Campo de supresión, FSP (RLIN)', 0, 0, '', 0, '', '', '', 0, 5, '', '', '', NULL),
		('090', 'v', 'Volúmenes, VOL (RLIN)', 'Volúmenes, VOL (RLIN)', 0, 0, '', 0, '', '', '', 0, 5, '', '', '', NULL),
		('090', 'y', 'Fecha, VOL (RLIN)', 'Fecha, VOL (RLIN)', 0, 0, '', 0, '', '', '', 0, 5, '', '', '', NULL),
		('090', 'z', 'Retención, VOL (RLIN)', 'Retención, VOL (RLIN)', 0, 0, '', 0, '', '', '', 0, 5, '', '', '', NULL),
		('091', 'a', 'Localización de microfilm en estantería', 'Localización de microfilm en estantería', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('092', '2', 'Número de edición', 'Número de edición', 0, 0, '', 0, '', '', '', NULL, -6, '', '', '', NULL),
		('092', 'a', 'Número de clasificación', 'Número de clasificación', 0, 0, '', 0, '', '', '', NULL, -6, '', '', '', NULL),
		('092', 'b', 'Número de documento/Ítem', 'Número de documento/Ítem', 0, 0, '', 0, '', '', '', NULL, -6, '', '', '', NULL),
		('092', 'e', 'Característica del encabezamiento', 'Característica del encabezamiento', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('092', 'f', 'Sufijo de archivo', 'Sufijo de archivo', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('096', 'a', 'Número de clasificación', 'Número de clasificación', 0, 0, '', 0, '', '', '', NULL, -6, '', '', '', NULL),
		('096', 'b', 'Número de documento/Ítem', 'Número de documento/Ítem', 0, 0, '', 0, '', '', '', NULL, -6, '', '', '', NULL),
		('096', 'e', 'Característica del encabezamiento', 'Característica del encabezamiento', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('096', 'f', 'Sufijo de archivo', 'Sufijo de archivo', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('098', 'a', 'Signatura topográfica basada en otros esquemas de clasificación', 'Signatura topográfica basada en otros esquemas de clasificación', 0, 0, '', 0, '', '', '', NULL, -6, '', '', '', NULL),
		('098', 'e', 'Característica del encabezamiento', 'Característica del encabezamiento', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('098', 'f', 'Sufijo de archivo', 'Sufijo de archivo', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('099', 'a', 'Número de clasificación', 'Número de clasificación', 1, 0, '', 0, '', '', '', NULL, -6, '', '', '', NULL),
		('099', 'e', 'Característica del encabezamiento', 'Característica del encabezamiento', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('099', 'f', 'Sufijo de archivo', 'Sufijo de archivo', 0, 0, '', 0, '', '', '', 0, -6, '', '', '', NULL),
		('100', '0', 'Número de control del registro de autoridad o número normalizado', 'Número de control del registro de autoridad o número normalizado', 1, 0, '', 1, '', '', '', NULL, -6, '', '', '', NULL),
		('100', '4', 'Código de función/relación', 'Código de función/relación', 1, 0, '', 1, '', '', '', 0, 0, '', '', '', NULL),
		('100', '6', 'Enlace', 'Enlace', 0, 0, '', 1, '', '', '', 0, -6, '', '', '', NULL),
		('100', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 1, '', '', '', 0, -6, '', '', '', NULL),
		('100', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 1, '', '', '', 0, -5, '', '', '', NULL),
		('100', 'a', 'Nombre de persona', 'Nombre de persona', 0, 0, 'biblio.author', 1, '', 'PERSO_NAME', '', 0, 0, '', '''100b'',''100c'',''100q'',''100d'',''100e'',''110a'',''110b'',''110c'',''110d'',''110e'',''111a'',''111e'',''111c'',''111d'',''130a'',''700a'',''700b'',''700c'',''700q'',''700d'',''700e'',''710a'',''710b'',''710c'',''710d'',''710e'',''711a'',''711e'',''711c'',''711d'',''720a'',''720e'',''796a'',''796b'',''796c'',''796q'',''796d'',''796e'',''797a'',''797b'',''797c'',''797d'',''797e'',''798a'',''798e'',''798c'',''798d'',''800a'',''800b'',''800c'',''800q'',''800d'',''800e'',''810a'',''810b'',''810c'',''810d'',''810e'',''811a'',''811e'',''811c'',''811d'',''896a'',''896b'',''896c'',''896q'',''896d'',''896e'',''897a'',''897b'',''897c'',''897d'',''897e'',''898a'',''898e'',''898c'',''898d'',''505r''', '', NULL),
		('100', 'b', 'Numeración', 'Numeración', 0, 0, '', 1, '', '', '', 0, -1, '', '', '', NULL),
		('100', 'c', 'Títulos y otros términos asociados al nombre', 'Títulos y otros términos asociados al nombre', 1, 0, '', 1, '', '', '', 0, -1, '', '', '', NULL),
		('100', 'd', 'Fechas asociadas al nombre', 'Fechas asociadas al nombre', 0, 0, '', 1, '', '', '', 0, 0, '', '', '', NULL),
		('100', 'e', 'Término indicativo de función/relación', 'Término indicativo de función/relación', 1, 0, '', 1, '', '', '', 0, 0, '', '', '', NULL),
		('100', 'f', 'Fecha de publicación/de la obra', 'Fecha de publicación/de la obra', 0, 0, '', 1, '', '', '', 0, -6, '', '', '', NULL),
		('100', 'g', 'Información miscelánea', 'Información miscelánea', 1, 0, '', 1, '', '', '', 0, -6, '', '', '', NULL),
		('100', 'j', 'Calificador de atribución', 'Calificador de atribución', 1, 0, '', 1, '', '', '', 0, -6, '', '', '', NULL),
		('100', 'k', 'Subencabezamiento de forma', 'Subencabezamiento de forma', 1, 0, '', 1, '', '', '', 0, -6, '', '', '', NULL),
		('100', 'l', 'Lenguaje de la obra', 'Lenguaje de la obra', 0, 0, '', 1, '', '', '', 0, -6, '', '', '', NULL),
		('100', 'n', 'Número de parte o sección de la obra', 'Número de parte o sección de la obra', 1, 0, '', 1, '', '', '', 0, -6, '', '', '', NULL),
		('100', 'p', 'Nombre de parte o sección de la obra', 'Nombre de parte o sección de la obra', 1, 0, '', 1, '', '', '', 0, -6, '', '', '', NULL),
		('100', 'q', 'Forma completa/desarrollada del nombre', 'Forma completa/desarrollada del nombre', 0, 0, '', 1, '', '', '', 0, 0, '', '', '', NULL),
		('100', 't', 'Título de la obra', 'Título de la obra', 0, 0, '', 1, '', '', '', 0, -6, '', '', '', NULL),
		('100', 'u', 'Filiación', 'Filiación', 0, 0, '', 1, '', '', '', 0, -6, '', '', '', NULL),
		('110', '0', 'Número de control del registro de autoridad o número normalizado', 'Número de control del registro de autoridad o número normalizado', 1, 0, '', 1, '', '', '', NULL, -6, '', '', '', NULL),
		('110', '4', 'Código de función/relación', 'Código de función/relación', 1, 0, '', 1, '', '', '', NULL, 0, '', '', '', NULL),
		('110', '6', 'Enlace', 'Enlace', 0, 0, '', 1, '', '', '', NULL, -6, '', '', '', NULL),
		('110', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 1, '', '', '', NULL, -6, '', '', '', NULL),
		('110', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 1, '', '', '', 0, -5, '', '', '', NULL),
		('110', 'a', 'Nombre de entidad corporativa o nombre de jurisdicción como elemento de entrada', 'Nombre de entidad corporativa o nombre de jurisdicción como elemento de entrada', 0, 0, '', 1, '', 'CORPO_NAME', '', NULL, 0, '', '', '', NULL),
		('110', 'b', 'Unidad subordinada', 'Unidad subordinada', 1, 0, '', 1, '', '', '', NULL, 0, '', '', '', NULL),
		('110', 'c', 'Sede del congreso/Lugar de la reunión', 'Sede del congreso/Lugar de la reunión', 1, 0, '', 1, '', '', '', NULL, -1, '', '', '', NULL),
		('110', 'd', 'Fecha del congreso/reunión o de la firma de un tratado', 'Fecha del congreso/reunión o de la firma de un tratado', 1, 0, '', 1, '', '', '', NULL, -1, '', '', '', NULL),
		('110', 'e', 'Término indicativo de función/relación', 'Término indicativo de función/relación', 1, 0, '', 1, '', '', '', NULL, 0, '', '', '', NULL),
		('110', 'f', 'Fecha de publicación/de la obra', 'Fecha de publicación/de la obra', 0, 0, '', 1, '', '', '', NULL, -6, '', '', '', NULL),
		('110', 'g', 'Información miscelánea', 'Información miscelánea', 1, 0, '', 1, '', '', '', NULL, -6, '', '', '', NULL),
		('110', 'k', 'Subencabezamiento de forma', 'Subencabezamiento de forma', 1, 0, '', 1, '', '', '', NULL, -6, '', '', '', NULL),
		('110', 'l', 'Lenguaje de la obra', 'Lenguaje de la obra', 0, 0, '', 1, '', '', '', NULL, -6, '', '', '', NULL),
		('110', 'n', 'Número del congreso/reunión o número de parte o sección', 'Número del congreso/reunión o número de parte o sección', 1, 0, '', 1, '', '', '', NULL, -6, '', '', '', NULL),
		('110', 'p', 'Nombre de parte o sección de la obra', 'Nombre de parte o sección de la obra', 1, 0, '', 1, '', '', '', NULL, -6, '', '', '', NULL),
		('110', 't', 'Título de la obra', 'Título de la obra', 0, 0, '', 1, '', '', '', NULL, -6, '', '', '', NULL),
		('110', 'u', 'Filiación', 'Filiación', 0, 0, '', 1, '', '', '', NULL, -6, '', '', '', NULL),
		('111', '0', 'Número de control del registro de autoridad o número normalizado', 'Número de control del registro de autoridad o número normalizado', 1, 0, '', 1, '', '', '', NULL, -6, '', '', '', NULL),
		('111', '4', 'Código de función/relación', 'Código de función/relación', 1, 0, NULL, 1, NULL, NULL, '', NULL, 0, '', '', '', NULL),
		('111', '6', 'Enlace', 'Enlace', 0, 0, NULL, 1, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('111', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 1, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('111', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 1, '', '', '', 0, -5, '', '', '', NULL),
		('111', 'a', 'Nombre de congreso/reunión o jurisdicción como elemento de entrada', 'Nombre de congreso/reunión o jurisdicción como elemento de entrada', 0, 0, NULL, 1, NULL, 'MEETI_NAME', '', NULL, 0, '', '', '', NULL),
		('111', 'b', 'Número [OBSOLETO]', 'Número [OBSOLETO]', 0, 0, NULL, 1, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('111', 'c', 'Sede del congreso/Lugar de la reunión', 'Sede del congreso/Lugar de la reunión', 1, 0, NULL, 1, NULL, NULL, '', NULL, 0, '', '', '', NULL),
		('111', 'd', 'Fecha del congreso/reunión', 'Fecha del congreso/reunión', 0, 0, NULL, 1, NULL, NULL, '', NULL, 0, '', '', '', NULL),
		('111', 'e', 'Unidad subordinada', 'Unidad subordinada', 1, 0, NULL, 1, NULL, NULL, '', NULL, 0, '', '', '', NULL),
		('111', 'f', 'Fecha de publicación/de la obra', 'Fecha de publicación/de la obra', 0, 0, NULL, 1, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('111', 'g', 'Información miscelánea', 'Información miscelánea', 1, 0, NULL, 1, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('111', 'j', 'Término indicativo de función/relación', 'Término indicativo de función/relación', 1, 0, NULL, 1, NULL, NULL, '', NULL, 0, '', '', '', NULL),
		('111', 'k', 'Subencabezamiento de forma', 'Subencabezamiento de forma', 1, 0, NULL, 1, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('111', 'l', 'Lenguaje de la obra', 'Lenguaje de la obra', 0, 0, NULL, 1, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('111', 'n', 'Número del congreso/reunión o número de parte o sección', 'Número del congreso/reunión o número de parte o sección', 1, 0, NULL, 1, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('111', 'p', 'Nombre de parte o sección de la obra', 'Nombre de parte o sección de la obra', 1, 0, NULL, 1, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('111', 'q', 'Nombre de congreso/reunión que sigue a un nombre de jurisdicción como elemento de entrada', 'Nombre de congreso/reunión que sigue a un nombre de jurisdicción como elemento de entrada', 0, 0, NULL, 1, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('111', 't', 'Título de la obra', 'Título de la obra', 0, 0, NULL, 1, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('111', 'u', 'Filiación', 'Filiación', 0, 0, NULL, 1, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('130', '0', 'Número de control del registro de autoridad o número normalizado', 'Número de control del registro de autoridad o número normalizado', 1, 0, '', 1, '', '', '', NULL, -6, '', '', '', NULL),
		('130', '6', 'Enlace', 'Enlace', 0, 0, NULL, 1, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('130', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 1, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('130', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 1, '', '', '', 0, -5, '', '', '', NULL),
		('130', 'a', 'Título uniforme', 'Título uniforme', 0, 0, NULL, 1, NULL, 'UNIF_TITLE', '', NULL, -1, '', '''130o'',''130m'',''130r'',''130s'',''130d'',''130k'',''130n'',''130p'',''130g'',''130l'',''130f'',''130h'',''130t''', '', NULL),
		('130', 'd', 'Fecha de la firma de un tratado', 'Fecha de la firma de un tratado', 1, 0, NULL, 1, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('130', 'f', 'Fecha de publicación/de la obra', 'Fecha de publicación/de la obra', 0, 0, NULL, 1, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('130', 'g', 'Información miscelánea', 'Información miscelánea', 1, 0, NULL, 1, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('130', 'h', 'Medio', 'Medio', 0, 0, NULL, 1, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('130', 'k', 'Subencabezamiento de forma', 'Subencabezamiento de forma', 1, 0, NULL, 1, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('130', 'l', 'Lenguaje de la obra', 'Lenguaje de la obra', 0, 0, NULL, 1, NULL, NULL, '', NULL, -1, '', '', '', NULL),
		('130', 'm', 'Medio de interpretación para música', 'Medio de interpretación para música', 1, 0, NULL, 1, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('130', 'n', 'Número de parte o sección de la obra', 'Número de parte o sección de la obra', 1, 0, NULL, 1, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('130', 'o', 'Mención de arreglo para música', 'Mención de arreglo para música', 0, 0, NULL, 1, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('130', 'p', 'Nombre de parte o sección de la obra', 'Nombre de parte o sección de la obra', 1, 0, NULL, 1, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('130', 'r', 'Clave para música', 'Clave para música', 0, 0, NULL, 1, NULL, NULL, '', NULL, -1, '', '', '', NULL),
		('130', 's', 'Versión', 'Versión', 0, 0, NULL, 1, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('130', 't', 'Título de la obra', 'Título de la obra', 0, 0, NULL, 1, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('210', '2', 'Fuente', 'Fuente', 1, 0, NULL, 2, NULL, NULL, '', NULL, -1, '', '', '', NULL),
		('210', '6', 'Enlace', 'Enlace', 0, 0, NULL, 2, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('210', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 2, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('210', 'a', 'Título abreviado', 'Título abreviado', 0, 0, NULL, 2, NULL, NULL, '', NULL, -1, '', '', '', NULL),
		('210', 'b', 'Información calificativa', 'Información calificativa', 0, 0, NULL, 2, NULL, NULL, '', NULL, -1, '', '', '', NULL),
		('211', '6', 'Enlace', 'Enlace', 0, 0, NULL, 2, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('211', 'a', 'Acrónimo o título breve', 'Acrónimo o título breve', 0, 0, NULL, 2, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('212', '6', 'Enlace', 'Enlace', 0, 0, NULL, 2, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('212', 'a', 'Acceso variante de título', 'Acceso variante de título', 0, 0, NULL, 2, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('214', '6', 'Enlace', 'Enlace', 0, 0, NULL, 2, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('214', 'a', 'Título aumentado', 'Título aumentado', 0, 0, NULL, 2, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('222', '6', 'Enlace', 'Enlace', 0, 0, NULL, 2, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('222', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 2, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('222', 'a', 'Título clave', 'Título clave', 0, 0, NULL, 2, NULL, NULL, '', NULL, -1, '', '', '', NULL),
		('222', 'b', 'Información calificativa', 'Información calificativa', 0, 0, NULL, 2, NULL, NULL, '', NULL, -1, '', '', '', NULL),
		('240', '0', 'Número de control del registro de autoridad o número normalizado', 'Número de control del registro de autoridad o número normalizado', 1, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('240', '6', 'Enlace', 'Enlace', 0, 0, '', 2, '', '', '', 0, -6, '', '', '', NULL),
		('240', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 2, '', '', '', 0, -6, '', '', '', NULL),
		('240', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 2, '', '', '', 0, -5, '', '', '', NULL),
		('240', 'a', 'Título uniforme', 'Título uniforme', 0, 0, 'biblio.unititle', 2, '', '', '', 0, -1, '', '', '', NULL),
		('240', 'd', 'Fecha de la firma de un tratado', 'Fecha de la firma de un tratado', 1, 0, '', 2, '', '', '', 0, -6, '', '', '', NULL),
		('240', 'f', 'Fecha de publicación/de la obra', 'Fecha de publicación/de la obra', 0, 0, '', 2, '', '', '', 0, -6, '', '', '', NULL),
		('240', 'g', 'Información miscelánea', 'Información miscelánea', 1, 0, '', 2, '', '', '', 0, -6, '', '', '', NULL),
		('240', 'h', 'Medio', 'Medio', 0, 0, '', 2, '', '', '', 0, -1, '', '', '', NULL),
		('240', 'k', 'Subencabezamiento de forma', 'Subencabezamiento de forma', 1, 0, '', 2, '', '', '', 0, -6, '', '', '', NULL),
		('240', 'l', 'Lenguaje de la obra', 'Lenguaje de la obra', 0, 0, '', 2, '', '', '', 0, -1, '', '', '', NULL),
		('240', 'm', 'Medio de interpretación para música', 'Medio de interpretación para música', 1, 0, '', 2, '', '', '', 0, -6, '', '', '', NULL),
		('240', 'n', 'Número de parte o sección de la obra', 'Número de parte o sección de la obra', 1, 0, '', 2, '', '', '', 0, -6, '', '', '', NULL),
		('240', 'o', 'Mención de arreglo para música', 'Mención de arreglo para música', 0, 0, '', 2, '', '', '', 0, -6, '', '', '', NULL),
		('240', 'p', 'Nombre de parte o sección de la obra', 'Nombre de parte o sección de la obra', 1, 0, '', 2, '', '', '', 0, -6, '', '', '', NULL),
		('240', 'r', 'Clave para música', 'Clave para música', 0, 0, '', 2, '', '', '', 0, -1, '', '', '', NULL),
		('240', 's', 'Versión', 'Versión', 0, 0, '', 2, '', '', '', 0, -1, '', '', '', NULL),
		('241', 'a', 'Título latinizado/romanizado', 'Título latinizado/romanizado', 0, 0, NULL, 2, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('241', 'h', 'Medio', 'Medio', 0, 0, NULL, 2, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('242', '6', 'Enlace', 'Enlace', 0, 0, NULL, 2, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('242', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 2, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('242', 'a', 'Título', 'Título', 0, 0, NULL, 2, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('242', 'b', 'Resto del título', 'Resto del título', 0, 0, NULL, 2, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('242', 'c', 'Mención de responsabilidad, etc.', 'Mención de responsabilidad, etc.', 0, 0, NULL, 2, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('242', 'd', 'Designación de sección (BK AM MP MU VM SE) [OBSOLETO]', 'Designación de sección (BK AM MP MU VM SE) [OBSOLETO]', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('242', 'e', 'Nombre de parte/sección (BK AM MP MU VM SE) [OBSOLETO]', 'Nombre de parte/sección (BK AM MP MU VM SE) [OBSOLETO]', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('242', 'h', 'Medio', 'Medio', 0, 0, NULL, 2, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('242', 'n', 'Número de parte o sección de la obra', 'Número de parte o sección de la obra', 1, 0, NULL, 2, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('242', 'p', 'Nombre de parte o sección de la obra', 'Nombre de parte o sección de la obra', 1, 0, NULL, 2, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('242', 'y', 'Código de lengua/lenguaje del título traducido', 'Código de lengua/lenguaje del título traducido', 0, 0, NULL, 2, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('243', '6', 'Enlace', 'Enlace', 0, 0, '', 2, '', '', '', 0, -6, '', '', '', NULL),
		('243', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 2, '', '', '', 0, -6, '', '', '', NULL),
		('243', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 2, '', '', '', 0, -5, '', '', '', NULL),
		('243', 'a', 'Título uniforme', 'Título uniforme', 0, 0, '', 2, '', '', '', 1, -1, '', '', '', NULL),
		('243', 'd', 'Fecha de la firma de un tratado', 'Fecha de la firma de un tratado', 1, 0, '', 2, '', '', '', 0, -6, '', '', '', NULL),
		('243', 'f', 'Fecha de publicación/de la obra', 'Fecha de publicación/de la obra', 0, 0, '', 2, '', '', '', 0, -6, '', '', '', NULL),
		('243', 'g', 'Información miscelánea', 'Información miscelánea', 1, 0, '', 2, '', '', '', 0, -6, '', '', '', NULL),
		('243', 'h', 'Medio', 'Medio', 0, 0, '', 2, '', '', '', 0, -1, '', '', '', NULL),
		('243', 'k', 'Subencabezamiento de forma', 'Subencabezamiento de forma', 1, 0, '', 2, '', '', '', 0, -6, '', '', '', NULL),
		('243', 'l', 'Lenguaje de la obra', 'Lenguaje de la obra', 0, 0, '', 2, '', '', '', 0, -1, '', '', '', NULL),
		('243', 'm', 'Medio de interpretación para música', 'Medio de interpretación para música', 1, 0, '', 2, '', '', '', 0, -6, '', '', '', NULL),
		('243', 'n', 'Número de parte o sección de la obra', 'Número de parte o sección de la obra', 1, 0, '', 2, '', '', '', 0, -6, '', '', '', NULL),
		('243', 'o', 'Mención de arreglo para música', 'Mención de arreglo para música', 0, 0, '', 2, '', '', '', 0, -6, '', '', '', NULL),
		('243', 'p', 'Nombre de parte o sección de la obra', 'Nombre de parte o sección de la obra', 1, 0, '', 2, '', '', '', 0, -6, '', '', '', NULL),
		('243', 'r', 'Clave para música', 'Clave para música', 0, 0, '', 2, '', '', '', 0, -6, '', '', '', NULL),
		('243', 's', 'Versión', 'Versión', 0, 0, '', 2, '', '', '', 0, -1, '', '', '', NULL),
		('245', '6', 'Enlace', 'Enlace', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('245', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('245', 'a', 'Título', 'Título', 0, 1, 'biblio.title', 2, '', '', '', NULL, 0, '', '''245b'',''245f'',''245g'',''245k'',''245n'',''245p'',''245s'',''245h'',''246i'',''246a'',''246b'',''246f'',''246g'',''246n'',''246p'',''246h'',''242a'',''242b'',''242n'',''242p'',''242h'',''505t''', '', NULL),
		('245', 'b', 'Resto del título', 'Resto del título', 0, 0, 'bibliosubtitle.subtitle', 2, '', '', '', NULL, 0, '', '', '', NULL),
		('245', 'c', 'Mención de responsabilidad, etc.', 'Mención de responsabilidad, etc.', 0, 0, '', 2, '', '', '', NULL, 0, '', '', '', NULL),
		('245', 'd', 'Designación de sección/parte/serie (SE) [OBSOLETO]', 'Designación de sección/parte/serie (SE) [OBSOLETO]', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('245', 'e', 'Nombre de parte/sección/serie', 'Nombre de parte/sección/serie', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('245', 'f', 'Fechas extremas/inclusivas', 'Fechas extremas/inclusivas', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('245', 'g', 'Fechas predominantes', 'Fechas predominantes', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('245', 'h', 'Medio', 'Medio', 0, 0, '', 2, '', '', '', NULL, 0, '', '', '', NULL),
		('245', 'k', 'Forma', 'Forma', 1, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('245', 'n', 'Número de parte o sección de la obra', 'Número de parte o sección de la obra', 1, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('245', 'p', 'Nombre de parte o sección de la obra', 'Nombre de parte o sección de la obra', 1, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('245', 's', 'Versión', 'Versión', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('246', '5', 'Institución que aplica el campo', 'Institución que aplica el campo', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('246', '6', 'Enlace', 'Enlace', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('246', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('246', 'a', 'Título propio/Titulo breve', 'Título propio/Titulo breve', 0, 0, '', 2, '', '', '', NULL, -1, '', '', '', NULL),
		('246', 'b', 'Resto del título', 'Resto del título', 0, 0, '', 2, '', '', '', NULL, -1, '', '', '', NULL),
		('246', 'd', 'Designación de sección/parte/serie (SE) [OBSOLETO]', 'Designación de sección/parte/serie (SE) [OBSOLETO]', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('246', 'e', 'Nombre de parte/sección/serie', 'Nombre de parte/sección/serie', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('246', 'f', 'Fecha o designación secuencial', 'Fecha o designación secuencial', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('246', 'g', 'Información miscelánea', 'Información miscelánea', 1, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('246', 'h', 'Medio', 'Medio', 0, 0, '', 2, '', '', '', NULL, -1, '', '', '', NULL),
		('246', 'i', 'Texto de visualización', 'Texto de visualización', 0, 0, '', 2, '', '', '', NULL, -1, '', '', '', NULL),
		('246', 'n', 'Número de parte o sección de la obra', 'Número de parte o sección de la obra', 1, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('246', 'p', 'Nombre de parte o sección de la obra', 'Nombre de parte o sección de la obra', 1, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('247', '6', 'Enlace', 'Enlace', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('247', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('247', 'a', 'Título', 'Título', 0, 0, '', 2, '', '', '', NULL, -1, '', '', '', NULL),
		('247', 'b', 'Resto del título', 'Resto del título', 0, 0, '', 2, '', '', '', NULL, -1, '', '', '', NULL),
		('247', 'd', 'Designación de sección (SE) [OBSOLETO]', 'Designación de sección (SE) [OBSOLETO]', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('247', 'e', 'Nombre de la parte/sección (SE) [OBSOLETO]', 'Nombre de la parte/sección (SE) [OBSOLETO]', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('247', 'f', 'Fecha o designación secuencial', 'Fecha o designación secuencial', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('247', 'g', 'Información miscelánea', 'Información miscelánea', 1, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('247', 'h', 'Medio', 'Medio', 0, 0, '', 2, '', '', '', NULL, -1, '', '', '', NULL),
		('247', 'n', 'Número de parte o sección de la obra', 'Número de parte o sección de la obra', 1, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('247', 'p', 'Nombre de parte o sección de la obra', 'Nombre de parte o sección de la obra', 1, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('247', 'x', 'Número Internacional Normalizado para Publicaciones Seriadas', 'Número Internacional Normalizado para Publicaciones Seriadas', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('250', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('250', '6', 'Enlace', 'Enlace', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('250', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('250', 'a', 'Mención de edición', 'Mención de edición', 0, 0, 'biblioitems.editionstatement', 2, '', '', '', NULL, 0, '', '', '', NULL),
		('250', 'b', 'Resto de la mención de edición', 'Resto de la mención de edición', 0, 0, '', 2, '', '', '', NULL, 0, '', '', '', NULL),
		('254', '6', 'Enlace', 'Enlace', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('254', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('254', 'a', 'Mención de presentación musical', 'Mención de presentación musical', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('255', '6', 'Enlace', 'Enlace', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('255', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('255', 'a', 'Mención de escala', 'Mención de escala', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('255', 'b', 'Mención de proyección', 'Mención de proyección', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('255', 'c', 'Mención de coordenadas', 'Mención de coordenadas', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('255', 'd', 'Mención de zona', 'Mención de zona', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('255', 'e', 'Mención de equinoccio', 'Mención de equinoccio', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('255', 'f', 'Coordenadas del anillo-G exterior', 'Coordenadas del anillo-G exterior', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('255', 'g', 'Coordenadas del anillo-G de exclusión', 'Coordenadas del anillo-G de exclusión', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('256', '6', 'Enlace', 'Enlace', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('256', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('256', 'a', 'Características del archivo de ordenador', 'Características del archivo de ordenador', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('257', '2', 'Fuente', 'Fuente', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('257', '6', 'Enlace', 'Enlace', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('257', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('257', 'a', 'País de la entidad productora', 'País de la entidad productora', 1, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('258', '6', 'Enlace', 'Enlace', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('258', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('258', 'a', 'Jurisdicción emisora', 'Jurisdicción emisora', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('258', 'b', 'Valor facial/Denominación', 'Valor facial/Denominación', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('260', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('260', '6', 'Enlace', 'Enlace', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('260', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('260', 'a', 'Lugar de publicación, distribución, etc.', 'Lugar de publicación, distribución, etc.', 1, 0, 'biblioitems.place', 2, '', '', '', NULL, 0, '', '', '', NULL),
		('260', 'b', 'Nombre del editor, distribuidor, etc.', 'Nombre del editor, distribuidor, etc.', 1, 0, 'biblioitems.publishercode', 2, '', '', '', NULL, 0, '', '', '', NULL),
		('260', 'c', 'Fecha de publicación, distribución, etc.', 'Fecha de publicación, distribución, etc.', 1, 0, 'biblio.copyrightdate', 2, '', '', '', NULL, 0, '', '', '', NULL),
		('260', 'd', 'Lamina o número del editor para música (Pre-RCAA 2) [OBSOLETO, CAN/MARC], [LOCAL, USA]', 'Lamina o número del editor para música (Pre-RCAA 2) [OBSOLETO, CAN/MARC], [LOCAL, USA]', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('260', 'e', 'Lugar de fabricación/manufactura', 'Lugar de fabricación/manufactura', 1, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('260', 'f', 'Fabricante', 'Fabricante', 1, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('260', 'g', 'Fecha de fabricación/manufactura', 'Fecha de fabricación/manufactura', 1, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('260', 'k', 'Identificación/número de fabricación/manufactura [OBSOLETO, CAN/MARC]', 'Identificación/número de fabricación/manufactura [OBSOLETO, CAN/MARC]', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('260', 'l', 'Matriz y/o número tomado [OBSOLETO, CAN/MARC]', 'Matriz y/o número tomado [OBSOLETO, CAN/MARC]', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('261', '6', 'Enlace', 'Enlace', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('261', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('261', 'a', 'Compañía productora', 'Compañía productora', 1, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('261', 'b', 'Compañía editora (distribuidor primario)', 'Compañía editora (distribuidor primario)', 1, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('261', 'c', 'Fecha de producción, publicación, etc.', 'Fecha de producción, publicación, etc.', 1, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('261', 'd', 'Fecha de producción, publicación, etc.', 'Fecha de producción, publicación, etc.', 1, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('261', 'e', 'Productor contractual', 'Productor contractual', 1, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('261', 'f', 'Lugar de producción, publicación, etc.', 'Lugar de producción, publicación, etc.', 1, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('262', '6', 'Enlace', 'Enlace', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('262', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('262', 'a', 'Lugar de producción, publicación, etc.', 'Lugar de producción, publicación, etc.', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('262', 'b', 'Nombre de editor o tratado', 'Nombre de editor o tratado', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('262', 'c', 'Fecha de producción, publicación, etc.', 'Fecha de producción, publicación, etc.', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('262', 'k', 'Indentificador de publicación seriada', 'Indentificador de publicación seriada', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('262', 'l', 'Matriz y/o número tomado', 'Matriz y/o número tomado', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('263', '6', 'Enlace', 'Enlace', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('263', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('263', 'a', 'Fecha proyectada de publicación', 'Fecha proyectada de publicación', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('264', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('264', '6', 'Enlace', 'Enlace', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('264', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('264', 'a', 'Producción, publicación, distribución, fabricación y copyright', 'Producción, publicación, distribución, fabricación y copyright', 1, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('264', 'b', 'Nombre del de productor, editor, distribuidor, fabricante', 'Nombre del de productor, editor, distribuidor, fabricante', 1, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('264', 'c', 'Fecha de producción, publicación, distribución, fabricación o copyright', 'Fecha de producción, publicación, distribución, fabricación o copyright', 1, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('265', '6', 'Enlace [OBSOLETO]', 'Enlace [OBSOLETO]', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('265', 'a', 'Fuente de adquisición/dirección de suscripción [OBSOLETO]', 'Fuente de adquisición/dirección de suscripción [OBSOLETO]', 1, 0, '', 2, '', '', '', NULL, -6, '', '', '', NULL),
		('270', '4', 'Código de función/relación', 'Código de función/relación', 1, 0, NULL, 2, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('270', '6', 'Enlace', 'Enlace', 0, 0, NULL, 2, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('270', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 2, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('270', 'a', 'Dirección', 'Dirección', 1, 0, NULL, 2, NULL, NULL, '', NULL, -1, '', '', '', NULL),
		('270', 'b', 'Ciudad', 'Ciudad', 0, 0, NULL, 2, NULL, NULL, '', NULL, -1, '', '', '', NULL),
		('270', 'c', 'Estado o provincia', 'Estado o provincia', 0, 0, NULL, 2, NULL, NULL, '', NULL, -1, '', '', '', NULL),
		('270', 'd', 'País', 'País', 0, 0, NULL, 2, NULL, NULL, '', NULL, -1, '', '', '', NULL),
		('270', 'e', 'Código postal', 'Código postal', 0, 0, NULL, 2, NULL, NULL, '', NULL, -1, '', '', '', NULL),
		('270', 'f', 'Términos que preceden al nombre', 'Términos que preceden al nombre', 0, 0, NULL, 2, NULL, NULL, '', NULL, -1, '', '', '', NULL),
		('270', 'g', 'Nombre', 'Nombre', 0, 0, NULL, 2, NULL, NULL, '', NULL, -1, '', '', '', NULL),
		('270', 'h', 'Términos que siguen al nombre', 'Términos que siguen al nombre', 0, 0, NULL, 2, NULL, NULL, '', NULL, -1, '', '', '', NULL),
		('270', 'i', 'Tipo de dirección', 'Tipo de dirección', 0, 0, NULL, 2, NULL, NULL, '', NULL, -1, '', '', '', NULL),
		('270', 'j', 'Número de teléfono especial', 'Número de teléfono especial', 1, 0, NULL, 2, NULL, NULL, '', NULL, -1, '', '', '', NULL),
		('270', 'k', 'Número de teléfono', 'Número de teléfono', 1, 0, NULL, 2, NULL, NULL, '', NULL, -1, '', '', '', NULL),
		('270', 'l', 'Número de fax', 'Número de fax', 1, 0, NULL, 2, NULL, NULL, '', NULL, -1, '', '', '', NULL),
		('270', 'm', 'Dirección de correo electrónico', 'Dirección de correo electrónico', 1, 0, NULL, 2, NULL, NULL, '', NULL, -1, '', '', '', NULL),
		('270', 'n', 'Número TDD o TTY', 'Número TDD o TTY', 1, 0, NULL, 2, NULL, NULL, '', NULL, -1, '', '', '', NULL),
		('270', 'p', 'Persona de contacto', 'Persona de contacto', 1, 0, NULL, 2, NULL, NULL, '', NULL, -1, '', '', '', NULL),
		('270', 'q', 'Cargo de la persona de contacto', 'Cargo de la persona de contacto', 1, 0, NULL, 2, NULL, NULL, '', NULL, -1, '', '', '', NULL),
		('270', 'r', 'Horario', 'Horario', 1, 0, NULL, 2, NULL, NULL, '', NULL, -1, '', '', '', NULL),
		('270', 'z', 'Nota pública', 'Nota pública', 1, 0, NULL, 2, NULL, NULL, '', NULL, -1, '', '', '', NULL),
		('300', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('300', '6', 'Enlace', 'Enlace', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('300', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('300', 'a', 'Extensión', 'Extensión', 1, 0, 'biblioitems.pages', 3, '', '', '', NULL, 0, '', '', '', NULL),
		('300', 'b', 'Otras características físicas', 'Otras características físicas', 0, 0, 'biblioitems.illus', 3, '', '', '', 0, 0, '', '', '', NULL),
		('300', 'c', 'Dimensiones', 'Dimensiones', 1, 0, 'biblioitems.size', 3, '', '', '', NULL, 0, '', '', '', NULL),
		('300', 'd', 'Material acompañante/anejo [OBSOLETO, CAN/MARC]', 'Material acompañante/anejo [OBSOLETO, CAN/MARC]', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('300', 'e', 'Material acompañante/anejo', 'Material acompañante/anejo', 0, 0, '', 3, '', '', '', NULL, 0, '', '', '', NULL),
		('300', 'f', 'Tipo de unidad', 'Tipo de unidad', 1, 0, '', 3, '', '', '', NULL, 0, '', '', '', NULL),
		('300', 'g', 'Tamaño de la unidad', 'Tamaño de la unidad', 1, 0, '', 3, '', '', '', NULL, 0, '', '', '', NULL),
		('300', 'k', 'Velocidad [Videodiscos, pre-RCAA2 registro solamente] [OBSOLETO, CAN/MARC]', 'Velocidad [Videodiscos, pre-RCAA2 registro solamente] [OBSOLETO, CAN/MARC]', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('300', 'm', 'Identificador/número de fabricador [pre-RCAA2 solo registros] [OBSOLETO, CAN/MARC]', 'Identificador/número de fabricador [pre-RCAA2 solo registros] [OBSOLETO, CAN/MARC]', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('300', 'n', 'Matriz y/o número tomado [Grabaciones sonoras, pre-RCAA2 solo registros] [OBSOLETO, CAN/MARC]', 'Matriz y/o número tomado [Grabaciones sonoras, pre-RCAA2 solo registros] [OBSOLETO, CAN/MARC]', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('301', 'a', 'Extensión del ítem', 'Extensión del ítem', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('301', 'b', 'Características de sonido', 'Características de sonido', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('301', 'c', 'Características de color', 'Características de color', 0, 0, '', 3, '', '', NULL, NULL, -6, '', '', '', NULL),
		('301', 'd', 'Dimensiones', 'Dimensiones', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('301', 'e', 'Características de sonido', 'Características de sonido', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('301', 'f', 'Velocidad', 'Velocidad', 0, 0, '', 3, '', '', NULL, NULL, -6, '', '', '', NULL),
		('302', 'a', 'Número de páginas', 'Número de páginas', 0, 0, '', 3, '', '', NULL, NULL, -6, '', '', '', NULL),
		('303', 'a', 'Número de unidad', 'Número de unidad', 0, 0, '', 3, '', '', NULL, NULL, -6, '', '', '', NULL),
		('304', 'a', 'Película/secuencia linear', 'Película/secuencia linear', 0, 0, '', 3, '', '', NULL, NULL, -6, '', '', '', NULL),
		('305', '6', 'Enlace', 'Enlace', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('305', 'a', 'Extensión', 'Extensión', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('305', 'b', 'Otras características físicas', 'Otras características físicas', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('305', 'c', 'Dimensiones', 'Dimensiones', 0, 0, '', 3, '', '', NULL, NULL, -6, '', '', '', NULL),
		('305', 'd', 'Microsurco o estándar', 'Microsurco o estándar', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('305', 'e', 'Estereofónico, monoaural', 'Estereofónico, monoaural', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('305', 'f', 'Número de pistas', 'Número de pistas', 0, 0, '', 3, '', '', NULL, NULL, -6, '', '', '', NULL),
		('305', 'm', 'Indentificador de publicación seriada', 'Indentificador de publicación seriada', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('305', 'n', 'Matriz y/o número tomado', 'Matriz y/o número tomado', 0, 0, '', 3, '', '', NULL, NULL, -6, '', '', '', NULL),
		('306', '6', 'Enlace', 'Enlace', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('306', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('306', 'a', 'Tiempo de reproducción/duración', 'Tiempo de reproducción/duración', 1, 0, '', 3, '', '', '', NULL, 0, '', '', '', NULL),
		('307', '6', 'Enlace', 'Enlace', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('307', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('307', 'a', 'Horario', 'Horario', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('307', 'b', 'Información adicional', 'Información adicional', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('308', '6', 'Enlace', 'Enlace', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('308', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('308', 'a', 'Número de carretes', 'Número de carretes', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('308', 'b', 'Película/Secuencia', 'Película/Secuencia', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('308', 'c', 'Características de sonido', 'Características de sonido', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('308', 'd', 'Características de color', 'Características de color', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('308', 'e', 'Ancho', 'Ancho', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('308', 'f', 'Formato de presentación', 'Formato de presentación', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('310', '6', 'Enlace', 'Enlace', 0, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('310', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('310', 'a', 'Periodicidad actual', 'Periodicidad actual', 0, 0, NULL, 3, NULL, NULL, '', NULL, -1, '', '', '', NULL),
		('310', 'b', 'Fecha de comienzo de la periodicidad actual', 'Fecha de comienzo de la periodicidad actual', 0, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('315', '6', 'Enlace', 'Enlace', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('315', 'a', 'Periodicidad', 'Periodicidad', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('315', 'b', 'Fechas de periodicidad', 'Fechas de periodicidad', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('321', '6', 'Enlace', 'Enlace', 0, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('321', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('321', 'a', 'Periodicidad anterior', 'Periodicidad anterior', 0, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('321', 'b', 'Fechas de la periodicidad anterior', 'Fechas de la periodicidad anterior', 0, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('336', '0', 'Número de control del registro de autoridad o número normalizado', 'Número de control del registro de autoridad o número normalizado', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('336', '2', 'Fuente', 'Fuente', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('336', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('336', '6', 'Enlace', 'Enlace', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('336', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('336', 'a', 'Término de tipo de contenido', 'Término de tipo de contenido', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('336', 'b', 'Código de tipo de contenido', 'Código de tipo de contenido', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('337', '0', 'Número de control del registro de autoridad o número normalizado', 'Número de control del registro de autoridad o número normalizado', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('337', '2', 'Fuente', 'Fuente', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('337', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('337', '6', 'Enlace', 'Enlace', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('337', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('337', 'a', 'Nombre/término del tipo de medio', 'Nombre/término del tipo de medio', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('337', 'b', 'Código del tipo de medio', 'Código del tipo de medio', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('338', '0', 'Número de control del registro de autoridad o número normalizado', 'Número de control del registro de autoridad o número normalizado', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('338', '2', 'Fuente', 'Fuente', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('338', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('338', '6', 'Enlace', 'Enlace', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('338', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('338', 'a', 'Nombre/término del tipo de soporte', 'Nombre/término del tipo de soporte', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('338', 'b', 'Código del tipo de soporte', 'Código del tipo de soporte', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('340', '0', 'Número de control del registro de autoridad o número normalizado', 'Número de control del registro de autoridad o número normalizado', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('340', '2', 'Fuente', 'Fuente', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('340', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('340', '6', 'Enlace', 'Enlace', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('340', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('340', 'a', 'Base y configuración del material', 'Base y configuración del material', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('340', 'b', 'Dimensiones', 'Dimensiones', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('340', 'c', 'Materiales aplicados a la superficie', 'Materiales aplicados a la superficie', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('340', 'd', 'Técnica en que se registra la información', 'Técnica en que se registra la información', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('340', 'e', 'Soporte', 'Soporte', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('340', 'f', 'Coeficiente/proporción de la producción', 'Coeficiente/proporción de la producción', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('340', 'h', 'Localización interna', 'Localización interna', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('340', 'i', 'Especificaciones técnicas del medio', 'Especificaciones técnicas del medio', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('340', 'j', 'Generación', 'Generación', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('340', 'k', 'Diseño', 'Diseño', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('340', 'm', 'Formato del libro', 'Formato del libro', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('340', 'n', 'Tamaño de fuente', 'Tamaño de fuente', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('340', 'o', 'Polaridad', 'Polaridad', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('342', '2', 'Método de referencia utilizado', 'Método de referencia utilizado', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('342', '6', 'Enlace', 'Enlace', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('342', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('342', 'a', 'Nombre', 'Nombre', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('342', 'b', 'Unidades de coordenadas o unidades de distancia', 'Unidades de coordenadas o unidades de distancia', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('342', 'c', 'Resolución en latitud', 'Resolución en latitud', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('342', 'd', 'Resolución en longitud', 'Resolución en longitud', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('342', 'e', 'Paralelo estándar o latitud de línea oblicua', 'Paralelo estándar o latitud de línea oblicua', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('342', 'f', 'Longitud de línea oblicua', 'Longitud de línea oblicua', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('342', 'g', 'Longitud del meridiano central o centro de la proyección', 'Longitud del meridiano central o centro de la proyección', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('342', 'h', 'Latitud del centro de la proyección u origen de la proyección', 'Latitud del centro de la proyección u origen de la proyección', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('342', 'i', 'Falsa abscisa', 'Falsa abscisa', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('342', 'j', 'Falsa ordenada', 'Falsa ordenada', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('342', 'k', 'Factor de escala', 'Factor de escala', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('342', 'l', 'Altura del punto de vista sobre la superficie', 'Altura del punto de vista sobre la superficie', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('342', 'm', 'Ángulo acimutal', 'Ángulo acimutal', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('342', 'n', 'Longitud del acimut del punto de medida o longitud vertical recta desde el polo', 'Longitud del acimut del punto de medida o longitud vertical recta desde el polo', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('342', 'o', 'Número de Landsat y de trayectoria', 'Número de Landsat y de trayectoria', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('342', 'p', 'Identificador de zona', 'Identificador de zona', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('342', 'q', 'Nombre del elipsoide', 'Nombre del elipsoide', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('342', 'r', 'Semieje mayor', 'Semieje mayor', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('342', 's', 'Denominador de proporción plana', 'Denominador de proporción plana', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('342', 't', 'Resolución vertical', 'Resolución vertical', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('342', 'u', 'Método de codificación vertical', 'Método de codificación vertical', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('342', 'v', 'Proyección plana local, local u otra, o descripción de la cuadrícula', 'Proyección plana local, local u otra, o descripción de la cuadrícula', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('342', 'w', 'Información de georeferencia plana local o local', 'Información de georeferencia plana local o local', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('343', '6', 'Enlace', 'Enlace', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('343', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('343', 'a', 'Método de codificación de coordenadas planas', 'Método de codificación de coordenadas planas', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('343', 'b', 'Unidades de distancia plana', 'Unidades de distancia plana', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('343', 'c', 'Resolución de la abscisa', 'Resolución de la abscisa', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('343', 'd', 'Resolución de la ordenada', 'Resolución de la ordenada', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('343', 'e', 'Resolución de distancia', 'Resolución de distancia', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('343', 'f', 'Resolución de orientación', 'Resolución de orientación', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('343', 'g', 'Unidades de orientación', 'Unidades de orientación', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('343', 'h', 'Dirección de referencia de la orientación', 'Dirección de referencia de la orientación', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('343', 'i', 'Meridiano de referencia de la orientación', 'Meridiano de referencia de la orientación', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('344', '0', 'Número de control del registro de autoridad o número normalizado', 'Número de control del registro de autoridad o número normalizado', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('344', '2', 'Fuente', 'Fuente', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('344', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('344', '6', 'Enlace', 'Enlace', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('344', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('344', 'a', 'Tipo de grabación', 'Tipo de grabación', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('344', 'b', 'Medio de grabación', 'Medio de grabación', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('344', 'c', 'Velocidad de reproducción', 'Velocidad de reproducción', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('344', 'd', 'Características del surco', 'Características del surco', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('344', 'e', 'Configuración de la pista', 'Configuración de la pista', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('344', 'f', 'Configuración de la cinta', 'Configuración de la cinta', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('344', 'g', 'Configuración de los canales de reproducción del sonido', 'Configuración de los canales de reproducción del sonido', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('344', 'h', 'Características especiales de reproducción', 'Características especiales de reproducción', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('345', '0', 'Número de control del registro de autoridad o número normalizado', 'Número de control del registro de autoridad o número normalizado', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('345', '2', 'Fuente', 'Fuente', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('345', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('345', '6', 'Enlace', 'Enlace', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('345', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('345', 'a', 'Formato de presentación', 'Formato de presentación', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('345', 'b', 'Velocidad de proyección', 'Velocidad de proyección', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('346', '0', 'Número de control del registro de autoridad o número normalizado', 'Número de control del registro de autoridad o número normalizado', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('346', '2', 'Fuente', 'Fuente', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('346', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('346', '6', 'Enlace', 'Enlace', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('346', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('346', 'a', 'Formato de vídeo', 'Formato de vídeo', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('346', 'b', 'Estándar de emisión', 'Estándar de emisión', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('347', 'a', 'Tipo de archivo', 'Tipo de archivo', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('347', '0', 'Número de control del registro de autoridad o número normalizado', 'Número de control del registro de autoridad o número normalizado', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('347', '2', 'Fuente', 'Fuente', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('347', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('347', '6', 'Enlace', 'Enlace', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('347', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('347', 'b', 'Formato de codificación', 'Formato de codificación', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('347', 'c', 'Tamaño de archivo', 'Tamaño de archivo', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('347', 'd', 'Resolución', 'Resolución', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('347', 'e', 'Codificación regional', 'Codificación regional', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('347', 'f', 'Tasa de bits de codificada', 'Tasa de bits de codificada', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('348', 'a', 'Término del formato de la música notada', 'Término del formato de la música notada', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('348', 'b', 'Código del formato de la música notada', 'Código del formato de la música notada', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('348', '0', 'Número de control del registro de autoridad o número normalizado', 'Número de control del registro de autoridad o número normalizado', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('348', '2', 'Fuente del término', 'Fuente del término', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('348', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('348', '6', 'Enlace', 'Enlace', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('348', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('350', '6', 'Enlace', 'Enlace', 0, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('350', 'a', 'Precio', 'Precio', 1, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('350', 'b', 'Formato de la publicación', 'Formato de la publicación', 1, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('351', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('351', '6', 'Enlace', 'Enlace', 0, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('351', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('351', 'a', 'Organización', 'Organización', 1, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('351', 'b', 'Ordenación', 'Ordenación', 1, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('351', 'c', 'Nivel jerárquico', 'Nivel jerárquico', 0, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('352', '6', 'Enlace', 'Enlace', 0, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('352', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('352', 'a', 'Método de referencia directo', 'Método de referencia directo', 0, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('352', 'b', 'Tipo de objeto', 'Tipo de objeto', 1, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('352', 'c', 'Contador de objetos', 'Contador de objetos', 1, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('352', 'd', 'Contador de filas', 'Contador de filas', 0, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('352', 'e', 'Contador de columnas', 'Contador de columnas', 0, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('352', 'f', 'Contador vertical', 'Contador vertical', 0, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('352', 'g', 'Nivel de topología VPF', 'Nivel de topología VPF', 0, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('352', 'i', 'Descripción de una referencia indirecta', 'Descripción de una referencia indirecta', 0, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('352', 'q', 'Formato de la imagen digital', 'Formato de la imagen digital', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('355', '6', 'Enlace', 'Enlace', 0, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('355', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('355', 'a', 'Clasificación de seguridad', 'Clasificación de seguridad', 0, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('355', 'b', 'Instrucciones de utilización', 'Instrucciones de utilización', 1, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('355', 'c', 'Información para la difusión externa', 'Información para la difusión externa', 1, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('355', 'd', 'Información sobre reducción de nivel de seguridad o desclasificación', 'Información sobre reducción de nivel de seguridad o desclasificación', 0, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('355', 'e', 'Sistema de clasificación', 'Sistema de clasificación', 0, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('355', 'f', 'Código del país de origen', 'Código del país de origen', 0, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('355', 'g', 'Fecha de reducción del nivel de seguridad', 'Fecha de reducción del nivel de seguridad', 0, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('355', 'h', 'Fecha de desclasificación', 'Fecha de desclasificación', 0, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('355', 'j', 'Autorización', 'Autorización', 1, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('357', '6', 'Enlace', 'Enlace', 0, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('357', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('357', 'a', 'Término de control del emisor', 'Término de control del emisor', 0, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('357', 'b', 'Agencia emisora', 'Agencia emisora', 1, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('357', 'c', 'Destinatarios autorizados de los documentos', 'Destinatarios autorizados de los documentos', 1, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('357', 'g', 'Otras restricciones', 'Otras restricciones', 1, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('359', 'a', 'Precio de alquiler', 'Precio de alquiler', 0, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('362', '6', 'Enlace', 'Enlace', 0, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('362', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('362', 'a', 'Fecha de publicación y/o designación secuencial', 'Fecha de publicación y/o designación secuencial', 0, 0, 'biblioitems.volumedesc', 3, NULL, NULL, '', NULL, -1, '', '', '', NULL),
		('362', 'z', 'Fuente de información', 'Fuente de información', 0, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('363', '6', 'Enlace', 'Enlace', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('363', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('363', 'a', 'Primer nivel de enumeración', 'Primer nivel de enumeración', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('363', 'b', 'Segundo nivel de enumeración', 'Segundo nivel de enumeración', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('363', 'c', 'Tercer nivel de enumeración', 'Tercer nivel de enumeración', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('363', 'd', 'Cuarto nivel de enumeración', 'Cuarto nivel de enumeración', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('363', 'e', 'Quinto nivel de enumeración', 'Quinto nivel de enumeración', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('363', 'f', 'Sexto nivel de enumeración', 'Sexto nivel de enumeración', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('363', 'g', 'Esquema de numeración alternativo, primer nivel de enumeración', 'Esquema de numeración alternativo, primer nivel de enumeración', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('363', 'h', 'Esquema de numeración alternativo, segundo nivel de enumeración', 'Esquema de numeración alternativo, segundo nivel de enumeración', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('363', 'i', 'Primer nivel de cronología', 'Primer nivel de cronología', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('363', 'j', 'Segundo nivel de cronología', 'Segundo nivel de cronología', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('363', 'k', 'Tercer nivel de cronología', 'Tercer nivel de cronología', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('363', 'l', 'Cuarto nivel de cronología', 'Cuarto nivel de cronología', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('363', 'm', 'Esquema de numeración alternativo, cronología', 'Esquema de numeración alternativo, cronología', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('363', 'u', 'Primer nivel de designación textual', 'Primer nivel de designación textual', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('363', 'v', 'Primer nivel de cronología, publicación', 'Primer nivel de cronología, publicación', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('363', 'x', 'Nota interna', 'Nota interna', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('363', 'z', 'Nota pública', 'Nota pública', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('365', '2', 'Fuente del código de tipo de precio', 'Fuente del código de tipo de precio', 0, 0, '', 3, '', '', '', NULL, -1, '', '', '', NULL),
		('365', '6', 'Enlace', 'Enlace', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('365', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('365', 'a', 'Código de tipo de precio', 'Código de tipo de precio', 0, 0, '', 3, '', '', '', NULL, -1, '', '', '', NULL),
		('365', 'b', 'Cantidad', 'Cantidad', 0, 0, '', 3, '', '', '', NULL, -1, '', '', '', NULL),
		('365', 'c', 'Código de moneda', 'Código de moneda', 0, 0, '', 3, '', '', '', NULL, -1, '', '', '', NULL),
		('365', 'd', 'Unidad de precio', 'Unidad de precio', 0, 0, '', 3, '', '', '', NULL, -1, '', '', '', NULL),
		('365', 'e', 'Nota sobre el precio', 'Nota sobre el precio', 0, 0, '', 3, '', '', '', NULL, -1, '', '', '', NULL),
		('365', 'f', 'Precio válido a partir de', 'Precio válido a partir de', 0, 0, '', 3, '', '', '', NULL, -1, '', '', '', NULL),
		('365', 'g', 'Precio válido hasta', 'Precio válido hasta', 0, 0, '', 3, '', '', '', NULL, -1, '', '', '', NULL),
		('365', 'h', 'Impuesto 1', 'Impuesto 1', 0, 0, '', 3, '', '', '', NULL, -1, '', '', '', NULL),
		('365', 'i', 'Impuesto 2', 'Impuesto 2', 0, 0, '', 3, '', '', '', NULL, -1, '', '', '', NULL),
		('365', 'j', 'Código ISO del país', 'Código ISO del país', 0, 0, '', 3, '', '', '', NULL, -1, '', '', '', NULL),
		('365', 'k', 'Código MARC del país', 'Código MARC del país', 0, 0, '', 3, '', '', '', NULL, -1, '', '', '', NULL),
		('365', 'm', 'Identificación de la entidad que asigna el precio', 'Identificación de la entidad que asigna el precio', 0, 0, '', 3, '', '', '', NULL, -1, '', '', '', NULL),
		('366', '2', 'Fuente del código de disponibilidad', 'Fuente del código de disponibilidad', 0, 0, '', 3, '', '', '', NULL, -1, '', '', '', NULL),
		('366', '6', 'Enlace', 'Enlace', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('366', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('366', 'a', 'Identificación abreviada del título por parte del editor', 'Identificación abreviada del título por parte del editor', 0, 0, '', 3, '', '', '', NULL, -1, '', '', '', NULL),
		('366', 'b', 'Fecha detallada de publicación', 'Fecha detallada de publicación', 0, 0, '', 3, '', '', '', NULL, -1, '', '', '', NULL),
		('366', 'c', 'Código del estado de la disponibilidad', 'Código del estado de la disponibilidad', 0, 0, '', 3, '', '', '', NULL, -1, '', '', '', NULL),
		('366', 'd', 'Próxima fecha prevista de disponibilidad', 'Próxima fecha prevista de disponibilidad', 0, 0, '', 3, '', '', '', NULL, -1, '', '', '', NULL),
		('366', 'e', 'Nota', 'Nota', 0, 0, '', 3, '', '', '', NULL, -1, '', '', '', NULL),
		('366', 'f', 'Categoría de descuento del editor', 'Categoría de descuento del editor', 0, 0, '', 3, '', '', '', NULL, -1, '', '', '', NULL),
		('366', 'g', 'Fecha en la que se agotó', 'Fecha en la que se agotó', 0, 0, '', 3, '', '', '', NULL, -1, '', '', '', NULL),
		('366', 'j', 'Código ISO del país', 'Código ISO del país', 0, 0, '', 3, '', '', '', NULL, -1, '', '', '', NULL),
		('366', 'k', 'Código MARC del país', 'Código MARC del país', 0, 0, '', 3, '', '', '', NULL, -1, '', '', '', NULL),
		('366', 'm', 'Identificación de la agencia', 'Identificación de la agencia', 0, 0, '', 3, '', '', '', NULL, -1, '', '', '', NULL),
		('370', '0', 'Número de control del registro de autoridad o número normalizado', 'Número de control del registro de autoridad o número normalizado', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('370', '2', 'Fuente del término', 'Fuente del término', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('370', '6', 'Enlace', 'Enlace', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('370', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('370', 'c', 'País asociado', 'País asociado', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('370', 'f', 'Otro lugar asociado', 'Otro lugar asociado', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('370', 'g', 'Lugar de origen de la obra', 'Lugar de origen de la obra', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('370', 's', 'Período de inicio', 'Período de inicio', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('370', 't', 'Fin de período', 'Fin de período', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('370', 'u', 'Identificador Uniforme del Recurso', 'Identificador Uniforme del Recurso', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('370', 'v', 'Fuente de información', 'Fuente de información', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('377', '2', 'Fuente', 'Fuente', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('377', '6', 'Enlace', 'Enlace', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('377', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('377', 'a', 'Código del idioma', 'Código del idioma', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('377', 'l', 'Término de lengua/lenguaje', 'Término de lengua/lenguaje', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('380', '0', 'Número de control del registro', 'Número de control del registro', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('380', '2', 'Fuente del término', 'Fuente del término', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('380', '6', 'Enlace', 'Enlace', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('380', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('380', 'a', 'Forma de la obra', 'Forma de la obra', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('381', '0', 'Número de control del registro', 'Número de control del registro', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('381', '2', 'Fuente del término', 'Fuente del término', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('381', '6', 'Enlace', 'Enlace', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('381', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('381', 'a', 'Otras características distintivas', 'Otras características distintivas', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('381', 'u', 'Identificador Uniforme del Recurso', 'Identificador Uniforme del Recurso', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('381', 'v', 'Fuente de información', 'Fuente de información', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('382', '0', 'Número de control del registro de autoridad o número normalizado', 'Número de control del registro de autoridad o número normalizado', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('382', '2', 'Fuente del término', 'Fuente del término', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('382', '6', 'Enlace', 'Enlace', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('382', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('382', 'a', 'Medio de interpretación', 'Medio de interpretación', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('382', 'b', 'Solista', 'Solista', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('382', 'd', 'Instrumento auxiliar', 'Instrumento auxiliar', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('382', 'e', 'Número de conjuntos', 'Número de conjuntos', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('382', 'n', 'Número de intérpretes de un mismo medio', 'Número de intérpretes de un mismo medio', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('382', 'p', 'Medio de interpretación alternativo', 'Medio de interpretación alternativo', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('382', 's', 'Número total de intérpretes', 'Número total de intérpretes', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('382', 'v', 'Nota', 'Nota', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('383', '2', 'Fuente', 'Fuente', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('383', '6', 'Enlace', 'Enlace', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('383', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('383', 'a', 'Número de serie', 'Número de serie', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('383', 'b', 'Número de opus', 'Número de opus', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('383', 'c', 'Número de catálogo temático', 'Número de catálogo temático', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('383', 'd', 'Código de catálogo temático', 'Código de catálogo temático', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('383', 'e', 'Editor asociado al número de serie o de opus', 'Editor asociado al número de serie o de opus', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('384', 'a', 'Tonalidad/Clave', 'Tonalidad/Clave', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('384', '6', 'Enlace', 'Enlace', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('384', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('385', '0', 'Número de control del registro de autoridad o número normalizado', 'Número de control del registro de autoridad o número normalizado', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('385', '2', 'Fuente', 'Fuente', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('385', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('385', '6', 'Enlace', 'Enlace', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('385', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('385', 'a', 'Término para el público', 'Término para el público', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('385', 'b', 'Código para el público', 'Código para el público', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('385', 'm', 'Término para el grupo demográfico', 'Término para el grupo demográfico', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('385', 'n', 'Código para el grupo demográfico', 'Código para el grupo demográfico', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('386', '0', 'Número de control del registro de autoridad o número normalizado', 'Número de control del registro de autoridad o número normalizado', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('386', '2', 'Fuente', 'Fuente', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('386', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('386', '6', 'Enlace', 'Enlace', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('386', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('386', 'a', 'Término para el creador/colaborador', 'Término para el creador/colaborador', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('386', 'b', 'Código para el creador/colaborador', 'Código para el creador/colaborador', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('386', 'm', 'Término para el grupo demográfico', 'Término para el grupo demográfico', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('386', 'n', 'Código para el grupo demográfico', 'Código para el grupo demográfico', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('388', '0', 'Número de control del registro de autoridad o número normalizado', 'Número de control del registro de autoridad o número normalizado', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('388', '2', 'Fuente del término', 'Fuente del término', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('388', '3', ' Especificación de materiales', ' Especificación de materiales', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('388', '6', ' Enlace', ' Enlace', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('388', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('388', 'a', 'Término para el periodo temporal de creación', 'Término para el periodo temporal de creación', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '', NULL),
		('400', '4', 'Código de función/relación', 'Código de función/relación', 1, 0, '', 4, '', '', '', 0, -6, '', '', '', NULL),
		('400', '6', 'Enlace', 'Enlace', 0, 0, '', 4, '', '', '', 0, -6, '', '', '', NULL),
		('400', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 4, '', '', '', 0, -6, '', '', '', NULL),
		('400', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 4, '', '', '', 0, -5, '', '', '', NULL),
		('400', 'a', 'Nombre de persona', 'Nombre de persona', 0, 0, '', 4, '', '', '', 0, -6, '', '', '', NULL),
		('400', 'b', 'Numeración', 'Numeración', 0, 0, '', 4, '', '', '', 0, -6, '', '', '', NULL),
		('400', 'c', 'Títulos y otros términos asociados al nombre', 'Títulos y otros términos asociados al nombre', 1, 0, '', 4, '', '', '', 0, -6, '', '', '', NULL),
		('400', 'd', 'Fechas asociadas al nombre', 'Fechas asociadas al nombre', 0, 0, '', 4, '', '', '', 0, -6, '', '', '', NULL),
		('400', 'e', 'Término indicativo de función/relación', 'Término indicativo de función/relación', 1, 0, '', 4, '', '', '', 0, -6, '', '', '', NULL),
		('400', 'f', 'Fecha de publicación/de la obra', 'Fecha de publicación/de la obra', 0, 0, '', 4, '', '', '', 0, -6, '', '', '', NULL),
		('400', 'g', 'Información miscelánea', 'Información miscelánea', 0, 0, '', 4, '', '', '', 0, -6, '', '', '', NULL),
		('400', 'k', 'Subencabezamiento de forma', 'Subencabezamiento de forma', 1, 0, '', 4, '', '', '', 0, -6, '', '', '', NULL),
		('400', 'l', 'Lenguaje de la obra', 'Lenguaje de la obra', 0, 0, '', 4, '', '', '', 0, -6, '', '', '', NULL),
		('400', 'n', 'Número de parte o sección de la obra', 'Número de parte o sección de la obra', 1, 0, '', 4, '', '', '', 0, -6, '', '', '', NULL),
		('400', 'p', 'Nombre de parte o sección de la obra', 'Nombre de parte o sección de la obra', 1, 0, '', 4, '', '', '', 0, -6, '', '', '', NULL),
		('400', 'q', 'Forma completa/desarrollada del nombre', 'Forma completa/desarrollada del nombre', 0, 0, '', 4, '', '', '', 0, -6, '', '', '', NULL),
		('400', 't', 'Título de la obra', 'Título de la obra', 0, 0, '', 4, '', '', '', 0, -6, '', '', '', NULL),
		('400', 'u', 'Filiación', 'Filiación', 0, 0, '', 4, '', '', '', 0, -6, '', '', '', NULL),
		('400', 'v', 'Designación de número de volumen o secuencia', 'Designación de número de volumen o secuencia', 0, 0, '', 4, '', '', '', NULL, -6, '', '', '', NULL),
		('400', 'x', 'Número Internacional Normalizado para Publicaciones Seriadas', 'Número Internacional Normalizado para Publicaciones Seriadas', 0, 0, '', 4, '', '', '', NULL, -6, '', '', '', NULL),
		('410', '4', 'Código de función/relación', 'Código de función/relación', 1, 0, '', 4, '', '', '', NULL, -6, '', '', '', NULL),
		('410', '6', 'Enlace', 'Enlace', 0, 0, '', 4, '', '', '', NULL, -6, '', '', '', NULL),
		('410', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 4, '', '', '', NULL, -6, '', '', '', NULL),
		('410', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 4, '', '', '', 0, -6, '', '', '', NULL),
		('410', 'a', 'Nombre de entidad corporativa o nombre de jurisdicción como elemento de entrada', 'Nombre de entidad corporativa o nombre de jurisdicción como elemento de entrada', 0, 0, '', 4, '', '', '', NULL, -6, '', '', '', NULL),
		('410', 'b', 'Unidad subordinada', 'Unidad subordinada', 1, 0, '', 4, '', '', '', NULL, -6, '', '', '', NULL),
		('410', 'c', 'Sede del congreso/Lugar de la reunión', 'Sede del congreso/Lugar de la reunión', 0, 0, '', 4, '', '', '', NULL, -6, '', '', '', NULL),
		('410', 'd', 'Fecha del congreso/reunión o de la firma de un tratado', 'Fecha del congreso/reunión o de la firma de un tratado', 1, 0, '', 4, '', '', '', NULL, -6, '', '', '', NULL),
		('410', 'e', 'Término indicativo de función/relación', 'Término indicativo de función/relación', 1, 0, '', 4, '', '', '', NULL, -6, '', '', '', NULL),
		('410', 'f', 'Fecha de publicación/de la obra', 'Fecha de publicación/de la obra', 0, 0, '', 4, '', '', '', NULL, -6, '', '', '', NULL),
		('410', 'g', 'Información miscelánea', 'Información miscelánea', 0, 0, '', 4, '', '', '', NULL, -6, '', '', '', NULL),
		('410', 'k', 'Subencabezamiento de forma', 'Subencabezamiento de forma', 1, 0, '', 4, '', '', '', NULL, -6, '', '', '', NULL),
		('410', 'l', 'Lenguaje de la obra', 'Lenguaje de la obra', 0, 0, '', 4, '', '', '', NULL, -6, '', '', '', NULL),
		('410', 'n', 'Número del congreso/reunión o número de parte o sección', 'Número del congreso/reunión o número de parte o sección', 1, 0, '', 4, '', '', '', NULL, -6, '', '', '', NULL),
		('410', 'p', 'Nombre de parte o sección de la obra', 'Nombre de parte o sección de la obra', 1, 0, '', 4, '', '', '', NULL, -6, '', '', '', NULL),
		('410', 't', 'Título de la obra', 'Título de la obra', 0, 0, '', 4, '', '', '', NULL, -6, '', '', '', NULL),
		('410', 'u', 'Filiación', 'Filiación', 0, 0, '', 4, '', '', '', NULL, -6, '', '', '', NULL),
		('410', 'v', 'Designación de número de volumen o secuencia', 'Designación de número de volumen o secuencia', 0, 0, '', 4, '', '', '', NULL, -6, '', '', '', NULL),
		('410', 'x', 'Número Internacional Normalizado para Publicaciones Seriadas', 'Número Internacional Normalizado para Publicaciones Seriadas', 0, 0, '', 4, '', '', '', NULL, -6, '', '', '', NULL),
		('411', '4', 'Código de función/relación', 'Código de función/relación', 1, 0, NULL, 4, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('411', '6', 'Enlace', 'Enlace', 0, 0, NULL, 4, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('411', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 4, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('411', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 4, '', '', '', 0, -5, '', '', '', NULL),
		('411', 'a', 'Nombre de congreso/reunión o jurisdicción como elemento de entrada', 'Nombre de congreso/reunión o jurisdicción como elemento de entrada', 0, 0, NULL, 4, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('411', 'b', 'Número [OBSOLETO]', 'Número [OBSOLETO]', 0, 0, NULL, 4, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('411', 'c', 'Sede del congreso/Lugar de la reunión', 'Sede del congreso/Lugar de la reunión', 0, 0, NULL, 4, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('411', 'd', 'Fecha del congreso/reunión', 'Fecha del congreso/reunión', 0, 0, NULL, 4, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('411', 'e', 'Unidad subordinada', 'Unidad subordinada', 1, 0, NULL, 4, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('411', 'f', 'Fecha de publicación/de la obra', 'Fecha de publicación/de la obra', 0, 0, NULL, 4, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('411', 'g', 'Información miscelánea', 'Información miscelánea', 0, 0, NULL, 4, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('411', 'k', 'Subencabezamiento de forma', 'Subencabezamiento de forma', 1, 0, NULL, 4, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('411', 'l', 'Lenguaje de la obra', 'Lenguaje de la obra', 0, 0, NULL, 4, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('411', 'n', 'Número del congreso/reunión o número de parte o sección', 'Número del congreso/reunión o número de parte o sección', 1, 0, NULL, 4, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('411', 'p', 'Nombre de parte o sección de la obra', 'Nombre de parte o sección de la obra', 1, 0, NULL, 4, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('411', 'q', 'Nombre de congreso/reunión que sigue a un nombre de jurisdicción como elemento de entrada', 'Nombre de congreso/reunión que sigue a un nombre de jurisdicción como elemento de entrada', 0, 0, NULL, 4, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('411', 't', 'Título de la obra', 'Título de la obra', 0, 0, NULL, 4, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('411', 'u', 'Filiación', 'Filiación', 0, 0, NULL, 4, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('411', 'v', 'Designación de número de volumen o secuencia', 'Designación de número de volumen o secuencia', 0, 0, '', 4, '', '', '', NULL, -6, '', '', '', NULL),
		('411', 'x', 'Número Internacional Normalizado para Publicaciones Seriadas', 'Número Internacional Normalizado para Publicaciones Seriadas', 0, 0, '', 4, '', '', '', NULL, -6, '', '', '', NULL),
		('440', '0', 'Número de control de registro de autoridad', 'Número de control de registro de autoridad', 1, 0, '', 4, '', '', '', NULL, -6, '', '', '', NULL),
		('440', '6', 'Enlace', 'Enlace', 0, 0, '', 4, '', '', '', NULL, -6, '', '', '', NULL),
		('440', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 4, '', '', '', NULL, -6, '', '', '', NULL),
		('440', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 4, '', '', '', 0, -5, '', '', '', NULL),
		('440', 'a', 'Título', 'Título', 0, 0, 'biblio.seriestitle', 4, '', 'UNIF_TITLE', '', NULL, 0, '', '''440n'',''440p'',''490a'',''830a'',''830n'',''830p'',''899a''', '', NULL),
		('440', 'n', 'Número de parte o sección de la obra', 'Número de parte o sección de la obra', 1, 0, 'biblioitems.number', 4, '', '', '', NULL, 0, '', '', '', NULL),
		('440', 'p', 'Nombre de parte o sección de la obra', 'Nombre de parte o sección de la obra', 1, 0, '', 4, '', '', '', NULL, 0, '', '', '', NULL),
		('440', 'v', 'Designación de volumen o secuencia', 'Designación de volumen o secuencia', 0, 0, 'biblioitems.volume', 4, '', '', '', NULL, 0, '', '', '', NULL),
		('440', 'w', 'Número de control del registro bibliográfico', 'Número de control del registro bibliográfico', 1, 0, '', 4, '', '', '', NULL, -6, '', '', '', NULL),
		('440', 'x', 'Número Internacional Normalizado para Publicaciones Seriadas', 'Número Internacional Normalizado para Publicaciones Seriadas', 0, 0, '', 4, '', '', '', NULL, 0, '', '', '', NULL),
		('490', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, '', 4, '', '', '', NULL, -6, '', '', '', NULL),
		('490', '6', 'Enlace', 'Enlace', 0, 0, '', 4, '', '', '', NULL, -6, '', '', '', NULL),
		('490', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 4, '', '', NULL, NULL, -6, '', '', '', NULL),
		('490', 'a', 'Mención de serie', 'Mención de serie', 1, 0, '', 4, '', '', '', NULL, -1, '', '', '', NULL),
		('490', 'l', 'Signatura topográfica de la Biblioteca del Congreso', 'Signatura topográfica de la Biblioteca del Congreso', 0, 0, '', 4, '', '', '', NULL, -6, '', '', '', NULL),
		('490', 'v', 'Designación de volumen o secuencia', 'Designación de volumen o secuencia', 1, 0, '', 4, '', '', '', NULL, -1, '', '', '', NULL),
		('490', 'x', 'Número Internacional Normalizado para Publicaciones Seriadas', 'Número Internacional Normalizado para Publicaciones Seriadas', 1, 0, '', 4, '', '', '', NULL, -1, '', '', '', NULL),
		('500', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('500', '5', 'Institución que aplica el campo', 'Institución que aplica el campo', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('500', '6', 'Enlace', 'Enlace', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('500', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('500', 'a', 'Nota general', 'Nota general', 0, 0, 'biblio.notes', 5, '', '', '', NULL, 0, '', '', '', NULL),
		('500', 'l', 'Signatura topográfica de la Biblioteca del Congreso (SE) [OBSOLETO]', 'Signatura topográfica de la Biblioteca del Congreso (SE) [OBSOLETO]', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('500', 'n', 'n (RLIN) [OBSOLETO]', 'n (RLIN) [OBSOLETO]', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('500', 'x', 'Número Internacional Normalizado para Publicaciones Seriadas (SE) [OBSOLETO]', 'Número Internacional Normalizado para Publicaciones Seriadas (SE) [OBSOLETO]', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('500', 'z', 'Fuente de nota de información (AM SE) [OBSOLETO]', 'Fuente de nota de información (AM SE) [OBSOLETO]', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('501', '5', 'Institución que aplica el campo', 'Institución que aplica el campo', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('501', '6', 'Enlace', 'Enlace', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('501', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('501', 'a', 'Nota de “Con”', 'Nota de “Con”', 0, 0, '', 5, '', '', '', NULL, 0, '', '', '', NULL),
		('502', '6', 'Enlace', 'Enlace', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('502', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('502', 'a', 'Nota de tesis', 'Nota de tesis', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('502', 'b', 'Tipo de título', 'Tipo de título', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('502', 'c', 'Nombre de la institución que otorga el título', 'Nombre de la institución que otorga el título', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('502', 'd', 'Año de obtención del título', 'Año de obtención del título', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('502', 'g', 'Información miscelánea', 'Información miscelánea', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('502', 'o', 'Identificador de la tesis', 'Identificador de la tesis', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('503', '8', 'Enlace', 'Enlace', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('503', 'a', 'Nota de historia bibliográfica', 'Nota de historia bibliográfica', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('504', '6', 'Enlace', 'Enlace', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('504', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('504', 'a', 'Nota de bibliografía, etc.', 'Nota de bibliografía, etc.', 0, 0, '', 5, NULL, NULL, '', NULL, 0, '', '', '', NULL),
		('504', 'b', 'Número de referencias', 'Número de referencias', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('505', '6', 'Enlace', 'Enlace', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('505', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('505', 'a', 'Nota de contenido con formato', 'Nota de contenido con formato', 0, 0, '', 5, '', '', '', NULL, 0, '', '', '', NULL),
		('505', 'g', 'Información miscelánea', 'Información miscelánea', 1, 0, '', 5, '', '', '', NULL, 0, '', '', '', NULL),
		('505', 'r', 'Mención de responsabilidad', 'Mención de responsabilidad', 1, 0, '', 5, '', '', '', NULL, 0, '', '', '', NULL),
		('505', 't', 'Título', 'Título', 1, 0, '', 5, '', '', '', NULL, 0, '', '', '', NULL),
		('505', 'u', 'Identificador Uniforme del Recurso', 'Identificador Uniforme del Recurso', 1, 0, '', 5, '', '', '', 1, 0, '', '', '', NULL),
		('506', '2', 'Fuente del término', 'Fuente del término', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('506', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('506', '5', 'Institución que aplica el campo', 'Institución que aplica el campo', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('506', '6', 'Enlace', 'Enlace', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('506', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('506', 'a', 'Limitaciones de acceso', 'Limitaciones de acceso', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('506', 'b', 'Autoridad competente/Jurisdicción', 'Autoridad competente/Jurisdicción', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('506', 'c', 'Condiciones para el acceso físico', 'Condiciones para el acceso físico', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('506', 'd', 'Usuarios autorizados', 'Usuarios autorizados', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('506', 'e', 'Autorización', 'Autorización', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('506', 'f', 'Terminología normalizada para las restricciones de acceso', 'Terminología normalizada para las restricciones de acceso', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('506', 'u', 'Identificador Uniforme del Recurso', 'Identificador Uniforme del Recurso', 1, 0, '', 5, '', '', '', 1, -6, '', '', '', NULL),
		('507', '6', 'Enlace', 'Enlace', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('507', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('507', 'a', 'Nota de escala o de fracción representativa', 'Nota de escala o de fracción representativa', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('507', 'b', 'Nota de resto de la escala', 'Nota de resto de la escala', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('508', '6', 'Enlace', 'Enlace', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('508', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('508', 'a', 'Nota de créditos de creación o producción', 'Nota de créditos de creación o producción', 0, 0, NULL, 5, NULL, NULL, '', NULL, -1, '', '', '', NULL),
		('509', 'a', 'Notas informales', 'Notas informales', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('510', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('510', '6', 'Enlace', 'Enlace', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('510', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('510', 'a', 'Nombre de la fuente', 'Nombre de la fuente', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('510', 'b', 'Cobertura de la fuente', 'Cobertura de la fuente', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('510', 'c', 'Localización dentro de la fuente', 'Localización dentro de la fuente', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('510', 'u', 'Identificador Uniforme del Recurso', 'Identificador Uniforme del Recurso', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('510', 'x', 'Número Internacional Normalizado para Publicaciones Seriadas', 'Número Internacional Normalizado para Publicaciones Seriadas', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('511', '6', 'Enlace', 'Enlace', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('511', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('511', 'a', 'Nota de participantes o intérpretes', 'Nota de participantes o intérpretes', 0, 0, '', 5, '', '', '', NULL, 0, '', '', '', NULL),
		('512', '6', 'Enlace', 'Enlace', 0, 0, '', -1, '', '', '', NULL, -6, '', '', '', NULL),
		('512', 'a', 'Nota de volúmenes anteriores o posteriores catalogados separadamente', 'Nota de volúmenes anteriores o posteriores catalogados separadamente', 0, 0, '', -1, '', '', '', NULL, -6, '', '', '', NULL),
		('513', '6', 'Enlace', 'Enlace', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('513', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('513', 'a', 'Tipo de informe', 'Tipo de informe', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('513', 'b', 'Periodo cubierto', 'Periodo cubierto', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('514', '6', 'Enlace', 'Enlace', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('514', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('514', 'a', 'Informe de exactitud del atributo', 'Informe de exactitud del atributo', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('514', 'b', 'Valor de exactitud del atributo', 'Valor de exactitud del atributo', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('514', 'c', 'Explicación de exactitud del atributo', 'Explicación de exactitud del atributo', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('514', 'd', 'Informe de consistencia lógica', 'Informe de consistencia lógica', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('514', 'e', 'Informe de exhaustividad', 'Informe de exhaustividad', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('514', 'f', 'Informe de la exactitud de la posición horizontal', 'Informe de la exactitud de la posición horizontal', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('514', 'g', 'Valor de la exactitud de la posición horizontal', 'Valor de la exactitud de la posición horizontal', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('514', 'h', 'Explicación de la exactitud de la posición horizontal', 'Explicación de la exactitud de la posición horizontal', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('514', 'i', 'Informe de la exactitud de la posición vertical', 'Informe de la exactitud de la posición vertical', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('514', 'j', 'Valor de la exactitud de la posición vertical', 'Valor de la exactitud de la posición vertical', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('514', 'k', 'Explicación de la exactitud de la posición vertical', 'Explicación de la exactitud de la posición vertical', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('514', 'm', 'Cobertura nubosa', 'Cobertura nubosa', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('514', 'u', 'Identificador Uniforme del Recurso', 'Identificador Uniforme del Recurso', 1, 0, '', 5, '', '', '', 1, -6, '', '', '', NULL),
		('514', 'z', 'Nota de visualización', 'Nota de visualización', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('515', '6', 'Enlace', 'Enlace', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('515', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('515', 'a', 'Nota de peculiaridades de la numeración', 'Nota de peculiaridades de la numeración', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('515', 'z', 'Fuente de la nota de información (SE) [OBSOLETO]', 'Fuente de la nota de información (SE) [OBSOLETO]', 0, 0, '', -1, '', '', '', NULL, -6, '', '', '', NULL),
		('516', '6', 'Enlace', 'Enlace', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('516', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('516', 'a', 'Nota de tipo de archivo de ordenador o de datos', 'Nota de tipo de archivo de ordenador o de datos', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('517', 'a', 'Formatos diferentes', 'Formatos diferentes', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('517', 'b', 'Descriptores de contenido', 'Descriptores de contenido', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('517', 'c', 'Técnicas adicionales de animación', 'Técnicas adicionales de animación', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('518', '0', 'Número de control del registro', 'Número de control del registro', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('518', '2', 'Fuente del término', 'Fuente del término', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('518', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('518', '6', 'Enlace', 'Enlace', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('518', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('518', 'a', 'Nota de fecha/hora y lugar de un acontecimiento', 'Nota de fecha/hora y lugar de un acontecimiento', 0, 0, '', 5, '', '', '', NULL, 0, '', '', '', NULL),
		('518', 'd', 'Fecha del acontecimiento', 'Fecha del acontecimiento', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('518', 'o', 'Otra información sobre el acontecimiento', 'Otra información sobre el acontecimiento', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('518', 'p', 'Lugar del acontecimiento', 'Lugar del acontecimiento', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('520', '2', 'Fuente', 'Fuente', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('520', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('520', '6', 'Enlace', 'Enlace', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('520', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('520', 'a', 'Sumario, etc.', 'Sumario, etc.', 0, 0, 'biblio.abstract', 5, '', '', '', NULL, 0, '', '', '', NULL),
		('520', 'b', 'Ampliación de la nota de sumario', 'Ampliación de la nota de sumario', 0, 0, '', 5, '', '', '', NULL, 0, '', '', '', NULL),
		('520', 'c', 'Fuente proveedora', 'Fuente proveedora', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('520', 'u', 'Identificador Uniforme del Recurso', 'Identificador Uniforme del Recurso', 1, 0, '', 5, '', '', '', 1, 0, '', '', '', NULL),
		('520', 'z', 'Fuente de la nota de información [OBSOLETO]', 'Fuente de la nota de información [OBSOLETO]', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('521', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('521', '6', 'Enlace', 'Enlace', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('521', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('521', 'a', 'Nota de público destinatario', 'Nota de público destinatario', 1, 0, NULL, 5, NULL, NULL, '', NULL, 0, '', '', '', NULL),
		('521', 'b', 'Fuente', 'Fuente', 0, 0, NULL, 5, NULL, NULL, '', NULL, 0, '', '', '', NULL),
		('522', '6', 'Enlace', 'Enlace', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('522', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('522', 'a', 'Nota de ámbito geográfico', 'Nota de ámbito geográfico', 0, 0, NULL, 5, NULL, NULL, '', NULL, -1, '', '', '', NULL),
		('523', '6', 'Enlace', 'Enlace', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('523', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('523', 'a', 'Periodo de tiempo de nota de contenido', 'Periodo de tiempo de nota de contenido', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('524', '2', 'Fuente de esquema utilizado', 'Fuente de esquema utilizado', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('524', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('524', '6', 'Enlace', 'Enlace', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('524', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('524', 'a', 'Nota de forma usual de cita de los materiales descritos', 'Nota de forma usual de cita de los materiales descritos', 0, 0, NULL, 5, NULL, NULL, '', NULL, 0, '', '', '', NULL),
		('525', '6', 'Enlace', 'Enlace', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('525', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('525', 'a', 'Nota de suplemento', 'Nota de suplemento', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('525', 'z', 'Fuente de la nota de información (SE) [OBSOLETO]', 'Fuente de la nota de información (SE) [OBSOLETO]', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('526', '5', 'Institución que aplica el campo', 'Institución que aplica el campo', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('526', '6', 'Enlace', 'Enlace', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('526', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('526', 'a', 'Nombre del programa', 'Nombre del programa', 0, 0, '', 5, '', '', '', NULL, 0, '', '', '', NULL),
		('526', 'b', 'Nivel de interés', 'Nivel de interés', 0, 0, '', 5, '', '', '', NULL, 0, '', '', '', NULL),
		('526', 'c', 'Nivel de lectura', 'Nivel de lectura', 0, 0, '', 5, '', '', '', NULL, 0, '', '', '', NULL),
		('526', 'd', 'Puntuación del título', 'Puntuación del título', 0, 0, '', 5, '', '', '', NULL, 0, '', '', '', NULL),
		('526', 'i', 'Texto de visualización', 'Texto de visualización', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('526', 'x', 'Nota interna', 'Nota interna', 1, 0, '', 5, '', '', '', NULL, 6, '', '', '', NULL),
		('526', 'z', 'Nota pública', 'Nota pública', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('527', '6', 'Enlace', 'Enlace', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('527', 'a', 'Nota de censura', 'Nota de censura', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('530', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('530', '6', 'Enlace', 'Enlace', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('530', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('530', 'a', 'Nota de formato físico adicional disponible', 'Nota de formato físico adicional disponible', 0, 0, NULL, 5, NULL, NULL, '', NULL, -1, '', '', '', NULL),
		('530', 'b', 'Fuente para la adquisición/disponibilidad', 'Fuente para la adquisición/disponibilidad', 0, 0, NULL, 5, NULL, NULL, '', NULL, -1, '', '', '', NULL),
		('530', 'c', 'Condiciones de adquisición/disponibilidad', 'Condiciones de adquisición/disponibilidad', 0, 0, NULL, 5, NULL, NULL, '', NULL, -1, '', '', '', NULL),
		('530', 'd', 'Número de orden', 'Número de orden', 0, 0, NULL, 5, NULL, NULL, '', NULL, -1, '', '', '', NULL),
		('530', 'u', 'Identificador Uniforme del Recurso', 'Identificador Uniforme del Recurso', 1, 0, NULL, 5, NULL, NULL, '', 1, -1, '', '', '', NULL),
		('530', 'z', 'Fuente de la nota de información (AM CF VM SE) [OBSOLETO]', 'Fuente de la nota de información (AM CF VM SE) [OBSOLETO]', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('533', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('533', '5', 'Institución que aplica el campo', 'Institución que aplica el campo', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('533', '6', 'Enlace', 'Enlace', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('533', '7', 'Datos de longitud fija sobre la reproducción', 'Datos de longitud fija sobre la reproducción', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('533', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('533', 'a', 'Tipo de reproducción', 'Tipo de reproducción', 0, 0, NULL, 5, NULL, NULL, '', NULL, -1, '', '', '', NULL),
		('533', 'b', 'Lugar de la reproducción', 'Lugar de la reproducción', 1, 0, NULL, 5, NULL, NULL, '', NULL, -1, '', '', '', NULL),
		('533', 'c', 'Institución responsable de la reproducción', 'Institución responsable de la reproducción', 1, 0, NULL, 5, NULL, NULL, '', NULL, -1, '', '', '', NULL),
		('533', 'd', 'Fecha de la reproducción', 'Fecha de la reproducción', 0, 0, NULL, 5, NULL, NULL, '', NULL, -1, '', '', '', NULL),
		('533', 'e', 'Descripción física de la reproducción', 'Descripción física de la reproducción', 0, 0, NULL, 5, NULL, NULL, '', NULL, -1, '', '', '', NULL),
		('533', 'f', 'Mención de serie de la reproducción', 'Mención de serie de la reproducción', 1, 0, NULL, 5, NULL, NULL, '', NULL, -1, '', '', '', NULL),
		('533', 'm', 'Fecha y/o designación secuencial de los originales reproducidos', 'Fecha y/o designación secuencial de los originales reproducidos', 1, 0, NULL, 5, NULL, NULL, '', NULL, -1, '', '', '', NULL),
		('533', 'n', 'Nota sobre la reproducción', 'Nota sobre la reproducción', 1, 0, NULL, 5, NULL, NULL, '', NULL, -1, '', '', '', NULL),
		('534', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('534', '6', 'Enlace', 'Enlace', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('534', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('534', 'a', 'Encabezamiento principal del original', 'Encabezamiento principal del original', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('534', 'b', 'Mención de edición del original', 'Mención de edición del original', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('534', 'c', 'Publicación, distribución, etc. del original', 'Publicación, distribución, etc. del original', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('534', 'e', 'Descripción física, etc. del original', 'Descripción física, etc. del original', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('534', 'f', 'Mención de serie del original', 'Mención de serie del original', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('534', 'k', 'Título clave del original', 'Título clave del original', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('534', 'l', 'Localización del original', 'Localización del original', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('534', 'm', 'Datos específicos del material', 'Datos específicos del material', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('534', 'n', 'Nota sobre el original', 'Nota sobre el original', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('534', 'o', 'Otros identificadores del recurso', 'Otros identificadores del recurso', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('534', 'p', 'Frase introductoria', 'Frase introductoria', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('534', 't', 'Mención de título del original', 'Mención de título del original', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('534', 'x', 'Número Internacional Normalizado para Publicaciones Seriadas', 'Número Internacional Normalizado para Publicaciones Seriadas', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('534', 'z', 'Número Internacional Estándar del Libro', 'Número Internacional Estándar del Libro', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('535', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('535', '6', 'Enlace', 'Enlace', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('535', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('535', 'a', 'Depositario(custodio)', 'Depositario(custodio)', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('535', 'b', 'Dirección postal', 'Dirección postal', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('535', 'c', 'País', 'País', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('535', 'd', 'Dirección de telecomunicaciones', 'Dirección de telecomunicaciones', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('535', 'g', 'Código de localización del depósito/repositorio', 'Código de localización del depósito/repositorio', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('536', '6', 'Enlace', 'Enlace', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('536', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('536', 'a', 'Texto de la nota', 'Texto de la nota', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('536', 'b', 'Número de contrato', 'Número de contrato', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('536', 'c', 'Número de subvención', 'Número de subvención', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('536', 'd', 'Número indiferenciado', 'Número indiferenciado', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('536', 'e', 'Número de elemento de programa', 'Número de elemento de programa', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('536', 'f', 'Número de proyecto', 'Número de proyecto', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('536', 'g', 'Número de tarea', 'Número de tarea', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('536', 'h', 'Número de tarea', 'Número de tarea', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('537', '6', 'Enlace', 'Enlace', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('537', 'a', 'Fuente de la nota de datos', 'Fuente de la nota de datos', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('538', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('538', '5', 'Institución que aplica el campo', 'Institución que aplica el campo', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('538', '6', 'Enlace', 'Enlace', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('538', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('538', 'a', 'Nota de detalles del sistema', 'Nota de detalles del sistema', 0, 0, '', 5, '', '', '', NULL, -1, '', '', '', NULL),
		('538', 'i', 'Texto de visualización', 'Texto de visualización', 0, 0, '', 5, '', '', '', NULL, -1, '', '', '', NULL),
		('538', 'u', 'Identificador Uniforme del Recurso', 'Identificador Uniforme del Recurso', 1, 0, '', 5, '', '', '', 1, -1, '', '', '', NULL),
		('540', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('540', '5', 'Institución que aplica el campo', 'Institución que aplica el campo', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('540', '6', 'Enlace', 'Enlace', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('540', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('540', 'a', 'Condiciones de uso y reproducción', 'Condiciones de uso y reproducción', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('540', 'b', 'Autoridad competente/Jurisdicción', 'Autoridad competente/Jurisdicción', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('540', 'c', 'Autorización', 'Autorización', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('540', 'd', 'Usuarios autorizados', 'Usuarios autorizados', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('540', 'u', 'Identificador Uniforme del Recurso', 'Identificador Uniforme del Recurso', 1, 0, '', 5, '', '', '', 1, -6, '', '', '', NULL),
		('541', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('541', '5', 'Institución que aplica el campo', 'Institución que aplica el campo', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('541', '6', 'Enlace', 'Enlace', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('541', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('541', 'a', 'Fuente de adquisición', 'Fuente de adquisición', 0, 0, '', 5, '', '', '', NULL, 1, '', '', '', NULL),
		('541', 'b', 'Dirección', 'Dirección', 0, 0, '', 5, '', '', '', NULL, 1, '', '', '', NULL),
		('541', 'c', 'Forma de adquisición', 'Forma de adquisición', 0, 0, '', 5, '', '', '', NULL, 1, '', '', '', NULL),
		('541', 'd', 'Fecha de adquisición', 'Fecha de adquisición', 0, 0, '', 5, '', '', '', NULL, 1, '', '', '', NULL),
		('541', 'e', 'Número de registro', 'Número de registro', 0, 0, '', 5, '', '', '', NULL, 1, '', '', '', NULL),
		('541', 'f', 'Propietario', 'Propietario', 0, 0, '', 5, '', '', '', NULL, 1, '', '', '', NULL),
		('541', 'h', 'Precio de compra', 'Precio de compra', 0, 0, '', 5, '', '', '', NULL, 1, '', '', '', NULL),
		('541', 'n', 'Extensión', 'Extensión', 1, 0, '', 5, '', '', '', NULL, 1, '', '', '', NULL),
		('541', 'o', 'Tipo de unidad', 'Tipo de unidad', 1, 0, '', 5, '', '', '', NULL, 1, '', '', '', NULL),
		('542', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('542', '6', 'Enlace', 'Enlace', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('542', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('542', 'a', 'Creador personal', 'Creador personal', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('542', 'b', 'Fecha de fallecimiento del creador personal', 'Fecha de fallecimiento del creador personal', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('542', 'c', 'Entidad creadora', 'Entidad creadora', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('542', 'd', 'Titular del copyright', 'Titular del copyright', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('542', 'e', 'Información de contacto del titular del copyright', 'Información de contacto del titular del copyright', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('542', 'f', 'Mención de copyright', 'Mención de copyright', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('542', 'g', 'Fecha de copyright', 'Fecha de copyright', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('542', 'h', 'Fecha de renovación del copyright', 'Fecha de renovación del copyright', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('542', 'i', 'Fecha de publicación', 'Fecha de publicación', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('542', 'j', 'Fecha de creación', 'Fecha de creación', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('542', 'k', 'Editor', 'Editor', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('542', 'l', 'Estado del copyright', 'Estado del copyright', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('542', 'm', 'Estado de la publicación', 'Estado de la publicación', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('542', 'n', 'Nota', 'Nota', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('542', 'o', 'Fecha de la búsqueda', 'Fecha de la búsqueda', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('542', 'p', 'País de publicación o creación', 'País de publicación o creación', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('542', 'q', 'Agencia que proporciona la información', 'Agencia que proporciona la información', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('542', 'r', 'Jurisdicción de la mención de copyright', 'Jurisdicción de la mención de copyright', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('542', 's', 'Fuente de información', 'Fuente de información', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('542', 'u', 'Identificador Uniforme del Recurso', 'Identificador Uniforme del Recurso', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('543', '6', 'Enlace', 'Enlace', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('543', 'a', 'Nota de solicitud de información', 'Nota de solicitud de información', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('544', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('544', '6', 'Enlace', 'Enlace', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('544', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('544', 'a', 'Depositario(custodio)', 'Depositario(custodio)', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('544', 'b', 'Dirección', 'Dirección', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('544', 'c', 'País', 'País', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('544', 'd', 'Título', 'Título', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('544', 'e', 'Procedencia', 'Procedencia', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('544', 'n', 'Nota', 'Nota', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('545', '6', 'Enlace', 'Enlace', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('545', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('545', 'a', 'Datos biográficos o históricos', 'Datos biográficos o históricos', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('545', 'b', 'Ampliación de la nota', 'Ampliación de la nota', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('545', 'u', 'Identificador Uniforme del Recurso', 'Identificador Uniforme del Recurso', 1, 0, '', 5, '', '', '', 1, -6, '', '', '', NULL),
		('546', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('546', '6', 'Enlace', 'Enlace', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('546', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('546', 'a', 'Nota de lengua/lenguaje', 'Nota de lengua/lenguaje', 0, 0, NULL, 5, NULL, NULL, '', NULL, 0, '', '', '', NULL),
		('546', 'b', 'Información sobre el código o alfabeto', 'Información sobre el código o alfabeto', 1, 0, NULL, 5, NULL, NULL, '', NULL, 0, '', '', '', NULL),
		('546', 'z', 'Fuente de la nota de información (SE) [OBSOLETO]', 'Fuente de la nota de información (SE) [OBSOLETO]', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('547', '6', 'Enlace', 'Enlace', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('547', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('547', 'a', 'Nota de relación compleja con los títulos anteriores', 'Nota de relación compleja con los títulos anteriores', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('547', 'z', 'Fuente de la nota de información (SE) [OBSOLETO]', 'Fuente de la nota de información (SE) [OBSOLETO]', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('550', '6', 'Enlace', 'Enlace', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('550', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('550', 'a', 'Nota de entidad responsable', 'Nota de entidad responsable', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('550', 'z', 'Fuente de la nota de información (SE) [OBSOLETO]', 'Fuente de la nota de información (SE) [OBSOLETO]', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('552', '6', 'Enlace', 'Enlace', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('552', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('552', 'a', 'Identificación del tipo de objeto', 'Identificación del tipo de objeto', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('552', 'b', 'Definición y fuente del tipo de objeto', 'Definición y fuente del tipo de objeto', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('552', 'c', 'Identificación del atributo', 'Identificación del atributo', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('552', 'd', 'Definición y fuente del atributo', 'Definición y fuente del atributo', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('552', 'e', 'Valor del ámbito', 'Valor del ámbito', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('552', 'f', 'Definición y fuente del valor del ámbito', 'Definición y fuente del valor del ámbito', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('552', 'g', 'Rango mínimo y máximo del ámbito', 'Rango mínimo y máximo del ámbito', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('552', 'h', 'Nombre y fuente del conjunto de códigos', 'Nombre y fuente del conjunto de códigos', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('552', 'i', 'Ámbito no representable', 'Ámbito no representable', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('552', 'j', 'Unidades de medida y resolución del atributo', 'Unidades de medida y resolución del atributo', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('552', 'k', 'Fechas de inicio y finalización de los valores del atributo', 'Fechas de inicio y finalización de los valores del atributo', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('552', 'l', 'Exactitud del valor del atributo', 'Exactitud del valor del atributo', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('552', 'm', 'Explicación de la exactitud del valor del atributo', 'Explicación de la exactitud del valor del atributo', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('552', 'n', 'Explicación de la exactitud del valor del atributo', 'Explicación de la exactitud del valor del atributo', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('552', 'o', 'Resumen del objeto y su atributo', 'Resumen del objeto y su atributo', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('552', 'p', 'Referencia detallada del objeto y su atributo', 'Referencia detallada del objeto y su atributo', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('552', 'u', 'Identificador Uniforme del Recurso', 'Identificador Uniforme del Recurso', 1, 0, '', 5, '', '', '', 1, -6, '', '', '', NULL),
		('552', 'z', 'Nota de visualización', 'Nota de visualización', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('555', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('555', '6', 'Enlace', 'Enlace', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('555', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('555', 'a', 'Nota de índice acumulativo u otros instrumentos bibliográficos', 'Nota de índice acumulativo u otros instrumentos bibliográficos', 0, 0, NULL, 5, NULL, NULL, '', NULL, -1, '', '', '', NULL),
		('555', 'b', 'Fuente para la adquisición/disponibilidad', 'Fuente para la adquisición/disponibilidad', 1, 0, NULL, 5, NULL, NULL, '', NULL, -1, '', '', '', NULL),
		('555', 'c', 'Grado de control', 'Grado de control', 0, 0, NULL, 5, NULL, NULL, '', NULL, -1, '', '', '', NULL),
		('555', 'd', 'Referencia bibliográfica', 'Referencia bibliográfica', 0, 0, NULL, 5, NULL, NULL, '', NULL, -1, '', '', '', NULL),
		('555', 'u', 'Identificador Uniforme del Recurso', 'Identificador Uniforme del Recurso', 1, 0, NULL, 5, NULL, NULL, '', 1, -1, '', '', '', NULL),
		('556', '6', 'Enlace', 'Enlace', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('556', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('556', 'a', 'Nota de información sobre la documentación', 'Nota de información sobre la documentación', 0, 0, NULL, 5, NULL, NULL, '', NULL, -1, '', '', '', NULL),
		('556', 'z', 'Número Internacional Estándar del Libro', 'Número Internacional Estándar del Libro', 1, 0, NULL, 5, NULL, NULL, '', NULL, -1, '', '', '', NULL),
		('561', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('561', '5', 'Institución que aplica el campo', 'Institución que aplica el campo', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('561', '6', 'Enlace', 'Enlace', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('561', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('561', 'a', 'Historia (Procedencia)', 'Historia (Procedencia)', 0, 0, '', 5, '', '', '', NULL, 6, '', '', '', NULL),
		('561', 'b', 'Tiempo de colación [OBSOLETO]', 'Tiempo de colación [OBSOLETO]', 0, 0, '', 5, '', '', '', NULL, 6, '', '', '', NULL),
		('561', 'u', 'Identificador Uniforme del Recurso', 'Identificador Uniforme del Recurso', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('562', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('562', '5', 'Institución que aplica el campo', 'Institución que aplica el campo', 0, 0, NULL, -1, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('562', '6', 'Enlace', 'Enlace', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('562', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('562', 'a', 'Marcas de identificación', 'Marcas de identificación', 1, 0, NULL, 5, NULL, NULL, '', NULL, -1, '', '', '', NULL),
		('562', 'b', 'Identificación de la copia', 'Identificación de la copia', 1, 0, NULL, 5, NULL, NULL, '', NULL, -1, '', '', '', NULL),
		('562', 'c', 'Identificación de la versión', 'Identificación de la versión', 1, 0, NULL, 5, NULL, NULL, '', NULL, -1, '', '', '', NULL),
		('562', 'd', 'Formato de presentación', 'Formato de presentación', 1, 0, NULL, 5, NULL, NULL, '', NULL, -1, '', '', '', NULL),
		('562', 'e', 'Número de copias', 'Número de copias', 1, 0, NULL, 5, NULL, NULL, '', NULL, -1, '', '', '', NULL),
		('563', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('563', '5', 'Institución que aplica el campo', 'Institución que aplica el campo', 0, 0, NULL, -1, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('563', '6', 'Enlace', 'Enlace', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('563', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('563', 'a', 'Nota de encuadernación', 'Nota de encuadernación', 0, 0, NULL, 5, NULL, NULL, '', NULL, -1, '', '', '', NULL),
		('563', 'u', 'Identificador Uniforme del Recurso', 'Identificador Uniforme del Recurso', 1, 0, NULL, 5, NULL, NULL, '', 1, -1, '', '', '', NULL),
		('565', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('565', '6', 'Enlace', 'Enlace', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('565', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('565', 'a', 'Número de casos/variables', 'Número de casos/variables', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('565', 'b', 'Nombre de la variable', 'Nombre de la variable', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('565', 'c', 'Unidad de análisis', 'Unidad de análisis', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('565', 'd', 'Muestra', 'Muestra', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('565', 'e', 'Esquema o código de ordenación', 'Esquema o código de ordenación', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('567', '6', 'Enlace', 'Enlace', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('567', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('567', 'a', 'Nota sobre la metodología', 'Nota sobre la metodología', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('570', '6', 'Enlace', 'Enlace', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('570', 'a', 'Nota del editor', 'Nota del editor', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('570', 'z', 'Fuente de la nota de información', 'Fuente de la nota de información', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('580', '6', 'Enlace', 'Enlace', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('580', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('580', 'a', 'Nota de relación compleja', 'Nota de relación compleja', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('580', 'z', 'Fuente de la nota de información [OBSOLETO]', 'Fuente de la nota de información [OBSOLETO]', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('581', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('581', '6', 'Enlace', 'Enlace', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('581', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('581', 'a', 'Nota de publicaciones sobre los materiales descritos', 'Nota de publicaciones sobre los materiales descritos', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('581', 'z', 'Número Internacional Estándar del Libro', 'Número Internacional Estándar del Libro', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('582', '6', 'Enlace', 'Enlace', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('582', 'a', 'Nota de archivos de computador relacionados', 'Nota de archivos de computador relacionados', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('583', '2', 'Fuente del término', 'Fuente del término', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('583', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('583', '5', 'Institución que aplica el campo', 'Institución que aplica el campo', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('583', '6', 'Enlace', 'Enlace', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('583', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('583', 'a', 'Acción', 'Acción', 0, 0, '', 5, '', '', '', NULL, -1, '', '', '', NULL),
		('583', 'b', 'Código de identificación de la acción', 'Código de identificación de la acción', 1, 0, '', 5, '', '', '', NULL, -1, '', '', '', NULL),
		('583', 'c', 'Fecha/hora de la acción', 'Fecha/hora de la acción', 1, 0, '', 5, '', '', '', NULL, -1, '', '', '', NULL),
		('583', 'd', 'Intervalo de la acción', 'Intervalo de la acción', 1, 0, '', 5, '', '', '', NULL, -1, '', '', '', NULL),
		('583', 'e', 'Contingencia de la acción', 'Contingencia de la acción', 1, 0, '', 5, '', '', '', NULL, -1, '', '', '', NULL),
		('583', 'f', 'Autorización', 'Autorización', 1, 0, '', 5, '', '', '', NULL, -1, '', '', '', NULL),
		('583', 'h', 'Autoridad competente/Jurisdicción', 'Autoridad competente/Jurisdicción', 1, 0, '', 5, '', '', '', NULL, -1, '', '', '', NULL),
		('583', 'i', 'Método de la acción', 'Método de la acción', 1, 0, '', 5, '', '', '', NULL, -1, '', '', '', NULL),
		('583', 'j', 'Lugar de la acción', 'Lugar de la acción', 1, 0, '', 5, '', '', '', NULL, -1, '', '', '', NULL),
		('583', 'k', 'Agente de la acción', 'Agente de la acción', 1, 0, '', 5, '', '', '', NULL, -1, '', '', '', NULL),
		('583', 'l', 'Estado', 'Estado', 1, 0, '', 5, '', '', '', NULL, -1, '', '', '', NULL),
		('583', 'n', 'Extensión', 'Extensión', 1, 0, '', 5, '', '', '', NULL, -1, '', '', '', NULL),
		('583', 'o', 'Tipo de unidad', 'Tipo de unidad', 1, 0, '', 5, '', '', '', NULL, -1, '', '', '', NULL),
		('583', 'u', 'Identificador Uniforme del Recurso', 'Identificador Uniforme del Recurso', 1, 0, '', 5, '', '', '', 1, -1, '', '', '', NULL),
		('583', 'x', 'Nota interna', 'Nota interna', 1, 0, '', 5, '', '', '', NULL, 4, '', '', '', NULL),
		('583', 'z', 'Nota pública', 'Nota pública', 1, 0, '', 5, '', '', '', NULL, -1, '', '', '', NULL),
		('584', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('584', '5', 'Institución que aplica el campo', 'Institución que aplica el campo', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('584', '6', 'Enlace', 'Enlace', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('584', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('584', 'a', 'Crecimiento', 'Crecimiento', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('584', 'b', 'Frecuencia de uso', 'Frecuencia de uso', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('585', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, NULL, 5, NULL, NULL, '', NULL, -1, '', '', '', NULL),
		('585', '5', 'Institución que aplica el campo', 'Institución que aplica el campo', 0, -6, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('585', '6', 'Enlace', 'Enlace', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('585', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('585', 'a', 'Nota de exposiciones', 'Nota de exposiciones', 0, 0, '', 5, '', '', '', NULL, -1, '', '', '', NULL),
		('586', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('586', '6', 'Enlace', 'Enlace', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('586', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('586', 'a', 'Nota de premios', 'Nota de premios', 0, 0, NULL, 5, NULL, NULL, '', NULL, -1, '', '', '', NULL),
		('588', '5', 'Institución que aplica el campo', 'Institución que aplica el campo', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('588', '6', 'Enlace', 'Enlace', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('588', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('588', 'a', 'Nota de fuente de la descripción', 'Nota de fuente de la descripción', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '', NULL),
		('590', '6', 'Enlace (RLIN)', 'Enlace (RLIN)', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('590', '8', 'Campo de enlace y número de secuencia (RLIN)', 'Campo de enlace y número de secuencia (RLIN)', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('590', 'a', 'Nota local', 'Nota local', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('590', 'b', 'Procedencia (VM) [OBSOLETO]', 'Procedencia (VM) [OBSOLETO]', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('590', 'c', 'Condición del los carretes individuales (VM) [OBSOLETO]', 'Condición del los carretes individuales (VM) [OBSOLETO]', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('590', 'd', 'Origen de la copia de seguridad (VM) [OBSOLETO]', 'Origen de la copia de seguridad (VM) [OBSOLETO]', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('600', '0', 'Número de control del registro de autoridad o número normalizado', 'Número de control del registro de autoridad o número normalizado', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('600', '2', 'Fuente del encabezamiento o término', 'Fuente del encabezamiento o término', 0, 0, '', 6, '', '', '', NULL, 0, '', '', '', NULL),
		('600', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('600', '4', 'Código de función/relación', 'Código de función/relación', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('600', '6', 'Enlace', 'Enlace', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('600', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('600', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 6, '', '', '', 0, -5, '', '', '', NULL),
		('600', 'a', 'Nombre de persona', 'Nombre de persona', 0, 0, '', 6, '', 'PERSO_NAME', '', NULL, 0, '', '', '', NULL),
		('600', 'b', 'Numeración', 'Numeración', 0, 0, '', 6, '', '', '', NULL, -1, '', '', '', NULL),
		('600', 'c', 'Títulos y otros términos asociados al nombre', 'Títulos y otros términos asociados al nombre', 1, 0, '', 6, '', '', '', NULL, -1, '', '', '', NULL),
		('600', 'd', 'Fechas asociadas al nombre', 'Fechas asociadas al nombre', 0, 0, '', 6, '', '', '', NULL, 0, '', '', '', NULL),
		('600', 'e', 'Término indicativo de función/relación', 'Término indicativo de función/relación', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('600', 'f', 'Fecha de publicación/de la obra', 'Fecha de publicación/de la obra', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('600', 'g', 'Información miscelánea', 'Información miscelánea', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('600', 'h', 'Medio', 'Medio', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('600', 'j', 'Calificador de atribución', 'Calificador de atribución', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('600', 'k', 'Subencabezamiento de forma', 'Subencabezamiento de forma', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('600', 'l', 'Lenguaje de la obra', 'Lenguaje de la obra', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('600', 'm', 'Medio de interpretación para música', 'Medio de interpretación para música', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('600', 'n', 'Número de parte o sección de la obra', 'Número de parte o sección de la obra', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('600', 'o', 'Mención de arreglo para música', 'Mención de arreglo para música', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('600', 'p', 'Nombre de parte o sección de la obra', 'Nombre de parte o sección de la obra', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('600', 'q', 'Forma completa/desarrollada del nombre', 'Forma completa/desarrollada del nombre', 0, 0, '', 6, '', '', '', NULL, 0, '', '', '', NULL),
		('600', 'r', 'Clave para música', 'Clave para música', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('600', 's', 'Versión', 'Versión', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('600', 't', 'Título de la obra', 'Título de la obra', 0, 0, '', 6, '', '', '', NULL, 0, '', '', '', NULL),
		('600', 'u', 'Filiación', 'Filiación', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('600', 'v', 'Subdivisión de forma', 'Subdivisión de forma', 1, 0, '', 6, '', '', '', NULL, 0, '', '', '', NULL),
		('600', 'x', 'Subdivisión general', 'Subdivisión general', 1, 0, '', 6, '', '', '', NULL, 0, '', '', '', NULL),
		('600', 'y', 'Subdivisión cronológica', 'Subdivisión cronológica', 1, 0, '', 6, '', '', '', NULL, 0, '', '', '', NULL),
		('600', 'z', 'Subdivisión geográfica', 'Subdivisión geográfica', 1, 0, '', 6, '', '', '', NULL, 0, '', '', '', NULL),
		('610', '0', 'Número de control del registro de autoridad o número normalizado', 'Número de control del registro de autoridad o número normalizado', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('610', '2', 'Fuente del encabezamiento o término', 'Fuente del encabezamiento o término', 0, 0, '', 6, '', '', '', NULL, 0, '', '', '', NULL),
		('610', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('610', '4', 'Código de función/relación', 'Código de función/relación', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('610', '6', 'Enlace', 'Enlace', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('610', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('610', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 6, '', '', '', 0, -5, '', '', '', NULL),
		('610', 'a', 'Nombre de entidad corporativa o nombre de jurisdicción como elemento de entrada', 'Nombre de entidad corporativa o nombre de jurisdicción como elemento de entrada', 0, 0, '', 6, '', 'CORPO_NAME', '', NULL, 0, '', '', '', NULL),
		('610', 'b', 'Unidad subordinada', 'Unidad subordinada', 1, 0, '', 6, '', '', '', NULL, 0, '', '', '', NULL),
		('610', 'c', 'Sede del congreso/Lugar de la reunión', 'Sede del congreso/Lugar de la reunión', 1, 0, '', 6, '', '', '', NULL, -1, '', '', '', NULL),
		('610', 'd', 'Fecha del congreso/reunión o de la firma de un tratado', 'Fecha del congreso/reunión o de la firma de un tratado', 1, 0, '', 6, '', '', '', NULL, -1, '', '', '', NULL),
		('610', 'e', 'Término indicativo de función/relación', 'Término indicativo de función/relación', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('610', 'f', 'Fecha de publicación/de la obra', 'Fecha de publicación/de la obra', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('610', 'g', 'Información miscelánea', 'Información miscelánea', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('610', 'h', 'Medio', 'Medio', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('610', 'k', 'Subencabezamiento de forma', 'Subencabezamiento de forma', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('610', 'l', 'Lenguaje de la obra', 'Lenguaje de la obra', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('610', 'm', 'Medio de interpretación para música', 'Medio de interpretación para música', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('610', 'n', 'Número del congreso/reunión o número de parte o sección', 'Número del congreso/reunión o número de parte o sección', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('610', 'o', 'Mención de arreglo para música', 'Mención de arreglo para música', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('610', 'p', 'Nombre de parte o sección de la obra', 'Nombre de parte o sección de la obra', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('610', 'r', 'Clave para música', 'Clave para música', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('610', 's', 'Versión', 'Versión', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('610', 't', 'Título de la obra', 'Título de la obra', 0, 0, '', 6, '', '', '', NULL, 0, '', '', '', NULL),
		('610', 'u', 'Filiación', 'Filiación', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('610', 'v', 'Subdivisión de forma', 'Subdivisión de forma', 1, 0, '', 6, '', '', '', NULL, 0, '', '', '', NULL),
		('610', 'x', 'Subdivisión general', 'Subdivisión general', 1, 0, '', 6, '', '', '', NULL, 0, '', '', '', NULL),
		('610', 'y', 'Subdivisión cronológica', 'Subdivisión cronológica', 1, 0, '', 6, '', '', '', NULL, 0, '', '', '', NULL),
		('610', 'z', 'Subdivisión geográfica', 'Subdivisión geográfica', 1, 0, '', 6, '', '', '', NULL, 0, '', '', '', NULL),
		('611', '0', 'Número de control del registro de autoridad o número normalizado', 'Número de control del registro de autoridad o número normalizado', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('611', '2', 'Fuente del encabezamiento o término', 'Fuente del encabezamiento o término', 0, 0, NULL, 6, NULL, NULL, '', NULL, -1, '', '', '', NULL),
		('611', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('611', '4', 'Código de función/relación', 'Código de función/relación', 1, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('611', '6', 'Enlace', 'Enlace', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('611', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('611', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 6, '', '', '', 0, -5, '', '', '', NULL),
		('611', 'a', 'Nombre de congreso/reunión o jurisdicción como elemento de entrada', 'Nombre de congreso/reunión o jurisdicción como elemento de entrada', 0, 0, NULL, 6, NULL, 'MEETI_NAME', '', NULL, -1, '', '', '', NULL),
		('611', 'b', 'Número (BK CF MP MU SE VM MX) [OBSOLETE]', 'Número (BK CF MP MU SE VM MX) [OBSOLETE]', 1, 0, NULL, -1, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('611', 'c', 'Sede del congreso/Lugar de la reunión', 'Sede del congreso/Lugar de la reunión', 1, 0, NULL, 6, NULL, NULL, '', NULL, -1, '', '', '', NULL),
		('611', 'd', 'Fecha del congreso/reunión', 'Fecha del congreso/reunión', 0, 0, NULL, 6, NULL, NULL, '', NULL, -1, '', '', '', NULL),
		('611', 'e', 'Unidad subordinada', 'Unidad subordinada', 1, 0, NULL, 6, NULL, NULL, '', NULL, -1, '', '', '', NULL),
		('611', 'f', 'Fecha de publicación/de la obra', 'Fecha de publicación/de la obra', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('611', 'g', 'Información miscelánea', 'Información miscelánea', 1, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('611', 'h', 'Medio', 'Medio', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('611', 'j', 'Término indicativo de función/relación', 'Término indicativo de función/relación', 1, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('611', 'k', 'Subencabezamiento de forma', 'Subencabezamiento de forma', 1, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('611', 'l', 'Lenguaje de la obra', 'Lenguaje de la obra', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('611', 'n', 'Número del congreso/reunión o número de parte o sección', 'Número del congreso/reunión o número de parte o sección', 1, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('611', 'p', 'Nombre de parte o sección de la obra', 'Nombre de parte o sección de la obra', 1, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('611', 'q', 'Nombre de congreso/reunión que sigue a un nombre de jurisdicción como elemento de entrada', 'Nombre de congreso/reunión que sigue a un nombre de jurisdicción como elemento de entrada', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('611', 's', 'Versión', 'Versión', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('611', 't', 'Título de la obra', 'Título de la obra', 0, 0, NULL, 6, NULL, NULL, '', NULL, -1, '', '', '', NULL),
		('611', 'u', 'Filiación', 'Filiación', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('611', 'v', 'Subdivisión de forma', 'Subdivisión de forma', 1, 0, NULL, 6, NULL, NULL, '', NULL, -1, '', '', '', NULL),
		('611', 'x', 'Subdivisión general', 'Subdivisión general', 1, 0, NULL, 6, NULL, NULL, '', NULL, -1, '', '', '', NULL),
		('611', 'y', 'Subdivisión cronológica', 'Subdivisión cronológica', 1, 0, NULL, 6, NULL, NULL, '', NULL, -1, '', '', '', NULL),
		('611', 'z', 'Subdivisión geográfica', 'Subdivisión geográfica', 1, 0, NULL, 6, NULL, NULL, '', NULL, -1, '', '', '', NULL),
		('630', '0', 'Número de control del registro de autoridad o número normalizado', 'Número de control del registro de autoridad o número normalizado', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('630', '2', 'Fuente del encabezamiento o término', 'Fuente del encabezamiento o término', 0, 0, NULL, 6, NULL, NULL, '', NULL, -1, '', '', '', NULL),
		('630', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('630', '4', 'Código de función/relación', 'Código de función/relación', 1, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('630', '6', 'Enlace', 'Enlace', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('630', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('630', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 6, '', '', '', 0, -5, '', '', '', NULL),
		('630', 'a', 'Título uniforme', 'Título uniforme', 0, 0, NULL, 6, NULL, 'UNIF_TITLE', '', NULL, 0, '', '', '', NULL),
		('630', 'd', 'Fecha de la firma de un tratado', 'Fecha de la firma de un tratado', 1, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('630', 'e', 'Término indicativo de función/relación', 'Término indicativo de función/relación', 1, 0, '', 6, '', '', '', NULL, -1, '', '', '', NULL),
		('630', 'f', 'Fecha de publicación/de la obra', 'Fecha de publicación/de la obra', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('630', 'g', 'Información miscelánea', 'Información miscelánea', 1, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('630', 'h', 'Medio', 'Medio', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('630', 'k', 'Subencabezamiento de forma', 'Subencabezamiento de forma', 1, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('630', 'l', 'Lenguaje de la obra', 'Lenguaje de la obra', 0, 0, NULL, 6, NULL, NULL, '', NULL, 0, '', '', '', NULL),
		('630', 'm', 'Medio de interpretación para música', 'Medio de interpretación para música', 1, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('630', 'n', 'Número de parte o sección de la obra', 'Número de parte o sección de la obra', 1, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('630', 'o', 'Mención de arreglo para música', 'Mención de arreglo para música', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('630', 'p', 'Nombre de parte o sección de la obra', 'Nombre de parte o sección de la obra', 1, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('630', 'r', 'Clave para música', 'Clave para música', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('630', 's', 'Versión', 'Versión', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('630', 't', 'Título de la obra', 'Título de la obra', 0, 0, NULL, 6, NULL, NULL, '', NULL, 0, '', '', '', NULL),
		('630', 'v', 'Subdivisión de forma', 'Subdivisión de forma', 1, 0, NULL, 6, NULL, NULL, '', NULL, 0, '', '', '', NULL),
		('630', 'x', 'Subdivisión general', 'Subdivisión general', 1, 0, NULL, 6, NULL, NULL, '', NULL, 0, '', '', '', NULL),
		('630', 'y', 'Subdivisión cronológica', 'Subdivisión cronológica', 1, 0, NULL, 6, NULL, NULL, '', NULL, 0, '', '', '', NULL),
		('630', 'z', 'Subdivisión geográfica', 'Subdivisión geográfica', 1, 0, NULL, 6, NULL, NULL, '', NULL, 0, '', '', '', NULL),
		('648', '0', 'Número de control del registro de autoridad o número normalizado', 'Número de control del registro de autoridad o número normalizado', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('648', '2', 'Fuente del encabezamiento o término', 'Fuente del encabezamiento o término', 0, 0, NULL, 6, NULL, NULL, '', NULL, 0, '', '', '', NULL),
		('648', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('648', '6', 'Enlace', 'Enlace', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('648', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('648', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 6, '', '', '', 0, -5, '', '', '', NULL),
		('648', 'a', 'Término cronológico', 'Término cronológico', 0, 0, NULL, 6, NULL, 'CHRON_TERM', '', NULL, 0, '', '', '', NULL),
		('648', 'v', 'Subdivisión de forma', 'Subdivisión de forma', 1, 0, NULL, 6, NULL, NULL, '', NULL, 0, '', '', '', NULL),
		('648', 'x', 'Subdivisión general', 'Subdivisión general', 1, 0, NULL, 6, NULL, NULL, '', NULL, 0, '', '', '', NULL),
		('648', 'y', 'Subdivisión cronológica', 'Subdivisión cronológica', 1, 0, NULL, 6, NULL, NULL, '', NULL, 0, '', '', '', NULL),
		('648', 'z', 'Subdivisión geográfica', 'Subdivisión geográfica', 1, 0, NULL, 6, NULL, NULL, '', NULL, 0, '', '', '', NULL),
		('650', '0', 'Número de control del registro de autoridad o número normalizado', 'Número de control del registro de autoridad o número normalizado', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('650', '2', 'Fuente del encabezamiento o término', 'Fuente del encabezamiento o término', 0, 0, '', 6, '', '', '', 0, 0, '', '', '', NULL),
		('650', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, '', 6, '', '', '', 0, -6, '', '', '', NULL),
		('650', '4', 'Código de función/relación', 'Código de función/relación', 1, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('650', '6', 'Enlace', 'Enlace', 0, 0, '', 6, '', '', '', 0, -6, '', '', '', NULL),
		('650', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 6, '', '', '', 0, -6, '', '', '', NULL),
		('650', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 6, '', '', '', 0, -5, '', '', '', NULL),
		('650', 'a', 'Término de materia o nombre geográfico como elemento de entrada', 'Término de materia o nombre geográfico como elemento de entrada', 0, 0, 'bibliosubject.subject', 6, '', 'TOPIC_TERM', '', 0, 0, '', '''6003'',''600a'',''600b'',''600c'',''600d'',''600e'',''600f'',''600g'',''600h'',''600k'',''600l'',''600m'',''600n'',''600o'',''600p'',''600r'',''600s'',''600t'',''600u'',''600x'',''600z'',''600y'',''600v'',''6103'',''610a'',''610b'',''610c'',''610d'',''610e'',''610f'',''610g'',''610h'',''610k'',''610l'',''610m'',''610n'',''610o'',''610p'',''610r'',''610s'',''610t'',''610u'',''610x'',''610z'',''610y'',''610v'',''6113'',''611a'',''611b'',''611c'',''611d'',''611e'',''611f'',''611g'',''611h'',''611k'',''611l'',''611m'',''611n'',''611o'',''611p'',''611r'',''611s'',''611t'',''611u'',''611x'',''611z'',''611y'',''611v'',''630a'',''630b'',''630c'',''630d'',''630e'',''630f'',''630g'',''630h'',''630k'',''630l'',''630m'',''630n'',''630o'',''630p'',''630r'',''630s'',''630t'',''630x'',''630z'',''630y'',''630v'',''6483'',''648a'',''648x'',''648z'',''648y'',''648v'',''6503'',''650b'',''650c'',''650d'',''650e'',''650x'',''650z'',''650y'',''650v'',''6513'',''651a'',''651b'',''651c'',''651d'',''651e'',''651x'',''651z'',''651y'',''651v'',''653a'',''6543'',''654a'',''654b'',''654x'',''654z'',''654y'',''654v'',''6553'',''655a'',''655b'',''655x'',''655z'',''655y'',''655v'',''6563'',''656a'',''656k'',''656x'',''656z'',''656y'',''656v'',''6573'',''657a'',''657x'',''657z'',''657y'',''657v'',''658a'',''658b'',''658c'',''658d'',''658v''', '', NULL),
		('650', 'b', 'Término de materia que sigue a un nombre geográfico como elemento de entrada', 'Término de materia que sigue a un nombre geográfico como elemento de entrada', 0, 0, '', 6, '', '', '', 0, -1, '', '', '', NULL),
		('650', 'c', 'Localización del acontecimiento', 'Localización del acontecimiento', 0, 0, '', 6, '', '', '', 0, -1, '', '', '', NULL),
		('650', 'd', 'Fechas vigentes', 'Fechas vigentes', 0, 0, '', 6, '', '', '', 0, -1, '', '', '', NULL),
		('650', 'e', 'Término indicativo de función/relación', 'Término indicativo de función/relación', 1, 0, '', 6, '', '', '', 0, -1, '', '', '', NULL),
		('650', 'g', 'Información miscelánea', 'Información miscelánea', 1, 0, '', 6, '', '', '', 0, -1, '', '', '', NULL),
		('650', 'v', 'Subdivisión de forma', 'Subdivisión de forma', 1, 0, '', 6, '', '', '', 0, 0, '', '', '', NULL),
		('650', 'x', 'Subdivisión general', 'Subdivisión general', 1, 0, '', 6, '', '', '', 0, 0, '', '', '', NULL),
		('650', 'y', 'Subdivisión cronológica', 'Subdivisión cronológica', 1, 0, '', 6, '', '', '', 0, 0, '', '', '', NULL),
		('650', 'z', 'Subdivisión geográfica', 'Subdivisión geográfica', 1, 0, '', 6, '', '', '', 0, 0, '', '', '', NULL),
		('651', '0', 'Número de control del registro de autoridad o número normalizado', 'Número de control del registro de autoridad o número normalizado', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('651', '2', 'Fuente del encabezamiento o término', 'Fuente del encabezamiento o término', 0, 0, '', 6, '', '', '', NULL, 0, '', '', '', NULL),
		('651', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('651', '4', 'Código de función/relación', 'Código de función/relación', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('651', '6', 'Enlace', 'Enlace', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('651', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('651', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 6, '', '', '', 0, -5, '', '', '', NULL),
		('651', 'a', 'Nombre geográfico', 'Nombre geográfico', 0, 0, '', 6, '', 'GEOGR_NAME', '', NULL, 0, '', '', '', NULL),
		('651', 'b', 'Nombre geográfico que sigue al elemento de entrada de lugar [OBSOLETO]', 'Nombre geográfico que sigue al elemento de entrada de lugar [OBSOLETO]', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('651', 'e', 'Término indicativo de función/relación', 'Término indicativo de función/relación', 1, 0, '', 6, '', '', '', NULL, -1, '', '', '', NULL),
		('651', 'g', 'Información miscelánea', 'Información miscelánea', 1, 0, '', 6, '', '', '', 0, -1, '', '', '', NULL),
		('651', 'v', 'Subdivisión de forma', 'Subdivisión de forma', 1, 0, '', 6, '', '', '', NULL, 0, '', '', '', NULL),
		('651', 'x', 'Subdivisión general', 'Subdivisión general', 1, 0, '', 6, '', '', '', NULL, 0, '', '', '', NULL),
		('651', 'y', 'Subdivisión cronológica', 'Subdivisión cronológica', 1, 0, '', 6, '', '', '', NULL, 0, '', '', '', NULL),
		('651', 'z', 'Subdivisión geográfica', 'Subdivisión geográfica', 1, 0, '', 6, '', '', '', NULL, 0, '', '', '', NULL),
		('652', 'a', 'Nombre geográfico o elemento de lugar', 'Nombre geográfico o elemento de lugar', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('652', 'x', 'Subdivisión general', 'Subdivisión general', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('652', 'y', 'Subdivisión cronológica', 'Subdivisión cronológica', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('652', 'z', 'Subdivisión geográfica', 'Subdivisión geográfica', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('653', '6', 'Enlace', 'Enlace', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('653', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('653', 'a', 'Término no controlado', 'Término no controlado', 1, 0, NULL, 6, NULL, NULL, '', NULL, 0, '', '', '', NULL),
		('654', '0', 'Número de control de registro de autoridad', 'Número de control de registro de autoridad', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('654', '2', 'Fuente del encabezamiento o término', 'Fuente del encabezamiento o término', 0, 0, '', 6, '', '', '', NULL, 0, '', '', '', NULL),
		('654', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('654', '4', 'Código de función/relación', 'Código de función/relación', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('654', '6', 'Enlace', 'Enlace', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('654', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('654', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 6, '', '', '', 0, -5, '', '', '', NULL),
		('654', 'a', 'Término principal', 'Término principal', 1, 0, '', 6, '', 'TOPIC_TERM', '', NULL, 0, '', '', '', NULL),
		('654', 'b', 'Término no-principal', 'Término no-principal', 1, 0, '', 6, '', '', '', NULL, 0, '', '', '', NULL),
		('654', 'c', 'Designación de faceta/jerarquía', 'Designación de faceta/jerarquía', 1, 0, '', 6, '', '', '', NULL, 0, '', '', '', NULL),
		('654', 'e', 'Término indicativo de función/relación', 'Término indicativo de función/relación', 1, 0, '', 6, '', '', '', NULL, -1, '', '', '', NULL),
		('654', 'v', 'Subdivisión de forma', 'Subdivisión de forma', 1, 0, '', 6, '', '', '', NULL, 0, '', '', '', NULL),
		('654', 'x', 'Subdivisión general', 'Subdivisión general', 1, 0, '', 6, '', '', '', NULL, 0, '', '', '', NULL),
		('654', 'y', 'Subdivisión cronológica', 'Subdivisión cronológica', 1, 0, '', 6, '', '', '', NULL, 0, '', '', '', NULL),
		('654', 'z', 'Subdivisión geográfica', 'Subdivisión geográfica', 1, 0, '', 6, '', '', '', NULL, 0, '', '', '', NULL),
		('655', '0', 'Número de control de registro de autoridad', 'Número de control de registro de autoridad', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('655', '2', 'Fuente del término', 'Fuente del término', 0, 0, '', 6, '', '', '', NULL, 0, '', '', '', NULL),
		('655', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('655', '5', 'Institución que aplica el campo', 'Institución que aplica el campo', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('655', '6', 'Enlace', 'Enlace', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('655', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('655', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 6, '', '', '', 0, -5, '', '', '', NULL),
		('655', 'a', 'Datos o término principal de género/forma', 'Datos o término principal de género/forma', 0, 0, '', 6, '', 'GENRE/FORM', '', NULL, 0, '', '', '', NULL),
		('655', 'b', 'Término no-principal', 'Término no-principal', 1, 0, '', 6, '', '', '', NULL, 0, '', '', '', NULL),
		('655', 'c', 'Designación de faceta/jerarquía', 'Designación de faceta/jerarquía', 1, 0, '', 6, '', '', '', NULL, 0, '', '', '', NULL),
		('655', 'v', 'Subdivisión de forma', 'Subdivisión de forma', 1, 0, '', 6, '', '', '', NULL, 0, '', '', '', NULL),
		('655', 'x', 'Subdivisión general', 'Subdivisión general', 1, 0, '', 6, '', '', '', NULL, 0, '', '', '', NULL),
		('655', 'y', 'Subdivisión cronológica', 'Subdivisión cronológica', 1, 0, '', 6, '', '', '', NULL, 0, '', '', '', NULL),
		('655', 'z', 'Subdivisión geográfica', 'Subdivisión geográfica', 1, 0, '', 6, '', '', '', NULL, 0, '', '', '', NULL),
		('656', '0', 'Número de control de registro de autoridad', 'Número de control de registro de autoridad', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('656', '2', 'Fuente del término', 'Fuente del término', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('656', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('656', '6', 'Enlace', 'Enlace', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('656', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('656', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 6, '', '', '', 0, -5, '', '', '', NULL),
		('656', 'a', 'Ocupación', 'Ocupación', 0, 0, '', 6, '', 'TOPIC_TERM', '', NULL, -6, '', '', '', NULL),
		('656', 'k', 'Forma', 'Forma', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('656', 'v', 'Subdivisión de forma', 'Subdivisión de forma', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('656', 'x', 'Subdivisión general', 'Subdivisión general', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('656', 'y', 'Subdivisión cronológica', 'Subdivisión cronológica', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('656', 'z', 'Subdivisión geográfica', 'Subdivisión geográfica', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('657', '0', 'Número de control de registro de autoridad', 'Número de control de registro de autoridad', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('657', '2', 'Fuente del término', 'Fuente del término', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('657', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('657', '6', 'Enlace', 'Enlace', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('657', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('657', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 6, '', '', '', 0, -5, '', '', '', NULL),
		('657', 'a', 'Función', 'Función', 0, 0, '', 6, '', 'TOPIC_TERM', '', NULL, -6, '', '', '', NULL),
		('657', 'v', 'Subdivisión de forma', 'Subdivisión de forma', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('657', 'x', 'Subdivisión general', 'Subdivisión general', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('657', 'y', 'Subdivisión cronológica', 'Subdivisión cronológica', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('657', 'z', 'Subdivisión geográfica', 'Subdivisión geográfica', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('658', '2', 'Fuente del término o código', 'Fuente del término o código', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('658', '6', 'Enlace', 'Enlace', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('658', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('658', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 6, '', '', '', 0, -5, '', '', '', NULL),
		('658', 'a', 'Objetivo curricular principal', 'Objetivo curricular principal', 0, 0, '', 6, '', 'TOPIC_TERM', '', NULL, 0, '', '', '', NULL),
		('658', 'b', 'Objetivo curricular subordinado', 'Objetivo curricular subordinado', 1, 0, '', 6, '', '', '', NULL, 0, '', '', '', NULL),
		('658', 'c', 'Código del currículo', 'Código del currículo', 0, 0, '', 6, '', '', '', NULL, 0, '', '', '', NULL),
		('658', 'd', 'Factor de correlación', 'Factor de correlación', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('662', '0', 'Número de control de registro de autoridad', 'Número de control de registro de autoridad', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('662', '2', 'Fuente del encabezamiento o término', 'Fuente del encabezamiento o término', 0, 0, '', 6, '', '', '', NULL, 0, '', '', '', NULL),
		('662', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('662', '4', 'Código de función/relación', 'Código de función/relación', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('662', '6', 'Enlace', 'Enlace', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('662', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('662', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 6, '', '', '', 0, -5, '', '', '', NULL),
		('662', 'a', 'País o entidad superior', 'País o entidad superior', 1, 0, '', 6, '', 'GEOGR_NAME', '', NULL, 0, '', '', '', NULL),
		('662', 'b', 'Jurisdicción política de primer nivel', 'Jurisdicción política de primer nivel', 0, 0, '', 6, '', '', '', NULL, 0, '', '', '', NULL),
		('662', 'c', 'Jurisdicción política intermedia', 'Jurisdicción política intermedia', 1, 0, '', 6, '', '', '', NULL, 0, '', '', '', NULL),
		('662', 'd', 'Ciudad', 'Ciudad', 0, 0, '', 6, '', '', '', NULL, 0, '', '', '', NULL),
		('662', 'e', 'Término indicativo de función/relación', 'Término indicativo de función/relación', 1, 0, '', 6, '', '', '', NULL, -1, '', '', '', NULL),
		('662', 'f', 'Subdivisión de ciudad', 'Subdivisión de ciudad', 1, 0, '', 6, '', '', '', NULL, 0, '', '', '', NULL),
		('662', 'g', 'Otras regiones o rasgos geográficos no jurisdiccionales', 'Otras regiones o rasgos geográficos no jurisdiccionales', 1, 0, '', 6, '', '', '', NULL, 0, '', '', '', NULL),
		('662', 'h', 'Área extraterrestre', 'Área extraterrestre', 1, 0, '', 6, '', '', '', NULL, 0, '', '', '', NULL),
		('690', '%', '% (RLIN)', '% (RLIN)', 0, 0, '', 6, '', '', '', 0, -6, '', '', '', NULL),
		('690', '2', 'Fuente del encabezamiento o término', 'Fuente del encabezamiento o término', 0, 0, '', 6, '', '', '', 0, 0, '', '', '', NULL),
		('690', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, '', 6, '', '', '', 0, -6, '', '', '', NULL),
		('690', '6', 'Enlace', 'Enlace', 0, 0, '', 6, '', '', '', 0, -6, '', '', '', NULL),
		('690', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 6, '', '', '', 0, -6, '', '', '', NULL),
		('690', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 6, '', '', '', 0, -5, '', '', '', NULL),
		('690', 'a', 'Término de materia o nombre geográfico como elemento inicial', 'Término de materia o nombre geográfico como elemento inicial', 0, 0, '', 6, '', 'TOPIC_TERM', '', 0, 0, '', '', '', NULL),
		('690', 'b', 'Término de materia que sigue a un nombre geográfico como elemento inicial', 'Término de materia que sigue a un nombre geográfico como elemento inicial', 0, 0, '', 6, '', '', '', 0, -1, '', '', '', NULL),
		('690', 'c', 'Localización del acontecimiento', 'Localización del acontecimiento', 0, 0, '', 6, '', '', '', 0, -6, '', '', '', NULL),
		('690', 'd', 'Fechas vigentes', 'Fechas vigentes', 0, 0, '', 6, '', '', '', 0, -1, '', '', '', NULL),
		('690', 'e', 'Término indicativo de función/relación', 'Término indicativo de función/relación', 0, 0, '', 6, '', '', '', 0, -1, '', '', '', NULL),
		('690', 'v', 'Subdivisión de forma', 'Subdivisión de forma', 1, 0, '', 6, '', '', '', 0, 0, '', '', '', NULL),
		('690', 'x', 'Subdivisión general', 'Subdivisión general', 1, 0, '', 6, '', '', '', 0, 0, '', '', '', NULL),
		('690', 'y', 'Subdivisión cronológica', 'Subdivisión cronológica', 1, 0, '', 6, '', '', '', 0, 0, '', '', '', NULL),
		('690', 'z', 'Subdivisión geográfica', 'Subdivisión geográfica', 1, 0, '', 6, '', '', '', 0, 0, '', '', '', NULL),
		('691', '%', '% (RLIN)', '% (RLIN)', 0, 0, '', 6, '', '', '', 0, -6, '', '', '', NULL),
		('691', '2', 'Fuente del encabezamiento o término', 'Fuente del encabezamiento o término', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('691', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('691', '6', 'Enlace', 'Enlace', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('691', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('691', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 6, '', '', '', 0, -5, '', '', '', NULL),
		('691', 'a', 'Nombre geográfico', 'Nombre geográfico', 0, 0, '', 6, '', 'GEOGR_NAME', '', NULL, -6, '', '', '', NULL),
		('691', 'b', 'Nombre geográfico que sigue al elemento de entrada de lugar [OBSOLETO]', 'Nombre geográfico que sigue al elemento de entrada de lugar [OBSOLETO]', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('691', 'v', 'Subdivisión de forma', 'Subdivisión de forma', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('691', 'x', 'Subdivisión general', 'Subdivisión general', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('691', 'y', 'Subdivisión cronológica', 'Subdivisión cronológica', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('691', 'z', 'Subdivisión geográfica', 'Subdivisión geográfica', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('696', '%', '% (RLIN)', '% (RLIN)', 0, 0, '', 6, '', '', '', 0, -6, '', '', '', NULL),
		('696', '2', 'Fuente del encabezamiento o término', 'Fuente del encabezamiento o término', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('696', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('696', '4', 'Código de función/relación', 'Código de función/relación', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('696', '6', 'Enlace', 'Enlace', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('696', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('696', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 6, '', '', '', 0, -5, '', '', '', NULL),
		('696', 'a', 'Nombre de persona', 'Nombre de persona', 0, 0, '', 6, '', 'PERSO_NAME', '', NULL, -6, '', '', '', NULL),
		('696', 'b', 'Numeración', 'Numeración', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('696', 'c', 'Títulos y otros términos asociados al nombre', 'Títulos y otros términos asociados al nombre', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('696', 'd', 'Fechas asociadas al nombre', 'Fechas asociadas al nombre', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('696', 'e', 'Término indicativo de función/relación', 'Término indicativo de función/relación', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('696', 'f', 'Fecha de publicación/de la obra', 'Fecha de publicación/de la obra', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('696', 'g', 'Información miscelánea', 'Información miscelánea', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('696', 'h', 'Medio', 'Medio', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('696', 'j', 'Calificador de atribución', 'Calificador de atribución', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('696', 'k', 'Subencabezamiento de forma', 'Subencabezamiento de forma', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('696', 'l', 'Lenguaje de la obra', 'Lenguaje de la obra', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('696', 'm', 'Medio de interpretación para música', 'Medio de interpretación para música', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('696', 'n', 'Número de parte o sección de la obra', 'Número de parte o sección de la obra', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('696', 'o', 'Mención de arreglo para música', 'Mención de arreglo para música', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('696', 'p', 'Nombre de parte o sección de la obra', 'Nombre de parte o sección de la obra', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('696', 'q', 'Forma completa/desarrollada del nombre', 'Forma completa/desarrollada del nombre', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('696', 'r', 'Clave para música', 'Clave para música', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('696', 's', 'Versión', 'Versión', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('696', 't', 'Título de la obra', 'Título de la obra', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('696', 'u', 'Filiación', 'Filiación', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('696', 'v', 'Subdivisión de forma', 'Subdivisión de forma', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('696', 'x', 'Subdivisión general', 'Subdivisión general', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('696', 'y', 'Subdivisión cronológica', 'Subdivisión cronológica', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('696', 'z', 'Subdivisión geográfica', 'Subdivisión geográfica', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('697', '%', '% (RLIN)', '% (RLIN)', 0, 0, '', 6, '', '', '', 0, -6, '', '', '', NULL),
		('697', '2', 'Fuente del encabezamiento o término', 'Fuente del encabezamiento o término', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('697', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('697', '4', 'Código de función/relación', 'Código de función/relación', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('697', '6', 'Enlace', 'Enlace', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('697', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('697', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 6, '', '', '', 0, -5, '', '', '', NULL),
		('697', 'a', 'Nombre de entidad corporativa o nombre de jurisdicción como elemento de entrada', 'Nombre de entidad corporativa o nombre de jurisdicción como elemento de entrada', 0, 0, '', 6, '', 'CORPO_NAME', '', NULL, -6, '', '', '', NULL),
		('697', 'b', 'Unidad subordinada', 'Unidad subordinada', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('697', 'c', 'Sede del congreso/Lugar de la reunión', 'Sede del congreso/Lugar de la reunión', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('697', 'd', 'Fecha del congreso/reunión o de la firma de un tratado', 'Fecha del congreso/reunión o de la firma de un tratado', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('697', 'e', 'Término indicativo de función/relación', 'Término indicativo de función/relación', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('697', 'f', 'Fecha de publicación/de la obra', 'Fecha de publicación/de la obra', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('697', 'g', 'Información miscelánea', 'Información miscelánea', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('697', 'h', 'Medio', 'Medio', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('697', 'k', 'Subencabezamiento de forma', 'Subencabezamiento de forma', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('697', 'l', 'Lenguaje de la obra', 'Lenguaje de la obra', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('697', 'm', 'Medio de interpretación para música', 'Medio de interpretación para música', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('697', 'n', 'Número del congreso/reunión o número de parte o sección', 'Número del congreso/reunión o número de parte o sección', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('697', 'o', 'Mención de arreglo para música', 'Mención de arreglo para música', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('697', 'p', 'Nombre de parte o sección de la obra', 'Nombre de parte o sección de la obra', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('697', 'r', 'Clave para música', 'Clave para música', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('697', 's', 'Versión', 'Versión', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('697', 't', 'Título de la obra', 'Título de la obra', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('697', 'u', 'Filiación', 'Filiación', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('697', 'v', 'Subdivisión de forma', 'Subdivisión de forma', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('697', 'x', 'Subdivisión general', 'Subdivisión general', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('697', 'y', 'Subdivisión cronológica', 'Subdivisión cronológica', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('697', 'z', 'Subdivisión geográfica', 'Subdivisión geográfica', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('698', '%', '% (RLIN)', '% (RLIN)', 0, 0, '', 6, '', '', '', 0, -6, '', '', '', NULL),
		('698', '2', 'Fuente del encabezamiento o término', 'Fuente del encabezamiento o término', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('698', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('698', '4', 'Código de función/relación', 'Código de función/relación', 1, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('698', '6', 'Enlace', 'Enlace', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('698', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('698', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 6, '', '', '', 0, -5, '', '', '', NULL),
		('698', 'a', 'Nombre de congreso/reunión o jurisdicción como elemento de entrada', 'Nombre de congreso/reunión o jurisdicción como elemento de entrada', 0, 0, NULL, 6, NULL, 'MEETI_NAME', '', NULL, -6, '', '', '', NULL),
		('698', 'b', 'Número (BK CF MP MU SE VM MX) [OBSOLETE]', 'Número (BK CF MP MU SE VM MX) [OBSOLETE]', 1, 0, NULL, -1, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('698', 'c', 'Sede del congreso/Lugar de la reunión', 'Sede del congreso/Lugar de la reunión', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('698', 'd', 'Fecha del congreso/reunión', 'Fecha del congreso/reunión', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('698', 'e', 'Unidad subordinada', 'Unidad subordinada', 1, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('698', 'f', 'Fecha de publicación/de la obra', 'Fecha de publicación/de la obra', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('698', 'g', 'Información miscelánea', 'Información miscelánea', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('698', 'h', 'Medio', 'Medio', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('698', 'k', 'Subencabezamiento de forma', 'Subencabezamiento de forma', 1, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('698', 'l', 'Lenguaje de la obra', 'Lenguaje de la obra', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('698', 'n', 'Número del congreso/reunión o número de parte o sección', 'Número del congreso/reunión o número de parte o sección', 1, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('698', 'p', 'Nombre de parte o sección de la obra', 'Nombre de parte o sección de la obra', 1, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('698', 'q', 'Nombre de congreso/reunión que sigue a un nombre de jurisdicción como elemento de entrada', 'Nombre de congreso/reunión que sigue a un nombre de jurisdicción como elemento de entrada', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('698', 's', 'Versión', 'Versión', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('698', 't', 'Título de la obra', 'Título de la obra', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('698', 'u', 'Filiación', 'Filiación', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('698', 'v', 'Subdivisión de forma', 'Subdivisión de forma', 1, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('698', 'x', 'Subdivisión general', 'Subdivisión general', 1, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('698', 'y', 'Subdivisión cronológica', 'Subdivisión cronológica', 1, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('698', 'z', 'Subdivisión geográfica', 'Subdivisión geográfica', 1, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('699', '%', '% (RLIN)', '% (RLIN)', 0, 0, '', 6, '', '', '', 0, -6, '', '', '', NULL),
		('699', '2', 'Fuente del encabezamiento o término', 'Fuente del encabezamiento o término', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('699', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('699', '6', 'Enlace', 'Enlace', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('699', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('699', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 6, '', '', '', 0, -5, '', '', '', NULL),
		('699', 'a', 'Título uniforme', 'Título uniforme', 0, 0, NULL, 6, NULL, 'UNIF_TITLE', '', NULL, -6, '', '', '', NULL),
		('699', 'd', 'Fecha de la firma de un tratado', 'Fecha de la firma de un tratado', 1, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('699', 'f', 'Fecha de publicación/de la obra', 'Fecha de publicación/de la obra', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('699', 'g', 'Información miscelánea', 'Información miscelánea', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('699', 'h', 'Medio', 'Medio', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('699', 'k', 'Subencabezamiento de forma', 'Subencabezamiento de forma', 1, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('699', 'l', 'Lenguaje de la obra', 'Lenguaje de la obra', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('699', 'm', 'Medio de interpretación para música', 'Medio de interpretación para música', 1, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('699', 'n', 'Número de parte o sección de la obra', 'Número de parte o sección de la obra', 1, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('699', 'o', 'Mención de arreglo para música', 'Mención de arreglo para música', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('699', 'p', 'Nombre de parte o sección de la obra', 'Nombre de parte o sección de la obra', 1, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('699', 'r', 'Clave para música', 'Clave para música', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('699', 's', 'Versión', 'Versión', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('699', 't', 'Título de la obra', 'Título de la obra', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('699', 'v', 'Subdivisión de forma', 'Subdivisión de forma', 1, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('699', 'x', 'Subdivisión general', 'Subdivisión general', 1, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('699', 'y', 'Subdivisión cronológica', 'Subdivisión cronológica', 1, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('700', '0', 'Número de control del registro de autoridad o número normalizado', 'Número de control del registro de autoridad o número normalizado', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('700', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('700', '4', 'Código de función/relación', 'Código de función/relación', 1, 0, '', 7, '', '', '', NULL, 0, '', '', '', NULL),
		('700', '5', 'Institución que aplica el campo', 'Institución que aplica el campo', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('700', '6', 'Enlace', 'Enlace', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('700', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('700', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 7, '', '', '', 0, -5, '', '', '', NULL),
		('700', 'a', 'Nombre de persona', 'Nombre de persona', 0, 0, 'additionalauthors.author', 7, '', 'PERSO_NAME', '', NULL, 0, '', '', '', NULL),
		('700', 'b', 'Numeración', 'Numeración', 0, 0, '', 7, '', '', '', NULL, -1, '', '', '', NULL),
		('700', 'c', 'Títulos y otros términos asociados al nombre', 'Títulos y otros términos asociados al nombre', 1, 0, '', 7, '', '', '', NULL, -1, '', '', '', NULL),
		('700', 'd', 'Fechas asociadas al nombre', 'Fechas asociadas al nombre', 0, 0, '', 7, '', '', '', NULL, 0, '', '', '', NULL),
		('700', 'e', 'Término indicativo de función/relación', 'Término indicativo de función/relación', 1, 0, '', 7, '', '', '', NULL, 0, '', '', '', NULL),
		('700', 'f', 'Fecha de publicación/de la obra', 'Fecha de publicación/de la obra', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('700', 'g', 'Información miscelánea', 'Información miscelánea', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('700', 'h', 'Medio', 'Medio', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('700', 'i', 'Información de relación/Frase instructiva de referencia', 'Información de relación/Frase instructiva de referencia', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('700', 'j', 'Calificador de atribución', 'Calificador de atribución', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('700', 'k', 'Subencabezamiento de forma', 'Subencabezamiento de forma', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('700', 'l', 'Lenguaje de la obra', 'Lenguaje de la obra', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('700', 'm', 'Medio de interpretación para música', 'Medio de interpretación para música', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('700', 'n', 'Número de parte o sección de la obra', 'Número de parte o sección de la obra', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('700', 'o', 'Mención de arreglo para música', 'Mención de arreglo para música', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('700', 'p', 'Nombre de parte o sección de la obra', 'Nombre de parte o sección de la obra', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('700', 'q', 'Forma completa/desarrollada del nombre', 'Forma completa/desarrollada del nombre', 0, 0, '', 7, '', '', '', NULL, 0, '', '', '', NULL),
		('700', 'r', 'Clave para música', 'Clave para música', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('700', 's', 'Versión', 'Versión', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('700', 't', 'Título de la obra', 'Título de la obra', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('700', 'u', 'Filiación', 'Filiación', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('700', 'x', 'Número Internacional Normalizado para Publicaciones Seriadas', 'Número Internacional Normalizado para Publicaciones Seriadas', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('705', 'a', 'Nombre de persona', 'Nombre de persona', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('705', 'b', 'Numeración', 'Numeración', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('705', 'c', 'Títulos y otros términos asociados al nombre', 'Títulos y otros términos asociados al nombre', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('705', 'd', 'Fechas asociadas al nombre', 'Fechas asociadas al nombre', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('705', 'e', 'Término indicativo de función/relación', 'Término indicativo de función/relación', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('705', 'f', 'Fecha de publicación/de la obra', 'Fecha de publicación/de la obra', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('705', 'g', 'Información miscelánea', 'Información miscelánea', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('705', 'h', 'Medio', 'Medio', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('705', 'k', 'Subencabezamiento de forma', 'Subencabezamiento de forma', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('705', 'l', 'Lenguaje de la obra', 'Lenguaje de la obra', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('705', 'm', 'Medio de interpretación para música', 'Medio de interpretación para música', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('705', 'n', 'Número de parte o sección de la obra', 'Número de parte o sección de la obra', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('705', 'o', 'Mención de arreglo para música', 'Mención de arreglo para música', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('705', 'p', 'Nombre de parte o sección de la obra', 'Nombre de parte o sección de la obra', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('705', 'r', 'Clave para música', 'Clave para música', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('705', 's', 'Versión', 'Versión', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('705', 't', 'Título de la obra', 'Título de la obra', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('710', '0', 'Número de control del registro de autoridad o número normalizado', 'Número de control del registro de autoridad o número normalizado', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('710', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('710', '4', 'Código de función/relación', 'Código de función/relación', 1, 0, '', 7, '', '', '', NULL, 0, '', '', '', NULL),
		('710', '5', 'Institución que aplica el campo', 'Institución que aplica el campo', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('710', '6', 'Enlace', 'Enlace', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('710', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('710', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 7, '', '', '', 0, -5, '', '', '', NULL),
		('710', 'a', 'Nombre de entidad corporativa o nombre de jurisdicción como elemento de entrada', 'Nombre de entidad corporativa o nombre de jurisdicción como elemento de entrada', 0, 0, '', 7, '', 'CORPO_NAME', '', NULL, 0, '', '', '', NULL),
		('710', 'b', 'Unidad subordinada', 'Unidad subordinada', 1, 0, '', 7, '', '', '', NULL, 0, '', '', '', NULL),
		('710', 'c', 'Sede del congreso/Lugar de la reunión', 'Sede del congreso/Lugar de la reunión', 1, 0, '', 7, '', '', '', NULL, -1, '', '', '', NULL),
		('710', 'd', 'Fecha del congreso/reunión o de la firma de un tratado', 'Fecha del congreso/reunión o de la firma de un tratado', 1, 0, '', 7, '', '', '', NULL, -1, '', '', '', NULL),
		('710', 'e', 'Término indicativo de función/relación', 'Término indicativo de función/relación', 1, 0, '', 7, '', '', '', NULL, 0, '', '', '', NULL),
		('710', 'f', 'Fecha de publicación/de la obra', 'Fecha de publicación/de la obra', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('710', 'g', 'Información miscelánea', 'Información miscelánea', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('710', 'h', 'Medio', 'Medio', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('710', 'i', 'Información de relación/Frase instructiva de referencia', 'Información de relación/Frase instructiva de referencia', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('710', 'k', 'Subencabezamiento de forma', 'Subencabezamiento de forma', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('710', 'l', 'Lenguaje de la obra', 'Lenguaje de la obra', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('710', 'm', 'Medio de interpretación para música', 'Medio de interpretación para música', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('710', 'n', 'Número del congreso/reunión o número de parte o sección', 'Número del congreso/reunión o número de parte o sección', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('710', 'o', 'Mención de arreglo para música', 'Mención de arreglo para música', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('710', 'p', 'Nombre de parte o sección de la obra', 'Nombre de parte o sección de la obra', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('710', 'r', 'Clave para música', 'Clave para música', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('710', 's', 'Versión', 'Versión', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('710', 't', 'Título de la obra', 'Título de la obra', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('710', 'u', 'Filiación', 'Filiación', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('710', 'x', 'Número Internacional Normalizado para Publicaciones Seriadas', 'Número Internacional Normalizado para Publicaciones Seriadas', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('711', '0', 'Número de control del registro de autoridad o número normalizado', 'Número de control del registro de autoridad o número normalizado', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('711', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('711', '4', 'Código de función/relación', 'Código de función/relación', 1, 0, NULL, 7, NULL, NULL, '', NULL, 0, '', '', '', NULL),
		('711', '5', 'Institución que aplica el campo', 'Institución que aplica el campo', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('711', '6', 'Enlace', 'Enlace', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('711', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('711', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 7, '', '', '', 0, -5, '', '', '', NULL),
		('711', 'a', 'Nombre de congreso/reunión o jurisdicción como elemento de entrada', 'Nombre de congreso/reunión o jurisdicción como elemento de entrada', 0, 0, NULL, 7, NULL, 'MEETI_NAME', '', NULL, 0, '', '', '', NULL),
		('711', 'b', 'Número (BK CF MP MU SE VM MX) [OBSOLETO]', 'Número (BK CF MP MU SE VM MX) [OBSOLETO]', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('711', 'c', 'Sede del congreso/Lugar de la reunión', 'Sede del congreso/Lugar de la reunión', 1, 0, NULL, 7, NULL, NULL, '', NULL, 0, '', '', '', NULL),
		('711', 'd', 'Fecha del congreso/reunión', 'Fecha del congreso/reunión', 0, 0, NULL, 7, NULL, NULL, '', NULL, 0, '', '', '', NULL),
		('711', 'e', 'Unidad subordinada', 'Unidad subordinada', 1, 0, NULL, 7, NULL, NULL, '', NULL, 0, '', '', '', NULL),
		('711', 'f', 'Fecha de publicación/de la obra', 'Fecha de publicación/de la obra', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('711', 'g', 'Información miscelánea', 'Información miscelánea', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('711', 'h', 'Medio', 'Medio', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('711', 'i', 'Información de relación/Frase instructiva de referencia', 'Información de relación/Frase instructiva de referencia', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('711', 'j', 'Término indicativo de función/relación', 'Término indicativo de función/relación', 1, 0, NULL, 7, NULL, NULL, '', NULL, 0, '', '', '', NULL),
		('711', 'k', 'Subencabezamiento de forma', 'Subencabezamiento de forma', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('711', 'l', 'Lenguaje de la obra', 'Lenguaje de la obra', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('711', 'n', 'Número del congreso/reunión o número de parte o sección', 'Número del congreso/reunión o número de parte o sección', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('711', 'p', 'Nombre de parte o sección de la obra', 'Nombre de parte o sección de la obra', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('711', 'q', 'Nombre de congreso/reunión que sigue a un nombre de jurisdicción como elemento de entrada', 'Nombre de congreso/reunión que sigue a un nombre de jurisdicción como elemento de entrada', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('711', 's', 'Versión', 'Versión', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('711', 't', 'Título de la obra', 'Título de la obra', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('711', 'u', 'Filiación', 'Filiación', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('711', 'x', 'Número Internacional Normalizado para Publicaciones Seriadas', 'Número Internacional Normalizado para Publicaciones Seriadas', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('715', '%', '% (RLIN)', '% (RLIN)', 0, 0, '', 7, '', '', '', 0, -6, '', '', '', NULL),
		('715', 'a', 'Nombre de entidad corporativa o nombre de jurisdicción', 'Nombre de entidad corporativa o nombre de jurisdicción', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('715', 'b', 'Unidad subordinada', 'Unidad subordinada', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('715', 'e', 'Término indicativo de función/relación', 'Término indicativo de función/relación', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('715', 'f', 'Fecha de publicación/de la obra', 'Fecha de publicación/de la obra', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('715', 'g', 'Información miscelánea', 'Información miscelánea', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('715', 'h', 'Medio', 'Medio', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('715', 'k', 'Subencabezamiento de forma', 'Subencabezamiento de forma', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('715', 'l', 'Lenguaje de la obra', 'Lenguaje de la obra', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('715', 'n', 'Número del congreso/reunión o número de parte o sección', 'Número del congreso/reunión o número de parte o sección', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('715', 'p', 'Nombre de parte o sección de la obra', 'Nombre de parte o sección de la obra', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('715', 'r', 'Clave para música', 'Clave para música', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('715', 's', 'Versión', 'Versión', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('715', 't', 'Título de la obra', 'Título de la obra', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('715', 'u', 'Información no impresos', 'Información no impresos', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('720', '4', 'Código de función/relación', 'Código de función/relación', 1, 0, NULL, 7, NULL, NULL, '', NULL, 0, '', '', '', NULL),
		('720', '6', 'Enlace', 'Enlace', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('720', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('720', 'a', 'Nombre', 'Nombre', 0, 0, '', 7, NULL, NULL, '', NULL, 0, '', '', '', NULL),
		('720', 'e', 'Término indicativo de función/relación', 'Término indicativo de función/relación', 1, 0, NULL, 7, NULL, NULL, '', NULL, 0, '', '', '', NULL),
		('730', '0', 'Número de control del registro de autoridad o número normalizado', 'Número de control del registro de autoridad o número normalizado', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('730', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('730', '5', 'Institución que aplica el campo', 'Institución que aplica el campo', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('730', '6', 'Enlace', 'Enlace', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('730', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('730', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 7, '', '', '', 0, -5, '', '', '', NULL),
		('730', 'a', 'Título uniforme', 'Título uniforme', 0, 0, '', 7, '', 'UNIF_TITLE', '', NULL, -1, '', '', '', NULL),
		('730', 'd', 'Fecha de la firma de un tratado', 'Fecha de la firma de un tratado', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('730', 'f', 'Fecha de publicación/de la obra', 'Fecha de publicación/de la obra', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('730', 'g', 'Información miscelánea', 'Información miscelánea', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('730', 'h', 'Medio', 'Medio', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('730', 'i', 'Información de relación/Frase instructiva de referencia', 'Información de relación/Frase instructiva de referencia', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('730', 'k', 'Subencabezamiento de forma', 'Subencabezamiento de forma', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('730', 'l', 'Lenguaje de la obra', 'Lenguaje de la obra', 0, 0, '', 7, '', '', '', NULL, -1, '', '', '', NULL),
		('730', 'm', 'Medio de interpretación para música', 'Medio de interpretación para música', 1, 0, '', 7, '', '', '', NULL, -1, '', '', '', NULL),
		('730', 'n', 'Número de parte o sección de la obra', 'Número de parte o sección de la obra', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('730', 'o', 'Mención de arreglo para música', 'Mención de arreglo para música', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('730', 'p', 'Nombre de parte o sección de la obra', 'Nombre de parte o sección de la obra', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('730', 'r', 'Clave para música', 'Clave para música', 0, 0, '', 7, '', '', '', NULL, -1, '', '', '', NULL),
		('730', 's', 'Versión', 'Versión', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('730', 't', 'Título de la obra', 'Título de la obra', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('730', 'x', 'Número Internacional Normalizado para Publicaciones Seriadas', 'Número Internacional Normalizado para Publicaciones Seriadas', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('740', '5', 'Institución que aplica el campo', 'Institución que aplica el campo', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('740', '6', 'Enlace', 'Enlace', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('740', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('740', 'a', 'Título relacionado o analítico no controlado', 'Título relacionado o analítico no controlado', 0, 0, '', 7, '', '', '', NULL, -1, '', '', '', NULL),
		('740', 'h', 'Medio', 'Medio', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('740', 'n', 'Número de parte o sección de la obra', 'Número de parte o sección de la obra', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('740', 'p', 'Nombre de parte o sección de la obra', 'Nombre de parte o sección de la obra', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('751', '0', 'Número de control de registro de autoridad', 'Número de control de registro de autoridad', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('751', '2', 'Fuente del encabezamiento o término', 'Fuente del encabezamiento o término', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('751', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('751', '4', 'Código de función/relación', 'Código de función/relación', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('751', '6', 'Enlace', 'Enlace', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('751', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('751', 'a', 'Nombre geográfico', 'Nombre geográfico', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('751', 'e', 'Término indicativo de función/relación', 'Término indicativo de función/relación', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('752', '0', 'Número de control de registro de autoridad', 'Número de control de registro de autoridad', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('752', '2', 'Fuente del encabezamiento o término', 'Fuente del encabezamiento o término', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('752', '6', 'Enlace', 'Enlace', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('752', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('752', 'a', 'País o entidad superior', 'País o entidad superior', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('752', 'b', 'Jurisdicción política de primer nivel', 'Jurisdicción política de primer nivel', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('752', 'c', 'Jurisdicción política intermedia', 'Jurisdicción política intermedia', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('752', 'd', 'Ciudad', 'Ciudad', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('752', 'f', 'Subdivisión de ciudad', 'Subdivisión de ciudad', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('752', 'g', 'Otras regiones o rasgos geográficos no jurisdiccionales', 'Otras regiones o rasgos geográficos no jurisdiccionales', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('752', 'h', 'Área extraterrestre', 'Área extraterrestre', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('753', '6', 'Enlace', 'Enlace', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('753', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('753', 'a', 'Marca y modelo de la máquina', 'Marca y modelo de la máquina', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('753', 'b', 'Lenguaje de programación', 'Lenguaje de programación', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('753', 'c', 'Sistema operativo', 'Sistema operativo', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('754', '0', 'Número de control de registro de autoridad', 'Número de control de registro de autoridad', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('754', '2', 'Fuente de la identificación taxonómica', 'Fuente de la identificación taxonómica', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('754', '6', 'Enlace', 'Enlace', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('754', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('754', 'a', 'Nombre taxonómico', 'Nombre taxonómico', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('754', 'c', 'Categoría taxonómica', 'Categoría taxonómica', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('754', 'd', 'Nombre común o alternativo', 'Nombre común o alternativo', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('754', 'x', 'Nota no pública', 'Nota no pública', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('754', 'z', 'Nota pública', 'Nota pública', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('755', '2', 'Fuente de la identificación taxonómica', 'Fuente de la identificación taxonómica', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('755', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('755', '6', 'Enlace', 'Enlace', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('755', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('755', 'a', 'Término de acceso', 'Término de acceso', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('755', 'x', 'Subdivisión general', 'Subdivisión general', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('755', 'y', 'Subdivisión cronológica', 'Subdivisión cronológica', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('755', 'z', 'Subdivisión geográfica', 'Subdivisión geográfica', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('760', '4', 'Código de relación', 'Código de relación', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('760', '6', 'Enlace', 'Enlace', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('760', '7', 'Subcampo de control', 'Subcampo de control', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('760', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('760', 'a', 'Encabezamiento principal', 'Encabezamiento principal', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('760', 'b', 'Edición', 'Edición', 0, 0, NULL, 7, NULL, NULL, '', NULL, 0, '', '', '', NULL),
		('760', 'c', 'Información calificativa', 'Información calificativa', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('760', 'd', 'Lugar, editor y fecha de publicación', 'Lugar, editor y fecha de publicación', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('760', 'g', 'Parte(s) relacionada(s)', 'Parte(s) relacionada(s)', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('760', 'h', 'Descripción física', 'Descripción física', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('760', 'i', 'Información de relación/Frase instructiva de referencia', 'Información de relación/Frase instructiva de referencia', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('760', 'm', 'Detalles específicos del material', 'Detalles específicos del material', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('760', 'n', 'Nota', 'Nota', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('760', 'o', 'Otro identificador del documento', 'Otro identificador del documento', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('760', 'q', 'Título paralelo (BK SE) [OBSOLETO]', 'Título paralelo (BK SE) [OBSOLETO]', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('760', 's', 'Título uniforme', 'Título uniforme', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('760', 't', 'Título', 'Título', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('760', 'w', 'Número de control del registro', 'Número de control del registro', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('760', 'x', 'Número Internacional Normalizado para Publicaciones Seriadas', 'Número Internacional Normalizado para Publicaciones Seriadas', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('760', 'y', 'Designación de CODEN', 'Designación de CODEN', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('762', '4', 'Código de relación', 'Código de relación', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('762', '6', 'Enlace', 'Enlace', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('762', '7', 'Subcampo de control', 'Subcampo de control', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('762', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('762', 'a', 'Encabezamiento principal', 'Encabezamiento principal', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('762', 'b', 'Edición', 'Edición', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('762', 'c', 'Información calificativa', 'Información calificativa', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('762', 'd', 'Lugar, editor y fecha de publicación', 'Lugar, editor y fecha de publicación', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('762', 'g', 'Parte(s) relacionada(s)', 'Parte(s) relacionada(s)', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('762', 'h', 'Descripción física', 'Descripción física', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('762', 'i', 'Información de relación/Frase instructiva de referencia', 'Información de relación/Frase instructiva de referencia', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('762', 'm', 'Detalles específicos del material', 'Detalles específicos del material', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('762', 'n', 'Nota', 'Nota', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('762', 'o', 'Otro identificador del documento', 'Otro identificador del documento', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('762', 'q', 'Título paralelo (BK SE) [OBSOLETO]', 'Título paralelo (BK SE) [OBSOLETO]', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('762', 's', 'Título uniforme', 'Título uniforme', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('762', 't', 'Título', 'Título', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('762', 'w', 'Número de control del registro', 'Número de control del registro', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('762', 'x', 'Número Internacional Normalizado para Publicaciones Seriadas', 'Número Internacional Normalizado para Publicaciones Seriadas', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('762', 'y', 'Designación de CODEN', 'Designación de CODEN', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('765', '4', 'Código de relación', 'Código de relación', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('765', '6', 'Enlace', 'Enlace', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('765', '7', 'Subcampo de control', 'Subcampo de control', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('765', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('765', 'a', 'Encabezamiento principal', 'Encabezamiento principal', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('765', 'b', 'Edición', 'Edición', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('765', 'c', 'Información calificativa', 'Información calificativa', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('765', 'd', 'Lugar, editor y fecha de publicación', 'Lugar, editor y fecha de publicación', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('765', 'g', 'Parte(s) relacionada(s)', 'Parte(s) relacionada(s)', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('765', 'h', 'Descripción física', 'Descripción física', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('765', 'i', 'Información de relación/Frase instructiva de referencia', 'Información de relación/Frase instructiva de referencia', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('765', 'k', 'Datos de la serie del documento relacionado', 'Datos de la serie del documento relacionado', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('765', 'm', 'Detalles específicos del material', 'Detalles específicos del material', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('765', 'n', 'Nota', 'Nota', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('765', 'o', 'Otro identificador del documento', 'Otro identificador del documento', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('765', 'q', 'Título paralelo (BK SE) [OBSOLETO]', 'Título paralelo (BK SE) [OBSOLETO]', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('765', 'r', 'Número de informe', 'Número de informe', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('765', 's', 'Título uniforme', 'Título uniforme', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('765', 't', 'Título', 'Título', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('765', 'u', 'Número Normalizado de Informe Técnico', 'Número Normalizado de Informe Técnico', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('765', 'w', 'Número de control del registro', 'Número de control del registro', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('765', 'x', 'Número Internacional Normalizado para Publicaciones Seriadas', 'Número Internacional Normalizado para Publicaciones Seriadas', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('765', 'y', 'Designación de CODEN', 'Designación de CODEN', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('765', 'z', 'Número Internacional Estándar del Libro', 'Número Internacional Estándar del Libro', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('767', '4', 'Código de relación', 'Código de relación', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('767', '6', 'Enlace', 'Enlace', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('767', '7', 'Subcampo de control', 'Subcampo de control', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('767', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('767', 'a', 'Encabezamiento principal', 'Encabezamiento principal', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('767', 'b', 'Edición', 'Edición', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('767', 'c', 'Información calificativa', 'Información calificativa', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('767', 'd', 'Lugar, editor y fecha de publicación', 'Lugar, editor y fecha de publicación', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('767', 'g', 'Parte(s) relacionada(s)', 'Parte(s) relacionada(s)', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('767', 'h', 'Descripción física', 'Descripción física', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('767', 'i', 'Información de relación/Frase instructiva de referencia', 'Información de relación/Frase instructiva de referencia', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('767', 'k', 'Datos de la serie del documento relacionado', 'Datos de la serie del documento relacionado', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('767', 'm', 'Detalles específicos del material', 'Detalles específicos del material', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('767', 'n', 'Nota', 'Nota', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('767', 'o', 'Otro identificador del documento', 'Otro identificador del documento', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('767', 'q', 'Título paralelo (BK SE) [OBSOLETO]', 'Título paralelo (BK SE) [OBSOLETO]', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('767', 'r', 'Número de informe', 'Número de informe', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('767', 's', 'Título uniforme', 'Título uniforme', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('767', 't', 'Título', 'Título', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('767', 'u', 'Número Normalizado de Informe Técnico', 'Número Normalizado de Informe Técnico', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('767', 'w', 'Número de control del registro', 'Número de control del registro', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('767', 'x', 'Número Internacional Normalizado para Publicaciones Seriadas', 'Número Internacional Normalizado para Publicaciones Seriadas', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('767', 'y', 'Designación de CODEN', 'Designación de CODEN', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('767', 'z', 'Número Internacional Estándar del Libro', 'Número Internacional Estándar del Libro', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('770', '4', 'Código de relación', 'Código de relación', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('770', '6', 'Enlace', 'Enlace', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('770', '7', 'Subcampo de control', 'Subcampo de control', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('770', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('770', 'a', 'Encabezamiento principal', 'Encabezamiento principal', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('770', 'b', 'Edición', 'Edición', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('770', 'c', 'Información calificativa', 'Información calificativa', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('770', 'd', 'Lugar, editor y fecha de publicación', 'Lugar, editor y fecha de publicación', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('770', 'g', 'Parte(s) relacionada(s)', 'Parte(s) relacionada(s)', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('770', 'h', 'Descripción física', 'Descripción física', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('770', 'i', 'Información de relación/Frase instructiva de referencia', 'Información de relación/Frase instructiva de referencia', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('770', 'k', 'Datos de la serie del documento relacionado', 'Datos de la serie del documento relacionado', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('770', 'm', 'Detalles específicos del material', 'Detalles específicos del material', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('770', 'n', 'Nota', 'Nota', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('770', 'o', 'Otro identificador del documento', 'Otro identificador del documento', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('770', 'q', 'Título paralelo (BK SE) [OBSOLETO]', 'Título paralelo (BK SE) [OBSOLETO]', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('770', 'r', 'Número de informe', 'Número de informe', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('770', 's', 'Título uniforme', 'Título uniforme', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('770', 't', 'Título', 'Título', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('770', 'u', 'Número Normalizado de Informe Técnico', 'Número Normalizado de Informe Técnico', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('770', 'w', 'Número de control del registro', 'Número de control del registro', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('770', 'x', 'Número Internacional Normalizado para Publicaciones Seriadas', 'Número Internacional Normalizado para Publicaciones Seriadas', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('770', 'y', 'Designación de CODEN', 'Designación de CODEN', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('770', 'z', 'Número Internacional Estándar del Libro', 'Número Internacional Estándar del Libro', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('772', '4', 'Código de relación', 'Código de relación', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('772', '6', 'Enlace', 'Enlace', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('772', '7', 'Subcampo de control', 'Subcampo de control', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('772', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('772', 'a', 'Encabezamiento principal', 'Encabezamiento principal', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('772', 'b', 'Edición', 'Edición', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('772', 'c', 'Información calificativa', 'Información calificativa', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('772', 'd', 'Lugar, editor y fecha de publicación', 'Lugar, editor y fecha de publicación', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('772', 'g', 'Parte(s) relacionada(s)', 'Parte(s) relacionada(s)', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('772', 'h', 'Descripción física', 'Descripción física', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('772', 'i', 'Información de relación/Frase instructiva de referencia', 'Información de relación/Frase instructiva de referencia', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('772', 'k', 'Datos de la serie del documento relacionado', 'Datos de la serie del documento relacionado', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('772', 'm', 'Detalles específicos del material', 'Detalles específicos del material', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('772', 'n', 'Nota', 'Nota', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('772', 'o', 'Otro identificador del documento', 'Otro identificador del documento', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('772', 'q', 'Título paralelo (BK SE) [OBSOLETO]', 'Título paralelo (BK SE) [OBSOLETO]', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('772', 'r', 'Número de informe', 'Número de informe', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('772', 's', 'Título uniforme', 'Título uniforme', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('772', 't', 'Título', 'Título', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('772', 'u', 'Número Normalizado de Informe Técnico', 'Número Normalizado de Informe Técnico', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('772', 'w', 'Número de control del registro', 'Número de control del registro', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('772', 'x', 'Número Internacional Normalizado para Publicaciones Seriadas', 'Número Internacional Normalizado para Publicaciones Seriadas', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('772', 'y', 'Designación de CODEN', 'Designación de CODEN', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('772', 'z', 'Número Internacional Estándar del Libro', 'Número Internacional Estándar del Libro', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('773', '0', 'Número bibliográfico anfitrión', 'Número bibliográfico anfitrión', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('773', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('773', '4', 'Código de relación', 'Código de relación', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('773', '6', 'Enlace', 'Enlace', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('773', '7', 'Subcampo de control', 'Subcampo de control', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('773', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('773', '9', 'Número de ítem anfitrión', 'Número de ítem anfitrión', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('773', 'a', 'Encabezamiento principal', 'Encabezamiento principal', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('773', 'b', 'Edición', 'Edición', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('773', 'd', 'Lugar, editor y fecha de publicación', 'Lugar, editor y fecha de publicación', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('773', 'g', 'Parte(s) relacionada(s)', 'Parte(s) relacionada(s)', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('773', 'h', 'Descripción física', 'Descripción física', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('773', 'i', 'Información de relación/Frase instructiva de referencia', 'Información de relación/Frase instructiva de referencia', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('773', 'k', 'Datos de la serie del documento relacionado', 'Datos de la serie del documento relacionado', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('773', 'm', 'Detalles específicos del material', 'Detalles específicos del material', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('773', 'n', 'Nota', 'Nota', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('773', 'o', 'Otro identificador del documento', 'Otro identificador del documento', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('773', 'p', 'Título abreviado', 'Título abreviado', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('773', 'q', 'Numeración y primera página', 'Numeración y primera página', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('773', 'r', 'Número de informe', 'Número de informe', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('773', 's', 'Título uniforme', 'Título uniforme', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('773', 't', 'Título', 'Título', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('773', 'u', 'Número Normalizado de Informe Técnico', 'Número Normalizado de Informe Técnico', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('773', 'w', 'Número de control del registro', 'Número de control del registro', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('773', 'x', 'Número Internacional Normalizado para Publicaciones Seriadas', 'Número Internacional Normalizado para Publicaciones Seriadas', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('773', 'y', 'Designación de CODEN', 'Designación de CODEN', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('773', 'z', 'Número Internacional Estándar del Libro', 'Número Internacional Estándar del Libro', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('774', '4', 'Código de relación', 'Código de relación', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('774', '6', 'Enlace', 'Enlace', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('774', '7', 'Subcampo de control', 'Subcampo de control', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('774', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('774', 'a', 'Encabezamiento principal', 'Encabezamiento principal', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('774', 'b', 'Edición', 'Edición', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('774', 'c', 'Información calificativa', 'Información calificativa', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('774', 'd', 'Lugar, editor y fecha de publicación', 'Lugar, editor y fecha de publicación', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('774', 'g', 'Parte(s) relacionada(s)', 'Parte(s) relacionada(s)', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('774', 'h', 'Descripción física', 'Descripción física', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('774', 'i', 'Información de relación/Frase instructiva de referencia', 'Información de relación/Frase instructiva de referencia', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('774', 'k', 'Datos de la serie del documento relacionado', 'Datos de la serie del documento relacionado', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('774', 'm', 'Detalles específicos del material', 'Detalles específicos del material', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('774', 'n', 'Nota', 'Nota', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('774', 'o', 'Otro identificador del documento', 'Otro identificador del documento', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('774', 'r', 'Número de informe', 'Número de informe', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('774', 's', 'Título uniforme', 'Título uniforme', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('774', 't', 'Título', 'Título', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('774', 'u', 'Número Normalizado de Informe Técnico', 'Número Normalizado de Informe Técnico', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('774', 'w', 'Número de control del registro', 'Número de control del registro', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('774', 'x', 'Número Internacional Normalizado para Publicaciones Seriadas', 'Número Internacional Normalizado para Publicaciones Seriadas', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('774', 'y', 'Designación de CODEN', 'Designación de CODEN', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('774', 'z', 'Número Internacional Estándar del Libro', 'Número Internacional Estándar del Libro', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('775', '4', 'Código de relación', 'Código de relación', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('775', '6', 'Enlace', 'Enlace', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('775', '7', 'Subcampo de control', 'Subcampo de control', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('775', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('775', 'a', 'Encabezamiento principal', 'Encabezamiento principal', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('775', 'b', 'Edición', 'Edición', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('775', 'c', 'Información calificativa', 'Información calificativa', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('775', 'd', 'Lugar, editor y fecha de publicación', 'Lugar, editor y fecha de publicación', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('775', 'e', 'Código del idioma', 'Código del idioma', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('775', 'f', 'Código de país', 'Código de país', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('775', 'g', 'Parte(s) relacionada(s)', 'Parte(s) relacionada(s)', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('775', 'h', 'Descripción física', 'Descripción física', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('775', 'i', 'Información de relación/Frase instructiva de referencia', 'Información de relación/Frase instructiva de referencia', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('775', 'k', 'Datos de la serie del documento relacionado', 'Datos de la serie del documento relacionado', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('775', 'm', 'Detalles específicos del material', 'Detalles específicos del material', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('775', 'n', 'Nota', 'Nota', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('775', 'o', 'Otro identificador del documento', 'Otro identificador del documento', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('775', 'q', 'Título paralelo (BK SE) [OBSOLETO]', 'Título paralelo (BK SE) [OBSOLETO]', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('775', 'r', 'Número de informe', 'Número de informe', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('775', 's', 'Título uniforme', 'Título uniforme', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('775', 't', 'Título', 'Título', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('775', 'u', 'Número Normalizado de Informe Técnico', 'Número Normalizado de Informe Técnico', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('775', 'w', 'Número de control del registro', 'Número de control del registro', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('775', 'x', 'Número Internacional Normalizado para Publicaciones Seriadas', 'Número Internacional Normalizado para Publicaciones Seriadas', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('775', 'y', 'Designación de CODEN', 'Designación de CODEN', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('775', 'z', 'Número Internacional Estándar del Libro', 'Número Internacional Estándar del Libro', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('776', '4', 'Código de relación', 'Código de relación', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('776', '6', 'Enlace', 'Enlace', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('776', '7', 'Subcampo de control', 'Subcampo de control', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('776', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('776', 'a', 'Encabezamiento principal', 'Encabezamiento principal', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('776', 'b', 'Edición', 'Edición', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('776', 'c', 'Información calificativa', 'Información calificativa', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('776', 'd', 'Lugar, editor y fecha de publicación', 'Lugar, editor y fecha de publicación', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('776', 'g', 'Parte(s) relacionada(s)', 'Parte(s) relacionada(s)', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('776', 'h', 'Descripción física', 'Descripción física', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('776', 'i', 'Información de relación/Frase instructiva de referencia', 'Información de relación/Frase instructiva de referencia', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('776', 'k', 'Datos de la serie del documento relacionado', 'Datos de la serie del documento relacionado', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('776', 'm', 'Detalles específicos del material', 'Detalles específicos del material', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('776', 'n', 'Nota', 'Nota', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('776', 'o', 'Otro identificador del documento', 'Otro identificador del documento', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('776', 'q', 'Título paralelo (BK SE) [OBSOLETO]', 'Título paralelo (BK SE) [OBSOLETO]', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('776', 'r', 'Número de informe', 'Número de informe', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('776', 's', 'Título uniforme', 'Título uniforme', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('776', 't', 'Título', 'Título', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('776', 'u', 'Número Normalizado de Informe Técnico', 'Número Normalizado de Informe Técnico', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('776', 'w', 'Número de control del registro', 'Número de control del registro', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('776', 'x', 'Número Internacional Normalizado para Publicaciones Seriadas', 'Número Internacional Normalizado para Publicaciones Seriadas', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('776', 'y', 'Designación de CODEN', 'Designación de CODEN', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('776', 'z', 'Número Internacional Estándar del Libro', 'Número Internacional Estándar del Libro', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('777', '4', 'Código de relación', 'Código de relación', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('777', '6', 'Enlace', 'Enlace', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('777', '7', 'Subcampo de control', 'Subcampo de control', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('777', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('777', 'a', 'Encabezamiento principal', 'Encabezamiento principal', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('777', 'b', 'Edición', 'Edición', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('777', 'c', 'Información calificativa', 'Información calificativa', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('777', 'd', 'Lugar, editor y fecha de publicación', 'Lugar, editor y fecha de publicación', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('777', 'g', 'Parte(s) relacionada(s)', 'Parte(s) relacionada(s)', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('777', 'h', 'Descripción física', 'Descripción física', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('777', 'i', 'Información de relación/Frase instructiva de referencia', 'Información de relación/Frase instructiva de referencia', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('777', 'k', 'Datos de la serie del documento relacionado', 'Datos de la serie del documento relacionado', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('777', 'm', 'Detalles específicos del material', 'Detalles específicos del material', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('777', 'n', 'Nota', 'Nota', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('777', 'o', 'Otro identificador del documento', 'Otro identificador del documento', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('777', 'q', 'Título paralelo (BK SE) [OBSOLETO]', 'Título paralelo (BK SE) [OBSOLETO]', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('777', 's', 'Título uniforme', 'Título uniforme', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('777', 't', 'Título', 'Título', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('777', 'w', 'Número de control del registro', 'Número de control del registro', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('777', 'x', 'Número Internacional Normalizado para Publicaciones Seriadas', 'Número Internacional Normalizado para Publicaciones Seriadas', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('777', 'y', 'Designación de CODEN', 'Designación de CODEN', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('780', '4', 'Código de relación', 'Código de relación', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('780', '6', 'Enlace', 'Enlace', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('780', '7', 'Subcampo de control', 'Subcampo de control', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('780', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('780', 'a', 'Encabezamiento principal', 'Encabezamiento principal', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('780', 'b', 'Edición', 'Edición', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('780', 'c', 'Información calificativa', 'Información calificativa', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('780', 'd', 'Lugar, editor y fecha de publicación', 'Lugar, editor y fecha de publicación', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('780', 'g', 'Parte(s) relacionada(s)', 'Parte(s) relacionada(s)', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('780', 'h', 'Descripción física', 'Descripción física', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('780', 'i', 'Información de relación/Frase instructiva de referencia', 'Información de relación/Frase instructiva de referencia', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('780', 'k', 'Datos de la serie del documento relacionado', 'Datos de la serie del documento relacionado', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('780', 'm', 'Detalles específicos del material', 'Detalles específicos del material', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('780', 'n', 'Nota', 'Nota', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('780', 'o', 'Otro identificador del documento', 'Otro identificador del documento', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('780', 'q', 'Título paralelo (BK SE) [OBSOLETO]', 'Título paralelo (BK SE) [OBSOLETO]', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('780', 'r', 'Número de informe', 'Número de informe', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('780', 's', 'Título uniforme', 'Título uniforme', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('780', 't', 'Título', 'Título', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('780', 'u', 'Número Normalizado de Informe Técnico', 'Número Normalizado de Informe Técnico', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('780', 'w', 'Número de control del registro', 'Número de control del registro', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('780', 'x', 'Número Internacional Normalizado para Publicaciones Seriadas', 'Número Internacional Normalizado para Publicaciones Seriadas', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('780', 'y', 'Designación de CODEN', 'Designación de CODEN', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('780', 'z', 'Número Internacional Estándar del Libro', 'Número Internacional Estándar del Libro', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('785', '4', 'Código de relación', 'Código de relación', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('785', '6', 'Enlace', 'Enlace', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('785', '7', 'Subcampo de control', 'Subcampo de control', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('785', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('785', 'a', 'Encabezamiento principal', 'Encabezamiento principal', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('785', 'b', 'Edición', 'Edición', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('785', 'c', 'Información calificativa', 'Información calificativa', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('785', 'd', 'Lugar, editor y fecha de publicación', 'Lugar, editor y fecha de publicación', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('785', 'g', 'Parte(s) relacionada(s)', 'Parte(s) relacionada(s)', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('785', 'h', 'Descripción física', 'Descripción física', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('785', 'i', 'Información de relación/Frase instructiva de referencia', 'Información de relación/Frase instructiva de referencia', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('785', 'k', 'Datos de la serie del documento relacionado', 'Datos de la serie del documento relacionado', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('785', 'm', 'Detalles específicos del material', 'Detalles específicos del material', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('785', 'n', 'Nota', 'Nota', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('785', 'o', 'Otro identificador del documento', 'Otro identificador del documento', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('785', 'q', 'Título paralelo (BK SE) [OBSOLETO]', 'Título paralelo (BK SE) [OBSOLETO]', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('785', 'r', 'Número de informe', 'Número de informe', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('785', 's', 'Título uniforme', 'Título uniforme', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('785', 't', 'Título', 'Título', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('785', 'u', 'Número Normalizado de Informe Técnico', 'Número Normalizado de Informe Técnico', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('785', 'w', 'Número de control del registro', 'Número de control del registro', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('785', 'x', 'Número Internacional Normalizado para Publicaciones Seriadas', 'Número Internacional Normalizado para Publicaciones Seriadas', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('785', 'y', 'Designación de CODEN', 'Designación de CODEN', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('785', 'z', 'Número Internacional Estándar del Libro', 'Número Internacional Estándar del Libro', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('786', '4', 'Código de relación', 'Código de relación', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('786', '6', 'Enlace', 'Enlace', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('786', '7', 'Subcampo de control', 'Subcampo de control', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('786', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('786', 'a', 'Encabezamiento principal', 'Encabezamiento principal', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('786', 'b', 'Edición', 'Edición', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('786', 'c', 'Información calificativa', 'Información calificativa', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('786', 'd', 'Lugar, editor y fecha de publicación', 'Lugar, editor y fecha de publicación', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('786', 'g', 'Parte(s) relacionada(s)', 'Parte(s) relacionada(s)', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('786', 'h', 'Descripción física', 'Descripción física', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('786', 'i', 'Información de relación/Frase instructiva de referencia', 'Información de relación/Frase instructiva de referencia', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('786', 'j', 'Periodo de duración del contenido', 'Periodo de duración del contenido', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('786', 'k', 'Datos de la serie del documento relacionado', 'Datos de la serie del documento relacionado', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('786', 'm', 'Detalles específicos del material', 'Detalles específicos del material', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('786', 'n', 'Nota', 'Nota', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('786', 'o', 'Otro identificador del documento', 'Otro identificador del documento', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('786', 'p', 'Título abreviado', 'Título abreviado', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('786', 'r', 'Número de informe', 'Número de informe', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('786', 's', 'Título uniforme', 'Título uniforme', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('786', 't', 'Título', 'Título', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('786', 'u', 'Número Normalizado de Informe Técnico', 'Número Normalizado de Informe Técnico', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('786', 'v', 'Contribución de la fuente', 'Contribución de la fuente', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('786', 'w', 'Número de control del registro', 'Número de control del registro', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('786', 'x', 'Número Internacional Normalizado para Publicaciones Seriadas', 'Número Internacional Normalizado para Publicaciones Seriadas', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('786', 'y', 'Designación de CODEN', 'Designación de CODEN', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('786', 'z', 'Número Internacional Estándar del Libro', 'Número Internacional Estándar del Libro', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('787', '4', 'Código de relación', 'Código de relación', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('787', '6', 'Enlace', 'Enlace', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('787', '7', 'Subcampo de control', 'Subcampo de control', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('787', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('787', 'a', 'Encabezamiento principal', 'Encabezamiento principal', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('787', 'b', 'Edición', 'Edición', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('787', 'c', 'Información calificativa', 'Información calificativa', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('787', 'd', 'Lugar, editor y fecha de publicación', 'Lugar, editor y fecha de publicación', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('787', 'g', 'Parte(s) relacionada(s)', 'Parte(s) relacionada(s)', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('787', 'h', 'Descripción física', 'Descripción física', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('787', 'i', 'Información de relación/Frase instructiva de referencia', 'Información de relación/Frase instructiva de referencia', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('787', 'k', 'Datos de la serie del documento relacionado', 'Datos de la serie del documento relacionado', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('787', 'm', 'Detalles específicos del material', 'Detalles específicos del material', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('787', 'n', 'Nota', 'Nota', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('787', 'o', 'Otro identificador del documento', 'Otro identificador del documento', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('787', 'q', 'Título paralelo (BK SE) [OBSOLETO]', 'Título paralelo (BK SE) [OBSOLETO]', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('787', 'r', 'Número de informe', 'Número de informe', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('787', 's', 'Título uniforme', 'Título uniforme', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('787', 't', 'Título', 'Título', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('787', 'u', 'Número Normalizado de Informe Técnico', 'Número Normalizado de Informe Técnico', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('787', 'w', 'Número de control del registro', 'Número de control del registro', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('787', 'x', 'Número Internacional Normalizado para Publicaciones Seriadas', 'Número Internacional Normalizado para Publicaciones Seriadas', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('787', 'y', 'Designación de CODEN', 'Designación de CODEN', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('787', 'z', 'Número Internacional Estándar del Libro', 'Número Internacional Estándar del Libro', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('789', '%', '%', '%', 0, 0, '', 7, '', '', '', 0, -6, '', '', '', NULL),
		('789', '2', '2', '2', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('789', '3', '3', '3', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('789', '4', '4', '4', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('789', '5', '5', '5', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('789', '6', '6', '6', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('789', '7', '7', '7', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('789', '8', '8', '8', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('789', '9', '9', '9', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('789', 'a', 'a', 'a', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('789', 'b', 'b', 'b', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('789', 'c', 'c', 'c', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('789', 'd', 'd', 'd', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('789', 'e', 'e', 'e', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('789', 'f', 'f', 'f', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('789', 'g', 'g', 'g', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('789', 'h', 'h', 'h', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('789', 'i', 'i', 'i', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('789', 'j', 'j', 'j', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('789', 'k', 'k', 'k', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('789', 'l', 'l', 'l', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('789', 'm', 'm', 'm', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('789', 'n', 'n', 'n', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('789', 'o', 'o', 'o', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('789', 'p', 'p', 'p', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('789', 'q', 'q', 'q', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('789', 'r', 'r', 'r', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('789', 's', 's', 's', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('789', 't', 't', 't', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('789', 'u', 'u', 'u', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('789', 'v', 'v', 'v', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('789', 'w', 'w', 'w', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('789', 'x', 'x', 'x', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('789', 'y', 'y', 'y', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('789', 'z', 'z', 'z', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('796', '%', '% (RLIN)', '% (RLIN)', 0, 0, '', 7, '', '', '', 0, -6, '', '', '', NULL),
		('796', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('796', '4', 'Código de función/relación', 'Código de función/relación', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('796', '5', 'Institución que aplica el campo', 'Institución que aplica el campo', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('796', '6', 'Enlace', 'Enlace', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('796', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('796', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 7, '', '', '', 0, -5, '', '', '', NULL),
		('796', 'a', 'Nombre de persona', 'Nombre de persona', 0, 0, '', 7, '', 'PERSO_NAME', '', NULL, -6, '', '', '', NULL),
		('796', 'b', 'Numeración', 'Numeración', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('796', 'c', 'Títulos y otros términos asociados al nombre', 'Títulos y otros términos asociados al nombre', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('796', 'd', 'Fechas asociadas al nombre', 'Fechas asociadas al nombre', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('796', 'e', 'Término indicativo de función/relación', 'Término indicativo de función/relación', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('796', 'f', 'Fecha de publicación/de la obra', 'Fecha de publicación/de la obra', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('796', 'g', 'Información miscelánea', 'Información miscelánea', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('796', 'h', 'Medio', 'Medio', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('796', 'j', 'Calificador de atribución', 'Calificador de atribución', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('796', 'k', 'Subencabezamiento de forma', 'Subencabezamiento de forma', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('796', 'l', 'Lenguaje de la obra', 'Lenguaje de la obra', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('796', 'm', 'Medio de interpretación para música', 'Medio de interpretación para música', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('796', 'n', 'Número de parte o sección de la obra', 'Número de parte o sección de la obra', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('796', 'o', 'Mención de arreglo para música', 'Mención de arreglo para música', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('796', 'p', 'Nombre de parte o sección de la obra', 'Nombre de parte o sección de la obra', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('796', 'q', 'Forma completa/desarrollada del nombre', 'Forma completa/desarrollada del nombre', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('796', 'r', 'Clave para música', 'Clave para música', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('796', 's', 'Versión', 'Versión', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('796', 't', 'Título de la obra', 'Título de la obra', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('796', 'u', 'Filiación', 'Filiación', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('796', 'x', 'Número Internacional Normalizado para Publicaciones Seriadas', 'Número Internacional Normalizado para Publicaciones Seriadas', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('797', '%', '% (RLIN)', '% (RLIN)', 0, 0, '', 7, '', '', '', 0, -6, '', '', '', NULL),
		('797', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('797', '4', 'Código de función/relación', 'Código de función/relación', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('797', '5', 'Institución que aplica el campo', 'Institución que aplica el campo', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('797', '6', 'Enlace', 'Enlace', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('797', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('797', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 7, '', '', '', 0, -5, '', '', '', NULL),
		('797', 'a', 'Nombre de entidad corporativa o nombre de jurisdicción como elemento de entrada', 'Nombre de entidad corporativa o nombre de jurisdicción como elemento de entrada', 0, 0, '', 7, '', 'CORPO_NAME', '', NULL, -6, '', '', '', NULL),
		('797', 'b', 'Unidad subordinada', 'Unidad subordinada', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('797', 'c', 'Sede del congreso/Lugar de la reunión', 'Sede del congreso/Lugar de la reunión', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('797', 'd', 'Fecha del congreso/reunión o de la firma de un tratado', 'Fecha del congreso/reunión o de la firma de un tratado', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('797', 'e', 'Término indicativo de función/relación', 'Término indicativo de función/relación', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('797', 'f', 'Fecha de publicación/de la obra', 'Fecha de publicación/de la obra', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('797', 'g', 'Información miscelánea', 'Información miscelánea', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('797', 'h', 'Medio', 'Medio', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('797', 'k', 'Subencabezamiento de forma', 'Subencabezamiento de forma', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('797', 'l', 'Lenguaje de la obra', 'Lenguaje de la obra', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('797', 'm', 'Medio de interpretación para música', 'Medio de interpretación para música', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('797', 'n', 'Número del congreso/reunión o número de parte o sección', 'Número del congreso/reunión o número de parte o sección', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('797', 'o', 'Mención de arreglo para música', 'Mención de arreglo para música', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('797', 'p', 'Nombre de parte o sección de la obra', 'Nombre de parte o sección de la obra', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('797', 'r', 'Clave para música', 'Clave para música', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('797', 's', 'Versión', 'Versión', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('797', 't', 'Título de la obra', 'Título de la obra', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('797', 'u', 'Filiación', 'Filiación', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('797', 'x', 'Número Internacional Normalizado para Publicaciones Seriadas', 'Número Internacional Normalizado para Publicaciones Seriadas', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('798', '%', '% (RLIN)', '% (RLIN)', 0, 0, '', 7, '', '', '', 0, -5, '', '', '', NULL),
		('798', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('798', '4', 'Código de función/relación', 'Código de función/relación', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('798', '5', 'Institución que aplica el campo', 'Institución que aplica el campo', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('798', '6', 'Enlace', 'Enlace', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('798', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('798', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 7, '', '', '', 0, -5, '', '', '', NULL),
		('798', 'a', 'Nombre de congreso/reunión o jurisdicción como elemento de entrada', 'Nombre de congreso/reunión o jurisdicción como elemento de entrada', 0, 0, NULL, 7, NULL, 'MEETI_NAME', '', NULL, -6, '', '', '', NULL),
		('798', 'b', 'Número (BK CF MP MU SE VM MX) [OBSOLETO]', 'Número (BK CF MP MU SE VM MX) [OBSOLETO]', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('798', 'c', 'Sede del congreso/Lugar de la reunión', 'Sede del congreso/Lugar de la reunión', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('798', 'd', 'Fecha del congreso/reunión', 'Fecha del congreso/reunión', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('798', 'e', 'Unidad subordinada', 'Unidad subordinada', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('798', 'f', 'Fecha de publicación/de la obra', 'Fecha de publicación/de la obra', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('798', 'g', 'Información miscelánea', 'Información miscelánea', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('798', 'h', 'Medio', 'Medio', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('798', 'k', 'Subencabezamiento de forma', 'Subencabezamiento de forma', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('798', 'l', 'Lenguaje de la obra', 'Lenguaje de la obra', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('798', 'n', 'Número del congreso/reunión o número de parte o sección', 'Número del congreso/reunión o número de parte o sección', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('798', 'p', 'Nombre de parte o sección de la obra', 'Nombre de parte o sección de la obra', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('798', 'q', 'Nombre de congreso/reunión que sigue a un nombre de jurisdicción como elemento de entrada', 'Nombre de congreso/reunión que sigue a un nombre de jurisdicción como elemento de entrada', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('798', 's', 'Versión', 'Versión', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('798', 't', 'Título de la obra', 'Título de la obra', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('798', 'u', 'Filiación', 'Filiación', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('798', 'x', 'Número Internacional Normalizado para Publicaciones Seriadas', 'Número Internacional Normalizado para Publicaciones Seriadas', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('799', '%', '% (RLIN)', '% (RLIN)', 0, 0, '', 7, '', '', '', 0, -6, '', '', '', NULL),
		('799', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('799', '5', 'Institución que aplica el campo', 'Institución que aplica el campo', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('799', '6', 'Enlace', 'Enlace', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('799', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('799', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 7, '', '', '', 0, -5, '', '', '', NULL),
		('799', 'a', 'Título uniforme', 'Título uniforme', 0, 0, '', 7, '', 'UNIF_TITLE', '', NULL, -6, '', '', '', NULL),
		('799', 'd', 'Fecha de la firma de un tratado', 'Fecha de la firma de un tratado', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('799', 'f', 'Fecha de publicación/de la obra', 'Fecha de publicación/de la obra', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('799', 'g', 'Información miscelánea', 'Información miscelánea', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('799', 'h', 'Medio', 'Medio', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('799', 'k', 'Subencabezamiento de forma', 'Subencabezamiento de forma', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('799', 'l', 'Lenguaje de la obra', 'Lenguaje de la obra', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('799', 'm', 'Medio de interpretación para música', 'Medio de interpretación para música', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('799', 'n', 'Número de parte o sección de la obra', 'Número de parte o sección de la obra', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('799', 'o', 'Mención de arreglo para música', 'Mención de arreglo para música', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('799', 'p', 'Nombre de parte o sección de la obra', 'Nombre de parte o sección de la obra', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('799', 'r', 'Clave para música', 'Clave para música', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('799', 's', 'Versión', 'Versión', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('799', 't', 'Título de la obra', 'Título de la obra', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('799', 'x', 'Número Internacional Normalizado para Publicaciones Seriadas', 'Número Internacional Normalizado para Publicaciones Seriadas', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '', NULL),
		('800', '0', 'Número de control del registro de autoridad o número normalizado', 'Número de control del registro de autoridad o número normalizado', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('800', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('800', '4', 'Código de función/relación', 'Código de función/relación', 1, 0, '', 8, '', '', '', NULL, -1, '', '', '', NULL),
		('800', '5', 'Institución que aplica el campo', 'Institución que aplica el campo', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('800', '6', 'Enlace', 'Enlace', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('800', '7', 'Subcampo de control', 'Subcampo de control', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('800', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('800', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 8, '', '', '', 0, -5, '', '', '', NULL),
		('800', 'a', 'Nombre de persona', 'Nombre de persona', 0, 0, '', 8, '', 'PERSO_NAME', '', NULL, -1, '', '', '', NULL),
		('800', 'b', 'Numeración', 'Numeración', 0, 0, '', 8, '', '', '', NULL, -1, '', '', '', NULL),
		('800', 'c', 'Títulos y otros términos asociados al nombre', 'Títulos y otros términos asociados al nombre', 1, 0, '', 8, '', '', '', NULL, -1, '', '', '', NULL),
		('800', 'd', 'Fechas asociadas al nombre', 'Fechas asociadas al nombre', 0, 0, '', 8, '', '', '', NULL, -1, '', '', '', NULL),
		('800', 'e', 'Término indicativo de función/relación', 'Término indicativo de función/relación', 1, 0, '', 8, '', '', '', NULL, -1, '', '', '', NULL),
		('800', 'f', 'Fecha de publicación/de la obra', 'Fecha de publicación/de la obra', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('800', 'g', 'Información miscelánea', 'Información miscelánea', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('800', 'h', 'Medio', 'Medio', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('800', 'j', 'Calificador de atribución', 'Calificador de atribución', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('800', 'k', 'Subencabezamiento de forma', 'Subencabezamiento de forma', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('800', 'l', 'Lenguaje de la obra', 'Lenguaje de la obra', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('800', 'm', 'Medio de interpretación para música', 'Medio de interpretación para música', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('800', 'n', 'Número de parte o sección de la obra', 'Número de parte o sección de la obra', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('800', 'o', 'Mención de arreglo para música', 'Mención de arreglo para música', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('800', 'p', 'Nombre de parte o sección de la obra', 'Nombre de parte o sección de la obra', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('800', 'q', 'Forma completa/desarrollada del nombre', 'Forma completa/desarrollada del nombre', 0, 0, '', 8, '', '', '', NULL, -1, '', '', '', NULL),
		('800', 'r', 'Clave para música', 'Clave para música', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('800', 's', 'Versión', 'Versión', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('800', 't', 'Título de la obra', 'Título de la obra', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('800', 'u', 'Filiación', 'Filiación', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('800', 'v', 'Designación de volumen o secuencia', 'Designación de volumen o secuencia', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('800', 'w', 'Número de control del registro bibliográfico', 'Número de control del registro bibliográfico', 1, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('800', 'x', 'Número Internacional Normalizado para Publicaciones Seriadas', 'Número Internacional Normalizado para Publicaciones Seriadas', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('810', '0', 'Número de control del registro de autoridad o número normalizado', 'Número de control del registro de autoridad o número normalizado', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('810', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('810', '4', 'Código de función/relación', 'Código de función/relación', 1, 0, '', 8, '', '', '', NULL, -1, '', '', '', NULL),
		('810', '5', 'Institución que aplica el campo', 'Institución que aplica el campo', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('810', '6', 'Enlace', 'Enlace', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('810', '7', 'Subcampo de control', 'Subcampo de control', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('810', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('810', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 8, '', '', '', 0, -5, '', '', '', NULL),
		('810', 'a', 'Nombre de entidad corporativa o nombre de jurisdicción como elemento de entrada', 'Nombre de entidad corporativa o nombre de jurisdicción como elemento de entrada', 0, 0, '', 8, '', 'CORPO_NAME', '', NULL, -1, '', '', '', NULL),
		('810', 'b', 'Unidad subordinada', 'Unidad subordinada', 1, 0, '', 8, '', '', '', NULL, -1, '', '', '', NULL),
		('810', 'c', 'Sede del congreso/Lugar de la reunión', 'Sede del congreso/Lugar de la reunión', 1, 0, '', 8, '', '', '', NULL, -1, '', '', '', NULL),
		('810', 'd', 'Fecha del congreso/reunión o de la firma de un tratado', 'Fecha del congreso/reunión o de la firma de un tratado', 1, 0, '', 8, '', '', '', NULL, -1, '', '', '', NULL),
		('810', 'e', 'Término indicativo de función/relación', 'Término indicativo de función/relación', 1, 0, '', 8, '', '', '', NULL, -1, '', '', '', NULL),
		('810', 'f', 'Fecha de publicación/de la obra', 'Fecha de publicación/de la obra', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('810', 'g', 'Información miscelánea', 'Información miscelánea', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('810', 'h', 'Medio', 'Medio', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('810', 'k', 'Subencabezamiento de forma', 'Subencabezamiento de forma', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('810', 'l', 'Lenguaje de la obra', 'Lenguaje de la obra', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('810', 'm', 'Medio de interpretación para música', 'Medio de interpretación para música', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('810', 'n', 'Número del congreso/reunión o número de parte o sección', 'Número del congreso/reunión o número de parte o sección', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('810', 'o', 'Mención de arreglo para música', 'Mención de arreglo para música', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('810', 'p', 'Nombre de parte o sección de la obra', 'Nombre de parte o sección de la obra', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('810', 'r', 'Clave para música', 'Clave para música', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('810', 's', 'Versión', 'Versión', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('810', 't', 'Título de la obra', 'Título de la obra', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('810', 'u', 'Filiación', 'Filiación', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('810', 'v', 'Designación de volumen o secuencia', 'Designación de volumen o secuencia', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('810', 'w', 'Número de control del registro bibliográfico', 'Número de control del registro bibliográfico', 1, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('810', 'x', 'Número Internacional Normalizado para Publicaciones Seriadas', 'Número Internacional Normalizado para Publicaciones Seriadas', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('811', '0', 'Número de control del registro de autoridad o número normalizado', 'Número de control del registro de autoridad o número normalizado', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('811', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('811', '4', 'Código de función/relación', 'Código de función/relación', 1, 0, NULL, 8, NULL, NULL, '', NULL, -1, '', '', '', NULL),
		('811', '5', 'Institución que aplica el campo', 'Institución que aplica el campo', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('811', '6', 'Enlace', 'Enlace', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('811', '7', 'Subcampo de control', 'Subcampo de control', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('811', '8', 'Enlace entre campos y número de secuencia', 'Enlace entre campos y número de secuencia', 1, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('811', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 8, '', '', '', 0, -5, '', '', '', NULL),
		('811', 'a', 'Nombre de congreso/reunión o jurisdicción como elemento de entrada', 'Nombre de congreso/reunión o jurisdicción como elemento de entrada', 0, 0, NULL, 8, NULL, 'MEETI_NAME', '', NULL, -1, '', '', '', NULL),
		('811', 'b', 'Número (BK CF MP MU SE VM MX) [OBSOLETO]', 'Número (BK CF MP MU SE VM MX) [OBSOLETO]', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('811', 'c', 'Sede del congreso/Lugar de la reunión', 'Sede del congreso/Lugar de la reunión', 1, 0, NULL, 8, NULL, NULL, '', NULL, -1, '', '', '', NULL),
		('811', 'd', 'Fecha del congreso/reunión', 'Fecha del congreso/reunión', 0, 0, NULL, 8, NULL, NULL, '', NULL, -1, '', '', '', NULL),
		('811', 'e', 'Unidad subordinada', 'Unidad subordinada', 1, 0, NULL, 8, NULL, NULL, '', NULL, -1, '', '', '', NULL),
		('811', 'f', 'Fecha de publicación/de la obra', 'Fecha de publicación/de la obra', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('811', 'g', 'Información miscelánea', 'Información miscelánea', 1, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('811', 'h', 'Medio', 'Medio', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('811', 'j', 'Término indicativo de función/relación', 'Término indicativo de función/relación', 1, 0, NULL, 8, NULL, NULL, '', NULL, -1, '', '', '', NULL),
		('811', 'k', 'Subencabezamiento de forma', 'Subencabezamiento de forma', 1, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('811', 'l', 'Lenguaje de la obra', 'Lenguaje de la obra', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('811', 'n', 'Número del congreso/reunión o número de parte o sección', 'Número del congreso/reunión o número de parte o sección', 1, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('811', 'p', 'Nombre de parte o sección de la obra', 'Nombre de parte o sección de la obra', 1, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('811', 'q', 'Nombre de congreso/reunión que sigue a un nombre de jurisdicción como elemento de entrada', 'Nombre de congreso/reunión que sigue a un nombre de jurisdicción como elemento de entrada', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('811', 's', 'Versión', 'Versión', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('811', 't', 'Título de la obra', 'Título de la obra', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('811', 'u', 'Filiación', 'Filiación', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('811', 'v', 'Designación de volumen o secuencia', 'Designación de volumen o secuencia', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('811', 'w', 'Número de control del registro bibliográfico', 'Número de control del registro bibliográfico', 1, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('811', 'x', 'Número Internacional Normalizado para Publicaciones Seriadas', 'Número Internacional Normalizado para Publicaciones Seriadas', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('830', '0', 'Número de control del registro de autoridad o número normalizado', 'Número de control del registro de autoridad o número normalizado', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('830', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('830', '5', 'Institución que aplica el campo', 'Institución que aplica el campo', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('830', '6', 'Enlace', 'Enlace', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('830', '7', 'Subcampo de control', 'Subcampo de control', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('830', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('830', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 8, '', '', '', 0, -5, '', '', '', NULL),
		('830', 'a', 'Título uniforme', 'Título uniforme', 0, 0, '', 8, '', 'UNIF_TITLE', '', NULL, -1, '', '', '', NULL),
		('830', 'd', 'Fecha de la firma de un tratado', 'Fecha de la firma de un tratado', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('830', 'f', 'Fecha de publicación/de la obra', 'Fecha de publicación/de la obra', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('830', 'g', 'Información miscelánea', 'Información miscelánea', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('830', 'h', 'Medio', 'Medio', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('830', 'k', 'Subencabezamiento de forma', 'Subencabezamiento de forma', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('830', 'l', 'Lenguaje de la obra', 'Lenguaje de la obra', 0, 0, '', 8, '', '', '', NULL, -1, '', '', '', NULL),
		('830', 'm', 'Medio de interpretación para música', 'Medio de interpretación para música', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('830', 'n', 'Número de parte o sección de la obra', 'Número de parte o sección de la obra', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('830', 'o', 'Mención de arreglo para música', 'Mención de arreglo para música', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('830', 'p', 'Nombre de parte o sección de la obra', 'Nombre de parte o sección de la obra', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('830', 'r', 'Clave para música', 'Clave para música', 0, 0, '', 8, '', '', '', NULL, -1, '', '', '', NULL),
		('830', 's', 'Versión', 'Versión', 0, 0, '', 8, '', '', '', NULL, -1, '', '', '', NULL),
		('830', 't', 'Título de la obra', 'Título de la obra', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('830', 'v', 'Designación de volumen o secuencia', 'Designación de volumen o secuencia', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('830', 'w', 'Número de control del registro bibliográfico', 'Número de control del registro bibliográfico', 1, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('830', 'x', 'Número Internacional Normalizado para Publicaciones Seriadas', 'Número Internacional Normalizado para Publicaciones Seriadas', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('840', 'a', 'Título', 'Título', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('840', 'h', 'Medio', 'Medio', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('840', 'v', 'Designación de número de volumen o secuencia', 'Designación de número de volumen o secuencia', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('841', 'a', 'Tipo de registro', 'Tipo de registro', 0, 0, NULL, 8, NULL, NULL, '', NULL, 5, '', '', '', NULL),
		('841', 'b', 'Datos de longitud fija', 'Datos de longitud fija', 0, 0, NULL, 8, NULL, NULL, '', NULL, 5, '', '', '', NULL),
		('841', 'e', 'Nivel de codificación', 'Nivel de codificación', 0, 0, NULL, 8, NULL, NULL, '', NULL, 5, '', '', '', NULL),
		('842', '6', 'Enlace', 'Enlace', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('842', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('842', 'a', 'Designador textual de la forma física', 'Designador textual de la forma física', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('843', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, NULL, 8, NULL, NULL, '', NULL, 5, '', '', '', NULL),
		('843', '6', 'Enlace', 'Enlace', 0, 0, NULL, 8, NULL, NULL, '', NULL, 5, '', '', '', NULL),
		('843', '7', 'Datos de longitud fija sobre la reproducción', 'Datos de longitud fija sobre la reproducción', 0, 0, NULL, 8, NULL, NULL, '', NULL, 5, '', '', '', NULL),
		('843', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 8, NULL, NULL, '', NULL, 5, '', '', '', NULL),
		('843', 'a', 'Tipo de reproducción', 'Tipo de reproducción', 0, 0, NULL, 8, NULL, NULL, '', NULL, 5, '', '', '', NULL),
		('843', 'b', 'Lugar de la reproducción', 'Lugar de la reproducción', 1, 0, NULL, 8, NULL, NULL, '', NULL, 5, '', '', '', NULL),
		('843', 'c', 'Institución responsable de la reproducción', 'Institución responsable de la reproducción', 1, 0, NULL, 8, NULL, NULL, '', NULL, 5, '', '', '', NULL),
		('843', 'd', 'Fecha de la reproducción', 'Fecha de la reproducción', 0, 0, NULL, 8, NULL, NULL, '', NULL, 5, '', '', '', NULL),
		('843', 'e', 'Descripción física de la reproducción', 'Descripción física de la reproducción', 1, 0, NULL, 8, NULL, NULL, '', NULL, 5, '', '', '', NULL),
		('843', 'f', 'Mención de serie de la reproducción', 'Mención de serie de la reproducción', 1, 0, NULL, 8, NULL, NULL, '', NULL, 5, '', '', '', NULL),
		('843', 'm', 'Fechas de publicación y/o designación secuencial  de los originales reproducidos', 'Fechas de publicación y/o designación secuencial  de los originales reproducidos', 1, 0, NULL, 8, NULL, NULL, '', NULL, 5, '', '', '', NULL),
		('843', 'n', 'Nota sobre la reproducción', 'Nota sobre la reproducción', 1, 0, NULL, 8, NULL, NULL, '', NULL, 5, '', '', '', NULL),
		('844', '6', 'Enlace', 'Enlace', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('844', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('844', 'a', 'Nombre de unidad', 'Nombre de unidad', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('845', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, NULL, 8, NULL, NULL, '', NULL, 5, '', '', '', NULL),
		('845', '5', 'Institución que aplica el campo', 'Institución que aplica el campo', 0, 0, NULL, 8, NULL, NULL, '', NULL, 5, '', '', '', NULL),
		('845', '6', 'Enlace', 'Enlace', 0, 0, NULL, 8, NULL, NULL, '', NULL, 5, '', '', '', NULL),
		('845', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 8, NULL, NULL, '', NULL, 5, '', '', '', NULL),
		('845', 'a', 'Condiciones de uso y reproducción', 'Condiciones de uso y reproducción', 0, 0, NULL, 8, NULL, NULL, '', NULL, 5, '', '', '', NULL),
		('845', 'b', 'Autoridad competente/Jurisdicción', 'Autoridad competente/Jurisdicción', 0, 0, NULL, 8, NULL, NULL, '', NULL, 5, '', '', '', NULL),
		('845', 'c', 'Autorización', 'Autorización', 0, 0, NULL, 8, NULL, NULL, '', NULL, 5, '', '', '', NULL),
		('845', 'd', 'Usuarios autorizados', 'Usuarios autorizados', 0, 0, NULL, 8, NULL, NULL, '', NULL, 5, '', '', '', NULL),
		('850', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 8, NULL, NULL, '', NULL, 5, '', '', '', NULL),
		('850', 'a', 'Institución que posee los fondos', 'Institución que posee los fondos', 1, 0, NULL, 8, NULL, NULL, '', NULL, 5, '', '', '', NULL),
		('850', 'b', 'Fondos (NR) (MU VM SE) [OBSOLETO]', 'Fondos (NR) (MU VM SE) [OBSOLETO]', 0, 0, NULL, 8, NULL, NULL, '', NULL, 5, '', '', '', NULL),
		('850', 'd', 'Fechas inclusivas (NR) (MU VM SE) [OBSOLETO]', 'Fechas inclusivas (NR) (MU VM SE) [OBSOLETO]', 0, 0, NULL, 8, NULL, NULL, '', NULL, 5, '', '', '', NULL),
		('850', 'e', 'Mención de retención (NR) (CF MU VM SE) [OBSOLETO]', 'Mención de retención (NR) (CF MU VM SE) [OBSOLETO]', 0, 0, NULL, 8, NULL, NULL, '', NULL, 5, '', '', '', NULL),
		('851', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, NULL, 8, NULL, NULL, '', NULL, 5, '', '', '', NULL),
		('851', '6', 'Enlace', 'Enlace', 0, 0, NULL, 8, NULL, NULL, '', NULL, 5, '', '', '', NULL),
		('851', 'a', 'Nombre (conservador o dueño)', 'Nombre (conservador o dueño)', 0, 0, NULL, 8, NULL, NULL, '', NULL, 5, '', '', '', NULL),
		('851', 'b', 'División institucional', 'División institucional', 0, 0, NULL, 8, NULL, NULL, '', NULL, 5, '', '', '', NULL),
		('851', 'c', 'Dirección de la calle', 'Dirección de la calle', 0, 0, NULL, 8, NULL, NULL, '', NULL, 5, '', '', '', NULL),
		('851', 'd', 'País', 'País', 0, 0, NULL, 8, NULL, NULL, '', NULL, 5, '', '', '', NULL),
		('851', 'e', 'Ubicación de las unidades', 'Ubicación de las unidades', 0, 0, NULL, 8, NULL, NULL, '', NULL, 5, '', '', '', NULL),
		('851', 'f', 'Número de documento/Ítem', 'Número de documento/Ítem', 0, 0, NULL, 8, NULL, NULL, '', NULL, 5, '', '', '', NULL),
		('851', 'g', 'Código de localización del depósito/repositorio', 'Código de localización del depósito/repositorio', 0, 0, NULL, 8, NULL, NULL, '', NULL, 5, '', '', '', NULL),
		('852', '2', 'Fuente del sistema de clasificación o colocación', 'Fuente del sistema de clasificación o colocación', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('852', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('852', '6', 'Enlace', 'Enlace', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('852', '8', 'Número de secuencia', 'Número de secuencia', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('852', 'a', 'Localización', 'Localización', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('852', 'b', 'Sublocalización o colección', 'Sublocalización o colección', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('852', 'c', 'Ubicación en estantería', 'Ubicación en estantería', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('852', 'd', 'Anterior ubicación en estantería', 'Anterior ubicación en estantería', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('852', 'e', 'Dirección', 'Dirección', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('852', 'f', 'Información codificada de la localización en otra ubicación', 'Información codificada de la localización en otra ubicación', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('852', 'g', 'Información no codificada de la localización en otra ubicación', 'Información no codificada de la localización en otra ubicación', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('852', 'h', 'Parte de la signatura que corresponde a la clasificación (Parte de la clasificación)', 'Parte de la signatura que corresponde a la clasificación (Parte de la clasificación)', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('852', 'i', 'Parte de la signatura que identifica el ejemplar (Parte del ítem)', 'Parte de la signatura que identifica el ejemplar (Parte del ítem)', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('852', 'j', 'Número de control en estantería', 'Número de control en estantería', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('852', 'k', 'Prefijo de la signatura', 'Prefijo de la signatura', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('852', 'l', 'Forma del título por la que se ordena', 'Forma del título por la que se ordena', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('852', 'm', 'Sufijo de la signatura', 'Sufijo de la signatura', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('852', 'n', 'Código de país', 'Código de país', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('852', 'p', 'Designación de la unidad física', 'Designación de la unidad física', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('852', 'q', 'Condición de la unidad física', 'Condición de la unidad física', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('852', 's', 'Derechos de autor del artículo-código de tarifa', 'Derechos de autor del artículo-código de tarifa', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('852', 't', 'Número de copia', 'Número de copia', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('852', 'u', 'Identificador Uniforme del Recurso', 'Identificador Uniforme del Recurso', 1, 0, '', 8, '', '', '', 1, 5, '', '', '', NULL),
		('852', 'x', 'Nota interna', 'Nota interna', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('852', 'z', 'Nota pública', 'Nota pública', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('853', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('853', '6', 'Enlace', 'Enlace', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('853', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('853', 'a', 'Primer nivel de enumeración', 'Primer nivel de enumeración', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('853', 'b', 'Segundo nivel de enumeración', 'Segundo nivel de enumeración', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('853', 'c', 'Tercer nivel de enumeración', 'Tercer nivel de enumeración', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('853', 'd', 'Cuarto nivel de enumeración', 'Cuarto nivel de enumeración', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('853', 'e', 'Quinto nivel de enumeración', 'Quinto nivel de enumeración', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('853', 'f', 'Sexto nivel de enumeración', 'Sexto nivel de enumeración', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('853', 'g', 'Esquema de numeración alternativo, primer nivel de enumeración', 'Esquema de numeración alternativo, primer nivel de enumeración', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('853', 'h', 'Esquema de numeración alternativo, segundo nivel de enumeración', 'Esquema de numeración alternativo, segundo nivel de enumeración', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('853', 'i', 'Primer nivel de cronología', 'Primer nivel de cronología', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('853', 'j', 'Segundo nivel de cronología', 'Segundo nivel de cronología', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('853', 'k', 'Tercer nivel de cronología', 'Tercer nivel de cronología', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('853', 'l', 'Cuarto nivel de cronología', 'Cuarto nivel de cronología', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('853', 'm', 'Esquema de numeración alternativo, cronología', 'Esquema de numeración alternativo, cronología', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('853', 'n', 'Nota del patrón', 'Nota del patrón', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('853', 'p', 'Número de unidades físicas (piezas) por entrega', 'Número de unidades físicas (piezas) por entrega', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('853', 't', 'Copia', 'Copia', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('853', 'u', 'Unidades bibliográficas para el nivel superior siguiente', 'Unidades bibliográficas para el nivel superior siguiente', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('853', 'v', 'Continuidad de numeración', 'Continuidad de numeración', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('853', 'w', 'Periodicidad', 'Periodicidad', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('853', 'x', 'Cambio de calendario', 'Cambio de calendario', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('853', 'y', 'Patrón de regularidad', 'Patrón de regularidad', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('853', 'z', 'Esquema de numeración', 'Esquema de numeración', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('854', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('854', '6', 'Enlace', 'Enlace', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('854', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('854', 'a', 'Primer nivel de enumeración', 'Primer nivel de enumeración', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('854', 'b', 'Segundo nivel de enumeración', 'Segundo nivel de enumeración', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('854', 'c', 'Tercer nivel de enumeración', 'Tercer nivel de enumeración', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('854', 'd', 'Cuarto nivel de enumeración', 'Cuarto nivel de enumeración', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('854', 'e', 'Quinto nivel de enumeración', 'Quinto nivel de enumeración', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('854', 'f', 'Sexto nivel de enumeración', 'Sexto nivel de enumeración', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('854', 'g', 'Esquema de numeración alternativo, primer nivel de enumeración', 'Esquema de numeración alternativo, primer nivel de enumeración', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('854', 'h', 'Esquema de numeración alternativo, segundo nivel de enumeración', 'Esquema de numeración alternativo, segundo nivel de enumeración', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('854', 'i', 'Primer nivel de cronología', 'Primer nivel de cronología', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('854', 'j', 'Segundo nivel de cronología', 'Segundo nivel de cronología', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('854', 'k', 'Tercer nivel de cronología', 'Tercer nivel de cronología', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('854', 'l', 'Cuarto nivel de cronología', 'Cuarto nivel de cronología', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('854', 'm', 'Esquema de numeración alternativo, cronología', 'Esquema de numeración alternativo, cronología', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('854', 'n', 'Nota del patrón', 'Nota del patrón', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('854', 'p', 'Número de unidades físicas (piezas) por entrega', 'Número de unidades físicas (piezas) por entrega', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('854', 't', 'Copia', 'Copia', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('854', 'u', 'Unidades bibliográficas para el nivel superior siguiente', 'Unidades bibliográficas para el nivel superior siguiente', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('854', 'v', 'Continuidad de numeración', 'Continuidad de numeración', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('854', 'w', 'Periodicidad', 'Periodicidad', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('854', 'x', 'Cambio de calendario', 'Cambio de calendario', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('854', 'y', 'Patrón de regularidad', 'Patrón de regularidad', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('854', 'z', 'Esquema de numeración', 'Esquema de numeración', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('855', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('855', '6', 'Enlace', 'Enlace', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('855', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('855', 'a', 'Primer nivel de enumeración', 'Primer nivel de enumeración', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('855', 'b', 'Segundo nivel de enumeración', 'Segundo nivel de enumeración', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('855', 'c', 'Tercer nivel de enumeración', 'Tercer nivel de enumeración', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('855', 'd', 'Cuarto nivel de enumeración', 'Cuarto nivel de enumeración', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('855', 'e', 'Quinto nivel de enumeración', 'Quinto nivel de enumeración', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('855', 'f', 'Sexto nivel de enumeración', 'Sexto nivel de enumeración', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('855', 'g', 'Esquema de numeración alternativo, primer nivel de enumeración', 'Esquema de numeración alternativo, primer nivel de enumeración', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('855', 'h', 'Esquema de numeración alternativo, segundo nivel de enumeración', 'Esquema de numeración alternativo, segundo nivel de enumeración', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('855', 'i', 'Primer nivel de cronología', 'Primer nivel de cronología', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('855', 'j', 'Segundo nivel de cronología', 'Segundo nivel de cronología', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('855', 'k', 'Tercer nivel de cronología', 'Tercer nivel de cronología', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('855', 'l', 'Cuarto nivel de cronología', 'Cuarto nivel de cronología', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('855', 'm', 'Esquema de numeración alternativo, cronología', 'Esquema de numeración alternativo, cronología', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('855', 'n', 'Nota del patrón', 'Nota del patrón', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('855', 'p', 'Número de unidades físicas (piezas) por entrega', 'Número de unidades físicas (piezas) por entrega', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('855', 't', 'Copia', 'Copia', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('855', 'u', 'Unidades bibliográficas para el nivel superior siguiente', 'Unidades bibliográficas para el nivel superior siguiente', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('855', 'v', 'Continuidad de numeración', 'Continuidad de numeración', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('855', 'w', 'Periodicidad', 'Periodicidad', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('855', 'x', 'Cambio de calendario', 'Cambio de calendario', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('855', 'y', 'Patrón de regularidad', 'Patrón de regularidad', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('855', 'z', 'Esquema de numeración', 'Esquema de numeración', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('856', '2', 'Método de acceso', 'Método de acceso', 0, 0, '', 8, '', '', '', 0, -6, '', '', '', NULL),
		('856', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, '', 8, '', '', '', 0, 0, '', '', '', NULL),
		('856', '6', 'Enlace', 'Enlace', 0, 0, '', 8, '', '', '', 0, -6, '', '', '', NULL),
		('856', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 8, '', '', '', 0, -6, '', '', '', NULL),
		('856', 'a', 'Nombre del host', 'Nombre del host', 1, 0, '', 8, '', '', '', 0, -1, '', '', '', NULL),
		('856', 'b', 'Número de acceso', 'Número de acceso', 1, 0, '', 8, '', '', '', 0, -1, '', '', '', NULL),
		('856', 'c', 'Información sobre la compresión', 'Información sobre la compresión', 1, 0, '', 8, '', '', '', 0, -1, '', '', '', NULL),
		('856', 'd', 'Ruta', 'Ruta', 1, 0, '', 8, '', '', '', 0, -1, '', '', '', NULL),
		('856', 'f', 'Nombre electrónico', 'Nombre electrónico', 1, 0, '', 8, '', '', '', 0, -1, '', '', '', NULL),
		('856', 'h', 'Procesador de la petición', 'Procesador de la petición', 0, 0, '', 8, '', '', '', 0, -1, '', '', '', NULL),
		('856', 'i', 'Instrucción', 'Instrucción', 1, 0, '', 8, '', '', '', 0, -1, '', '', '', NULL),
		('856', 'j', 'Bits por segundo', 'Bits por segundo', 0, 0, '', 8, '', '', '', 0, -1, '', '', '', NULL),
		('856', 'k', 'Contraseña', 'Contraseña', 0, 0, '', 8, '', '', '', 0, -1, '', '', '', NULL),
		('856', 'l', 'Proceso de conexión (Logon)', 'Proceso de conexión (Logon)', 0, 0, '', 8, '', '', '', 0, -1, '', '', '', NULL),
		('856', 'm', 'Contacto para facilitar el acceso', 'Contacto para facilitar el acceso', 1, 0, '', 8, '', '', '', 0, -1, '', '', '', NULL),
		('856', 'n', 'Nombre de la localización del host', 'Nombre de la localización del host', 0, 0, '', 8, '', '', '', 0, -1, '', '', '', NULL),
		('856', 'o', 'Sistema operativo', 'Sistema operativo', 0, 0, '', 8, '', '', '', 0, -1, '', '', '', NULL),
		('856', 'p', 'Puerto', 'Puerto', 0, 0, '', 8, '', '', '', 0, -1, '', '', '', NULL),
		('856', 'q', 'Tipo de formato electrónico', 'Tipo de formato electrónico', 0, 0, '', 8, '', '', '', 0, -1, '', '', '', NULL),
		('856', 'r', 'Parámetros', 'Parámetros', 0, 0, '', 8, '', '', '', 0, -1, '', '', '', NULL),
		('856', 's', 'Tamaño de archivo', 'Tamaño de archivo', 1, 0, '', 8, '', '', '', 0, -1, '', '', '', NULL),
		('856', 't', 'Emulación del terminal', 'Emulación del terminal', 1, 0, '', 8, '', '', '', 0, -1, '', '', '', NULL),
		('856', 'u', 'Identificador Uniforme del Recurso', 'Identificador Uniforme del Recurso', 1, 0, 'biblioitems.url', 8, '', '', '', 1, 0, '', '', '', NULL),
		('856', 'v', 'Horario en que el acceso está disponible', 'Horario en que el acceso está disponible', 1, 0, '', 8, '', '', '', 0, -1, '', '', '', NULL),
		('856', 'w', 'Número de control del registro', 'Número de control del registro', 1, 0, '', 8, '', '', '', 0, -1, '', '', '', NULL),
		('856', 'x', 'Nota interna', 'Nota interna', 1, 0, '', 8, '', '', '', 0, 1, '', '', '', NULL),
		('856', 'y', 'Texto de enlace', 'Texto de enlace', 1, 0, '', 8, '', '', '', 0, 0, '', '', '', NULL),
		('856', 'z', 'Nota pública', 'Nota pública', 1, 0, '', 8, '', '', '', 0, 0, '', '', '', NULL),
		('859', 'b', 'Iniciales del operador, OID (RLIN)', 'Iniciales del operador, OID (RLIN)', 0, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('859', 'c', 'Iniciales del catalogador, CIN (RLIN)', 'Iniciales del catalogador, CIN (RLIN)', 0, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('859', 'd', 'TDC (RLIN)', 'TDC (RLIN)', 0, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('859', 'l', 'LIB (RLIN)', 'LIB (RLIN)', 0, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('859', 'p', 'PRI (RLIN)', 'PRI (RLIN)', 0, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('859', 'r', 'REG (RLIN)', 'REG (RLIN)', 0, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('859', 'v', 'VER (RLIN)', 'VER (RLIN)', 0, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('859', 'x', 'LDEL (RLIN)', 'LDEL (RLIN)', 0, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('863', '6', 'Enlace', 'Enlace', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('863', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('863', 'a', 'Primer nivel de enumeración', 'Primer nivel de enumeración', 0, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('863', 'b', 'Segundo nivel de enumeración', 'Segundo nivel de enumeración', 0, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('863', 'c', 'Tercer nivel de enumeración', 'Tercer nivel de enumeración', 0, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('863', 'd', 'Cuarto nivel de enumeración', 'Cuarto nivel de enumeración', 0, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('863', 'e', 'Quinto nivel de enumeración', 'Quinto nivel de enumeración', 0, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('863', 'f', 'Sexto nivel de enumeración', 'Sexto nivel de enumeración', 0, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('863', 'g', 'Esquema de numeración alternativo, primer nivel de enumeración', 'Esquema de numeración alternativo, primer nivel de enumeración', 0, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('863', 'h', 'Esquema de numeración alternativo, segundo nivel de enumeración', 'Esquema de numeración alternativo, segundo nivel de enumeración', 0, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('863', 'i', 'Primer nivel de cronología', 'Primer nivel de cronología', 0, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('863', 'j', 'Segundo nivel de cronología', 'Segundo nivel de cronología', 0, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('863', 'k', 'Tercer nivel de cronología', 'Tercer nivel de cronología', 0, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('863', 'l', 'Cuarto nivel de cronología', 'Cuarto nivel de cronología', 0, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('863', 'm', 'Esquema de numeración alternativo, cronología', 'Esquema de numeración alternativo, cronología', 0, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('863', 'n', 'Año gregoriano convertido', 'Año gregoriano convertido', 0, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('863', 'o', 'Tipo de unidad', 'Tipo de unidad', 1, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('863', 'p', 'Designación de la unidad física', 'Designación de la unidad física', 0, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('863', 'q', 'Condición de la unidad física', 'Condición de la unidad física', 0, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('863', 's', 'Derechos de autor del artículo-código de tarifa', 'Derechos de autor del artículo-código de tarifa', 1, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('863', 't', 'Número de copia', 'Número de copia', 0, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('863', 'v', 'Fecha de emisión', 'Fecha de emisión', 1, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('863', 'w', 'Indicador de ruptura', 'Indicador de ruptura', 0, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('863', 'x', 'Nota interna', 'Nota interna', 1, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('863', 'z', 'Nota pública', 'Nota pública', 1, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('864', '6', 'Enlace', 'Enlace', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('864', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('864', 'a', 'Primer nivel de enumeración', 'Primer nivel de enumeración', 0, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('864', 'b', 'Segundo nivel de enumeración', 'Segundo nivel de enumeración', 0, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('864', 'c', 'Tercer nivel de enumeración', 'Tercer nivel de enumeración', 0, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('864', 'd', 'Cuarto nivel de enumeración', 'Cuarto nivel de enumeración', 0, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('864', 'e', 'Quinto nivel de enumeración', 'Quinto nivel de enumeración', 0, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('864', 'f', 'Sexto nivel de enumeración', 'Sexto nivel de enumeración', 0, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('864', 'g', 'Esquema de numeración alternativo, primer nivel de enumeración', 'Esquema de numeración alternativo, primer nivel de enumeración', 0, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('864', 'h', 'Esquema de numeración alternativo, segundo nivel de enumeración', 'Esquema de numeración alternativo, segundo nivel de enumeración', 0, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('864', 'i', 'Primer nivel de cronología', 'Primer nivel de cronología', 0, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('864', 'j', 'Segundo nivel de cronología', 'Segundo nivel de cronología', 0, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('864', 'k', 'Tercer nivel de cronología', 'Tercer nivel de cronología', 0, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('864', 'l', 'Cuarto nivel de cronología', 'Cuarto nivel de cronología', 0, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('864', 'm', 'Esquema de numeración alternativo, cronología', 'Esquema de numeración alternativo, cronología', 0, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('864', 'n', 'Año gregoriano convertido', 'Año gregoriano convertido', 0, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('864', 'o', 'Tipo de unidad', 'Tipo de unidad', 1, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('864', 'p', 'Designación de la unidad física', 'Designación de la unidad física', 0, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('864', 'q', 'Condición de la unidad física', 'Condición de la unidad física', 0, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('864', 's', 'Derechos de autor del artículo-código de tarifa', 'Derechos de autor del artículo-código de tarifa', 1, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('864', 't', 'Número de copia', 'Número de copia', 0, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('864', 'v', 'Fecha de emisión', 'Fecha de emisión', 1, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('864', 'w', 'Indicador de ruptura', 'Indicador de ruptura', 0, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('864', 'x', 'Nota interna', 'Nota interna', 1, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('864', 'z', 'Nota pública', 'Nota pública', 1, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('865', '6', 'Enlace', 'Enlace', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('865', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('865', 'a', 'Primer nivel de enumeración', 'Primer nivel de enumeración', 0, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('865', 'b', 'Segundo nivel de enumeración', 'Segundo nivel de enumeración', 0, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('865', 'c', 'Tercer nivel de enumeración', 'Tercer nivel de enumeración', 0, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('865', 'd', 'Cuarto nivel de enumeración', 'Cuarto nivel de enumeración', 0, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('865', 'e', 'Quinto nivel de enumeración', 'Quinto nivel de enumeración', 0, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('865', 'f', 'Sexto nivel de enumeración', 'Sexto nivel de enumeración', 0, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('865', 'g', 'Esquema de numeración alternativo, primer nivel de enumeración', 'Esquema de numeración alternativo, primer nivel de enumeración', 0, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('865', 'h', 'Esquema de numeración alternativo, segundo nivel de enumeración', 'Esquema de numeración alternativo, segundo nivel de enumeración', 0, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('865', 'i', 'Primer nivel de cronología', 'Primer nivel de cronología', 0, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('865', 'j', 'Segundo nivel de cronología', 'Segundo nivel de cronología', 0, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('865', 'k', 'Tercer nivel de cronología', 'Tercer nivel de cronología', 0, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('865', 'l', 'Cuarto nivel de cronología', 'Cuarto nivel de cronología', 0, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('865', 'm', 'Esquema de numeración alternativo, cronología', 'Esquema de numeración alternativo, cronología', 0, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('865', 'n', 'Año gregoriano convertido', 'Año gregoriano convertido', 0, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('865', 'o', 'Tipo de unidad', 'Tipo de unidad', 1, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('865', 'p', 'Designación de la unidad física', 'Designación de la unidad física', 0, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('865', 'q', 'Condición de la unidad física', 'Condición de la unidad física', 0, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('865', 's', 'Derechos de autor del artículo-código de tarifa', 'Derechos de autor del artículo-código de tarifa', 1, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('865', 't', 'Número de copia', 'Número de copia', 0, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('865', 'v', 'Fecha de emisión', 'Fecha de emisión', 1, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('865', 'w', 'Indicador de ruptura', 'Indicador de ruptura', 0, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('865', 'x', 'Nota interna', 'Nota interna', 1, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('865', 'z', 'Nota pública', 'Nota pública', 1, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('866', '6', 'Enlace', 'Enlace', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('866', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('866', 'a', 'Cadena textual', 'Cadena textual', 0, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('866', 'x', 'Nota interna', 'Nota interna', 1, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('866', 'z', 'Nota pública', 'Nota pública', 1, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('867', '6', 'Enlace', 'Enlace', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('867', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('867', 'a', 'Cadena textual', 'Cadena textual', 0, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('867', 'x', 'Nota interna', 'Nota interna', 1, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('867', 'z', 'Nota pública', 'Nota pública', 1, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('868', '6', 'Enlace', 'Enlace', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('868', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('868', 'a', 'Cadena textual', 'Cadena textual', 0, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('868', 'x', 'Nota interna', 'Nota interna', 1, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('868', 'z', 'Nota pública', 'Nota pública', 1, 0, '', 8, '', '', '', 0, 5, '', '', '', NULL),
		('870', '4', 'Código de función/relación', 'Código de función/relación', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('870', '6', 'Enlace', 'Enlace', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('870', 'a', 'Nombre de persona', 'Nombre de persona', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('870', 'b', 'Numeración', 'Numeración', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('870', 'c', 'Títulos y otros términos asociados al nombre', 'Títulos y otros términos asociados al nombre', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('870', 'd', 'Fechas asociadas al nombre', 'Fechas asociadas al nombre', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('870', 'e', 'Término indicativo de función/relación', 'Término indicativo de función/relación', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('870', 'f', 'Fecha de publicación/de la obra', 'Fecha de publicación/de la obra', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('870', 'g', 'Información miscelánea', 'Información miscelánea', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('870', 'j', 'Etiqueta y número de secuencia', 'Etiqueta y número de secuencia', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('870', 'k', 'Subencabezamiento de forma', 'Subencabezamiento de forma', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('870', 'l', 'Lenguaje de la obra', 'Lenguaje de la obra', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('870', 'n', 'Número de parte o sección de la obra', 'Número de parte o sección de la obra', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('870', 'p', 'Nombre de parte o sección de la obra', 'Nombre de parte o sección de la obra', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('870', 'q', 'Forma completa/desarrollada del nombre', 'Forma completa/desarrollada del nombre', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('870', 't', 'Título de la obra', 'Título de la obra', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('870', 'u', 'Filiación', 'Filiación', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('871', '4', 'Código de función/relación', 'Código de función/relación', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('871', '6', 'Enlace', 'Enlace', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('871', 'a', 'Nombre de entidad corporativa o nombre de jurisdicción como elemento de entrada', 'Nombre de entidad corporativa o nombre de jurisdicción como elemento de entrada', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('871', 'b', 'Unidad subordinada', 'Unidad subordinada', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('871', 'c', 'Sede del congreso/Lugar de la reunión', 'Sede del congreso/Lugar de la reunión', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('871', 'd', 'Fecha del congreso/reunión o de la firma de un tratado', 'Fecha del congreso/reunión o de la firma de un tratado', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('871', 'e', 'Término indicativo de función/relación', 'Término indicativo de función/relación', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('871', 'f', 'Fecha de publicación/de la obra', 'Fecha de publicación/de la obra', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('871', 'g', 'Información miscelánea', 'Información miscelánea', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('871', 'j', 'Etiqueta y número de secuencia', 'Etiqueta y número de secuencia', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('871', 'k', 'Subencabezamiento de forma', 'Subencabezamiento de forma', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('871', 'l', 'Lenguaje de la obra', 'Lenguaje de la obra', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('871', 'n', 'Número del congreso/reunión o número de parte o sección', 'Número del congreso/reunión o número de parte o sección', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('871', 'p', 'Nombre de parte o sección de la obra', 'Nombre de parte o sección de la obra', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('871', 't', 'Título de la obra', 'Título de la obra', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('871', 'u', 'Filiación', 'Filiación', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('872', '4', 'Código de función/relación', 'Código de función/relación', 1, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('872', '6', 'Enlace', 'Enlace', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('872', 'a', 'Nombre de congreso/reunión o jurisdicción como elemento de entrada', 'Nombre de congreso/reunión o jurisdicción como elemento de entrada', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('872', 'b', 'Número [OBSOLETO]', 'Número [OBSOLETO]', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('872', 'c', 'Sede del congreso/Lugar de la reunión', 'Sede del congreso/Lugar de la reunión', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('872', 'd', 'Fecha del congreso/reunión', 'Fecha del congreso/reunión', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('872', 'e', 'Unidad subordinada', 'Unidad subordinada', 1, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('872', 'f', 'Fecha de publicación/de la obra', 'Fecha de publicación/de la obra', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('872', 'g', 'Información miscelánea', 'Información miscelánea', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('872', 'j', 'Etiqueta y número de secuencia', 'Etiqueta y número de secuencia', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('872', 'k', 'Subencabezamiento de forma', 'Subencabezamiento de forma', 1, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('872', 'l', 'Lenguaje de la obra', 'Lenguaje de la obra', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('872', 'n', 'Número del congreso/reunión o número de parte o sección', 'Número del congreso/reunión o número de parte o sección', 1, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('872', 'p', 'Nombre de parte o sección de la obra', 'Nombre de parte o sección de la obra', 1, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('872', 'q', 'Nombre de congreso/reunión que sigue a un nombre de jurisdicción como elemento de entrada', 'Nombre de congreso/reunión que sigue a un nombre de jurisdicción como elemento de entrada', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('872', 't', 'Título de la obra', 'Título de la obra', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('872', 'u', 'Filiación', 'Filiación', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('873', '6', 'Enlace', 'Enlace', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('873', 'a', 'Título uniforme', 'Título uniforme', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('873', 'd', 'Fecha de la firma de un tratado', 'Fecha de la firma de un tratado', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('873', 'f', 'Fecha de publicación/de la obra', 'Fecha de publicación/de la obra', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('873', 'g', 'Información miscelánea', 'Información miscelánea', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('873', 'h', 'Medio', 'Medio', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('873', 'j', 'Etiqueta y número de secuencia', 'Etiqueta y número de secuencia', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('873', 'k', 'Subencabezamiento de forma', 'Subencabezamiento de forma', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('873', 'l', 'Lenguaje de la obra', 'Lenguaje de la obra', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('873', 'm', 'Medio de interpretación para música', 'Medio de interpretación para música', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('873', 'n', 'Número de parte o sección de la obra', 'Número de parte o sección de la obra', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('873', 'o', 'Mención de arreglo para música', 'Mención de arreglo para música', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('873', 'p', 'Nombre de parte o sección de la obra', 'Nombre de parte o sección de la obra', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('873', 'r', 'Clave para música', 'Clave para música', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('873', 's', 'Versión', 'Versión', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('873', 't', 'Título de la obra', 'Título de la obra', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('876', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('876', '6', 'Enlace', 'Enlace', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('876', '8', 'Número de secuencia', 'Número de secuencia', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('876', 'a', 'Número de ítem interno', 'Número de ítem interno', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('876', 'b', 'Número interno de ítem inválido o cancelado', 'Número interno de ítem inválido o cancelado', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('876', 'c', 'Coste', 'Coste', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('876', 'd', 'Fecha de adquisición', 'Fecha de adquisición', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('876', 'e', 'Fuente de adquisición', 'Fuente de adquisición', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('876', 'h', 'Restricciones de uso', 'Restricciones de uso', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('876', 'j', 'Estado del ítem/unidad física', 'Estado del ítem/unidad física', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('876', 'l', 'Localización temporal', 'Localización temporal', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('876', 'p', 'Designación de la unidad física', 'Designación de la unidad física', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('876', 'r', 'Designación de pieza inválida o cancelada', 'Designación de pieza inválida o cancelada', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('876', 't', 'Número de copia', 'Número de copia', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('876', 'x', 'Nota interna', 'Nota interna', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('876', 'z', 'Nota pública', 'Nota pública', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('877', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('877', '6', 'Enlace', 'Enlace', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('877', '8', 'Número de secuencia', 'Número de secuencia', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('877', 'a', 'Número de ítem interno', 'Número de ítem interno', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('877', 'b', 'Número interno de ítem inválido o cancelado', 'Número interno de ítem inválido o cancelado', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('877', 'c', 'Coste', 'Coste', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('877', 'd', 'Fecha de adquisición', 'Fecha de adquisición', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('877', 'e', 'Fuente de adquisición', 'Fuente de adquisición', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('877', 'h', 'Restricciones de uso', 'Restricciones de uso', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('877', 'j', 'Estado del ítem/unidad física', 'Estado del ítem/unidad física', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('877', 'l', 'Localización temporal', 'Localización temporal', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('877', 'p', 'Designación de la unidad física', 'Designación de la unidad física', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('877', 'r', 'Designación de pieza inválida o cancelada', 'Designación de pieza inválida o cancelada', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('877', 't', 'Número de copia', 'Número de copia', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('877', 'x', 'Nota interna', 'Nota interna', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('877', 'z', 'Nota pública', 'Nota pública', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('878', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('878', '6', 'Enlace', 'Enlace', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('878', '8', 'Número de secuencia', 'Número de secuencia', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('878', 'a', 'Número de ítem interno', 'Número de ítem interno', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('878', 'b', 'Número interno de ítem inválido o cancelado', 'Número interno de ítem inválido o cancelado', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('878', 'c', 'Coste', 'Coste', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('878', 'd', 'Fecha de adquisición', 'Fecha de adquisición', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('878', 'e', 'Fuente de adquisición', 'Fuente de adquisición', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('878', 'h', 'Restricciones de uso', 'Restricciones de uso', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('878', 'j', 'Estado del ítem/unidad física', 'Estado del ítem/unidad física', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('878', 'l', 'Localización temporal', 'Localización temporal', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('878', 'p', 'Designación de la unidad física', 'Designación de la unidad física', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('878', 'r', 'Designación de pieza inválida o cancelada', 'Designación de pieza inválida o cancelada', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('878', 't', 'Número de copia', 'Número de copia', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('878', 'x', 'Nota interna', 'Nota interna', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('878', 'z', 'Nota pública', 'Nota pública', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('880', '2', '2', '2', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('880', '3', '3', '3', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('880', '4', '4', '4', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('880', '5', '5', '5', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('880', '6', 'Enlace', 'Enlace', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('880', '7', '7', '7', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('880', '8', '8', '8', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('880', '9', '9', '9', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('880', 'a', 'a', 'a', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('880', 'b', 'b', 'b', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('880', 'c', 'c', 'c', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('880', 'd', 'd', 'd', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('880', 'e', 'e', 'e', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('880', 'f', 'f', 'f', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('880', 'g', 'g', 'g', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('880', 'h', 'h', 'h', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('880', 'i', 'i', 'i', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('880', 'j', 'j', 'j', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('880', 'k', 'k', 'k', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('880', 'l', 'l', 'l', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('880', 'm', 'm', 'm', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('880', 'n', 'n', 'n', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('880', 'o', 'o', 'o', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('880', 'p', 'p', 'p', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('880', 'q', 'q', 'q', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('880', 'r', 'r', 'r', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('880', 's', 's', 's', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('880', 't', 't', 't', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('880', 'u', 'u', 'u', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('880', 'v', 'v', 'v', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('880', 'w', 'w', 'w', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('880', 'x', 'x', 'x', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('880', 'y', 'y', 'y', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('880', 'z', 'z', 'z', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('882', '6', 'Enlace', 'Enlace', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('882', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('882', 'a', 'Título que sustituye al registro eliminado', 'Título que sustituye al registro eliminado', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('882', 'i', 'Texto explicativo', 'Texto explicativo', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('882', 'w', 'Número de control del registro bibliográfico que sustituye al eliminado', 'Número de control del registro bibliográfico que sustituye al eliminado', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('883', '0', 'Número de control del registro de autoridad o número normalizado', 'Número de control del registro de autoridad o número normalizado', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('883', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('883', 'a', 'Proceso de generación', 'Proceso de generación', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('883', 'c', 'Valor de confidencia', 'Valor de confidencia', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('883', 'd', 'Fecha de generación', 'Fecha de generación', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('883', 'q', 'Agencia que genera los datos', 'Agencia que genera los datos', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('883', 'x', 'Fecha final de validez', 'Fecha final de validez', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('883', 'u', 'Identificador Uniforme del Recurso', 'Identificador Uniforme del Recurso', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('883', 'w', 'Número de control del registro bibliográfico', 'Número de control del registro bibliográfico', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('884', 'a', 'Proceso de conversión', 'Proceso de conversión', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('884', 'g', 'Fecha de conversión', 'Fecha de conversión', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('884', 'k', 'Identificador de los metadatos originales', 'Identificador de los metadatos originales', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('884', 'q', 'Agencia que convierte los datos', 'Agencia que convierte los datos', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('884', 'u', 'Identificador Uniforme del Recurso', 'Identificador Uniforme del Recurso', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('886', '0', '0', '0', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('886', '1', '1', '1', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('886', '2', '2', '2', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('886', '3', '3', '3', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('886', '4', '4', '4', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('886', '5', '5', '5', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('886', '6', '6', '6', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('886', '7', '7', '7', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('886', '8', '8', '8', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('886', '9', '9', '9', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('886', 'a', 'a', 'a', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('886', 'b', 'b', 'b', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('886', 'c', 'c', 'c', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('886', 'd', 'd', 'd', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('886', 'e', 'e', 'e', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('886', 'f', 'f', 'f', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('886', 'g', 'g', 'g', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('886', 'h', 'h', 'h', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('886', 'i', 'i', 'i', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('886', 'j', 'j', 'j', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('886', 'k', 'k', 'k', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('886', 'l', 'l', 'l', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('886', 'm', 'm', 'm', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('886', 'n', 'n', 'n', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('886', 'o', 'o', 'o', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('886', 'p', 'p', 'p', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('886', 'q', 'q', 'q', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('886', 'r', 'r', 'r', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('886', 's', 's', 's', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('886', 't', 't', 't', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('886', 'u', 'u', 'u', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('886', 'v', 'v', 'v', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('886', 'w', 'w', 'w', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('886', 'x', 'x', 'x', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('886', 'y', 'y', 'y', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('886', 'z', 'z', 'z', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('887', '2', 'Fuente de los datos', 'Fuente de los datos', 0, 0, NULL, 8, NULL, NULL, '', NULL, 0, '', '', '', NULL),
		('887', 'a', 'Contenido de campo no-MARC', 'Contenido de campo no-MARC', 0, 0, NULL, 8, NULL, NULL, '', NULL, 0, '', '', '', NULL),
		('896', '%', '% (RLIN)', '% (RLIN)', 0, 0, '', 8, '', '', '', 0, -6, '', '', '', NULL),
		('896', '4', 'Código de función/relación', 'Código de función/relación', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('896', '6', 'Enlace', 'Enlace', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('896', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('896', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 8, '', '', '', 0, -5, '', '', '', NULL),
		('896', 'a', 'Nombre de persona', 'Nombre de persona', 0, 0, '', 8, '', 'PERSO_NAME', '', NULL, -6, '', '', '', NULL),
		('896', 'b', 'Numeración', 'Numeración', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('896', 'c', 'Títulos y otros términos asociados al nombre', 'Títulos y otros términos asociados al nombre', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('896', 'd', 'Fechas asociadas al nombre', 'Fechas asociadas al nombre', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('896', 'e', 'Término indicativo de función/relación', 'Término indicativo de función/relación', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('896', 'f', 'Fecha de publicación/de la obra', 'Fecha de publicación/de la obra', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('896', 'g', 'Información miscelánea', 'Información miscelánea', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('896', 'h', 'Medio', 'Medio', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('896', 'j', 'Calificador de atribución', 'Calificador de atribución', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('896', 'k', 'Subencabezamiento de forma', 'Subencabezamiento de forma', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('896', 'l', 'Lenguaje de la obra', 'Lenguaje de la obra', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('896', 'm', 'Medio de interpretación para música', 'Medio de interpretación para música', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('896', 'n', 'Número de parte o sección de la obra', 'Número de parte o sección de la obra', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('896', 'o', 'Mención de arreglo para música', 'Mención de arreglo para música', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('896', 'p', 'Nombre de parte o sección de la obra', 'Nombre de parte o sección de la obra', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('896', 'q', 'Forma completa/desarrollada del nombre', 'Forma completa/desarrollada del nombre', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('896', 'r', 'Clave para música', 'Clave para música', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('896', 's', 'Versión', 'Versión', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('896', 't', 'Título de la obra', 'Título de la obra', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('896', 'u', 'Filiación', 'Filiación', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('896', 'v', 'Designación de volumen o secuencia', 'Designación de volumen o secuencia', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('897', '%', '% (RLIN)', '% (RLIN)', 0, 0, '', 8, '', '', '', 0, -6, '', '', '', NULL),
		('897', '4', 'Código de función/relación', 'Código de función/relación', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('897', '6', 'Enlace', 'Enlace', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('897', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('897', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 8, '', '', '', 0, -5, '', '', '', NULL),
		('897', 'a', 'Nombre de entidad corporativa o nombre de jurisdicción como elemento de entrada', 'Nombre de entidad corporativa o nombre de jurisdicción como elemento de entrada', 0, 0, '', 8, '', 'CORPO_NAME', '', NULL, -6, '', '', '', NULL),
		('897', 'b', 'Unidad subordinada', 'Unidad subordinada', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('897', 'c', 'Sede del congreso/Lugar de la reunión', 'Sede del congreso/Lugar de la reunión', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('897', 'd', 'Fecha del congreso/reunión o de la firma de un tratado', 'Fecha del congreso/reunión o de la firma de un tratado', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('897', 'e', 'Término indicativo de función/relación', 'Término indicativo de función/relación', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('897', 'f', 'Fecha de publicación/de la obra', 'Fecha de publicación/de la obra', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('897', 'g', 'Información miscelánea', 'Información miscelánea', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('897', 'h', 'Medio', 'Medio', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('897', 'k', 'Subencabezamiento de forma', 'Subencabezamiento de forma', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('897', 'l', 'Lenguaje de la obra', 'Lenguaje de la obra', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('897', 'm', 'Medio de interpretación para música', 'Medio de interpretación para música', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('897', 'n', 'Número del congreso/reunión o número de parte o sección', 'Número del congreso/reunión o número de parte o sección', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('897', 'o', 'Mención de arreglo para música', 'Mención de arreglo para música', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('897', 'p', 'Nombre de parte o sección de la obra', 'Nombre de parte o sección de la obra', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('897', 'r', 'Clave para música', 'Clave para música', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('897', 's', 'Versión', 'Versión', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('897', 't', 'Título de la obra', 'Título de la obra', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('897', 'u', 'Filiación', 'Filiación', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('897', 'v', 'Designación de volumen o secuencia', 'Designación de volumen o secuencia', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('898', '%', '% (RLIN)', '% (RLIN)', 0, 0, '', 8, '', '', '', 0, -6, '', '', '', NULL),
		('898', '4', 'Código de función/relación', 'Código de función/relación', 1, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('898', '6', 'Enlace', 'Enlace', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('898', '8', 'Enlace entre campos y número de secuencia', 'Enlace entre campos y número de secuencia', 1, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('898', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 8, '', '', '', 0, -5, '', '', '', NULL),
		('898', 'a', 'Nombre de congreso/reunión o jurisdicción como elemento de entrada', 'Nombre de congreso/reunión o jurisdicción como elemento de entrada', 0, 0, NULL, 8, NULL, 'MEETI_NAME', '', NULL, -6, '', '', '', NULL),
		('898', 'b', 'Número (BK CF MP MU SE VM MX) [OBSOLETO]', 'Número (BK CF MP MU SE VM MX) [OBSOLETO]', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('898', 'c', 'Sede del congreso/Lugar de la reunión', 'Sede del congreso/Lugar de la reunión', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('898', 'd', 'Fecha del congreso/reunión', 'Fecha del congreso/reunión', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('898', 'e', 'Unidad subordinada', 'Unidad subordinada', 1, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('898', 'f', 'Fecha de publicación/de la obra', 'Fecha de publicación/de la obra', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('898', 'g', 'Información miscelánea', 'Información miscelánea', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('898', 'h', 'Medio', 'Medio', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('898', 'k', 'Subencabezamiento de forma', 'Subencabezamiento de forma', 1, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('898', 'l', 'Lenguaje de la obra', 'Lenguaje de la obra', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('898', 'n', 'Número del congreso/reunión o número de parte o sección', 'Número del congreso/reunión o número de parte o sección', 1, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('898', 'p', 'Nombre de parte o sección de la obra', 'Nombre de parte o sección de la obra', 1, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('898', 'q', 'Nombre de congreso/reunión que sigue a un nombre de jurisdicción como elemento de entrada', 'Nombre de congreso/reunión que sigue a un nombre de jurisdicción como elemento de entrada', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('898', 's', 'Versión', 'Versión', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('898', 't', 'Título de la obra', 'Título de la obra', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('898', 'u', 'Filiación', 'Filiación', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('898', 'v', 'Designación de volumen o secuencia', 'Designación de volumen o secuencia', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('899', '%', '% (RLIN)', '% (RLIN)', 0, 0, '', 8, '', '', '', 0, -6, '', '', '', NULL),
		('899', '6', 'Enlace', 'Enlace', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('899', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('899', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 8, '', '', '', 0, -5, '', '', '', NULL),
		('899', 'a', 'Título uniforme', 'Título uniforme', 0, 0, '', 8, '', 'UNIF_TITLE', '', NULL, -6, '', '', '', NULL),
		('899', 'd', 'Fecha de la firma de un tratado', 'Fecha de la firma de un tratado', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('899', 'f', 'Fecha de publicación/de la obra', 'Fecha de publicación/de la obra', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('899', 'g', 'Información miscelánea', 'Información miscelánea', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('899', 'h', 'Medio', 'Medio', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('899', 'k', 'Subencabezamiento de forma', 'Subencabezamiento de forma', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('899', 'l', 'Lenguaje de la obra', 'Lenguaje de la obra', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('899', 'm', 'Medio de interpretación para música', 'Medio de interpretación para música', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('899', 'n', 'Número de parte o sección de la obra', 'Número de parte o sección de la obra', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('899', 'o', 'Mención de arreglo para música', 'Mención de arreglo para música', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('899', 'p', 'Nombre de parte o sección de la obra', 'Nombre de parte o sección de la obra', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('899', 'r', 'Clave para música', 'Clave para música', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('899', 's', 'Versión', 'Versión', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('899', 't', 'Título de la obra', 'Título de la obra', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '', NULL),
		('899', 'v', 'Designación de número de volumen o secuencia', 'Designación de número de volumen o secuencia', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '', NULL),
		('900', '4', 'Código de función/relación', 'Código de función/relación', 1, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('900', '6', 'Enlace', 'Enlace', 0, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('900', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('900', 'a', 'Nombre de persona', 'Nombre de persona', 0, 0, '', 9, '', '', '', 0, 5, '', '''110a'',''700a'',''710a''', '', NULL),
		('900', 'b', 'Numeración', 'Numeración', 0, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('900', 'c', 'Títulos y otros términos asociados al nombre', 'Títulos y otros términos asociados al nombre', 1, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('900', 'd', 'Fechas asociadas al nombre', 'Fechas asociadas al nombre', 0, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('900', 'e', 'Término indicativo de función/relación', 'Término indicativo de función/relación', 1, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('900', 'f', 'Fecha de publicación/de la obra', 'Fecha de publicación/de la obra', 0, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('900', 'g', 'Información miscelánea', 'Información miscelánea', 0, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('900', 'j', 'Calificador de atribución', 'Calificador de atribución', 1, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('900', 'k', 'Subencabezamiento de forma', 'Subencabezamiento de forma', 1, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('900', 'l', 'Lenguaje de la obra', 'Lenguaje de la obra', 0, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('900', 'n', 'Número de parte o sección de la obra', 'Número de parte o sección de la obra', 1, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('900', 'p', 'Nombre de parte o sección de la obra', 'Nombre de parte o sección de la obra', 1, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('900', 'q', 'Forma completa/desarrollada del nombre', 'Forma completa/desarrollada del nombre', 0, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('900', 't', 'Título de la obra', 'Título de la obra', 0, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('900', 'u', 'Filiación', 'Filiación', 0, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('901', '0', '0', '0', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('901', '1', '1', '1', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('901', '2', '2', '2', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('901', '3', '3', '3', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('901', '4', '4', '4', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('901', '5', '5', '5', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('901', '6', '6', '6', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('901', '7', '7', '7', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('901', '8', '8', '8', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('901', '9', '9', '9', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('901', 'a', 'a', 'a', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('901', 'b', 'b', 'b', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('901', 'c', 'c', 'c', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('901', 'd', 'd', 'd', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('901', 'e', 'e', 'e', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('901', 'f', 'f', 'f', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('901', 'g', 'g', 'g', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('901', 'h', 'h', 'h', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('901', 'i', 'i', 'i', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('901', 'j', 'j', 'j', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('901', 'k', 'k', 'k', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('901', 'l', 'l', 'l', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('901', 'm', 'm', 'm', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('901', 'n', 'n', 'n', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('901', 'o', 'o', 'o', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('901', 'p', 'p', 'p', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('901', 'q', 'q', 'q', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('901', 'r', 'r', 'r', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('901', 's', 's', 's', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('901', 't', 't', 't', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('901', 'u', 'u', 'u', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('901', 'v', 'v', 'v', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('901', 'w', 'w', 'w', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('901', 'x', 'x', 'x', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('901', 'y', 'y', 'y', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('901', 'z', 'z', 'z', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('902', '0', '0', '0', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('902', '1', '1', '1', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('902', '2', '2', '2', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('902', '3', '3', '3', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('902', '4', '4', '4', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('902', '5', '5', '5', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('902', '6', '6', '6', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('902', '7', '7', '7', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('902', '8', '8', '8', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('902', '9', '9', '9', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('902', 'a', 'a', 'a', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('902', 'b', 'b', 'b', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('902', 'c', 'c', 'c', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('902', 'd', 'd', 'd', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('902', 'e', 'e', 'e', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('902', 'f', 'f', 'f', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('902', 'g', 'g', 'g', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('902', 'h', 'h', 'h', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('902', 'i', 'i', 'i', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('902', 'j', 'j', 'j', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('902', 'k', 'k', 'k', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('902', 'l', 'l', 'l', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('902', 'm', 'm', 'm', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('902', 'n', 'n', 'n', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('902', 'o', 'o', 'o', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('902', 'p', 'p', 'p', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('902', 'q', 'q', 'q', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('902', 'r', 'r', 'r', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('902', 's', 's', 's', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('902', 't', 't', 't', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('902', 'u', 'u', 'u', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('902', 'v', 'v', 'v', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('902', 'w', 'w', 'w', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('902', 'x', 'x', 'x', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('902', 'y', 'y', 'y', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('902', 'z', 'z', 'z', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('903', '0', '0', '0', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('903', '1', '1', '1', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('903', '2', '2', '2', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('903', '3', '3', '3', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('903', '4', '4', '4', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('903', '5', '5', '5', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('903', '6', '6', '6', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('903', '7', '7', '7', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('903', '8', '8', '8', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('903', '9', '9', '9', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('903', 'a', 'a', 'a', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('903', 'b', 'b', 'b', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('903', 'c', 'c', 'c', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('903', 'd', 'd', 'd', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('903', 'e', 'e', 'e', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('903', 'f', 'f', 'f', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('903', 'g', 'g', 'g', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('903', 'h', 'h', 'h', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('903', 'i', 'i', 'i', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('903', 'j', 'j', 'j', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('903', 'k', 'k', 'k', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('903', 'l', 'l', 'l', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('903', 'm', 'm', 'm', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('903', 'n', 'n', 'n', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('903', 'o', 'o', 'o', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('903', 'p', 'p', 'p', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('903', 'q', 'q', 'q', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('903', 'r', 'r', 'r', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('903', 's', 's', 's', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('903', 't', 't', 't', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('903', 'u', 'u', 'u', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('903', 'v', 'v', 'v', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('903', 'w', 'w', 'w', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('903', 'x', 'x', 'x', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('903', 'y', 'y', 'y', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('903', 'z', 'z', 'z', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('904', '0', '0', '0', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('904', '1', '1', '1', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('904', '2', '2', '2', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('904', '3', '3', '3', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('904', '4', '4', '4', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('904', '5', '5', '5', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('904', '6', '6', '6', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('904', '7', '7', '7', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('904', '8', '8', '8', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('904', '9', '9', '9', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('904', 'a', 'a', 'a', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('904', 'b', 'b', 'b', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('904', 'c', 'c', 'c', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('904', 'd', 'd', 'd', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('904', 'e', 'e', 'e', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('904', 'f', 'f', 'f', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('904', 'g', 'g', 'g', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('904', 'h', 'h', 'h', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('904', 'i', 'i', 'i', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('904', 'j', 'j', 'j', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('904', 'k', 'k', 'k', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('904', 'l', 'l', 'l', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('904', 'm', 'm', 'm', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('904', 'n', 'n', 'n', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('904', 'o', 'o', 'o', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('904', 'p', 'p', 'p', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('904', 'q', 'q', 'q', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('904', 'r', 'r', 'r', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('904', 's', 's', 's', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('904', 't', 't', 't', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('904', 'u', 'u', 'u', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('904', 'v', 'v', 'v', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('904', 'w', 'w', 'w', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('904', 'x', 'x', 'x', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('904', 'y', 'y', 'y', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('904', 'z', 'z', 'z', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('905', '0', '0', '0', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('905', '1', '1', '1', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('905', '2', '2', '2', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('905', '3', '3', '3', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('905', '4', '4', '4', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('905', '5', '5', '5', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('905', '6', '6', '6', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('905', '7', '7', '7', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('905', '8', '8', '8', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('905', '9', '9', '9', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('905', 'a', 'a', 'a', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('905', 'b', 'b', 'b', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('905', 'c', 'c', 'c', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('905', 'd', 'd', 'd', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('905', 'e', 'e', 'e', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('905', 'f', 'f', 'f', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('905', 'g', 'g', 'g', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('905', 'h', 'h', 'h', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('905', 'i', 'i', 'i', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('905', 'j', 'j', 'j', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('905', 'k', 'k', 'k', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('905', 'l', 'l', 'l', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('905', 'm', 'm', 'm', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('905', 'n', 'n', 'n', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('905', 'o', 'o', 'o', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('905', 'p', 'p', 'p', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('905', 'q', 'q', 'q', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('905', 'r', 'r', 'r', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('905', 's', 's', 's', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('905', 't', 't', 't', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('905', 'u', 'u', 'u', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('905', 'v', 'v', 'v', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('905', 'w', 'w', 'w', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('905', 'x', 'x', 'x', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('905', 'y', 'y', 'y', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('905', 'z', 'z', 'z', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('906', '0', '0', '0', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('906', '1', '1', '1', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('906', '2', '2', '2', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('906', '3', '3', '3', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('906', '4', '4', '4', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('906', '5', '5', '5', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('906', '6', '6', '6', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('906', '7', '7', '7', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('906', '8', '8', '8', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('906', '9', '9', '9', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('906', 'a', 'a', 'a', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('906', 'b', 'b', 'b', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('906', 'c', 'c', 'c', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('906', 'd', 'd', 'd', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('906', 'e', 'e', 'e', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('906', 'f', 'f', 'f', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('906', 'g', 'g', 'g', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('906', 'h', 'h', 'h', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('906', 'i', 'i', 'i', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('906', 'j', 'j', 'j', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('906', 'k', 'k', 'k', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('906', 'l', 'l', 'l', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('906', 'm', 'm', 'm', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('906', 'n', 'n', 'n', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('906', 'o', 'o', 'o', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('906', 'p', 'p', 'p', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('906', 'q', 'q', 'q', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('906', 'r', 'r', 'r', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('906', 's', 's', 's', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('906', 't', 't', 't', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('906', 'u', 'u', 'u', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('906', 'v', 'v', 'v', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('906', 'w', 'w', 'w', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('906', 'x', 'x', 'x', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('906', 'y', 'y', 'y', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('906', 'z', 'z', 'z', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('907', '0', '0', '0', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('907', '1', '1', '1', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('907', '2', '2', '2', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('907', '3', '3', '3', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('907', '4', '4', '4', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('907', '5', '5', '5', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('907', '6', '6', '6', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('907', '7', '7', '7', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('907', '8', '8', '8', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('907', '9', '9', '9', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('907', 'a', 'a', 'a', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('907', 'b', 'b', 'b', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('907', 'c', 'c', 'c', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('907', 'd', 'd', 'd', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('907', 'e', 'e', 'e', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('907', 'f', 'f', 'f', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('907', 'g', 'g', 'g', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('907', 'h', 'h', 'h', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('907', 'i', 'i', 'i', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('907', 'j', 'j', 'j', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('907', 'k', 'k', 'k', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('907', 'l', 'l', 'l', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('907', 'm', 'm', 'm', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('907', 'n', 'n', 'n', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('907', 'o', 'o', 'o', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('907', 'p', 'p', 'p', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('907', 'q', 'q', 'q', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('907', 'r', 'r', 'r', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('907', 's', 's', 's', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('907', 't', 't', 't', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('907', 'u', 'u', 'u', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('907', 'v', 'v', 'v', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('907', 'w', 'w', 'w', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('907', 'x', 'x', 'x', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('907', 'y', 'y', 'y', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('907', 'z', 'z', 'z', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('908', 'a', 'Colocar parámetro de comando', 'Colocar parámetro de comando', 0, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('910', 'a', 'Datos de opción del usuario', 'Datos de opción del usuario', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('911', '4', 'Código de función/relación', 'Código de función/relación', 1, 0, NULL, 9, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('911', '6', 'Enlace', 'Enlace', 0, 0, NULL, 9, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('911', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 9, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('911', 'a', 'Nombre de congreso/reunión o jurisdicción como elemento de entrada', 'Nombre de congreso/reunión o jurisdicción como elemento de entrada', 0, 0, NULL, 9, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('911', 'b', 'Número [OBSOLETO]', 'Número [OBSOLETO]', 0, 0, NULL, 9, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('911', 'c', 'Sede del congreso/Lugar de la reunión', 'Sede del congreso/Lugar de la reunión', 0, 0, NULL, 9, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('911', 'd', 'Fecha del congreso/reunión', 'Fecha del congreso/reunión', 0, 0, NULL, 9, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('911', 'e', 'Unidad subordinada', 'Unidad subordinada', 1, 0, NULL, 9, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('911', 'f', 'Fecha de publicación/de la obra', 'Fecha de publicación/de la obra', 0, 0, NULL, 9, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('911', 'g', 'Información miscelánea', 'Información miscelánea', 0, 0, NULL, 9, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('911', 'k', 'Subencabezamiento de forma', 'Subencabezamiento de forma', 1, 0, NULL, 9, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('911', 'l', 'Lenguaje de la obra', 'Lenguaje de la obra', 0, 0, NULL, 9, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('911', 'n', 'Número del congreso/reunión o número de parte o sección', 'Número del congreso/reunión o número de parte o sección', 1, 0, NULL, 9, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('911', 'p', 'Nombre de parte o sección de la obra', 'Nombre de parte o sección de la obra', 1, 0, NULL, 9, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('911', 'q', 'Nombre de congreso/reunión que sigue a un nombre de jurisdicción como elemento de entrada', 'Nombre de congreso/reunión que sigue a un nombre de jurisdicción como elemento de entrada', 0, 0, NULL, 9, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('911', 't', 'Título de la obra', 'Título de la obra', 0, 0, NULL, 9, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('911', 'u', 'Filiación', 'Filiación', 0, 0, NULL, 9, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('930', '6', 'Enlace', 'Enlace', 0, 0, NULL, 9, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('930', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, NULL, 9, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('930', 'a', 'Título uniforme', 'Título uniforme', 0, 0, NULL, 9, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('930', 'd', 'Fecha de la firma de un tratado', 'Fecha de la firma de un tratado', 1, 0, NULL, 9, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('930', 'f', 'Fecha de publicación/de la obra', 'Fecha de publicación/de la obra', 0, 0, NULL, 9, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('930', 'g', 'Información miscelánea', 'Información miscelánea', 0, 0, NULL, 9, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('930', 'h', 'Medio', 'Medio', 0, 0, NULL, 9, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('930', 'k', 'Subencabezamiento de forma', 'Subencabezamiento de forma', 1, 0, NULL, 9, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('930', 'l', 'Lenguaje de la obra', 'Lenguaje de la obra', 0, 0, NULL, 9, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('930', 'm', 'Medio de interpretación para música', 'Medio de interpretación para música', 1, 0, NULL, 9, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('930', 'n', 'Número de parte o sección de la obra', 'Número de parte o sección de la obra', 1, 0, NULL, 9, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('930', 'o', 'Mención de arreglo para música', 'Mención de arreglo para música', 0, 0, NULL, 9, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('930', 'p', 'Nombre de parte o sección de la obra', 'Nombre de parte o sección de la obra', 1, 0, NULL, 9, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('930', 'r', 'Clave para música', 'Clave para música', 0, 0, NULL, 9, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('930', 's', 'Versión', 'Versión', 0, 0, NULL, 9, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('930', 't', 'Título de la obra', 'Título de la obra', 0, 0, NULL, 9, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('936', 'a', 'Numero(s) de control OCLC de registros paralelo(s) (OCLC); Pieza utilizada para catalogación, PUC (RLIN)', 'Numero(s) de control OCLC de registros paralelo(s) (OCLC); Pieza utilizada para catalogación, PUC (RLIN)', 1, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('940', '6', 'Enlace', 'Enlace', 0, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('940', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('940', 'a', 'Título uniforme', 'Título uniforme', 0, 0, '', 9, '', '', '', 1, -6, '', '', '', NULL),
		('940', 'd', 'Fecha de la firma de un tratado', 'Fecha de la firma de un tratado', 1, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('940', 'f', 'Fecha de publicación/de la obra', 'Fecha de publicación/de la obra', 0, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('940', 'g', 'Información miscelánea', 'Información miscelánea', 0, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('940', 'h', 'Medio', 'Medio', 0, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('940', 'k', 'Subencabezamiento de forma', 'Subencabezamiento de forma', 1, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('940', 'l', 'Lenguaje de la obra', 'Lenguaje de la obra', 0, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('940', 'm', 'Medio de interpretación para música', 'Medio de interpretación para música', 1, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('940', 'n', 'Número de parte o sección de la obra', 'Número de parte o sección de la obra', 1, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('940', 'o', 'Mención de arreglo para música', 'Mención de arreglo para música', 0, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('940', 'p', 'Nombre de parte o sección de la obra', 'Nombre de parte o sección de la obra', 1, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('940', 'r', 'Clave para música', 'Clave para música', 0, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('940', 's', 'Versión', 'Versión', 0, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('941', 'a', 'Título latinizado/romanizado', 'Título latinizado/romanizado', 0, 0, NULL, 9, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('941', 'h', 'Medio', 'Medio', 0, 0, NULL, 9, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('943', '6', 'Enlace', 'Enlace', 0, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('943', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('943', 'a', 'Título uniforme', 'Título uniforme', 0, 0, '', 9, '', '', '', 1, 5, '', '', '130', NULL),
		('943', 'd', 'Fecha de la firma de un tratado', 'Fecha de la firma de un tratado', 1, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('943', 'f', 'Fecha de publicación/de la obra', 'Fecha de publicación/de la obra', 0, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('943', 'g', 'Información miscelánea', 'Información miscelánea', 0, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('943', 'h', 'Medio', 'Medio', 0, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('943', 'k', 'Subencabezamiento de forma', 'Subencabezamiento de forma', 1, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('943', 'l', 'Lenguaje de la obra', 'Lenguaje de la obra', 0, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('943', 'm', 'Medio de interpretación para música', 'Medio de interpretación para música', 1, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('943', 'n', 'Número de parte o sección de la obra', 'Número de parte o sección de la obra', 1, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('943', 'o', 'Mención de arreglo para música', 'Mención de arreglo para música', 0, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('943', 'p', 'Nombre de parte o sección de la obra', 'Nombre de parte o sección de la obra', 1, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('943', 'r', 'Clave para música', 'Clave para música', 0, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('943', 's', 'Versión', 'Versión', 0, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('945', '0', '0', '0', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('945', '1', '1', '1', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('945', '2', '2', '2', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('945', '3', '3', '3', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('945', '4', '4', '4', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('945', '5', '5', '5', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('945', '6', '6', '6', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('945', '7', '7', '7', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('945', '8', '8', '8', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('945', '9', '9', '9', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('945', 'a', 'a', 'a', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('945', 'b', 'b', 'b', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('945', 'c', 'c', 'c', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('945', 'd', 'd', 'd', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('945', 'e', 'e', 'e', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('945', 'f', 'f', 'f', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('945', 'g', 'g', 'g', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('945', 'h', 'h', 'h', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('945', 'i', 'i', 'i', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('945', 'j', 'j', 'j', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('945', 'k', 'k', 'k', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('945', 'l', 'l', 'l', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('945', 'm', 'm', 'm', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('945', 'n', 'n', 'n', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('945', 'o', 'o', 'o', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('945', 'p', 'p', 'p', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('945', 'q', 'q', 'q', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('945', 'r', 'r', 'r', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('945', 's', 's', 's', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('945', 't', 't', 't', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('945', 'u', 'u', 'u', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('945', 'v', 'v', 'v', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('945', 'w', 'w', 'w', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('945', 'x', 'x', 'x', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('945', 'y', 'y', 'y', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('945', 'z', 'z', 'z', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('946', '0', '0', '0', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('946', '1', '1', '1', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('946', '2', '2', '2', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('946', '3', '3', '3', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('946', '4', '4', '4', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('946', '5', '5', '5', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('946', '6', '6', '6', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('946', '7', '7', '7', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('946', '8', '8', '8', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('946', '9', '9', '9', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('946', 'a', 'a', 'a', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('946', 'b', 'b', 'b', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('946', 'c', 'c', 'c', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('946', 'd', 'd', 'd', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('946', 'e', 'e', 'e', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('946', 'f', 'f', 'f', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('946', 'g', 'g', 'g', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('946', 'h', 'h', 'h', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('946', 'i', 'i', 'i', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('946', 'j', 'j', 'j', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('946', 'k', 'k', 'k', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('946', 'l', 'l', 'l', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('946', 'm', 'm', 'm', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('946', 'n', 'n', 'n', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('946', 'o', 'o', 'o', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('946', 'p', 'p', 'p', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('946', 'q', 'q', 'q', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('946', 'r', 'r', 'r', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('946', 's', 's', 's', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('946', 't', 't', 't', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('946', 'u', 'u', 'u', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('946', 'v', 'v', 'v', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('946', 'w', 'w', 'w', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('946', 'x', 'x', 'x', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('946', 'y', 'y', 'y', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('946', 'z', 'z', 'z', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('947', '0', '0', '0', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('947', '1', '1', '1', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('947', '2', '2', '2', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('947', '3', '3', '3', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('947', '4', '4', '4', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('947', '5', '5', '5', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('947', '6', '6', '6', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('947', '7', '7', '7', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('947', '8', '8', '8', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('947', '9', '9', '9', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('947', 'a', 'a', 'a', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('947', 'b', 'b', 'b', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('947', 'c', 'c', 'c', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('947', 'd', 'd', 'd', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('947', 'e', 'e', 'e', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('947', 'f', 'f', 'f', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('947', 'g', 'g', 'g', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('947', 'h', 'h', 'h', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('947', 'i', 'i', 'i', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('947', 'j', 'j', 'j', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('947', 'k', 'k', 'k', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('947', 'l', 'l', 'l', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('947', 'm', 'm', 'm', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('947', 'n', 'n', 'n', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('947', 'o', 'o', 'o', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('947', 'p', 'p', 'p', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('947', 'q', 'q', 'q', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('947', 'r', 'r', 'r', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('947', 's', 's', 's', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('947', 't', 't', 't', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('947', 'u', 'u', 'u', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('947', 'v', 'v', 'v', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('947', 'w', 'w', 'w', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('947', 'x', 'x', 'x', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('947', 'y', 'y', 'y', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('947', 'z', 'z', 'z', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('948', '0', '0 (OCLC)', '0 (OCLC)', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('948', '1', '1 (OCLC)', '1 (OCLC)', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('948', '2', '2 (OCLC)', '2 (OCLC)', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('948', '3', '3 (OCLC)', '3 (OCLC)', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('948', '4', '4 (OCLC)', '4 (OCLC)', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('948', '5', '5 (OCLC)', '5 (OCLC)', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('948', '6', '6 (OCLC)', '6 (OCLC)', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('948', '7', '7 (OCLC)', '7 (OCLC)', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('948', '8', '8 (OCLC)', '8 (OCLC)', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('948', '9', '9 (OCLC)', '9 (OCLC)', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('948', 'a', 'Designador de la parte de la serie, SPT (RLIN)', 'Designador de la parte de la serie, SPT (RLIN)', 0, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('948', 'b', 'b (OCLC)', 'b (OCLC)', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('948', 'c', 'c (OCLC)', 'c (OCLC)', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('948', 'd', 'd (OCLC)', 'd (OCLC)', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('948', 'e', 'e (OCLC)', 'e (OCLC)', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('948', 'f', 'f (OCLC)', 'f (OCLC)', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('948', 'g', 'g (OCLC)', 'g (OCLC)', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('948', 'h', 'h (OCLC)', 'h (OCLC)', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('948', 'i', 'i (OCLC)', 'i (OCLC)', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('948', 'j', 'j (OCLC)', 'j (OCLC)', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('948', 'k', 'k (OCLC)', 'k (OCLC)', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('948', 'l', 'l (OCLC)', 'l (OCLC)', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('948', 'm', 'm (OCLC)', 'm (OCLC)', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('948', 'n', 'n (OCLC)', 'n (OCLC)', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('948', 'o', 'o (OCLC)', 'o (OCLC)', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('948', 'p', 'p (OCLC)', 'p (OCLC)', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('948', 'q', 'q (OCLC)', 'q (OCLC)', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('948', 'r', 'r (OCLC)', 'r (OCLC)', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('948', 's', 's (OCLC)', 's (OCLC)', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('948', 't', 't (OCLC)', 't (OCLC)', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('948', 'u', 'u (OCLC)', 'u (OCLC)', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('948', 'v', 'v (OCLC)', 'v (OCLC)', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('948', 'w', 'w (OCLC)', 'w (OCLC)', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('948', 'x', 'x (OCLC)', 'x (OCLC)', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('948', 'y', 'y (OCLC)', 'y (OCLC)', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('948', 'z', 'z (OCLC)', 'z (OCLC)', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('949', '0', '0', '0', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('949', '1', '1', '1', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('949', '2', '2', '2', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('949', '3', '3', '3', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('949', '4', '4', '4', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('949', '5', '5', '5', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('949', '6', '6', '6', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('949', '7', '7', '7', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('949', '8', '8', '8', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('949', '9', '9', '9', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('949', 'a', 'a', 'a', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('949', 'b', 'b', 'b', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('949', 'c', 'c', 'c', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('949', 'd', 'd', 'd', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('949', 'e', 'e', 'e', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('949', 'f', 'f', 'f', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('949', 'g', 'g', 'g', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('949', 'h', 'h', 'h', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('949', 'i', 'i', 'i', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('949', 'j', 'j', 'j', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('949', 'k', 'k', 'k', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('949', 'l', 'l', 'l', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('949', 'm', 'm', 'm', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('949', 'n', 'n', 'n', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('949', 'o', 'o', 'o', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('949', 'p', 'p', 'p', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('949', 'q', 'q', 'q', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('949', 'r', 'r', 'r', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('949', 's', 's', 's', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('949', 't', 't', 't', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('949', 'u', 'u', 'u', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('949', 'v', 'v', 'v', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('949', 'w', 'w', 'w', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('949', 'x', 'x', 'x', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('949', 'y', 'y', 'y', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('949', 'z', 'z', 'z', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('950', 'a', 'Número de clasificación, LCAL (RLIN)', 'Número de clasificación, LCAL (RLIN)', 0, 0, '', 9, '', '', '', 0, 5, '', '', '', NULL),
		('950', 'b', 'Número del libro/signatura topográfica indivisible, LCAL (RLIN)', 'Número del libro/signatura topográfica indivisible, LCAL (RLIN)', 0, 0, '', 9, '', '', '', 0, 5, '', '', '', NULL),
		('950', 'd', 'Texto-libre adicional sellado por debajo de la signatura topográfica, LCAL (RLIN)', 'Texto-libre adicional sellado por debajo de la signatura topográfica, LCAL (RLIN)', 1, 0, '', 9, '', '', '', 0, 5, '', '', '', NULL),
		('950', 'e', 'Texto-libre adicional o sello perfilado por debajo de la signatura topográfica, LCAL (RLIN)', 'Texto-libre adicional o sello perfilado por debajo de la signatura topográfica, LCAL (RLIN)', 1, 0, '', 9, '', '', '', 0, 5, '', '', '', NULL),
		('950', 'f', 'Localización-Nivel de nota de pie, LFNT (RLIN)', 'Localización-Nivel de nota de pie, LFNT (RLIN)', 0, 0, '', 9, '', '', '', 0, 5, '', '', '', NULL),
		('950', 'h', 'Nivel-localización historia de la transacción de salida, LHST (RLIN)', 'Nivel-localización historia de la transacción de salida, LHST (RLIN)', 0, 0, '', 9, '', '', '', 0, 5, '', '', '', NULL),
		('950', 'i', 'Nivel-localización solicitud de ficha adicional, LEXT (RLIN)', 'Nivel-localización solicitud de ficha adicional, LEXT (RLIN)', 0, 0, '', 9, '', '', '', 0, 5, '', '', '', NULL),
		('950', 'l', 'Ubicación en estantería permanente, LOC (RLIN)', 'Ubicación en estantería permanente, LOC (RLIN)', 0, 0, '', 9, '', '', '', 0, 5, '', '', '', NULL),
		('950', 'n', 'Localización-Nivel de nota complementaria, LANT (RLIN)', 'Localización-Nivel de nota complementaria, LANT (RLIN)', 1, 0, '', 9, '', '', '', 0, 5, '', '', '', NULL),
		('950', 'p', 'Localización-Nivel de exploración, LPTH (RLIN)', 'Localización-Nivel de exploración, LPTH (RLIN)', 0, 0, '', 9, '', '', '', 0, 5, '', '', '', NULL),
		('950', 't', 'Nivel-localización supresión de campo, LFSP (RLIN)', 'Nivel-localización supresión de campo, LFSP (RLIN)', 0, 0, '', 9, '', '', '', 0, 5, '', '', '', NULL),
		('950', 'u', 'Notas de material no impreso, LANT (RLIN)', 'Notas de material no impreso, LANT (RLIN)', 1, 0, '', 9, '', '', '', 0, 5, '', '', '', NULL),
		('950', 'v', 'Volúmenes, LVOL (RLIN)', 'Volúmenes, LVOL (RLIN)', 0, 0, '', 9, '', '', '', 0, 5, '', '', '', NULL),
		('950', 'w', 'Estado del código de la suscripción, LANT (RLIN)', 'Estado del código de la suscripción, LANT (RLIN)', 0, 0, '', 9, '', '', '', 0, 5, '', '', '', NULL),
		('950', 'y', 'Fecha, LVOL (RLIN)', 'Fecha, LVOL (RLIN)', 0, 0, '', 9, '', '', '', 0, 5, '', '', '', NULL),
		('950', 'z', 'Retención, LVOL (RLIN)', 'Retención, LVOL (RLIN)', 0, 0, '', 9, '', '', '', 0, 5, '', '', '', NULL),
		('951', '2', 'Fuente del encabezamiento o término', 'Fuente del encabezamiento o término', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('951', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('951', '6', 'Enlace', 'Enlace', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('951', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('951', 'a', 'Nombre geográfico', 'Nombre geográfico', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('951', 'b', 'Nombre geográfico que sigue al elemento de entrada de lugar [OBSOLETO]', 'Nombre geográfico que sigue al elemento de entrada de lugar [OBSOLETO]', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('951', 'v', 'Subdivisión de forma', 'Subdivisión de forma', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('951', 'x', 'Subdivisión general', 'Subdivisión general', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('951', 'y', 'Subdivisión cronológica', 'Subdivisión cronológica', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('951', 'z', 'Subdivisión geográfica', 'Subdivisión geográfica', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '', NULL),
		('955', 'a', 'Classification number, CCAL (RLIN)', 'Classification number, CCAL (RLIN)', 0, 0, '', 9, '', '', '', 0, 5, '', '', '', NULL),
		('955', 'b', 'Número de libro/signatura topográfica indivisible, CCAL (RLIN)', 'Número de libro/signatura topográfica indivisible, CCAL (RLIN)', 0, 0, '', 9, '', '', '', 0, 5, '', '', '', NULL),
		('955', 'c', 'Información de la copia y descripción del material, CCAL + MDES (RLIN)', 'Información de la copia y descripción del material, CCAL + MDES (RLIN)', 0, 0, '', 9, '', '', '', 0, 5, '', '', '', NULL),
		('955', 'h', 'Copy status--for earlier dates, CST (RLIN)', 'Copy status--for earlier dates, CST (RLIN)', 0, 0, '', 9, '', '', '', 0, 5, '', '', '', NULL),
		('955', 'i', 'Estado de la copia, CST (RLIN)', 'Estado de la copia, CST (RLIN)', 0, 0, '', 9, '', '', '', 0, 5, '', '', '', NULL),
		('955', 'l', 'Ubicación en estantería permanente, LOC (RLIN)', 'Ubicación en estantería permanente, LOC (RLIN)', 0, 0, '', 9, '', '', '', 0, 5, '', '', '', NULL),
		('955', 'q', 'Número de control de adquisición, HNT (RLIN)', 'Número de control de adquisición, HNT (RLIN)', 1, 0, '', 9, '', '', '', 0, 5, '', '', '', NULL),
		('955', 'r', 'Número de control de circulación, HNT (RLIN)', 'Número de control de circulación, HNT (RLIN)', 0, 0, '', 9, '', '', '', 0, 5, '', '', '', NULL),
		('955', 's', 'Nota de catálogo topográfico, HNT (RLIN)', 'Nota de catálogo topográfico, HNT (RLIN)', 1, 0, '', 9, '', '', '', 1, 5, '', '', '', NULL),
		('955', 'u', 'Notas de materiales no impresos, HNT (RLIN)', 'Notas de materiales no impresos, HNT (RLIN)', 1, 0, '', 9, '', '', '', 0, 5, '', '', '', NULL),
		('956', '2', 'Método de acceso', 'Método de acceso', 0, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('956', '3', 'Especificación de materiales', 'Especificación de materiales', 0, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('956', '6', 'Enlace', 'Enlace', 0, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('956', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('956', 'a', 'Nombre del host', 'Nombre del host', 1, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('956', 'b', 'Número de acceso', 'Número de acceso', 1, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('956', 'c', 'Información sobre la compresión', 'Información sobre la compresión', 1, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('956', 'd', 'Ruta', 'Ruta', 1, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('956', 'f', 'Nombre electrónico', 'Nombre electrónico', 1, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('956', 'h', 'Procesador de la petición', 'Procesador de la petición', 0, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('956', 'i', 'Instrucción', 'Instrucción', 1, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('956', 'j', 'Bits por segundo', 'Bits por segundo', 0, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('956', 'k', 'Contraseña', 'Contraseña', 0, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('956', 'l', 'Proceso de conexión (Logon)', 'Proceso de conexión (Logon)', 0, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('956', 'm', 'Contacto para facilitar el acceso', 'Contacto para facilitar el acceso', 1, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('956', 'n', 'Name of location of host in subfield', 'Name of location of host in subfield', 0, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('956', 'o', 'Sistema operativo', 'Sistema operativo', 0, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('956', 'p', 'Puerto', 'Puerto', 0, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('956', 'q', 'Tipo de formato electrónico', 'Tipo de formato electrónico', 0, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('956', 'r', 'Parámetros', 'Parámetros', 0, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('956', 's', 'Tamaño de archivo', 'Tamaño de archivo', 1, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('956', 't', 'Emulación del terminal', 'Emulación del terminal', 1, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('956', 'u', 'Identificador Uniforme del Recurso', 'Identificador Uniforme del Recurso', 1, 0, '', 9, '', '', '', 1, -6, '', '', '', NULL),
		('956', 'v', 'Horario en que el acceso está disponible', 'Horario en que el acceso está disponible', 1, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('956', 'w', 'Número de control del registro', 'Número de control del registro', 1, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('956', 'x', 'Nota interna', 'Nota interna', 1, 0, '', 9, '', '', '', 0, 6, '', '', '', NULL),
		('956', 'y', 'Texto de enlace', 'Texto de enlace', 1, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('956', 'z', 'Nota pública', 'Nota pública', 1, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('960', '3', 'Especificación de materiales, MATL', 'Especificación de materiales, MATL', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('960', 'a', 'Localización física, PLOC (RLIN)', 'Localización física, PLOC (RLIN)', 0, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('967', 'a', 'GNR (RLIN)', 'GNR (RLIN)', 0, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('967', 'c', 'PSI (RLIN)', 'PSI (RLIN)', 0, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('980', '4', 'Código de función/relación', 'Código de función/relación', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('980', '6', 'Enlace', 'Enlace', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('980', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('980', 'a', 'Nombre de persona', 'Nombre de persona', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('980', 'b', 'Numeración', 'Numeración', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('980', 'c', 'Títulos y otros términos asociados al nombre', 'Títulos y otros términos asociados al nombre', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('980', 'd', 'Fechas asociadas al nombre', 'Fechas asociadas al nombre', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('980', 'e', 'Término indicativo de función/relación', 'Término indicativo de función/relación', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('980', 'f', 'Fecha de publicación/de la obra', 'Fecha de publicación/de la obra', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('980', 'g', 'Información miscelánea', 'Información miscelánea', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('980', 'h', 'Medio', 'Medio', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('980', 'j', 'Calificador de atribución', 'Calificador de atribución', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('980', 'k', 'Subencabezamiento de forma', 'Subencabezamiento de forma', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('980', 'l', 'Lenguaje de la obra', 'Lenguaje de la obra', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('980', 'm', 'Medio de interpretación para música', 'Medio de interpretación para música', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('980', 'n', 'Número de parte o sección de la obra', 'Número de parte o sección de la obra', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('980', 'o', 'Mención de arreglo para música', 'Mención de arreglo para música', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('980', 'p', 'Nombre de parte o sección de la obra', 'Nombre de parte o sección de la obra', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('980', 'q', 'Forma completa/desarrollada del nombre', 'Forma completa/desarrollada del nombre', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('980', 'r', 'Clave para música', 'Clave para música', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('980', 's', 'Versión', 'Versión', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('980', 't', 'Título de la obra', 'Título de la obra', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('980', 'u', 'Filiación', 'Filiación', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('980', 'v', 'Designación de volumen o secuencia', 'Designación de volumen o secuencia', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('981', '4', 'Código de función/relación', 'Código de función/relación', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('981', '6', 'Enlace', 'Enlace', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('981', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('981', 'a', 'Nombre de entidad corporativa o nombre de jurisdicción como elemento de entrada', 'Nombre de entidad corporativa o nombre de jurisdicción como elemento de entrada', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('981', 'b', 'Unidad subordinada', 'Unidad subordinada', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('981', 'c', 'Sede del congreso/Lugar de la reunión', 'Sede del congreso/Lugar de la reunión', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('981', 'd', 'Fecha del congreso/reunión o de la firma de un tratado', 'Fecha del congreso/reunión o de la firma de un tratado', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('981', 'e', 'Término indicativo de función/relación', 'Término indicativo de función/relación', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('981', 'f', 'Fecha de publicación/de la obra', 'Fecha de publicación/de la obra', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('981', 'g', 'Información miscelánea', 'Información miscelánea', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('981', 'h', 'Medio', 'Medio', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('981', 'k', 'Subencabezamiento de forma', 'Subencabezamiento de forma', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('981', 'l', 'Lenguaje de la obra', 'Lenguaje de la obra', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('981', 'm', 'Medio de interpretación para música', 'Medio de interpretación para música', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('981', 'n', 'Número del congreso/reunión o número de parte o sección', 'Número del congreso/reunión o número de parte o sección', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('981', 'o', 'Mención de arreglo para música', 'Mención de arreglo para música', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('981', 'p', 'Nombre de parte o sección de la obra', 'Nombre de parte o sección de la obra', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('981', 'r', 'Clave para música', 'Clave para música', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('981', 's', 'Versión', 'Versión', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('981', 't', 'Título de la obra', 'Título de la obra', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('981', 'u', 'Filiación', 'Filiación', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('981', 'v', 'Designación de volumen o secuencia', 'Designación de volumen o secuencia', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('982', '4', 'Código de función/relación', 'Código de función/relación', 1, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('982', '6', 'Enlace', 'Enlace', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('982', '8', 'Enlace entre campos y número de secuencia', 'Enlace entre campos y número de secuencia', 1, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('982', 'a', 'Nombre de congreso/reunión o jurisdicción como elemento de entrada', 'Nombre de congreso/reunión o jurisdicción como elemento de entrada', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('982', 'b', 'Número (BK CF MP MU SE VM MX) [OBSOLETO]', 'Número (BK CF MP MU SE VM MX) [OBSOLETO]', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('982', 'c', 'Sede del congreso/Lugar de la reunión', 'Sede del congreso/Lugar de la reunión', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('982', 'd', 'Fecha del congreso/reunión', 'Fecha del congreso/reunión', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('982', 'e', 'Unidad subordinada', 'Unidad subordinada', 1, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('982', 'f', 'Fecha de publicación/de la obra', 'Fecha de publicación/de la obra', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('982', 'g', 'Información miscelánea', 'Información miscelánea', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('982', 'h', 'Medio', 'Medio', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('982', 'k', 'Subencabezamiento de forma', 'Subencabezamiento de forma', 1, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('982', 'l', 'Lenguaje de la obra', 'Lenguaje de la obra', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('982', 'n', 'Número del congreso/reunión o número de parte o sección', 'Número del congreso/reunión o número de parte o sección', 1, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('982', 'p', 'Nombre de parte o sección de la obra', 'Nombre de parte o sección de la obra', 1, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('982', 'q', 'Nombre de congreso/reunión que sigue a un nombre de jurisdicción como elemento de entrada', 'Nombre de congreso/reunión que sigue a un nombre de jurisdicción como elemento de entrada', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('982', 's', 'Versión', 'Versión', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('982', 't', 'Título de la obra', 'Título de la obra', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('982', 'u', 'Filiación', 'Filiación', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('982', 'v', 'Designación de volumen o secuencia', 'Designación de volumen o secuencia', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '', NULL),
		('983', '6', 'Enlace', 'Enlace', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('983', '8', 'Enlace entre campo y número de secuencia', 'Enlace entre campo y número de secuencia', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('983', 'a', 'Título uniforme', 'Título uniforme', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('983', 'd', 'Fecha de la firma de un tratado', 'Fecha de la firma de un tratado', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('983', 'f', 'Fecha de publicación/de la obra', 'Fecha de publicación/de la obra', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('983', 'g', 'Información miscelánea', 'Información miscelánea', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('983', 'h', 'Medio', 'Medio', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('983', 'k', 'Subencabezamiento de forma', 'Subencabezamiento de forma', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('983', 'l', 'Lenguaje de la obra', 'Lenguaje de la obra', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('983', 'm', 'Medio de interpretación para música', 'Medio de interpretación para música', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('983', 'n', 'Número de parte o sección de la obra', 'Número de parte o sección de la obra', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('983', 'o', 'Mención de arreglo para música', 'Mención de arreglo para música', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('983', 'p', 'Nombre de parte o sección de la obra', 'Nombre de parte o sección de la obra', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('983', 'r', 'Clave para música', 'Clave para música', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('983', 's', 'Versión', 'Versión', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('983', 't', 'Título de la obra', 'Título de la obra', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('983', 'v', 'Designación de número de volumen o secuencia', 'Designación de número de volumen o secuencia', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('984', 'a', 'Número de identificación del fondo de la biblioteca', 'Número de identificación del fondo de la biblioteca', 0, 0, '', 9, '', '', '', NULL, 5, '', '', '', NULL),
		('984', 'b', 'Códigos de descripción física', 'Códigos de descripción física', 1, 0, '', 9, '', '', '', 0, 5, '', '', '', NULL),
		('984', 'c', 'Número de clasificación', 'Número de clasificación', 0, 0, '', 9, '', '', '', 0, 5, '', '', '', NULL),
		('984', 'd', 'Volumen u otra numeración', 'Volumen u otra numeración', 0, 0, '', 9, '', '', '', 0, 5, '', '', '', NULL),
		('984', 'e', 'Fechas', 'Fechas', 0, 0, '', 9, '', '', '', 0, 5, '', '', '', NULL),
		('984', 'f', 'Nota de nivel de detalle', 'Nota de nivel de detalle', 0, 0, '', 9, '', '', '', 0, 5, '', '', '', NULL),
		('984', 'g', 'Nota de referencia', 'Nota de referencia', 0, 0, '', 9, '', '', '', 0, 5, '', '', '', NULL),
		('984', 'h', 'Nota de retención', 'Nota de retención', 0, 0, '', 9, '', '', '', 0, 5, '', '', '', NULL),
		('987', 'a', 'Identificador de latinización/conversión', 'Identificador de latinización/conversión', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '', NULL),
		('987', 'b', 'Agencia que convirtió, creó o revisó', 'Agencia que convirtió, creó o revisó', 1, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('987', 'c', 'Fecha de conversión o revisión', 'Fecha de conversión o revisión', 0, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('987', 'd', 'Código de estado', 'Código de estado', 0, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('987', 'e', 'Versión del programa de conversión utilizado', 'Versión del programa de conversión utilizado', 0, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('987', 'f', 'Nota', 'Nota', 0, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('990', 'a', 'Enlace de información para campos 9XX', 'Enlace de información para campos 9XX', 1, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('990', 'b', 'Enlace de información para campo correspondiente con campo 9XX', 'Enlace de información para campo correspondiente con campo 9XX', 1, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('995', '0', 'Estatus de retiro [LOCAL, KOHA]', 'Estatus de retiro [LOCAL, KOHA]', 0, 0, '', 9, '', '', '', 0, 5, '', '', '', NULL),
		('995', '1', 'Estatus de pérdida [LOCAL, KOHA]', 'Estatus de pérdida [LOCAL, KOHA]', 0, 0, '', 9, '', '', '', 0, 5, '', '', '', NULL),
		('995', '2', 'Código de sistema (Clasificación específica u otro esquema y edición) [LOCAL, KOHA]', 'Código de sistema (Clasificación específica u otro esquema y edición) [LOCAL, KOHA]', 0, 0, '', 9, '', '', '', NULL, 5, '', '', '', NULL),
		('995', '3', 'Restricciones de uso [LOCAL, KOHA]', 'Restricciones de uso [LOCAL, KOHA]', 0, 0, '', 9, '', '', '', 0, 5, '', '', '', NULL),
		('995', '4', 'Koha clasificación normalizada para ordenar [LOCAL, KOHA]', 'Koha clasificación normalizada para ordenar [LOCAL, KOHA]', 0, 0, '', 9, '', '', '', 0, 5, '', '', '', NULL),
		('995', '5', 'Calificador codificado de ubicación [LOCAL, KOHA]', 'Calificador codificado de ubicación [LOCAL, KOHA]', 1, 0, '', 9, '', '', '', NULL, 5, '', '', '', NULL),
		('995', '6', 'Número de copia [LOCAL, KOHA]', 'Número de copia [LOCAL, KOHA]', 0, 0, '', 9, '', '', '', NULL, 5, '', '', '', NULL),
		('995', '7', 'Identificador Uniforme del Recurso [LOCAL, KOHA]', 'Identificador Uniforme del Recurso [LOCAL, KOHA]', 1, 0, '', 9, '', '', '', 1, 5, '', '', '', NULL),
		('995', '8', 'Colección Koha [LOCAL, KOHA]', 'Colección Koha [LOCAL, KOHA]', 0, 0, '', 9, '', '', '', 0, 5, '', '', '', NULL),
		('995', '9', 'Número interno de ítem (Koha itemnumber, autogenerado) [LOCAL, KOHA]', 'Número interno de ítem (Koha itemnumber, autogenerado) [LOCAL, KOHA]', 0, 0, '', 9, '', '', '', 0, 5, '', '', '', NULL),
		('995', 'a', 'Origen del ítem (sede de origen)(texto libre)', 'Origen del ítem (sede de origen)(texto libre)', 0, 0, '', 9, '', '', '', 0, 5, '', '', '', NULL),
		('995', 'b', 'Origen del ítem/unidad física (sede de origen) (codificado)', 'Origen del ítem/unidad física (sede de origen) (codificado)', 0, 0, '', 9, '', '', '', 0, 5, '', '', '', NULL),
		('995', 'c', 'Organización de préstamo o tenencia (sede de tenencia)(texto libre)', 'Organización de préstamo o tenencia (sede de tenencia)(texto libre)', 0, 0, '', 9, '', '', '', 0, 5, '', '', '', NULL),
		('995', 'd', 'Código de la institución que presta o almacena (fondo de la sucursal)', 'Código de la institución que presta o almacena (fondo de la sucursal)', 0, 0, '', 9, '', '', '', 0, 5, '', '', '', NULL),
		('995', 'e', 'Detalles de género', 'Detalles de género', 0, 0, '', 9, '', '', '', 0, 5, '', '', '', NULL),
		('995', 'f', 'Código de barras', 'Código de barras', 0, 0, '', 9, '', '', '', 0, 5, '', '', '', NULL),
		('995', 'g', 'Prefijo de código de barra', 'Prefijo de código de barra', 0, 0, '', 9, '', '', '', 0, 5, '', '', '', NULL),
		('995', 'h', 'Incrementación del Código de barras', 'Incrementación del Código de barras', 0, 0, '', 9, '', '', '', 0, 5, '', '', '', NULL),
		('995', 'i', 'Sufijo de Código de barras', 'Sufijo de Código de barras', 0, 0, '', 9, '', '', '', 0, 5, '', '', '', NULL),
		('995', 'j', 'Sección', 'Sección', 0, 0, '', 9, '', '', '', 0, 5, '', '', '', NULL),
		('995', 'k', 'Signatura topográfica (signatura topográfica completa)', 'Signatura topográfica (signatura topográfica completa)', 0, 0, '', 9, '', '', '', 0, 5, '', '', '', NULL),
		('995', 'l', 'Numeración (volumen u otra parte)', 'Numeración (volumen u otra parte)', 0, 0, '', 9, '', '', '', 0, 5, '', '', '', NULL),
		('995', 'm', 'Fecha de préstamo o depósito', 'Fecha de préstamo o depósito', 0, 0, '', 9, '', '', '', 0, 5, '', '', '', NULL),
		('995', 'n', 'Expiración de fecha de préstamo', 'Expiración de fecha de préstamo', 0, 0, '', 9, '', '', '', 0, 5, '', '', '', NULL),
		('995', 'o', 'Tipo de circulación (no para préstamo)', 'Tipo de circulación (no para préstamo)', 1, 0, '', 9, '', '', '', 0, 5, '', '', '', NULL),
		('995', 'p', 'Publicación seriada', 'Publicación seriada', 0, 0, '', 9, '', '', '', 0, 5, '', '', '', NULL),
		('995', 'q', 'Público/audiencia destinatario (nivel de edad)', 'Público/audiencia destinatario (nivel de edad)', 0, 0, '', 9, '', '', '', 0, 5, '', '', '', NULL),
		('995', 'r', 'Tipo de ítem/unidad física y material', 'Tipo de ítem/unidad física y material', 0, 0, '', 9, '', '', '', 0, 5, '', '', '', NULL),
		('995', 's', 'Modo de adquisición', 'Modo de adquisición', 0, 0, '', 9, '', '', '', 0, 5, '', '', '', NULL),
		('995', 't', 'Género', 'Género', 0, 0, '', 9, '', '', '', 0, 5, '', '', '', NULL),
		('995', 'u', 'Nota de la copia', 'Nota de la copia', 0, 0, '', 9, '', '', '', 0, 5, '', '', '', NULL),
		('995', 'v', 'Número de publicación periódica', 'Número de publicación periódica', 0, 0, '', 9, '', '', '', 0, 5, '', '', '', NULL),
		('995', 'w', 'Código de organización del receptor', 'Código de organización del receptor', 0, 0, '', 9, '', '', '', 0, 5, '', '', '', NULL),
		('995', 'x', 'Organización receptora, texto libre', 'Organización receptora, texto libre', 0, 0, '', 9, '', '', '', 0, 5, '', '', '', NULL),
		('995', 'y', 'Código de organización padre beneficiaria', 'Código de organización padre beneficiaria', 0, 0, '', 9, '', '', '', 0, 5, '', '', '', NULL),
		('995', 'z', 'Organización padre beneficiaria, texto libre', 'Organización padre beneficiaria, texto libre', 0, 0, '', 9, '', '', '', 0, 5, '', '', '', NULL),
		('998', 'b', 'Iniciales del operador, OID (RLIN)', 'Iniciales del operador, OID (RLIN)', 0, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('998', 'c', 'Iniciales del catalogador, CIN (RLIN)', 'Iniciales del catalogador, CIN (RLIN)', 0, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('998', 'd', 'Primera fecha, FD (RLIN)', 'Primera fecha, FD (RLIN)', 0, 0, '', 9, '', '', '', 0, -6, '', '', '', NULL),
		('998', 'i', 'RINS (RLIN)', 'RINS (RLIN)', 0, 0, '', 9, '', '', '', 0, 5, '', '', '', NULL),
		('998', 'l', 'LI (RLIN)', 'LI (RLIN)', 0, 0, '', 9, '', '', '', 0, 5, '', '', '', NULL),
		('998', 'n', 'NUC (RLIN)', 'NUC (RLIN)', 0, 0, '', 9, '', '', '', 0, 5, '', '', '', NULL),
		('998', 'p', 'PROC (RLIN)', 'PROC (RLIN)', 0, 0, '', 9, '', '', '', 0, 5, '', '', '', NULL),
		('998', 's', 'CC (RLIN)', 'CC (RLIN)', 0, 0, '', 9, '', '', '', 0, 5, '', '', '', NULL),
		('998', 't', 'RTYP (RLIN)', 'RTYP (RLIN)', 0, 0, '', 9, '', '', '', 0, 5, '', '', '', NULL),
		('998', 'w', 'PLINK (RLIN)', 'PLINK (RLIN)', 0, 0, '', 9, '', '', '', 0, 5, '', '', '', NULL);


UPDATE `marc_subfield_structure` SET maxlength=24 WHERE tagfield='000';
UPDATE `marc_subfield_structure` SET maxlength=40 WHERE tagfield='008';
